/*
**  wsc.h
**
**  Use for both Win16 & Win32.
**  For Win32 compilers supporting the "declspec" keyword.
*/


#ifdef STATIC_LIBRARY
  #define DLL_IMPORT_EXPORT
#else
  #ifdef WIN32
    #ifdef DLL_SOURCE_CODE
       #define DLL_IMPORT_EXPORT 
    #else
       #define DLL_IMPORT_EXPORT 
    #endif
  #else
    #define DLL_IMPORT_EXPORT 
  #endif
#endif

#ifdef __cplusplus
  #define NoMangle 
#else
  #define NoMangle
#endif

NoMangle int DLL_IMPORT_EXPORT TntBaud(int,unsigned);
NoMangle int DLL_IMPORT_EXPORT TntBrkSig(int,char);
NoMangle int DLL_IMPORT_EXPORT TntCTS(int);
NoMangle int DLL_IMPORT_EXPORT TntDCD(int);
NoMangle int DLL_IMPORT_EXPORT TntDebug(int);
NoMangle int DLL_IMPORT_EXPORT TntDone(int);
NoMangle int DLL_IMPORT_EXPORT TntDSR(int);
NoMangle int DLL_IMPORT_EXPORT TntDTR(int,char);
NoMangle int DLL_IMPORT_EXPORT TntFlow(int,char);
NoMangle int DLL_IMPORT_EXPORT TntInfo(char);
NoMangle int DLL_IMPORT_EXPORT TntGetc(int);
NoMangle int DLL_IMPORT_EXPORT TntGets(int,LPSTR,unsigned);
NoMangle int DLL_IMPORT_EXPORT TntParms(int,int,int,int);
NoMangle int DLL_IMPORT_EXPORT TntPutc(int,char);
NoMangle int DLL_IMPORT_EXPORT TntPuts(int,LPSTR,unsigned);
NoMangle int DLL_IMPORT_EXPORT TntRead(int,int);
NoMangle int DLL_IMPORT_EXPORT TntReset(int,int,int);
NoMangle int DLL_IMPORT_EXPORT TntRI(int);
NoMangle int DLL_IMPORT_EXPORT TntRTS(int,char);
NoMangle int DLL_IMPORT_EXPORT TntRxClear(int);
NoMangle int DLL_IMPORT_EXPORT TntRxQue(int);
NoMangle int DLL_IMPORT_EXPORT TntStatus(int,unsigned);
NoMangle DWORD DLL_IMPORT_EXPORT TntTimer(void);
NoMangle int DLL_IMPORT_EXPORT TntTxClear(int);
NoMangle int DLL_IMPORT_EXPORT TntTxQue(int);
NoMangle int DLL_IMPORT_EXPORT TntUnGetc(int,char);
#ifdef WIN32
NoMangle int DLL_IMPORT_EXPORT TntWinError(LPSTR,int);
NoMangle int DLL_IMPORT_EXPORT TntEvent(int, DWORD);
NoMangle int DLL_IMPORT_EXPORT TntMessage(int, HWND, WORD, DWORD);
#endif

#define COM1   0
#define COM2   1
#define COM3   2
#define COM4   3
#define COM5   4
#define COM6   5
#define COM7   6
#define COM8   7
#define COM9   8
#define COM10  9
#define COM11 10
#define COM12 11
#define COM13 12
#define COM14 13
#define COM15 14
#define COM16 15
#define COM17 16
#define COM18 17

/* Parity Codes */

#define WSC_NoParity 0
#define WSC_OddParity  1
#define WSC_EvenParity 2
#define WSC_MarkParity 3
#define WSC_SpaceParity 4

/* Stop Bit Codes */

#define WSC_OneStopBit   0
#define WSC_One5StopBits 1
#define WSC_TwoStopBits  2

/* Word Length Codes */

#define WSC_WordLength5  5
#define WSC_WordLength6  6
#define WSC_WordLength7  7
#define WSC_WordLength8  8

/* return codes */

#define WSC_NO_DATA   (-100)
#define WSC_RANGE     (-101)
#define WSC_ABORTED   (-102)
#define WSC_WIN32ERR  (-103)
#define WSC_EXPIRED   (-104)
#define WSC_BUFFERS   (-105)
#define WSC_THREAD    (-106)

#define WSC_IE_BADID     (-1)
#define WSC_IE_OPEN      (-2)
#define WSC_IE_NOPEN     (-3)
#define WSC_IE_MEMORY    (-4)
#define WSC_IE_DEFAULT   (-5)
#define WSC_IE_HARDWARE  (-10)
#define WSC_IE_BYTESIZE  (-11)
#define WSC_IE_BAUDRATE  (-12)

/* baud codes */

#define WSC_Baud110    0
#define WSC_Baud300    1
#define WSC_Baud1200   2
#define WSC_Baud2400   3
#define WSC_Baud4800   4
#define WSC_Baud9600   5
#define WSC_Baud19200  6
#define WSC_Baud38400  7
#define WSC_Baud57600  8
#define WSC_Baud115200 9

/* TntGetError masks */

#define WSC_RXOVER   0x0001
#define WSC_OVERRUN  0x0002
#define WSC_PARITY   0x0004
#define WSC_FRAME    0x0008
#define WSC_BREAK    0x0010
#define WSC_TXFULL   0x0100

/* TntDTR and TntRTS Commands */

#define WSC_SET_LINE     'S'
#define WSC_CLEAR_LINE   'C'
#define WSC_READ_LINE    'R'

/* TntBrkSig Commands */

#define WSC_ASSERT_BREAK 'A'
#define WSC_CANCEL_BREAK 'C'
#define WSC_DETECT_BREAK 'D'

/* TntFlow Commands */

#define WSC_HARDWARE_FLOW_CONTROL 'H'
#define WSC_SOFTWARE_FLOW_CONTROL 'S'
#define WSC_NO_FLOW_CONTROL       'N'

/* TntInfo commands */

#define WSC_GET_VERTntN      'V'
#define WSC_IS_32BITS        '3'
