import java.awt.*;
import javax.swing.*;
import java.io.*;
import java.math.BigInteger;
import com.symantec.itools.javax.swing.borders.SoftBevelBorder;
import com.symantec.itools.javax.swing.borders.CompoundBorder;
import com.symantec.itools.javax.swing.borders.MatteBorder;
import com.symantec.itools.javax.swing.borders.BevelBorder;
import com.symantec.itools.javax.swing.borders.EmptyBorder;
import com.symantec.itools.javax.swing.borders.LineBorder;
import com.symantec.itools.javax.swing.JButtonGroupPanel;
import com.symantec.itools.javax.swing.JChart;



public class AFRframe extends javax.swing.JFrame
{
    
    javax.swing.JTextField display_cells[][]= new javax.swing.JTextField[17][14];
    javax.swing.JTextField last_part_cell = null;
    javax.swing.JTextField last_boost_cell = null;
    javax.swing.JTextField last_nos_cell = null;
    
    float cell_values[][][] = new float [5][17][14];
    // 0 - 02's
    // 1 - timing
    // 2 - air flow
    // 3 - pulse width
    // 4 - duty cycle

    int row = 0;
    int column = 0;
    int boost_limit = 10;

	public AFRframe()
	{
		// This code is automatically generated by Visual Cafe when you add
		// components to the visual environment. It instantiates and initializes
		// the components. To modify the code, only use code syntax that matches
		// what Visual Cafe can generate, or Visual Cafe may be unable to back
		// parse your Java file into its visual environment.
		//{{INIT_CONTROLS
		setTitle("AFR Settings");
		getContentPane().setLayout(null);
		getContentPane().setBackground(new java.awt.Color(204,204,204));
		setSize(485,457);
		setVisible(false);
		//$$ softBevelBorder1.move(176,528);
		//$$ compoundBorder1.move(32,520);
		//$$ compoundBorder2.move(56,520);
		//$$ matteBorder1.move(80,520);
		//$$ bevelBorder1.move(104,520);
		//$$ emptyBorder1.move(128,520);
		//$$ lineBorder1.move(144,520);
		//$$ bevelBorder2.move(0,518);
		open_afr_config.setMode(FileDialog.LOAD);
		open_afr_config.setTitle("Open");
		//$$ open_afr_config.move(48,518);
		save_afr_config.setMode(FileDialog.SAVE);
		save_afr_config.setTitle("Save");
		//$$ save_afr_config.move(72,518);
		JButtonGroupPanel1.setLayout(new GridLayout(1,0,0,0));
		getContentPane().add(JButtonGroupPanel1);
		JButtonGroupPanel1.setBounds(8,384,472,64);
		show_o2.setText("O2v");
		show_o2.setActionCommand("jradioButton");
		JButtonGroupPanel1.add(show_o2);
		show_timing.setText("Timing");
		show_timing.setActionCommand("jradioButton");
		JButtonGroupPanel1.add(show_timing);
		show_air.setText("Air Flow");
		show_air.setActionCommand("jradioButton");
		JButtonGroupPanel1.add(show_air);
		show_pulse.setText("Pulse Width");
		show_pulse.setActionCommand("jradioButton");
		JButtonGroupPanel1.add(show_pulse);
		show_duty.setText("Duty Cycle");
		show_duty.setActionCommand("jradioButton");
		JButtonGroupPanel1.add(show_duty);
		//}}

		//{{INIT_MENUS
		//}}

		//{{REGISTER_LISTENERS
		SymMouse aSymMouse = new SymMouse();
		show_o2.addMouseListener(aSymMouse);
		show_timing.addMouseListener(aSymMouse);
		show_air.addMouseListener(aSymMouse);
		show_pulse.addMouseListener(aSymMouse);
		show_duty.addMouseListener(aSymMouse);
		//}}
	}

	public AFRframe(String sTitle)
	{
		this();
		setTitle(sTitle);
	}

	public void setVisible(boolean b)
	{
		//if (b)
			//setLocation(50, 50);
		super.setVisible(b);
//		add_controls();
//		set_colors();
//        interpolate_data();
	}

	void add_controls()
	{
	    String headings[] = new String[20];
	    int x = 48;
	    int y = 48;
	    int base_rpm = 2000;

	    headings[1] = "1 psi";
	    headings[2] = "3";
	    headings[3] = "5";
	    headings[4] = "7";
	    headings[5] = "9";
	    headings[6] = "11";
	    headings[7] = "13";
	    headings[8] = "15";
	    headings[9] = "17";
	    headings[10] = "19";
	    headings[11] = "21";
	    headings[12] = "23";
	    headings[13] = "25";
	    headings[14] = "27";
	    headings[15] = "29";
	    headings[16] = "NOS";
	    row = 0;
	    do
	    {
	        x = 24;
	        column = 0;
	        do
	        {
                if (row != 0 || column != 0)
                {
            	    display_cells[row][column] = new javax.swing.JTextField();
		            getContentPane().add(display_cells[row][column]);
		            if (row != 0 && column != 0)
		            {
//                        display_cells[row][column].addFocusListener(aSymFocus);
		                display_cells[row][column].setSelectionColor(java.awt.Color.black);
		                display_cells[row][column].setSelectedTextColor(java.awt.Color.white);
                    }
        		    display_cells[row][column].setFont(new Font("Dialog", Font.PLAIN, 9));
   		            display_cells[row][column].setBounds(x,y,30,18);
		            display_cells[row][column].setEditable(false);
                    display_cells[row][column].setForeground(java.awt.Color.white);
                    display_cells[row][column].setBackground(java.awt.Color.blue);
                    display_cells[row][column].setBorder(bevelBorder2);
                    display_cells[row][column].setVisible(true);
                    if (column == 0 || row == 0)
                    {
    		            display_cells[row][column].setEditable(false);
                        display_cells[row][column].setForeground(java.awt.Color.black);
    		            display_cells[row][column].setBackground(java.awt.Color.green);
    		            if (column == 0 && row > 0)
    		                display_cells[row][column].setText(headings[row]);
                    }
                }
                if (row == 0 && column > 0)
                {
                    display_cells[row][column].setText(Integer.toString(base_rpm));
                    base_rpm = base_rpm + 500;
                }
                x = x + 30;
	            ++ column;
	        }
	        while
	        (column <= 13);
	        y = y + 18;
	        ++ row;
	    }
	    while (row <= 16);
	    
	    x = 0;
	    do
	    {
	        row = 0;
	        do
	        {
	            column = 0;
	            do
	            {
	                cell_values[x][row][column] = 0F;
	                ++ column;
	            }
	            while (column <= 13);
	            ++ row;
	        }
	        while (row <= 16); 
	    ++ x;
	    }
	    while (x <= 4);
	}

	static public void main(String args[])
	{
		(new AFRframe()).setVisible(true);
	}

	public void addNotify()
	{
		// Record the size of the window prior to calling parents addNotify.
		Dimension size = getSize();

		super.addNotify();

		if (frameSizeAdjusted)
			return;
		frameSizeAdjusted = true;

		// Adjust size of frame according to the insets and menu bar
		Insets insets = getInsets();
		javax.swing.JMenuBar menuBar = getRootPane().getJMenuBar();
		int menuBarHeight = 0;
		if (menuBar != null)
			menuBarHeight = menuBar.getPreferredSize().height;
		setSize(insets.left + insets.right + size.width, insets.top + insets.bottom + size.height + menuBarHeight);
	}

	// Used by addNotify
	boolean frameSizeAdjusted = false;

	//{{DECLARE_CONTROLS
	com.symantec.itools.javax.swing.borders.SoftBevelBorder softBevelBorder1 = new com.symantec.itools.javax.swing.borders.SoftBevelBorder();
	com.symantec.itools.javax.swing.borders.CompoundBorder compoundBorder1 = new com.symantec.itools.javax.swing.borders.CompoundBorder();
	com.symantec.itools.javax.swing.borders.CompoundBorder compoundBorder2 = new com.symantec.itools.javax.swing.borders.CompoundBorder();
	com.symantec.itools.javax.swing.borders.MatteBorder matteBorder1 = new com.symantec.itools.javax.swing.borders.MatteBorder();
	com.symantec.itools.javax.swing.borders.BevelBorder bevelBorder1 = new com.symantec.itools.javax.swing.borders.BevelBorder();
	com.symantec.itools.javax.swing.borders.EmptyBorder emptyBorder1 = new com.symantec.itools.javax.swing.borders.EmptyBorder();
	com.symantec.itools.javax.swing.borders.LineBorder lineBorder1 = new com.symantec.itools.javax.swing.borders.LineBorder();
	com.symantec.itools.javax.swing.borders.BevelBorder bevelBorder2 = new com.symantec.itools.javax.swing.borders.BevelBorder();
	java.awt.FileDialog open_afr_config = new java.awt.FileDialog(this);
	java.awt.FileDialog save_afr_config = new java.awt.FileDialog(this);
	com.symantec.itools.javax.swing.JButtonGroupPanel JButtonGroupPanel1 = new com.symantec.itools.javax.swing.JButtonGroupPanel();
	javax.swing.JRadioButton show_o2 = new javax.swing.JRadioButton();
	javax.swing.JRadioButton show_timing = new javax.swing.JRadioButton();
	javax.swing.JRadioButton show_air = new javax.swing.JRadioButton();
	javax.swing.JRadioButton show_pulse = new javax.swing.JRadioButton();
	javax.swing.JRadioButton show_duty = new javax.swing.JRadioButton();
	//}}

	//{{DECLARE_MENUS
	//}}


	class SymMouse extends java.awt.event.MouseAdapter
	{
		public void mouseClicked(java.awt.event.MouseEvent event)
		{
			Object object = event.getSource();
			if (object == show_o2)
				show_o2_mouseClicked(event);
			else if (object == show_timing)
				show_timing_mouseClicked(event);
			else if (object == show_air)
				show_air_mouseClicked(event);
			else if (object == show_pulse)
				show_pulse_mouseClicked(event);
			else if (object == show_duty)
				show_duty_mouseClicked(event);
		}
	}


	void animate_cells(int r, byte t, float p, byte a, float o2v, int field_id, boolean tf)
	{
	    int [] boost_bounds = new int[20];
	    int nos = 0;
	    int x = 0;
	    int boost_index = 0;
	    if (r < 2000)
	        return;
	    if (t < 98)
	        return;
	    if (p < 1F)
	        return;

	    boost_index = 1;
	    do
	    {
	        boost_bounds[x] = boost_index;
	        boost_index += 2;
	        ++ x;
	    }
	    while(x < 15);
	    
	    x = 14;
	    if (p >= 1F)
	        do
	        {
	            if (p >= (float)boost_bounds[x])
	            {
	                if ( x < 14)
	                {
                        if (p - (float)boost_bounds[x] > (float)boost_bounds[x + 1] - p)
                            boost_index = x + 2;
                        else
	                        boost_index = x + 1;
	                    //System.out.println(p + " " + x + " " + boost_bounds[x] + " " + boost_index);
	                }
	                else
	                    boost_index = 14;
	                break;
	            }
	            -- x;
	        }
	        while (x >= 0);
	    
	    int rx = (r - 1500) / 500;
	    if ((2000 + (rx * 500)) - r < r - (1500 + (rx * 500)))
	        ++ rx;
	    //System.out.println(field_id + " " + boost_index + " " + rx);
	    if (o2v > cell_values[field_id][boost_index][rx] && !tf)
	        cell_values[field_id][boost_index][rx] = o2v;    
	    if (o2v < cell_values[field_id][boost_index][rx] && tf)
	        cell_values[field_id][boost_index][rx] = o2v;    
	}

    void display_pgm()
    {
        int x;
        int row;
        int column;
	    x = 0;
	    if (show_o2.isSelected())
	        x = 0;
	    if (show_timing.isSelected())
	        x = 1;
	    if (show_air.isSelected())
	        x = 2;
	    if (show_pulse.isSelected())
	        x = 3;
	    if (show_duty.isSelected())
	        x = 4;
	    row = 1;
	    do
	    {
	        column = 1;
	        do
	        {
	            if (cell_values[x][row][column] != 0F)
	            {
	                if (x != 2)
	                  display_cells[row][column].setText(Float.toString(cell_values[x][row][column]));
	                else
	                  display_cells[row][column].setText(Integer.toString((int)cell_values[x][row][column]));
	            }
	            else
	                display_cells[row][column].setText("");
	            ++ column;
	        }
	        while (column <= 13);
	        ++ row;
	    }
	    while (row <= 16); 
    }

	void show_o2_mouseClicked(java.awt.event.MouseEvent event)
	{
		// to do: code goes here.
		display_pgm();
	}

	void show_timing_mouseClicked(java.awt.event.MouseEvent event)
	{
		// to do: code goes here.
		display_pgm();
	}

	void show_air_mouseClicked(java.awt.event.MouseEvent event)
	{
		// to do: code goes here.
		display_pgm();
	}

	void show_pulse_mouseClicked(java.awt.event.MouseEvent event)
	{
		// to do: code goes here.
		display_pgm();
	}

	void show_duty_mouseClicked(java.awt.event.MouseEvent event)
	{
		// to do: code goes here.
		display_pgm();
	}
}
