/*
	A basic extension of the java.awt.Frame class
 */

import java.awt.*;

public class CHART3Dframe extends Frame
{

    private Plotter           plotter = null;
    public static ImageReader ireader;
    public boolean            showgrid = false;
    public boolean            showbox  = false;
    public int                oldx = 50;
    public int                oldy = 50;

	public CHART3Dframe()
	{
		// This code is automatically generated by Visual Cafe when you add
		// components to the visual environment. It instantiates and initializes
		// the components. To modify the code, only use code syntax that matches
		// what Visual Cafe can generate, or Visual Cafe may be unable to back
		// parse your Java file into its visual environment.
		//{{INIT_CONTROLS
		setLayout(null);
		setBackground(new java.awt.Color(204,204,204));
		setSize(640,480);
		setVisible(false);
		ResetChart.setLabel("Reset");
		add(ResetChart);
		ResetChart.setBackground(new java.awt.Color(204,204,204));
		ResetChart.setBounds(24,24,60,40);
		ShowOptions.setLabel("Options");
		add(ShowOptions);
		ShowOptions.setBackground(new java.awt.Color(204,204,204));
		ShowOptions.setBounds(24,84,60,40);
		ShowFilter.setLabel("Filter");
		add(ShowFilter);
		ShowFilter.setBackground(new java.awt.Color(204,204,204));
		ShowFilter.setBounds(24,144,60,40);
		ShowGrid.setLabel("Grid");
		add(ShowGrid);
		ShowGrid.setBackground(new java.awt.Color(204,204,204));
		ShowGrid.setBounds(24,204,60,40);
		add(ratio_slider);
		ratio_slider.setBounds(440,448,192,16);
		//}}

		//{{INIT_MENUS
		//}}

		//{{REGISTER_LISTENERS
		SymWindow aSymWindow = new SymWindow();
		this.addWindowListener(aSymWindow);
		SymAction lSymAction = new SymAction();
		ResetChart.addActionListener(lSymAction);
		ShowOptions.addActionListener(lSymAction);
		ShowFilter.addActionListener(lSymAction);
		ShowGrid.addActionListener(lSymAction);
		SymAdjustment lSymAdjustment = new SymAdjustment();
		ratio_slider.addAdjustmentListener(lSymAdjustment);
		//}}
	}

	public CHART3Dframe(String title)
	{
		this();
		setTitle(title);
	}

    /**
     * Shows or hides the component depending on the boolean flag b.
     * @param b  if true, show the component; otherwise, hide the component.
     * @see java.awt.Component#isVisible
     */
    public void setVisible(boolean b)
	{
		if(b)
		{
			setLocation(50, 50);
            ireader = new ImageReader (this);
            setLayout (null);
            plotter = new Plotter (size ().width, size ().height);
            add (plotter);
            plotter.move (0, 0);
            plotter.loadData (0);
            plotter.setData (true);

		}
		super.setVisible(b);
	}

	static public void main(String args[])
	{
		(new CHART3Dframe()).setVisible(true);
	}

	public void addNotify()
	{
	    // Record the size of the window prior to calling parents addNotify.
	    Dimension d = getSize();

		super.addNotify();

		if (fComponentsAdjusted)
			return;

		// Adjust components according to the insets
		Insets insets = getInsets();
		setSize(insets.left + insets.right + d.width, insets.top + insets.bottom + d.height);
		Component components[] = getComponents();
		for (int i = 0; i < components.length; i++)
		{
			Point p = components[i].getLocation();
			p.translate(insets.left, insets.top);
			components[i].setLocation(p);
		}
		fComponentsAdjusted = true;
	}

    // Used for addNotify check.
	boolean fComponentsAdjusted = false;

	//{{DECLARE_CONTROLS
	java.awt.Button ResetChart = new java.awt.Button();
	java.awt.Button ShowOptions = new java.awt.Button();
	java.awt.Button ShowFilter = new java.awt.Button();
	java.awt.Button ShowGrid = new java.awt.Button();
	java.awt.Scrollbar ratio_slider = new java.awt.Scrollbar(Scrollbar.HORIZONTAL,10,1,5,20);
	//}}

	//{{DECLARE_MENUS
	//}}

	class SymWindow extends java.awt.event.WindowAdapter
	{
		public void windowClosing(java.awt.event.WindowEvent event)
		{
			Object object = event.getSource();
			if (object == CHART3Dframe.this)
				CHART3Dframe_WindowClosing(event);
		}
	}

	void CHART3Dframe_WindowClosing(java.awt.event.WindowEvent event)
	{
		setVisible(false);		 // hide the Frame
	}

	class SymAction implements java.awt.event.ActionListener
	{
		public void actionPerformed(java.awt.event.ActionEvent event)
		{
			Object object = event.getSource();
			if (object == ResetChart)
				ResetChart_ActionPerformed(event);
			else if (object == ShowOptions)
				ShowOptions_ActionPerformed(event);
			else if (object == ShowFilter)
				ShowFilter_ActionPerformed(event);
			else if (object == ShowGrid)
				ShowGrid_ActionPerformed(event);
		}
	}

	void ResetChart_ActionPerformed(java.awt.event.ActionEvent event)
	{
		// to do: code goes here.

		plotter.view.onWheelResetButton();

	}

	void ShowOptions_ActionPerformed(java.awt.event.ActionEvent event)
	{
		// to do: code goes here.

		plotter.ShowOptionBox();
	}

	void ShowFilter_ActionPerformed(java.awt.event.ActionEvent event)
	{
		// to do: code goes here.

		plotter.ShowFilterBox();
	}

	void ShowGrid_ActionPerformed(java.awt.event.ActionEvent event)
	{
		// to do: code goes here.

		//showgrid showbox

		if (!showgrid && !showbox)
		    {
		        showgrid = true;
		        plotter.view.onCheckrClick(showgrid, showbox);
		    }
		else
		    if (showgrid & !showbox)
		        {
		            showbox = true;
		            plotter.view.onCheckrClick(showgrid, showbox);
		        }
		    else
		        {
		            showgrid = false;
		            showbox  = false;
		            plotter.view.onCheckrClick(showgrid, showbox);
		        }
	}

	class SymAdjustment implements java.awt.event.AdjustmentListener
	{
		public void adjustmentValueChanged(java.awt.event.AdjustmentEvent event)
		{
			Object object = event.getSource();
			if (object == ratio_slider)
				ratioSlider_AdjustmentValueChanged(event);
			

		}
	}

	void ratioSlider_AdjustmentValueChanged(java.awt.event.AdjustmentEvent event)
	{
		// to do: code goes here.
		
		plotter.zoom_rtn(ratio_slider.getValue());
	}
}
