import java.awt.*;


public class Checker extends Canvas {

    private Image         image;
    private int           x;
    private int           y;
    private int           cwidth;
    private int           cheight;
    private boolean       pressed;
    private boolean       mousedown;
    private CheckerClient client;
    private String        info;
    public  String        text;


    Checker (Image img, int posx, int posy, int w, int h,
             boolean initstate,
             String info,
             String checkertext, CheckerClient checkerclient) {
        image   = img;
        x       = posx;
        y       = posy;
        cwidth  = w;
        cheight = h;
        pressed = initstate;
        mousedown = false;
        client  = checkerclient;
        text    = checkertext;
        this.info = info;
        resize (cwidth, cheight);
    }



    public void paint (Graphics graph) {
        update (graph);
        return;
    }


    public synchronized void update (Graphics graph) {
        int clipx;
        int clipy;
        if (pressed || mousedown) {
            clipx = x + cwidth;
            clipy = y;
            }
        else {
            clipx = x;
            clipy = y;
            }

        Graphics clipgraph = graph.create (0, 0, cwidth, cheight);
        clipgraph.drawImage (image, -clipx, -clipy, null);
        return;
    }



    public boolean mouseDown (Event event, int x, int y) {
        if (x >= cwidth || y >= cheight || x <0 || y<0)
            return true;

        mousedown = true;
        InfoLine.setText (info);
        repaint ();
        return true;
    }




    public boolean mouseUp (Event event, int x, int y) {
        if (! mousedown)
            return false;
        mousedown = false;
        pressed = ! pressed;
        InfoLine.clearText ();
        repaint ();
        if (x >= cwidth || y >= cheight || x<0 || y<0)
            return true;
        client.onCheckerClick (this, pressed);
        return true;
    }

}

