import java.awt.*;


public class ImageButton extends Canvas {

    private Image        image;
    private int          x;
    private int          y;
    private int          width;
    private int          height;
    private boolean      pressed;
    private ButtonClient client;
    public  String       text;
    private String       info;


    ImageButton (Image img, int posx, int posy, int w, int h,
                 String info,
                 String buttontext, ButtonClient buttonclient) {
        image   = img;
        x       = posx;
        y       = posy;
        width   = w;
        height  = h;
        pressed = false;
        client  = buttonclient;
        text    = buttontext;
        this.info = info;
        resize (width, height);
    }



    public void paint (Graphics graph) {
        update (graph);
        return;
    }


    public synchronized void update (Graphics graph) {
        int clipx;
        int clipy;
        if (pressed) {
            clipx = x + width;
            clipy = y;
            }
        else {
            clipx = x;
            clipy = y;
            }

        Graphics clipgraph = graph.create (0, 0, width, height);
        clipgraph.drawImage (image, -clipx, -clipy, null);
        return;
    }



    public boolean mouseDown (Event event, int x, int y) {
        boolean inbutton;
        if (x >= width || y >= height || x <0 || y<0)
            return true;

        pressed = true;
        InfoLine.setText (info);
        repaint ();
        return true;
    }




    public boolean mouseUp (Event event, int x, int y) {
        if (! pressed)
            return false;
        pressed = false;
        InfoLine.clearText ();
        repaint ();
        if (x >= width || y >= height || x<0 || y<0)
            return true;
        client.onButtonClick (this);
        return true;
    }

}

