import java.awt.*;



public class LegendBox extends Canvas {

    static private boolean   labeldone;
    static private boolean   colordone;
    static private String [] colorstr;
    static private String    xlabel;
    static private String    ylabel;
    static private String    zlabel;
    static private String    sizelabel;
    static private float     xmin, xmax;
    static private float     ymin, ymax;
    static private float     zmin, zmax;
    static private LegendBox inst = null;

    private Color [] colortab;
    private Font font;

    
    public LegendBox () {
        inst = this;
        resize (150, 420);
        labeldone = false;
        colordone = false;
        font = new Font ("TimesRoman", Font.BOLD, 12);
        
        colortab = new Color [12];
        colortab[0] = Color.yellow;
        colortab[1] = Color.red;
        colortab[2] = Color.blue;
        colortab[3] = Color.green;
        colortab[4] = Color.white;
        colortab[5] = Color.pink;
        colortab[6] = Color.yellow.darker ().darker ();
        colortab[7] = Color.red.darker ().darker ();
        colortab[8] = Color.blue.darker ().darker ();
        colortab[9] = Color.green.darker ().darker ();
        colortab[10] = Color.white.darker ().darker ();
        colortab[11] = Color.pink.darker ().darker ();
        return;
    }



    static public void setColor (String [] str) {
        colorstr = str;
        colordone = true;
        if (inst != null)
            inst.repaint ();
        return;
    }
    
    
    static public void clearColor () {
        colorstr = null;
        colordone = false;
        if (inst != null)
            inst.repaint ();
        return;
    }


    static public void setScale (String xtext, float minx, float maxx,
                                 String ytext, float miny, float maxy,
                                 String ztext, float minz, float maxz,
                                 String sizetext) {
        xlabel = xtext;
        ylabel = ytext;
        zlabel = ztext;
        sizelabel = sizetext;
        xmin = minx;
        ymin = miny;
        zmin = minz;
        xmax = maxx;
        ymax = maxy;
        zmax = maxz;
        labeldone = true;
        if (inst != null)
            inst.repaint ();
        return;
    }


    public void paint (Graphics graph) {
        graph.setFont (font);
        graph.setColor (Color.lightGray);
        graph.fillRect (0, 0, size().width, size().height);
        
        int i;
/*        for (i=0; i<12; i++) {
            graph.setColor (colortab[i]);
            graph.fillRect (10, 10+20*i, 20, 15);
            graph.setColor (Color.black);
            graph.drawRect (10, 10+20*i, 20, 15);
            }
        
        if (colordone) {
            graph.setColor (Color.black);
            for (i=0; i<12; i++)
                if (! colorstr[i].equals ("- N/A -"))
                    graph.drawString (colorstr[i], 45, 23+20*i);
            }
*/        
        graph.setColor (Color.white);
        graph.drawLine (10, 13*20, size().width-10, 13*20);
        graph.drawLine (size().width-3, 10, size().width-3, size().height-10);
        graph.setColor (Color.gray);
        graph.drawLine (10, 13*20+1, size().width-10, 13*20+1);
        graph.drawLine (size().width-2, 10, size().width-2, size().height-10);
        
        
        if (labeldone) {
            graph.setColor (Color.red.darker ());
            graph.drawString (xlabel, 10, 280);
            graph.drawString (ylabel, 10, 315);
            graph.drawString (zlabel, 10, 350);
            
            if (sizelabel.length () > 0)
                graph.drawString (sizelabel + " for Size", 10, 385);

            graph.setColor (Color.black);
            graph.drawString (String.valueOf (xmin), 20, 295);
            graph.drawString (String.valueOf (ymin), 20, 330);
            graph.drawString (String.valueOf (zmin), 20, 365);
            graph.drawString (String.valueOf (xmax), 80, 295);
            graph.drawString (String.valueOf (ymax), 80, 330);
            graph.drawString (String.valueOf (zmax), 80, 365);
            }
        }
}
