import java.awt.*;
import java.util.Hashtable;



public class OptionBox extends Frame {

    Label error1 = new Label ();
    Label error2 = new Label ();
    Label xlabel = new Label ("X Field");
    Label ylabel = new Label ("Y Field");
    Label zlabel = new Label ("Z Field");
    Label sizelabel = new Label ("Size Field");
    Label scalelabel = new Label ("Scale");
    Label minlabel = new Label ("Min");
    Label maxlabel = new Label ("Max");
    Label colorlabel = new Label ("Color Field");
    Label defcollabel = new Label ("Default");
    Label yellowlabel = new Label ("Yellow");
    Label redlabel = new Label ("Red");
    Label bluelabel = new Label ("Blue");
    Label greenlabel = new Label ("Green");
    Label whitelabel = new Label ("White");
    Label pinklabel = new Label ("Pink");
    Label dyellowlabel = new Label ("Dark Yellow");
    Label dredlabel = new Label ("Dark Red");
    Label dbluelabel = new Label ("Dark Blue");
    Label dgreenlabel = new Label ("Dark Green");
    Label dwhitelabel = new Label ("Dark White");
    Label dpinklabel = new Label ("Dark Pink");

    Choice xchoice = new Choice ();
    Choice ychoice = new Choice ();
    Choice zchoice = new Choice ();
    Choice sizechoice = new Choice ();
    Choice colorchoice = new Choice ();
    Choice defcolchoice = new Choice ();
    TextField minxtext = new TextField ();
    TextField maxxtext = new TextField ();
    TextField minytext = new TextField ();
    TextField maxytext = new TextField ();
    TextField minztext = new TextField ();
    TextField maxztext = new TextField ();
    TextField minsizetext = new TextField ();
    TextField maxsizetext = new TextField ();
    Choice yellowtext = null;
    Choice redtext = null;
    Choice bluetext = null;
    Choice greentext = null;
    Choice whitetext = null;
    Choice pinktext  = null;
    Choice dyellowtext = null;
    Choice dredtext = null;
    Choice dbluetext = null;
    Choice dgreentext = null;
    Choice dwhitetext = null;
    Choice dpinktext  = null;
    Panel  pyellowtext = new Panel ();
    Panel  predtext = new Panel ();
    Panel  pbluetext = new Panel ();
    Panel  pgreentext = new Panel ();
    Panel  pwhitetext = new Panel ();
    Panel  ppinktext = new Panel ();
    Panel  pdyellowtext = new Panel ();
    Panel  pdredtext = new Panel ();
    Panel  pdbluetext = new Panel ();
    Panel  pdgreentext = new Panel ();
    Panel  pdwhitetext = new Panel ();
    Panel  pdpinktext = new Panel ();
    Button ok = new Button ("OK");
    Button apply = new Button ("Apply");
    Button cancel = new Button ("Cancel");


    final static int COLUMNWIDTH = 200;
    final static int ROWHEIGHT   = 40;
    final static int INITXPOS    = 5;
    final static int INITYPOS    = 10;
    final static int LABELWIDTH  = 90;
    final static int COLORMARGIN = 20;



    Plotter   plotter;
    Database  database;


    public OptionBox (Plotter plotter, Database database) {

        super ("Visualization Options") ;
        this.plotter  = plotter;
        this.database = database;

        resize (2*COLUMNWIDTH+15+90+210, 8*ROWHEIGHT+70) ;
        setResizable (true);
        setLayout (null);
        setBackground (Color.lightGray);


        for (int i=0; i<database.fieldcount; i++) {
            if (database.fieldtype[i] == Database.NUMERIC) {
                xchoice.addItem (database.fieldname[i]);
                ychoice.addItem (database.fieldname[i]);
                zchoice.addItem (database.fieldname[i]);
                sizechoice.addItem (database.fieldname[i]);
                }

            if (database.fieldtype[i] == Database.STRING)
                colorchoice.addItem (database.fieldname[i]);
            }

        getColorList ();

        defcolchoice.addItem ("Yellow");
        defcolchoice.addItem ("Red");
        defcolchoice.addItem ("Blue");
        defcolchoice.addItem ("Green");
        defcolchoice.addItem ("White");
        defcolchoice.addItem ("Pink");


        xchoice.addItem ("None");  xchoice.select (0);
        ychoice.addItem ("None");  ychoice.select (0);
        zchoice.addItem ("None");  zchoice.select (0);
        sizechoice.addItem ("None");  sizechoice.select (0);
        colorchoice.addItem ("None"); colorchoice.select (0);
        defcolchoice.select (0);


        Panel pxchoice = new Panel ();
        Panel pychoice = new Panel ();
        Panel pzchoice = new Panel ();
        Panel psizechoice = new Panel ();
        Panel pcolorchoice = new Panel ();
        Panel pdefcolchoice = new Panel ();

        xlabel.move (INITXPOS, INITYPOS+ROWHEIGHT);
        ylabel.move (INITXPOS, INITYPOS+2*ROWHEIGHT);
        zlabel.move (INITXPOS, INITYPOS+3*ROWHEIGHT);
        sizelabel.move (INITXPOS, INITYPOS+4*ROWHEIGHT);
        error1.move (INITXPOS, INITYPOS+6*ROWHEIGHT-25);
        error2.move (INITXPOS, INITYPOS+6*ROWHEIGHT);
        ok.move (15+INITXPOS, INITYPOS+7*ROWHEIGHT+15);
        apply.move (15+INITXPOS+70, INITYPOS+7*ROWHEIGHT+15);
        cancel.move (15+INITXPOS+140, INITYPOS+7*ROWHEIGHT+15);

        pxchoice.move (INITXPOS+LABELWIDTH, INITYPOS+ROWHEIGHT-3);
        pychoice.move (INITXPOS+LABELWIDTH, INITYPOS+2*ROWHEIGHT-3);
        pzchoice.move (INITXPOS+LABELWIDTH, INITYPOS+3*ROWHEIGHT-3);
        psizechoice.move (INITXPOS+LABELWIDTH, INITYPOS+4*ROWHEIGHT-3);

        minxtext.move (COLUMNWIDTH+INITXPOS, INITYPOS+ROWHEIGHT);
        minytext.move (COLUMNWIDTH+INITXPOS, INITYPOS+2*ROWHEIGHT);
        minztext.move (COLUMNWIDTH+INITXPOS, INITYPOS+3*ROWHEIGHT);
        minsizetext.move (COLUMNWIDTH+INITXPOS, INITYPOS+4*ROWHEIGHT);
        maxxtext.move (COLUMNWIDTH+50, INITYPOS+ROWHEIGHT);
        maxytext.move (COLUMNWIDTH+50, INITYPOS+2*ROWHEIGHT);
        maxztext.move (COLUMNWIDTH+50, INITYPOS+3*ROWHEIGHT);
        maxsizetext.move (COLUMNWIDTH+50, INITYPOS+4*ROWHEIGHT);
        
        scalelabel.move (COLUMNWIDTH+INITXPOS+30, INITYPOS+15);
        minlabel.move (COLUMNWIDTH+INITXPOS, INITYPOS+5*ROWHEIGHT);
        maxlabel.move (COLUMNWIDTH+50, INITYPOS+5*ROWHEIGHT);
        

        colorlabel.move (COLUMNWIDTH+90+2*INITXPOS, INITYPOS+ROWHEIGHT);
        defcollabel.move (COLUMNWIDTH+90+2*INITXPOS, INITYPOS+2*ROWHEIGHT);
        yellowlabel.move (COLUMNWIDTH+90+2*INITXPOS+COLORMARGIN, INITYPOS+3*ROWHEIGHT);
        redlabel.move (COLUMNWIDTH+90+2*INITXPOS+COLORMARGIN, INITYPOS+4*ROWHEIGHT);
        bluelabel.move (COLUMNWIDTH+90+2*INITXPOS+COLORMARGIN, INITYPOS+5*ROWHEIGHT);
        greenlabel.move (COLUMNWIDTH+90+2*INITXPOS+COLORMARGIN, INITYPOS+6*ROWHEIGHT);
        whitelabel.move (COLUMNWIDTH+90+2*INITXPOS+COLORMARGIN, INITYPOS+7*ROWHEIGHT);
        pinklabel.move (COLUMNWIDTH+90+2*INITXPOS+COLORMARGIN, INITYPOS+8*ROWHEIGHT);
        dyellowlabel.move (COLUMNWIDTH+290+2*INITXPOS+COLORMARGIN, INITYPOS+3*ROWHEIGHT);
        dredlabel.move (COLUMNWIDTH+290+2*INITXPOS+COLORMARGIN, INITYPOS+4*ROWHEIGHT);
        dbluelabel.move (COLUMNWIDTH+290+2*INITXPOS+COLORMARGIN, INITYPOS+5*ROWHEIGHT);
        dgreenlabel.move (COLUMNWIDTH+290+2*INITXPOS+COLORMARGIN, INITYPOS+6*ROWHEIGHT);
        dwhitelabel.move (COLUMNWIDTH+290+2*INITXPOS+COLORMARGIN, INITYPOS+7*ROWHEIGHT);
        dpinklabel.move (COLUMNWIDTH+290+2*INITXPOS+COLORMARGIN, INITYPOS+8*ROWHEIGHT);

        pcolorchoice.move (COLUMNWIDTH+90+2*INITXPOS+LABELWIDTH, INITYPOS+ROWHEIGHT-3);
        pdefcolchoice.move (COLUMNWIDTH+90+2*INITXPOS+LABELWIDTH, INITYPOS+2*ROWHEIGHT-3);

        int width = COLUMNWIDTH-2*INITXPOS-LABELWIDTH;
        int labelheight  = 25;
        int choiceheight = 35;
        int textheight   = 35;

        xlabel.resize (LABELWIDTH, labelheight);
        ylabel.resize (LABELWIDTH, labelheight);
        zlabel.resize (LABELWIDTH, labelheight);
        sizelabel.resize (LABELWIDTH, labelheight);
        scalelabel.resize (LABELWIDTH, labelheight);
        minlabel.resize (30, labelheight);
        maxlabel.resize (30, labelheight);
        error1.resize (COLUMNWIDTH-2*INITXPOS, labelheight);
        error2.resize (COLUMNWIDTH-2*INITXPOS, labelheight);
        colorlabel.resize (LABELWIDTH, labelheight);
        defcollabel.resize (LABELWIDTH, labelheight);
        yellowlabel.resize (LABELWIDTH-COLORMARGIN, labelheight);
        redlabel.resize (LABELWIDTH-COLORMARGIN, labelheight);
        bluelabel.resize (LABELWIDTH-COLORMARGIN, labelheight);
        greenlabel.resize (LABELWIDTH-COLORMARGIN, labelheight);
        whitelabel.resize (LABELWIDTH-COLORMARGIN, labelheight);
        pinklabel.resize (LABELWIDTH-COLORMARGIN, labelheight);
        dyellowlabel.resize (LABELWIDTH-COLORMARGIN, labelheight);
        dredlabel.resize (LABELWIDTH-COLORMARGIN, labelheight);
        dbluelabel.resize (LABELWIDTH-COLORMARGIN, labelheight);
        dgreenlabel.resize (LABELWIDTH-COLORMARGIN, labelheight);
        dwhitelabel.resize (LABELWIDTH-COLORMARGIN, labelheight);
        dpinklabel.resize (LABELWIDTH-COLORMARGIN, labelheight);


        ok.resize (55, labelheight);
        apply.resize (55, labelheight);
        cancel.resize (55, labelheight);

        pxchoice.resize (width+INITXPOS, choiceheight);
        pychoice.resize (width+INITXPOS, choiceheight);
        pzchoice.resize (width+INITXPOS, choiceheight);
        psizechoice.resize (width+INITXPOS, choiceheight);

        minxtext.resize (width/2-5, textheight);
        minytext.resize (width/2-5, textheight);
        minztext.resize (width/2-5, textheight);
        minsizetext.resize (width/2-5, textheight);
        maxxtext.resize (width/2-5, textheight);
        maxytext.resize (width/2-5, textheight);
        maxztext.resize (width/2-5, textheight);
        maxsizetext.resize (width/2-5, textheight);

        pcolorchoice.resize (width, choiceheight);
        pdefcolchoice.resize (width, choiceheight);

        yellowlabel.setForeground (Color.yellow);
        redlabel.setForeground (Color.red);
        bluelabel.setForeground (Color.blue);
        greenlabel.setForeground (Color.green);
        whitelabel.setForeground (Color.white);
        pinklabel.setForeground (Color.pink);
        dyellowlabel.setForeground (Color.yellow.darker ().darker ());
        dredlabel.setForeground (Color.red.darker ().darker ());
        dbluelabel.setForeground (Color.blue.darker ().darker ());
        dgreenlabel.setForeground (Color.green.darker ().darker ());
        dwhitelabel.setForeground (Color.white.darker ().darker ());
        dpinklabel.setForeground (Color.pink.darker ().darker ());



        add (error1);
        add (error2);
        add (xlabel);
        add (ylabel);
        add (zlabel);
        add (sizelabel);
        add (colorlabel);
        add (defcollabel);
        add (yellowlabel);
        add (redlabel);
        add (bluelabel);
        add (greenlabel);
        add (whitelabel);
        add (pinklabel);
        add (dyellowlabel);
        add (dredlabel);
        add (dbluelabel);
        add (dgreenlabel);
        add (dwhitelabel);
        add (dpinklabel);
        add (pxchoice);    pxchoice.add (xchoice);
        add (pychoice);   pychoice.add (ychoice);
        add (pzchoice);    pzchoice.add (zchoice);
        add (psizechoice); psizechoice.add (sizechoice);
        add (pcolorchoice);   pcolorchoice.add (colorchoice);
        add (pdefcolchoice);  pdefcolchoice.add (defcolchoice);
        add (minxtext);    add (maxxtext);
        add (minytext);    add (maxytext);
        add (minztext);    add (maxztext);
        add (minsizetext); add (maxsizetext);
        add (scalelabel);
        add (minlabel);
        add (maxlabel);
        add (pyellowtext);
        add (predtext);
        add (pbluetext);
        add (pgreentext);
        add (pwhitetext);
        add (ppinktext);
        add (pdyellowtext);
        add (pdredtext);
        add (pdbluetext);
        add (pdgreentext);
        add (pdwhitetext);
        add (pdpinktext);
        add (ok);
        add (apply);
        add (cancel);

    }



    public void getColorList () {
        int width = COLUMNWIDTH-2*INITXPOS-LABELWIDTH;
        int textheight   = 35;
        
        if (yellowtext != null)  pyellowtext.remove (yellowtext);
        if (redtext != null)  predtext.remove (redtext);
        if (bluetext != null)  pbluetext.remove (bluetext);
        if (greentext != null)  pgreentext.remove (greentext);
        if (whitetext != null)  pwhitetext.remove (whitetext);
        if (pinktext != null)  ppinktext.remove (pinktext);
        if (dyellowtext != null)  pdyellowtext.remove (dyellowtext);
        if (dredtext != null)  pdredtext.remove (dredtext);
        if (dbluetext != null)  pdbluetext.remove (dbluetext);
        if (dgreentext != null)  pdgreentext.remove (dgreentext);
        if (dwhitetext != null)  pdwhitetext.remove (dwhitetext);
        if (dpinktext != null)  pdpinktext.remove (dpinktext);

        yellowtext = new Choice ();
        redtext = new Choice ();
        bluetext = new Choice ();
        greentext = new Choice ();
        whitetext = new Choice ();
        pinktext  = new Choice ();
        dyellowtext = new Choice ();
        dredtext = new Choice ();
        dbluetext = new Choice ();
        dgreentext = new Choice ();
        dwhitetext = new Choice ();
        dpinktext  = new Choice ();

        pyellowtext.move (COLUMNWIDTH+90+2*INITXPOS+LABELWIDTH, INITYPOS+3*ROWHEIGHT);
        predtext.move (COLUMNWIDTH+90+2*INITXPOS+LABELWIDTH, INITYPOS+4*ROWHEIGHT);
        pbluetext.move (COLUMNWIDTH+90+2*INITXPOS+LABELWIDTH, INITYPOS+5*ROWHEIGHT);
        pgreentext.move (COLUMNWIDTH+90+2*INITXPOS+LABELWIDTH, INITYPOS+6*ROWHEIGHT);
        pwhitetext.move (COLUMNWIDTH+90+2*INITXPOS+LABELWIDTH, INITYPOS+7*ROWHEIGHT);
        ppinktext.move (COLUMNWIDTH+90+2*INITXPOS+LABELWIDTH, INITYPOS+8*ROWHEIGHT);
        pdyellowtext.move (COLUMNWIDTH+290+2*INITXPOS+LABELWIDTH, INITYPOS+3*ROWHEIGHT);
        pdredtext.move (COLUMNWIDTH+290+2*INITXPOS+LABELWIDTH, INITYPOS+4*ROWHEIGHT);
        pdbluetext.move (COLUMNWIDTH+290+2*INITXPOS+LABELWIDTH, INITYPOS+5*ROWHEIGHT);
        pdgreentext.move (COLUMNWIDTH+290+2*INITXPOS+LABELWIDTH, INITYPOS+6*ROWHEIGHT);
        pdwhitetext.move (COLUMNWIDTH+290+2*INITXPOS+LABELWIDTH, INITYPOS+7*ROWHEIGHT);
        pdpinktext.move (COLUMNWIDTH+290+2*INITXPOS+LABELWIDTH, INITYPOS+8*ROWHEIGHT);

        pyellowtext.resize (width, textheight);
        predtext.resize (width, textheight);
        pbluetext.resize (width, textheight);
        pgreentext.resize (width, textheight);
        pwhitetext.resize (width, textheight);
        ppinktext.resize (width, textheight);
        pdyellowtext.resize (width, textheight);
        pdredtext.resize (width, textheight);
        pdbluetext.resize (width, textheight);
        pdgreentext.resize (width, textheight);
        pdwhitetext.resize (width, textheight);
        pdpinktext.resize (width, textheight);

        int field = -1;
        String colorstr = colorchoice.getSelectedItem ();
        if (colorstr != null)
            for (int i=0; i<database.fieldcount; i++)
                if (colorstr.equals (database.fieldname[i])) {
                    field = i;
                    break;
                    }
        
        String list [] = new String [database.reccount];
        int listcount = 0;
        if (field >= 0)
            for (int i=0; i<database.reccount; i++) {
                String value = database.stringValue (i, field);
               boolean found = false;
                for (int j=0; j<listcount; j++)
                    if (list[j].equals (value)) {
                        found = true;
                        break;
                        }
                if (! found)
                    list[listcount++] = new String (value);
                }
        
        yellowtext.addItem ("- N/A -");
        redtext.addItem ("- N/A -");
        bluetext.addItem ("- N/A -");
        greentext.addItem ("- N/A -");
        whitetext.addItem ("- N/A -");
        pinktext.addItem ("- N/A -");
        dyellowtext.addItem ("- N/A -");
        dredtext.addItem ("- N/A -");
        dbluetext.addItem ("- N/A -");
        dgreentext.addItem ("- N/A -");
        dwhitetext.addItem ("- N/A -");
        dpinktext.addItem ("- N/A -");

        for (int i=0; i<listcount; i++) {
            yellowtext.addItem (list[i]);
            redtext.addItem (list[i]);
            bluetext.addItem (list[i]);
            greentext.addItem (list[i]);
            whitetext.addItem (list[i]);
            pinktext.addItem (list[i]);
            dyellowtext.addItem (list[i]);
            dredtext.addItem (list[i]);
            dbluetext.addItem (list[i]);
            dgreentext.addItem (list[i]);
            dwhitetext.addItem (list[i]);
            dpinktext.addItem (list[i]);
            }

        pyellowtext.add (yellowtext);
        predtext.add (redtext);
        pbluetext.add (bluetext);
        pgreentext.add (greentext);
        pwhitetext.add (whitetext);
        ppinktext.add (pinktext);
        pdyellowtext.add (dyellowtext);
        pdredtext.add (dredtext);
        pdbluetext.add (dbluetext);
        pdgreentext.add (dgreentext);
        pdwhitetext.add (dwhitetext);
        pdpinktext.add (dpinktext);
        }


    public synchronized boolean handleEvent (Event event) {
        if (event.id != Event.ACTION_EVENT)
            return false ;

        if (event.target == colorchoice) {
            getColorList ();
            return true;
            }
        
        if ("Cancel".equals (event.arg)) {
            plotter.active = true;
            dispose ();
            }


        if ("OK".equals (event.arg) || "Apply".equals (event.arg)) {
            String xstr = xchoice.getSelectedItem ();
            String ystr = ychoice.getSelectedItem ();
            String zstr = zchoice.getSelectedItem ();
            String sizestr = sizechoice.getSelectedItem ();
            String colorstr = colorchoice.getSelectedItem ();

            if ((xstr.equals (ystr) && ! xstr.equals ("None")) ||
                (ystr.equals (zstr) && ! ystr.equals ("None")) ||
                (zstr.equals (sizestr) && ! zstr.equals ("None")) ||
                (sizestr.equals (xstr) && ! sizestr.equals ("None")) ||
                (sizestr.equals (ystr) && ! sizestr.equals ("None")) ||
                (xstr.equals (zstr) && ! xstr.equals ("None"))) {
                error1.setText ("X/Y/Z/Size choices");
                error2.setText ("cannot be identical.");
                return true;
                }

            int x=-1, y=-1, z=-1;
            int size=-1;
            int color=-1;

            for (int i=0; i<database.fieldcount; i++) {
                String name = database.fieldname [i];
                if (name.equals (xstr))      x=i;
                if (name.equals (ystr))      y=i;
                if (name.equals (zstr))      z=i;
                if (name.equals (sizestr))   size=i;
                if (name.equals (colorstr))  color=i;
                }

            Color defcolor;
            switch (defcolchoice.getSelectedIndex ()) {
                case 0:  defcolor = Color.yellow; break;
                case 1:  defcolor = Color.red;    break;
                case 2:  defcolor = Color.blue;   break;
                case 3:  defcolor = Color.green;  break;
                case 4:  defcolor = Color.white;  break;
                case 5:  defcolor = Color.pink;   break;
                default: defcolor = Color.yellow;
                }


            Hashtable colorhash = new Hashtable ();
            String colorvalue [] = new String [12];
            
            String yellowstr = colorvalue [0] = yellowtext.getSelectedItem ();
            String redstr = colorvalue [1] = redtext.getSelectedItem ();
            String bluestr = colorvalue [2] = bluetext.getSelectedItem ();
            String greenstr = colorvalue [3] = greentext.getSelectedItem ();
            String whitestr = colorvalue [4] = whitetext.getSelectedItem ();
            String pinkstr = colorvalue [5] = pinktext.getSelectedItem ();
            String dyellowstr = colorvalue [6] = dyellowtext.getSelectedItem ();
            String dredstr = colorvalue [7] = dredtext.getSelectedItem ();
            String dbluestr = colorvalue [8] = dbluetext.getSelectedItem ();
            String dgreenstr = colorvalue [9] = dgreentext.getSelectedItem ();
            String dwhitestr = colorvalue [10] = dwhitetext.getSelectedItem ();
            String dpinkstr = colorvalue [11] = dpinktext.getSelectedItem ();


            for (int i=0; i<11; i++) {
                if (colorvalue[i].equals ("- N/A -"))
                    continue;
                for (int j=i+1; j<12; j++) {
                    if (colorvalue[j].equals ("- N/A -"))
                        continue;
                    if (colorvalue[i].equals (colorvalue[j])) {
                        error1.setText ("Error: Distinct colors");
                        error2.setText ("for the same string.");
                        return true;
                        }
                    }
                }


            if (! yellowstr.equals ("- N/A -"))
                colorhash.put (yellowstr, Color.yellow);
            if (! redstr.equals ("- N/A -"))
                colorhash.put (redstr, Color.red);
            if (! bluestr.equals ("- N/A -"))
                colorhash.put (bluestr, Color.blue);
            if (! greenstr.equals ("- N/A -"))
                colorhash.put (greenstr, Color.green);
            if (! whitestr.equals ("- N/A -"))
                colorhash.put (whitestr, Color.white);
            if (! pinkstr.equals ("- N/A -"))
                colorhash.put (pinkstr, Color.pink);
            if (! dyellowstr.equals ("- N/A -"))
                colorhash.put (dyellowstr, Color.yellow.darker ().darker ());
            if (! dredstr.equals ("- N/A -"))
                colorhash.put (dredstr, Color.red.darker ().darker ());
            if (! dbluestr.equals ("- N/A -"))
                colorhash.put (dbluestr, Color.blue.darker ().darker ());
            if (! dgreenstr.equals ("- N/A -"))
                colorhash.put (dgreenstr, Color.green.darker ().darker ());
            if (! dwhitestr.equals ("- N/A -"))
                colorhash.put (dwhitestr, Color.white.darker ().darker ());
            if (! dpinkstr.equals ("- N/A -"))
                colorhash.put (dpinkstr, Color.pink.darker ().darker ());

            
            
            float minx = 0.0f,   maxx = 0.0f;
            float miny = 0.0f,   maxy = 0.0f;
            float minz = 0.0f,   maxz = 0.0f;
            float minsize = 0.0f;
            float maxsize = 0.0f;
            
            String minxstr = minxtext.getText ();
            String minystr = minytext.getText ();
            String minzstr = minztext.getText ();
            String minsizestr = minsizetext.getText ();
            String maxxstr = maxxtext.getText ();
            String maxystr = maxytext.getText ();
            String maxzstr = maxztext.getText ();
            String maxsizestr = maxsizetext.getText ();
            
            if (minxstr.length () != 0)
                minx = Float.valueOf (minxstr).floatValue ();
            if (minystr.length () != 0)
                miny = Float.valueOf (minystr).floatValue ();
            if (minzstr.length () != 0)
                minz = Float.valueOf (minzstr).floatValue ();
            if (minsizestr.length () != 0)
                minsize = Float.valueOf (minsizestr).floatValue ();
            if (maxxstr.length () != 0)
                maxx = Float.valueOf (maxxstr).floatValue ();
            if (maxystr.length () != 0)
                maxy = Float.valueOf (maxystr).floatValue ();
            if (maxzstr.length () != 0)
                maxz = Float.valueOf (maxzstr).floatValue ();
            if (maxsizestr.length () != 0)
                maxsize = Float.valueOf (maxsizestr).floatValue ();
            
            
            if (minx > maxx || miny > maxy || minz > maxz) {
                error1.setText ("Error: Min/Max values");
                error2.setText ("for scale don't match.");
                return true;
                }
            
            Mapper mapper = new Mapper (x, y, z, size,
                color, defcolor, 
                minx, maxx, miny, maxy, minz, maxz, minsize, maxsize,
                colorhash);

            mapper.rescale (database, 
                minxstr.length () == 0 && maxxstr.length () == 0,
                minystr.length () == 0 && maxystr.length () == 0,
                minzstr.length () == 0 && maxzstr.length () == 0,
                minsizestr.length () == 0 && maxsizestr.length () == 0);
            plotter.setData (mapper);

            LegendBox.setColor (colorvalue);
        }


        if ("OK".equals (event.arg)) {
            plotter.active = true;
            dispose ();
            }

        return true ;
    }
}
