/*
		A basic implementation of the JDialog class.
*/

import java.awt.*;
import java.io.*;
import javax.swing.*;
import com.symantec.itools.javax.swing.borders.BevelBorder;

public class PMSdialog extends javax.swing.JDialog
{
    error_dialog error_diag = null;
    PMSframe pms_frame = null;
    tunerlib tlib = null;
    
	public PMSdialog(Frame parent)
	{
		super(parent);
		
		// This code is automatically generated by Visual Cafe when you add
		// components to the visual environment. It instantiates and initializes
		// the components. To modify the code, only use code syntax that matches
		// what Visual Cafe can generate, or Visual Cafe may be unable to back
		// parse your Java file into its visual environment.
		//{{INIT_CONTROLS
		getContentPane().setLayout(null);
		setSize(335,166);
		setVisible(false);
		JTextField1.setText("Select COM port for access to the PMS");
		JTextField1.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
		JTextField1.setEnabled(false);
		getContentPane().add(JTextField1);
		JTextField1.setBackground(new java.awt.Color(204,204,204));
		JTextField1.setBounds(24,16,288,40);
		port_list.addItem("Choose port");
		port_list.addItem("COM 1");
		port_list.addItem("COM 2");
		port_list.addItem("COM 3");
		port_list.addItem("COM 4");
		try {
			port_list.select(0);
		}
		catch (IllegalArgumentException e) { }
		getContentPane().add(port_list);
		port_list.setBounds(24,72,100,25);
		start_log.setText("Ok");
		start_log.setActionCommand("Ok");
		start_log.setBorder(bevelBorder1);
		getContentPane().add(start_log);
		start_log.setBounds(160,72,64,32);
		//$$ bevelBorder1.move(8,168);
		cancel_button.setText("Cancel");
		cancel_button.setActionCommand("Cancel");
		cancel_button.setBorder(bevelBorder1);
		getContentPane().add(cancel_button);
		cancel_button.setBounds(248,72,64,32);
		eeprom_status.setEditable(false);
		eeprom_status.setEnabled(false);
		getContentPane().add(eeprom_status);
		eeprom_status.setBounds(24,128,288,24);
		//}}
	
		//{{REGISTER_LISTENERS
		SymMouse aSymMouse = new SymMouse();
		cancel_button.addMouseListener(aSymMouse);
		start_log.addMouseListener(aSymMouse);
		//}}
	}

	public PMSdialog()
	{
		this((Frame)null);
	}

	public PMSdialog(String sTitle)
	{
		this();
		setTitle(sTitle);
	}

	public void setVisible(boolean b)
	{
		super.setVisible(b);
		eeprom_status.setText("Choose the com port & click 'OK'");
	}

	static public void main(String args[])
	{
		(new PMSdialog()).setVisible(true);
	}

	public void addNotify()
	{
		// Record the size of the window prior to calling parents addNotify.
		Dimension size = getSize();

		super.addNotify();

		if (frameSizeAdjusted)
			return;
		frameSizeAdjusted = true;

		// Adjust size of frame according to the insets
		Insets insets = getInsets();
		setSize(insets.left + insets.right + size.width, insets.top + insets.bottom + size.height);
	}

	// Used by addNotify
	boolean frameSizeAdjusted = false;

	//{{DECLARE_CONTROLS
	javax.swing.JTextField JTextField1 = new javax.swing.JTextField();
	java.awt.Choice port_list = new java.awt.Choice();
	javax.swing.JButton start_log = new javax.swing.JButton();
	com.symantec.itools.javax.swing.borders.BevelBorder bevelBorder1 = new com.symantec.itools.javax.swing.borders.BevelBorder();
	javax.swing.JButton cancel_button = new javax.swing.JButton();
	java.awt.TextField eeprom_status = new java.awt.TextField();
	//}}


	class SymMouse extends java.awt.event.MouseAdapter
	{
		public void mouseClicked(java.awt.event.MouseEvent event)
		{
			Object object = event.getSource();
			if (object == cancel_button)
				cancelButton_mouseClicked(event);
			else if (object == start_log)
				startLog_mouseClicked(event);
		}
	}

	void cancelButton_mouseClicked(java.awt.event.MouseEvent event)
	{
		// to do: code goes here.
		port_list.select(1);
		try {
			setVisible(false);
		} catch (java.lang.Exception e) {
		}
	}

	void startLog_mouseClicked(java.awt.event.MouseEvent event)
	{
		// to do: code goes here.
			 
		start_log_mouseClicked_Interaction1(event);
	}

	void start_log_mouseClicked_Interaction1(java.awt.event.MouseEvent event)
	{
		// to do: code goes here
	    int rc = 0;
	    int hex_address = 0x00;
	    int hex_value = 0x00;
	    byte e2p_file[] = new byte[10000];
        File ef1 = null;                             // work file
        RandomAccessFile ef1x = null;
        String address_string = "0x0000";
        byte address_bytes[] = new byte[4];
        int x = 0;
        
        // work file

		if (this.port_list.getSelectedIndex() == 0)
		    {
		        error_rtn("No COM port selected!");
                return;		        
		    }
		    
		if (tlib == null)
		  tlib = new tunerlib();
		  
		// call routine to process pms eeprom (read)
		
		rc = tlib.getPMS(this.port_list.getSelectedIndex() - 1, 1, 0, 0);
		if (rc != 0)
		  {
		    // pms comm error
		    error_rtn("PMS access error: " + Integer.toString(rc));
		    return;
		  }
		  
		// open temp.bcf - if too short, error & delete
        try
        {
		    ef1 = new File(System.getProperty("user.dir"), "temp.bcf");
		    ef1x = new RandomAccessFile(ef1, "r");
		    if (ef1x.length() < 18430)
		    {
		        ef1x.close();
		        error_rtn("EEprom download incomplete!");
		        return;
		    }
		    do
		    {
		        // read address
		        address_string = "" + (char)ef1x.readByte() + (char)ef1x.readByte() + (char)ef1x.readByte() + (char)ef1x.readByte();
                try
                {
                    hex_address = Integer.parseInt(address_string, 16) - 0xa000;
                }
                catch (Exception e)
                {
                }
                x = 0;
                do
                {
                    address_string = "" + (char)ef1x.readByte() + (char)ef1x.readByte();
                    try
                    {
                        e2p_file[hex_address + x] = (byte)Integer.parseInt(address_string, 16);
                    }
                    catch (Exception e)
                    {
                    }
                        ++ x;
                }
                while (x <= 15);
		    }
		    while (ef1x.getFilePointer() < 18429);
		    ef1x.close();
		    ef1 = new File(System.getProperty("user.dir"), "tmp.e2p");
		    ef1x = new RandomAccessFile(ef1, "rw");
		    x = 0;
		    do
		    {
		        ef1x.writeByte(e2p_file[x]);
		        ++ x;
		    }
		    while (x + 0xa000 < 0xbfff);
		    ef1x.close();
		    pms_frame.pms_config_dir = System.getProperty("user.dir");
		    pms_frame.pms_config_file = "\\tmp.e2p";
		    pms_frame.recall_data();
		    pms_frame.display_pgm();
		    
		}
		catch(IOException ioe)
		{
		    error_rtn("Unable to process eeprom download: " + ioe);
		    return;
		}
		// reformat to tnt.e2p
		// delete temp.bcf
		// load txt.e2p
		try {
			setVisible(false);
		} catch (java.lang.Exception e) {
		}
	}
	void error_rtn(String em)
	{
		try {
			// record_dialog Create and show as non-modal
			if (error_diag == null)
			error_diag = new error_dialog();
			error_diag.error_field.setText(em);
			error_diag.setVisible(true);
		} catch (java.lang.Exception e) {
		}
	}
}