//import java.applet.Applet;
import java.awt.*;

public class Plotter extends Panel implements CheckerClient, SliderClient, ButtonClient {

    private ImageButton   xviewbutton;
    private ImageButton   yviewbutton;
    private ImageButton   zviewbutton;
    private Checker       zoomchecker;
    private Slider        xratioslider;
    private Slider        yratioslider;
    private Slider        zratioslider;
    private Checker       transchecker;
    private Checker       gridchecker;
    private Wheel         xwheel;
    private Wheel         ywheel;
    private ImageButton   aboutbutton;
    private ImageButton   optionbutton;
    private ImageButton   openbutton;
    private ImageButton   filterbutton;
    private ImageButton   animatebutton;
    private LegendBox     legend;
    private boolean       zoommode;
//    private FileList      filelist;
    private InfoLine      infoline;

    public  boolean       active;
    public  Database      original;
    public  Database      database;
    private Mapper        mapper;
    public  PlotView      view;





    Plotter (int w, int h) {
        setLayout (null);
        resize (w, h);
        setBackground (Color.lightGray);

        active = true;
        zoommode = false;

        int xctlsize = 35;
        int yctlsize = 30;
        int LEGENDWIDTH = 150;
        int width = w-LEGENDWIDTH;
        int height = h;

        legend = new LegendBox ();
        add (legend);
        legend.move (0, 0);

        infoline = new InfoLine ();
        add (infoline);
        int infosize = infoline.size ().height;
        infoline.move (LEGENDWIDTH, height-infosize);

        view = new PlotView (this, width-yctlsize, height-xctlsize-infosize);
        add (view);
        view.move (LEGENDWIDTH+0, 0);

//        ywheel = new Wheel (Wheel.VERTICAL, 140, view);
//        add (ywheel);
//        ywheel.move (LEGENDWIDTH+width-25, height-xctlsize-145-infosize);

//        xwheel = new Wheel (Wheel.HORIZONTAL, 140, view);
//        add (xwheel);
//        xwheel.move (LEGENDWIDTH+width-yctlsize-120+4, height-28-infosize);

//        Image masterimage = getImage ("master.gif");
//        optionbutton = new ImageButton (masterimage,
//                                        0, 60, 20, 20,
//                                        "Set X/Y/Z axes, colors and other visualization options.",
//                                        "options", this);
//        add (optionbutton);
//        optionbutton.move (LEGENDWIDTH+width-yctlsize-145-75+23, height-28-infosize);


//        aboutbutton = new ImageButton (masterimage,
//                                       40, 60, 20, 20,
//                                       "Copyright and author information.",
//                                       "about", this);
//        add (aboutbutton);
//        aboutbutton.move (LEGENDWIDTH+width-yctlsize-145-75+23+23, height-28-infosize);

//        xviewbutton = new ImageButton (masterimage, 0,  0, 20, 20, "Project along X axis.", "xview", view);
//        yviewbutton = new ImageButton (masterimage, 0, 20, 20, 20, "Project along Y axis.", "yview", view);
//        zviewbutton = new ImageButton (masterimage, 0, 40, 20, 20, "Project along Z axis.", "zview", view);
//        add (xviewbutton);
//        add (yviewbutton);
//        add (zviewbutton);
//        xviewbutton.move (LEGENDWIDTH+width-25, 5);
//        yviewbutton.move (LEGENDWIDTH+width-25, 27);
//        zviewbutton.move (LEGENDWIDTH+width-25, 49);


//        filterbutton = new ImageButton (masterimage, 80, 0, 20, 20,
//                                        "Perform data filtration.",
//                                        "filter", this);
//        add (filterbutton);
//        filterbutton.move (LEGENDWIDTH+width-yctlsize-145-75-23, height-28-infosize);

//        openbutton = new ImageButton (masterimage, 40, 40, 20, 20,
//                                     "Open a database to visualize", "open", this);
//        add (openbutton);
//        openbutton.move (LEGENDWIDTH+width-yctlsize-145-75-23-23, height-28-infosize);
//
//        animatebutton = new ImageButton (masterimage, 80, 20, 20, 20,
//                                        "Open the animation panel.",
//                                        "animate", this);
//        add (animatebutton);
//        animatebutton.move (LEGENDWIDTH+width-yctlsize-145-75, height-28-infosize);


//        zoomchecker = new Checker (masterimage, 0, 80, 20, 28, false,
//                                  "Switch the current zoom mode.",
//                                  "zoom", this);
//        xratioslider = new Slider (70, 0.5f, 2.0f, 1.0f, "xratio", this);
//        yratioslider = new Slider (70, 0.5f, 2.0f, 1.0f, "yratio", this);
//        zratioslider = new Slider (70, 0.5f, 2.0f, 1.0f, "zratio", this);
//        add (xratioslider);
//        add (yratioslider);
//        add (zratioslider);
//        add (zoomchecker);
//        zoomchecker.move (LEGENDWIDTH+5, height-xctlsize+3-infosize);
//        xratioslider.move (LEGENDWIDTH+27, height-xctlsize+3-infosize);
//        yratioslider.move (LEGENDWIDTH+27, height-xctlsize+13-infosize);
//        zratioslider.move (LEGENDWIDTH+27, height-xctlsize+23-infosize);


//        transchecker = new Checker (masterimage, 40, 0, 20, 20, true,
//                                    "Switch opaque coordinate plane on/off.",
///                                    "transparency", view);
//        gridchecker = new Checker (masterimage, 40, 20, 20, 20, false,
//                                    "Switch grid on/off.",
//                                    "grid", view);
//        add (transchecker);
//        add (gridchecker);
//        transchecker.move (LEGENDWIDTH+width-25, 100-infosize);
//        gridchecker.move (LEGENDWIDTH+width-25, 122-infosize);
    }



//    public boolean setList (FileList filelist) {
//        this.filelist = filelist;
//        return true;
//    }



    public boolean loadData (int index) {
        try {
//            original = new Database (PlotApp.applet.getCodeBase (),
//                                     filelist.url (index));
              original = new Database();
        } catch (Exception e) {return false;}
        database = original;
        mapper = new Mapper (database);
        return true;
    }


    public boolean loadData (Database db) {
        database = db;
        return true;
    }


    public boolean setData (boolean remap) {
        return view.setData (database, mapper, remap);
    }


    public boolean setData (Mapper mapper) {
        this.mapper = mapper;
        return view.setData (database, mapper, true);
    }


    public void zoom_rtn(int value)
    {
        float ratio;

            ratio = (float)value / 10;
            view.setXRatio (ratio);
            view.setYRatio (ratio);
            view.setZRatio (ratio);
            view.setView ();
            view.repaint ();
    }
    
    public void onSliderMotion (Slider slider, float value) {
        float ratio;

        if ("xratio".equals (slider.text)) {
            ratio = value;
            view.setXRatio (ratio);
            if (! zoommode) {
                view.setYRatio (ratio);
                view.setZRatio (ratio);
                yratioslider.set (ratio);
                zratioslider.set (ratio);
                }
            view.setView ();
            view.repaint ();
            }

        if ("yratio".equals (slider.text)) {
            ratio = value;
            view.setYRatio (ratio);
            if (! zoommode) {
                view.setXRatio (ratio);
                view.setZRatio (ratio);
                xratioslider.set (ratio);
                zratioslider.set (ratio);
                }
            view.setView ();
            view.repaint ();
            }

        if ("zratio".equals (slider.text)) {
            ratio = value;
            view.setZRatio (ratio);
            if (! zoommode) {
                view.setYRatio (ratio);
                view.setXRatio (ratio);
                xratioslider.set (ratio);
                yratioslider.set (ratio);
                }
            view.setView ();
            view.repaint ();
            }

        return;
    }



    public void onCheckerClick (Checker checker, boolean checked) {
        if ("zoom".equals (checker.text))
            zoommode = checked;
        return;
    }




    public void onButtonClick (ImageButton button) {
//        if ("open".equals (button.text) && active) {
//            active = false;
//            OpenBox openbox = new OpenBox (view, this);
//            openbox.show ();
//            }

//        if ("filter".equals (button.text) && active) {
//            active = false;
//            FilterBox filterbox = new FilterBox (this, original);
//            filterbox.show ();
//            }

//        if ("options".equals (button.text) && active) {
//            active = false;
//            OptionBox optionbox = new OptionBox (this, original);
//            optionbox.show ();
//            }

//        if ("about".equals (button.text) && active) {
//            AboutBox aboutbox = new AboutBox ();
//            aboutbox.show ();
//            }

//        if ("animate".equals (button.text) && active) {
//            active = false;
//            AniBox anibox = new AniBox (this, database);
//            anibox.show ();
//            }

    }

    public void ShowFilterBox()
    {
              active = false;
              FilterBox filterbox = new FilterBox (this, original);
              filterbox.show ();
    }

    public void ShowOptionBox()
    {
              active = false;
              OptionBox optionbox = new OptionBox (this, original);
              optionbox.show ();
    }
}
