import java.awt.*;


public class Slider extends Canvas {

    private static Image image = null;
    private int          size;
    private int          motionsize;
    private boolean      pressed;
    private float        min;
    private float        max;
    private int          pos;
    public  String       text;
    private SliderClient client;



    Slider (int slidersize, float minv, float maxv, float initv,
            String slidertext, SliderClient sliderclient) {

//        if (image == null)
//            image = CHART3Dframe.ireader.getimage ("slider.gif");
        min   = minv;
        max   = maxv;
        size  = slidersize;
        motionsize = slidersize - 10 - 13;
        pos   = (int) ((initv-minv) / (maxv-minv) * motionsize);
        pressed = false;
        text = slidertext;
        client = sliderclient;
        resize (size, 8);
    }



    public void paint (Graphics graph) {
        update (graph);
        return;
    }


    public synchronized void update (Graphics graph) {
        graph.setColor (Color.lightGray);
        graph.fillRect (0, 0, size, 8);

        Graphics clipgraph;
        clipgraph = graph.create (0, 0, 4, 8);
        clipgraph.drawImage (image, 0, 0, null);
        clipgraph = graph.create (size-4, 0, 4, 8);
        clipgraph.drawImage (image, 0, 0, null);

        graph.setColor (Color.darkGray);
        graph.drawLine (5, 3, size-6, 3);
        graph.setColor (Color.white);
        graph.drawLine (5, 4, size-6, 4);

        clipgraph = graph.create (5 + pos, 0, 13, 8);
        clipgraph.drawImage (image, -4, 0, null);
    }





    public boolean mouseDown (Event event, int x, int y) {
        if (x >= size || y >= 8 || x<0 || y<0)
            return true;
        if (x < 5+pos || x >=5+13+pos)
            return true;

        pressed = true;
        return true;
    }



    public boolean mouseDrag (Event event, int x, int y) {
        if (! pressed)
            return true;
        if (x < 5 || x > size-18)
            return true;
        pos = x-5;
        repaint ();
        client.onSliderMotion (this,
            ((float)pos/(float)motionsize) * (max-min) + min);
        return true;
    }



    public boolean mouseUp (Event event, int x, int y) {
        if (! pressed)
            return false;
        pressed = false;
        return true;
    }



    public void set (float value) {
        pos = (int) ((value-min) / (max-min) * motionsize);
        repaint ();
    }

}


