/*
	This simple extension of the java.awt.Frame class
	contains all the elements necessary to act as the
	main window of an application.
 */

import java.awt.*;
import symantec.itools.awt.util.ToolBarPanel;
import javax.swing.JPopupMenu;
import javax.swing.JToolBar;
import symantec.itools.awt.StatusBar;
import javax.swing.JTextField;
import javax.swing.JButton;
import java.io.*;
import com.symantec.itools.javax.swing.borders.BevelBorder;

public class TunerStein extends Frame
{
    PLAYframe play_diag = null;
    control_dialog control_diag = null;
    error_dialog error_diag = null;

    AFCframe1 afc_frame = null;
    AFCframe2 afc2_frame = null;
    ITCframe1 itc_frame = null;
    PMSframe  pms_frame = null;
    
    String afc1_config_file = null;
    String afc2_config_file = null;
    String itc_config_file = null;
    String pms_config_file = null;
    String main_config_file = "tnt.cfg";
    
    String afc1_config_dir = null;
    String afc2_config_dir = null;
    String itc_config_dir = null;
    String pms_config_dir = null;
    int    window_height  = 0;
    int    window_width   = 0;
    int    window_x       = 0;
    int    window_y       = 0;
    
	public TunerStein()
	{
		// This code is automatically generated by Visual Cafe when you add
		// components to the visual environment. It instantiates and initializes
		// the components. To modify the code, only use code syntax that matches
		// what Visual Cafe can generate, or Visual Cafe may be unable to back
		// parse your Java file into its visual environment.
		
		//{{INIT_CONTROLS
		setLayout(null);
		setBackground(new java.awt.Color(204,204,204));
		setFont(new Font("Dialog", Font.PLAIN, 12));
		setSize(291,86);
		setVisible(false);
		JButton1.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
		JButton1.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
		JButton1.setText("Controls");
		JButton1.setActionCommand("Controls");
		JButton1.setAutoscrolls(true);
		JButton1.setBorder(bevelBorder1);
		JButton1.setToolTipText("Define fuel/timing controllers");
		JButton1.setEnabled(false);
		add(JButton1);
		JButton1.setBackground(java.awt.Color.red);
		JButton1.setFont(new Font("Dialog", Font.PLAIN, 11));
		JButton1.setBounds(132,12,48,60);
		JButton1.setVisible(false);
		//$$ bevelBorder1.move(24,312);
		JButton2.setText("Player");
		JButton2.setActionCommand("Play");
		JButton2.setBorder(bevelBorder2);
		JButton2.setToolTipText("Play back recorded log files");
		add(JButton2);
		JButton2.setBackground(java.awt.Color.green);
		JButton2.setFont(new Font("Dialog", Font.PLAIN, 12));
		JButton2.setBounds(24,12,240,60);
		//$$ bevelBorder2.move(48,312);
		JButton3.setText("Record");
		JButton3.setActionCommand("Record");
		JButton3.setBorder(bevelBorder3);
		JButton3.setToolTipText("Choose data logging sources");
		JButton3.setEnabled(false);
		add(JButton3);
		JButton3.setFont(new Font("Dialog", Font.PLAIN, 12));
		JButton3.setBounds(216,12,48,60);
		JButton3.setVisible(false);
		//$$ bevelBorder3.move(72,312);
		fileDialog1.setMode(FileDialog.LOAD);
		fileDialog1.setTitle("Open");
		//$$ fileDialog1.move(24,312);
		setTitle("TunerStein Player (c) Hal Landry");
		setResizable(false);
		//}}
		
		//{{INIT_MENUS
		//}}
		
		//{{REGISTER_LISTENERS
		SymWindow aSymWindow = new SymWindow();
		this.addWindowListener(aSymWindow);
		SymAction lSymAction = new SymAction();
		SymMouse aSymMouse = new SymMouse();
		JButton3.addMouseListener(aSymMouse);
		JButton2.addActionListener(lSymAction);
		JButton1.addActionListener(lSymAction);
		JButton3.addActionListener(lSymAction);
		JButton2.addMouseListener(aSymMouse);
		//}}
		apply_cfg();
	}
	
	public TunerStein(String title)
	{
		this();
		setTitle(title);
	}
	
    /**
     * Shows or hides the component depending on the boolean flag b.
     * @param b  if true, show the component; otherwise, hide the component.
     * @see java.awt.Component#isVisible
     */
    public void setVisible(boolean b)
	{
		super.setVisible(b);
	}
	
	static public void main(String args[])
	{
		try
		{
			//Create a new instance of our application's frame, and make it visible.
    		(new TunerStein()).setVisible(true);
		}
		catch (Throwable t)
		{
			System.err.println(t);
			t.printStackTrace();
			//Ensure the application exits with an error condition.
			System.exit(1);
		}
	}
	
	public void addNotify()
	{
		// Record the size of the window prior to calling parents addNotify.
		Dimension d = getSize();
		
		super.addNotify();
	
		if (fComponentsAdjusted)
			return;
	
		// Adjust components according to the insets
		setSize(getInsets().left + getInsets().right + d.width, getInsets().top + getInsets().bottom + d.height);
		Component components[] = getComponents();
		for (int i = 0; i < components.length; i++)
		{
			Point p = components[i].getLocation();
			p.translate(getInsets().left, getInsets().top);
			components[i].setLocation(p);
		}
		fComponentsAdjusted = true;
	}
	
	// Used for addNotify check.
	boolean fComponentsAdjusted = false;
	
	//{{DECLARE_CONTROLS
	javax.swing.JButton JButton1 = new javax.swing.JButton();
	com.symantec.itools.javax.swing.borders.BevelBorder bevelBorder1 = new com.symantec.itools.javax.swing.borders.BevelBorder();
	javax.swing.JButton JButton2 = new javax.swing.JButton();
	com.symantec.itools.javax.swing.borders.BevelBorder bevelBorder2 = new com.symantec.itools.javax.swing.borders.BevelBorder();
	javax.swing.JButton JButton3 = new javax.swing.JButton();
	com.symantec.itools.javax.swing.borders.BevelBorder bevelBorder3 = new com.symantec.itools.javax.swing.borders.BevelBorder();
	java.awt.FileDialog fileDialog1 = new java.awt.FileDialog(this);
	//}}
	
	//{{DECLARE_MENUS
	//}}
	
	class SymWindow extends java.awt.event.WindowAdapter
	{
		public void windowClosing(java.awt.event.WindowEvent event)
		{
			Object object = event.getSource();
			if (object == TunerStein.this)
				TunerStein_WindowClosing(event);
		}
	}
	
	void TunerStein_WindowClosing(java.awt.event.WindowEvent event)
	{
		// to do: code goes here.
			 
		TunerStein_WindowClosing_Interaction1(event);
	}


	void TunerStein_WindowClosing_Interaction1(java.awt.event.WindowEvent event)
	{
	    record_cfg();
	    this.dispose();                  // Free system resources
		System.exit(0);             // close the application
	}

	
	class SymAction implements java.awt.event.ActionListener
	{
		public void actionPerformed(java.awt.event.ActionEvent event)
		{
			Object object = event.getSource();
			if (object == JButton2)
				JButton2_actionPerformed(event);
			else if (object == JButton1)
				JButton1_actionPerformed(event);
			else if (object == JButton3)
				JButton3_actionPerformed(event);
			
			
			
		}
	}

	class SymMouse extends java.awt.event.MouseAdapter
	{
		public void mouseClicked(java.awt.event.MouseEvent event)
		{
			Object object = event.getSource();
			if (object == JButton3)
				JButton3_mouseClicked(event);
			else if (object == JButton2)
				JButton2_mouseClicked(event);
		}

		public void mouseExited(java.awt.event.MouseEvent event)
		{
			
			
		}

		public void mouseEntered(java.awt.event.MouseEvent event)
		{
			
			
		}
	}

	void JButton3_mouseClicked(java.awt.event.MouseEvent event)
	{
		// to do: code goes here.
	}

	void JButton2_actionPerformed(java.awt.event.ActionEvent event)
	{
		// to do: code goes here.
	}

	void JButton1_actionPerformed(java.awt.event.ActionEvent event)
	{
		// to do: code goes here.
			 
		JButton1_actionPerformed_Interaction1(event);
	}

	void JButton3_actionPerformed(java.awt.event.ActionEvent event)
	{
		// to do: code goes here.
	}

	void JButton1_actionPerformed_Interaction1(java.awt.event.ActionEvent event)
	{
	    
		try {
			// control_dialog Create and show as non-modal
			if (control_diag == null)
			control_diag = new control_dialog(this, false);
			if (play_diag != null)
			{
			    control_diag.afc_frame = play_diag.afc_frame;
			    control_diag.itc_frame = play_diag.itc_frame;
			    control_diag.pms_frame = play_diag.pms_frame;
			    control_diag.afc2_frame = play_diag.afc2_frame;
			}   
			control_diag.afc1_config_file = afc1_config_file;
			control_diag.afc1_config_dir  = afc1_config_dir;
			control_diag.afc2_config_file = afc2_config_file;
			control_diag.afc2_config_dir  = afc2_config_dir;
			control_diag.itc_config_file  = itc_config_file;
			control_diag.itc_config_dir   = itc_config_dir;
			control_diag.pms_config_file  = pms_config_file;
			control_diag.pms_config_dir   = pms_config_dir;
			control_diag.setVisible(true);
		    afc1_config_file = control_diag.afc1_config_file;
		    afc1_config_dir  = control_diag.afc1_config_dir;
		    afc2_config_file = control_diag.afc2_config_file;
		    afc2_config_dir  = control_diag.afc2_config_dir;
		    itc_config_file  = control_diag.itc_config_file;
		    itc_config_dir   = control_diag.itc_config_dir;
		    pms_config_file  = control_diag.pms_config_file;
		    pms_config_dir   = control_diag.pms_config_dir;
		} catch (java.lang.Exception e) 
		{
		    error_rtn(e.getMessage());
		}
	}

	void JButton2_mouseClicked(java.awt.event.MouseEvent event)
	{
		// to do: code goes here.
			 
		JButton2_mouseClicked_Interaction1(event);
	}

	void JButton2_mouseClicked_Interaction1(java.awt.event.MouseEvent event)
	{
//	    error_rtn("10");
		try {
			// PLAYframe Create and show the PLAYframe
//			System.out.println("1");
			if (play_diag == null)
			    play_diag = new PLAYframe();
//			System.out.println("2");
			if (control_diag != null)
			{
			    play_diag.afc_frame = control_diag.afc_frame;
			    play_diag.afc2_frame = control_diag.afc2_frame;
			    play_diag.itc_frame = control_diag.itc_frame;
			    play_diag.pms_frame = control_diag.pms_frame;
			}
//			System.out.println("3");
			play_diag.setVisible(true);
		} catch (java.lang.Exception e) 
		{
//		    System.out.println("error " + e.getMessage());
		    error_rtn(e.getMessage());
		}
	}
	
	void apply_cfg()
	{
	    // main frame 0
	    // play frame 200
	    // control frame 400
	    // afc1 frame 600
	    // afc2 frame 800
	    // itc frame 1000
	    // pms frame 1200
	    
	    loading_diag ld = null;
	    
		try {
			// PLAYframe Create and show the PLAYframe
	    ld = new loading_diag(this);
	    ld.setVisible(true);
		} catch (java.lang.Exception e) 
		{
		    error_rtn(e.getMessage());
		}
	    File f = new File(System.getProperty("user.dir"), "tnt.cfg");
	    if (!f.exists())
	    {
	        record_cfg();
	    }
	    try
	    {
   	        RandomAccessFile rf = new RandomAccessFile(f, "rw");
   	        int x = 0;
   	        int y = 0;
   	        int h = 0;
   	        int w = 0;
   	        rf.seek(0);
   	        x = rf.readInt();
   	        y = rf.readInt();
            setLocation(x, y);
            rf.seek(400);
            if (rf.readBoolean())
            {
		        try {
			        // PLAYframe Create and show the PLAYframe
			        if (control_diag == null)
			            control_diag = new control_dialog(this, false);
		        } catch (java.lang.Exception e) 
		        {
		            error_rtn(e.getMessage());
		        }
		        x = rf.readInt();
		        y = rf.readInt();
		        control_diag.setLocation(x, y);
		        control_diag.setVisible(rf.readBoolean());
		        control_diag.afc_1.setSelected(rf.readBoolean());
		        control_diag.afc_2.setSelected(rf.readBoolean());
		        control_diag.itc.setSelected(rf.readBoolean());
		        control_diag.pms.setSelected(rf.readBoolean());
		        control_diag.afc_1.setEnabled(rf.readBoolean());
		        control_diag.afc_2.setEnabled(rf.readBoolean());
		        control_diag.itc.setEnabled(rf.readBoolean());
		        control_diag.pms.setEnabled(rf.readBoolean());
		        control_diag.afc2_mouseClicked(null);
		        control_diag.afc1_mouseClicked(null);
		        control_diag.itc_mouseClicked(null);
		        control_diag.pms_mouseClicked(null);
		    }
            rf.seek(600);
            byte fn[] = new byte[200];
            if (rf.readBoolean())
            {
		        try {
			        // PLAYframe Create and show the PLAYframe
			        if (afc_frame == null)
			            afc_frame = new AFCframe1();
		        } catch (java.lang.Exception e) 
		        {
		            error_rtn(e.getMessage());
		        }
		        x = rf.readInt();
		        y = rf.readInt();
		        afc_frame.setLocation(x, y);
		        afc_frame.setVisible(rf.readBoolean());
		        afc_frame.afc1_config_file = recall_string(rf);
                afc_frame.afc1_config_dir = recall_string(rf);
                afc_frame.recall_cfg1();
		    }
            rf.seek(800);
            if (rf.readBoolean())
            {
		        try {
			        // PLAYframe Create and show the PLAYframe
			        if (afc2_frame == null)
			            afc2_frame = new AFCframe2();
		        } catch (java.lang.Exception e) 
		        {
		            error_rtn(e.getMessage());    
		        }
		        x = rf.readInt();
		        y = rf.readInt();
		        afc2_frame.setLocation(x, y);
		        afc2_frame.setVisible(rf.readBoolean());
		        afc2_frame.afc2_config_file = recall_string(rf);
                afc2_frame.afc2_config_dir = recall_string(rf);
                afc2_frame.recall_cfg1();
		    }
            rf.seek(1000);
            if (rf.readBoolean())
            {
		        try {
			        // PLAYframe Create and show the PLAYframe
			        if (itc_frame == null)
			            itc_frame = new ITCframe1();
		        } catch (java.lang.Exception e) 
		        {
		            error_rtn(e.getMessage());
		        }
		        x = rf.readInt();
		        y = rf.readInt();
		        itc_frame.setLocation(x, y);
		        itc_frame.setVisible(rf.readBoolean());
		        itc_frame.itc1_config_file = recall_string(rf);
                itc_frame.itc1_config_dir = recall_string(rf);
                itc_frame.recall_cfg1();
		    }
            rf.seek(1200);
            if (rf.readBoolean())
            {
		        try {
			        // PLAYframe Create and show the PLAYframe
			        if (pms_frame == null)
			            pms_frame = new PMSframe();
		        } catch (java.lang.Exception e) 
		        {
		            error_rtn(e.getMessage());
		        }
		        x = rf.readInt();
		        y = rf.readInt();
		        pms_frame.setLocation(x, y);
		        boolean sv = rf.readBoolean();
		        pms_frame.pms_config_file = recall_string(rf);
                pms_frame.pms_config_dir = recall_string(rf);
                pms_frame.recall_data();
                pms_frame.PMS_program_1.setSelected(rf.readBoolean());
                pms_frame.PMS_program_2.setSelected(rf.readBoolean());
                pms_frame.PMS_program_3.setSelected(rf.readBoolean());
                pms_frame.PMS_fuel.setSelected(rf.readBoolean());
                pms_frame.PMS_timing.setSelected(rf.readBoolean());
                pms_frame.display_pgm();
		        pms_frame.setVisible(sv);
		    }
            rf.seek(200);
            if (rf.readBoolean())
            {
//                System.out.println("load play frame");
		        try {
			        // PLAYframe Create and show the PLAYframe
			        if (play_diag == null)
			            play_diag = new PLAYframe();
		        } catch (java.lang.Exception e) 
		        {
		            error_rtn(e.getMessage());
		        }
		        x = rf.readInt();
		        y = rf.readInt();
		        play_diag.setLocation(x, y);
		        if (pms_frame != null)
		            play_diag.pms_frame = pms_frame;
		        if (afc_frame != null)
		            play_diag.afc_frame = afc_frame;
		        if (afc2_frame != null)
		            play_diag.afc2_frame = afc2_frame;
		        if (itc_frame != null)
		            play_diag.itc_frame = itc_frame;
		        play_diag.setVisible(true);
		        JButton2.setText(play_diag.player_version);
		        rf.readBoolean();
		        boolean b1 = rf.readBoolean();
		        boolean b2 = rf.readBoolean();
		        play_diag.theFile = recall_string(rf);
		        play_diag.theFileDir = recall_string(rf);
	//	        System.out.println(play_diag.theFile);
//		        System.out.println(play_diag.theFileDir);
//        	    if ( (play_diag.theFile == null) || (play_diag.theFile.equals("")))
        	        play_diag.theFile = null;
//        	    else
//		            play_diag.recall_cfg1();
		        play_diag.reset_charts();
		        play_diag.plot_data();
		        play_diag.animate_control.setEnabled(b1);
		        play_diag.animate_control.setSelected(b2);
		        play_diag.itc_animate.setSelected(rf.readBoolean());
		        play_diag.afc_animate.setSelected(rf.readBoolean());
		        play_diag.afc2_animate.setSelected(rf.readBoolean());
		        play_diag.animateControl_itemStateChanged(null);
		        play_diag.advanced_fuel_calc.setSelected(rf.readBoolean());
		        if (rf.readBoolean())
		            {
		                play_diag.x_2d = rf.readInt();
		                play_diag.y_2d = rf.readInt();
		            }
		    }
            rf.close();
   	    }
   	    catch (IOException ioe)
   	    {
		    error_rtn("Unable to open file: " + ioe);
   	    }
   	    if (ld != null)
   	    {
   	        ld.setVisible(false);
   	        ld.dispose();
   	    }
	}
	
	void record_cfg()
	{
	    byte fn[] = new byte[200];
	    
	    // main frame 0
	    // play frame 200
	    // control frame 400
	    // afc1 frame 600
	    // afc2 frame 800
	    // itc frame 1000
	    // pms frame 1200
	    if (control_diag != null)
	    {
	        if (control_diag.afc_frame != null)
	            afc_frame = control_diag.afc_frame;
	        if (control_diag.afc2_frame != null)
	            afc2_frame = control_diag.afc2_frame;
	        if (control_diag.itc_frame != null)
	            itc_frame = control_diag.itc_frame;
	        if (control_diag.pms_frame != null)
	            pms_frame = control_diag.pms_frame;
	    }
	    if (play_diag != null)
	    {
	        if (play_diag.afc_frame != null)
	            afc_frame = play_diag.afc_frame;
	        if (play_diag.afc2_frame != null)
	            afc2_frame = play_diag.afc2_frame;
	        if (play_diag.itc_frame != null)
	            itc_frame = play_diag.itc_frame;
	        if (play_diag.pms_frame != null)
	            pms_frame = play_diag.pms_frame;
	    }
	    
	    File f = new File(System.getProperty("user.dir"), "tnt.cfg");
	    try
	    {
   	        RandomAccessFile rf = new RandomAccessFile(f, "rw");
   	        // store main frame
   	        rf.seek(0);
   	        Rectangle r = new Rectangle();
   	        r = getBounds();
   	        rf.writeInt(r.x);
   	        rf.writeInt(r.y);
   	        // store play frame
   	        rf.seek(200);
   	        if (play_diag != null)
   	        {
   	            r = play_diag.getBounds();
   	            rf.writeBoolean(true);
//   	            System.out.println("Play frame");
   	            rf.writeInt(r.x);
   	            rf.writeInt(r.y);
   	            rf.writeBoolean(play_diag.isVisible());
   	            rf.writeBoolean(play_diag.animate_control.isEnabled());
   	            rf.writeBoolean(play_diag.animate_control.isSelected());
   	            put_string(rf, play_diag.theFile);
//   	            System.out.println(play_diag.theFile);
//   	            System.out.println(play_diag.theFileDir);
   	            put_string(rf, play_diag.theFileDir);
   	            rf.writeBoolean(play_diag.itc_animate.isSelected());
   	            rf.writeBoolean(play_diag.afc_animate.isSelected());
   	            rf.writeBoolean(play_diag.afc2_animate.isSelected());
   	            rf.writeBoolean(play_diag.advanced_fuel_calc.isSelected());
   	            if (play_diag.c2d_frame != null)
   	            {
   	                r = play_diag.c2d_frame.getBounds();
   	                rf.writeBoolean(true);
   	                rf.writeInt(r.x);
   	                rf.writeInt(r.y);
   	            }
   	            else
   	            {   
   	                rf.writeBoolean(false);
   	                rf.writeInt(0);
   	                rf.writeInt(0);
   	            }
   	        }
   	        else
   	        {
   	            rf.writeBoolean(false);
   	            rf.writeInt(0);
   	            rf.writeInt(0);
   	            rf.writeBoolean(false);
   	            rf.writeBoolean(false);
   	            rf.writeInt(0);
   	            rf.writeInt(0);
   	            rf.writeBoolean(false);
   	            rf.writeBoolean(false);
   	            rf.writeBoolean(false);
   	        }
   	        // store control frame
   	        rf.seek(400);
   	        if (control_diag != null)
   	        {
   	            r = control_diag.getBounds();
   	            rf.writeBoolean(true);
   	            rf.writeInt(r.x);
   	            rf.writeInt(r.y);
   	            rf.writeBoolean(control_diag.isVisible());
   	            rf.writeBoolean(control_diag.afc_1.isSelected());
   	            rf.writeBoolean(control_diag.afc_2.isSelected());
   	            rf.writeBoolean(control_diag.itc.isSelected());
   	            rf.writeBoolean(control_diag.pms.isSelected());
   	            rf.writeBoolean(control_diag.afc_1.isEnabled());
   	            rf.writeBoolean(control_diag.afc_2.isEnabled());
   	            rf.writeBoolean(control_diag.itc.isEnabled());
   	            rf.writeBoolean(control_diag.pms.isEnabled());
   	        }
   	        else
   	        {
   	            rf.writeBoolean(false);
   	            rf.writeInt(0);
   	            rf.writeInt(0);
   	            rf.writeBoolean(false);
   	            rf.writeBoolean(false);
   	            rf.writeBoolean(false);
   	            rf.writeBoolean(false);
   	            rf.writeBoolean(false);
   	            rf.writeBoolean(false);
   	            rf.writeBoolean(false);
   	            rf.writeBoolean(false);
   	            rf.writeBoolean(false);
   	        }
   	        // store afc1 frame
   	        rf.seek(600);
   	        if (afc_frame != null)
   	        {
   	            r = afc_frame.getBounds();
   	            rf.writeBoolean(true);
   	            rf.writeInt(r.x);
   	            rf.writeInt(r.y);
   	            rf.writeBoolean(afc_frame.isVisible());
   	            put_string(rf, afc_frame.afc1_config_file);
   	            put_string(rf, afc_frame.afc1_config_dir);
   	        }
   	        else
   	        {
   	            rf.writeBoolean(false);
   	            rf.writeInt(0);
   	            rf.writeInt(0);
   	            rf.writeBoolean(false);
   	        }
   	        // store afc2 frame
   	        rf.seek(800);
   	        if (afc2_frame != null)
   	        {
   	            r = afc2_frame.getBounds();
   	            rf.writeBoolean(true);
   	            rf.writeInt(r.x);
   	            rf.writeInt(r.y);
   	            rf.writeBoolean(afc2_frame.isVisible());
   	            put_string(rf, afc2_frame.afc2_config_file);
   	            put_string(rf, afc2_frame.afc2_config_dir);
   	        }
   	        else
   	        {
   	            rf.writeBoolean(false);
   	            rf.writeInt(0);
   	            rf.writeInt(0);
   	            rf.writeBoolean(false);
   	        }
   	        // store itc  frame
   	        rf.seek(1000);
   	        if (itc_frame != null)
   	        {
   	            r = itc_frame.getBounds();
   	            rf.writeBoolean(true);
   	            rf.writeInt(r.x);
   	            rf.writeInt(r.y);
   	            rf.writeBoolean(itc_frame.isVisible());
   	            put_string(rf, itc_frame.itc1_config_file);
   	            put_string(rf, itc_frame.itc1_config_dir);
   	        }
   	        else
   	        {
   	            rf.writeBoolean(false);
   	            rf.writeInt(0);
   	            rf.writeInt(0);
   	            rf.writeBoolean(false);
   	        }
   	        // store pms  frame
   	        rf.seek(1200);
   	        if (pms_frame != null)
   	        {
   	            r = pms_frame.getBounds();
   	            rf.writeBoolean(true);
   	            rf.writeInt(r.x);
   	            rf.writeInt(r.y);
   	            rf.writeBoolean(pms_frame.isVisible());
   	            put_string(rf, pms_frame.pms_config_file);
   	            put_string(rf, pms_frame.pms_config_dir);
   	            rf.writeBoolean(pms_frame.PMS_program_1.isSelected());
   	            rf.writeBoolean(pms_frame.PMS_program_2.isSelected());
   	            rf.writeBoolean(pms_frame.PMS_program_3.isSelected());
   	            rf.writeBoolean(pms_frame.PMS_fuel.isSelected());
   	            rf.writeBoolean(pms_frame.PMS_timing.isSelected());
   	        }
   	        else
   	        {
   	            rf.writeBoolean(false);
   	            rf.writeInt(0);
   	            rf.writeInt(0);
   	            rf.writeBoolean(false);
   	            rf.writeInt(0);
   	            rf.writeInt(0);
   	            rf.writeBoolean(true);
   	            rf.writeBoolean(false);
   	            rf.writeBoolean(false);
   	            rf.writeBoolean(true);
   	            rf.writeBoolean(false);
   	        }
   	        rf.close();
   	    }
   	    catch (IOException ioe)
   	    {
		    error_rtn("Unable to open file: " + ioe);
   	    }
	}
	
	void put_string(RandomAccessFile rf, String s)
	{
        byte fn[] = new byte[200];
        try
        {
   	        if (s != null)
   	        {
   	            String fs = new String(s);
   	            fn = fs.getBytes();
   	            rf.writeInt(s.length());
   	            fn = fs.getBytes();
   	            int x = 0;
   	            do
   	            {
                    rf.writeByte(fn[x]);
   	                ++ x;
   	            }
   	            while (x < fs.length());
   	        }
   	        else
   	        {
   	            rf.writeInt(0);
   	        }
   	    }
   	    catch (IOException ioe)
   	    {
		    error_rtn("Unable to open file: " + ioe);
   	    }
	}
	
	String recall_string(RandomAccessFile rf)
	{
        byte fn[] = new byte[200];
        try
        {
	        int x = rf.readInt();
//	        System.out.println("string " + x);
	        if (x != 0 && x < 200)
	        {
		        int y = 0;
		        do
		        {
		            fn[y] = rf.readByte();
		            ++ y;
		        }
		        while (y < x);
		        String fs = new String(fn, 0, x);
		        return fs.toString();
	        }
	        return " ";
	    }
	    catch (IOException ioe)
	    {
		    error_rtn("Unable to open file: " + ioe);
	    }
	    return " ";
	}
	
    void error_rtn(String em)
	{
		try 
		{
			// record_dialog Create and show as non-modal
			if (error_diag == null)
			    error_diag = new error_dialog();
			error_diag.error_field.setText(em);
			error_diag.setVisible(true);
		} 
		catch (java.lang.Exception e) 
		{
		    error_rtn(e.getMessage());
		}
	}

}

// add log file play back
// add 3d charting
// add 2d charting
// add pms control panels
// add afc control panel
// add itc control panel
// add PMS data capture
// add obd data capture
// add drb data capture
// add data capture monitor (digital)
// add save log file feature