
class Vector3D extends Object {
    public float x;
    public float y;
    public float z;



    public Vector3D () {
        x = 0.0f;
        y = 0.0f;
        z = 0.0f;
    }


    public Vector3D (float vx, float vy, float vz) {
        x = vx;
        y = vy;
        z = vz;
    }



    public Vector3D (Vector3D v) {
        x = v.x;
        y = v.y;
        z = v.z;
    }



    public Vector3D plus (Vector3D v) {
        return new Vector3D (x+v.x, y+v.y, z+v.z);
    }


    public Vector3D minus (Vector3D v) {
        return new Vector3D (x-v.x, y-v.y, z-v.z);
    }


    public Vector3D negative () {
        return new Vector3D (-x, -y, -z);
    }


    public float length () {
        return (float) Math.sqrt (x*x + y*y + z*z);
    }


    public Vector3D normalize (float length) {
        float mod = (float) Math.sqrt (x*x + y*y + z*z);
        x *= length/mod;
        y *= length/mod;
        z *= length/mod;
        return this;
    }


    public void print () {
        System.out.println ("(" + x + ", " + y + ", " + z + ")");
        return;
    }
}

