/*
		A basic implementation of the JFrame class.
*/

import java.awt.*;
import javax.swing.*;
import java.util.*;
import symantec.itools.awt.StatusBar;
import symantec.itools.awt.util.ToolBarPanel;

public class chartitem extends javax.swing.JFrame
{
    PLAYframe pf = null;
    chartcontrolp chartcontrol_frame = null;
    long last_record = -1;
    long log_records;
    int current_point = -1;
    boolean chart_loaded = false;
    boolean local_scroll = false;
    float   hover_value = 0F;
    long curr_record = -1;
    int mark_loc = 0;
	int chart_item = -1;
	int chart_high = -1;
	int chart_low = -1;
	int data_high = 0;
	int data_low = 65000;
	int frame_count = 0;
	long hover_x = 0;
	String ts;
	String lts = " ";
    Vector points = new Vector(); // x-axis is data value, y-axis is plottable point
    int lastDrawnPoint = 0;
    int lastx = 0;
    int w;
    int h;
	int top;
	int bottom;
	int left;
	int right;
	float conversion_factor = -1F;
    boolean inupdate = false;
    boolean inpaint = false;
    Insets insets = insets();
    long first_point;
    long last_point;

	public chartitem()
	{
		// This code is automatically generated by Visual Cafe when you add
		// components to the visual environment. It instantiates and initializes
		// the components. To modify the code, only use code syntax that matches
		// what Visual Cafe can generate, or Visual Cafe may be unable to back
		// parse your Java file into its visual environment.
		//{{INIT_CONTROLS
		setResizable(false);
		getContentPane().setLayout(null);
		setCursor(java.awt.Cursor.getPredefinedCursor(java.awt.Cursor.CROSSHAIR_CURSOR));
		setSize(405,130);
		setVisible(false);
		//}}

		//{{INIT_MENUS
		//}}
	
		//{{REGISTER_LISTENERS
		SymMouseMotion aSymMouseMotion = new SymMouseMotion();
		this.addMouseMotionListener(aSymMouseMotion);
		SymWindow aSymWindow = new SymWindow();
		this.addWindowListener(aSymWindow);
		SymMouse aSymMouse = new SymMouse();
		this.addMouseListener(aSymMouse);
		//}}
	}

	public chartitem(String sTitle)
	{
		this();
		setTitle(sTitle);
	}

	public void setVisible(boolean b)
	{
		super.setVisible(b);
	}

	static public void main(String args[])
	{
		(new chartitem()).setVisible(true);
	}

	public void addNotify()
	{
		// Record the size of the window prior to calling parents addNotify.
		Dimension size = getSize();

		super.addNotify();

		if (frameSizeAdjusted)
			return;
		frameSizeAdjusted = true;

		// Adjust size of frame according to the insets and menu bar
		Insets insets = getInsets();
		javax.swing.JMenuBar menuBar = getRootPane().getJMenuBar();
		int menuBarHeight = 0;
		if (menuBar != null)
			menuBarHeight = menuBar.getPreferredSize().height;
		setSize(insets.left + insets.right + size.width, insets.top + insets.bottom + size.height + menuBarHeight);
	}

	// Used by addNotify
	boolean frameSizeAdjusted = false;

	//{{DECLARE_CONTROLS
	//}}

	//{{DECLARE_MENUS
	//}}

    public void paint(Graphics g)
    {
        Point curPt = null;
        long start;
        int lastx1;
        int ly1;
        int ly2;

		if (inupdate)
		{
			inupdate = false;
			return;
		}
		set_bounds();
		lastx1 = lastx;
		lastx = left;
//		if (curr_record >= log_records)
	//	    return;
		if (curr_record > last_record && last_record > 0 && last_record < w)
		    curr_record = last_record;
		start = Math.max(0, curr_record - (w - 2));
        inpaint = true;    
        first_point = start;
        last_point = curr_record;
        for (long i=start; i<curr_record; i++)
        {
            if (i >= 32000)
              break;
			Point pt = (Point)points.elementAt((int)i);
			if (curPt != null)
	        {
			    if (i - start == hover_x)
			    {
			        hover_value = (float)(pt.y) / 100F;
			    }
				if (lastx >= right)
				{
					// scroll

					g.copyArea(left,top,right,bottom, -1, 0);

					// clear

					g.clearRect(right,top,right,bottom);

					lastx = right;
				}

				// draw line from lastx to x + 1
				ly1 = (int)((curPt.y / 100) * conversion_factor);
				ly2 = (int)((pt.y / 100) * conversion_factor);
				g.drawLine(lastx - 2,h - ly1 + insets.top,lastx - 1,h - ly2 + insets.top);
				inupdate = false;
			}
			curPt = pt;
			++ lastx;
		}

		lastDrawnPoint = points.size();
        lastx = lastx1;
    }


    public void update(Graphics g) 
    {
        paint(g);
    }

    void set_bounds()
    {

		insets = insets();
		w = size().width-insets.left-insets.right;
		h = size().height-insets.top-insets.bottom;
		left = insets.left;
		right = size().width - (insets.right + 1);
		top = insets.top;
		bottom = size().height - (insets.bottom + 1);
	}
    
    public void plot_point(int data_point)
    {
        set_bounds();
        inupdate = true;
		if (lastx == 0)
		{
			lastx = left;
			ts = getTitle();
		}
		if (data_point / 100 > data_high)
			data_high = data_point / 100;
		if (data_point / 100 < data_low)
			data_low = data_point / 100;
		++ frame_count;
        Point pt = new Point(lastx, data_point);
		setrange(data_high);	
        points.addElement(pt);
        //repaint();
        ++ lastx;
        update_status();
        inupdate = false;
        return;
	}
	
	void resetrange()
	{
	    int loop;
	    
	    if (points.size() == 0)
	        return;
	    data_low = 65000;
	    data_high = -1;
	    conversion_factor = -1;
	    for (loop=0;loop<points.size();loop++)
	    {
			Point pt = (Point)points.elementAt(loop);
		    if (pt.y / 100 > data_high)
			    data_high = pt.y / 100;
		    if (pt.y / 100 < data_low)
			    data_low = pt.y / 100;
	    }
	    setrange(data_high);
//	    paint();
	}

	void setrange(int v)
	{
		if (conversion_factor == -1F)	
	        conversion_factor = (float)h / (float)chart_high;
		if (chartcontrol_frame != null)
		{
		    if (chartcontrol_frame.autorange.isSelected())
		    {
		        if (v > 0)
		            conversion_factor = (float)h / (float)v;
		    }
		    else
    	        conversion_factor = (float)h / (float)chart_high;
		}
	}
	
	void update_status()
	{
	    String x;
	    
	    x = "Min: " + Integer.toString(chart_low) + " ";
	    x = x + "Max: " + Integer.toString(chart_high) + " ";
        if (data_low != 65000)
        {
	        x = x + "High: " + Integer.toString(data_high) + " ";
	        x = x + "Low: " + Integer.toString(data_low) + " ";
	    }
	    x = x + "(" + hover_value + ")";
//	    System.out.println(hover_value);
	    //if (!this.isVisible())
	    //    return;
	    setTitle(ts + " " + x);
	    lts = ts + " " + x;
	}

	class SymMouseMotion extends java.awt.event.MouseMotionAdapter
	{
		public void mouseMoved(java.awt.event.MouseEvent event)
		{
			Object object = event.getSource();
			if (object == chartitem.this)
				chartitem_mouseMoved(event);
		}
	}

	void chartitem_mouseMoved(java.awt.event.MouseEvent event)
	{
		// to do: code goes here.
		
		hover_x = event.getX() - insets.left;
		if (hover_x > w - 2 || hover_x > last_record)
		    return;
		local_scroll = true;    
//		update_status();
		pf.single_click = true;
		pf.point_log_file(0);
		pf.point_log_file(hover_x + first_point + 2);
		pf.read_log_record();
		pf.display_log_record();
		pf.single_click = false;
		paintmark(hover_x);
		//setTitle(ts + " " + Float.toString(hover_value));
		local_scroll = false;
			 
	}
	
    public void paint()
    {
        Graphics g;
        g=this.getGraphics();
        g.clearRect(0,0,size().width,size().height);
        paint(g);
        g.dispose();
    }    
        

	class SymWindow extends java.awt.event.WindowAdapter
	{
		public void windowClosed(java.awt.event.WindowEvent event)
		{
			Object object = event.getSource();
			if (object == chartitem.this)
				chartitem_windowClosed(event);
		}

		public void windowActivated(java.awt.event.WindowEvent event)
		{
			Object object = event.getSource();
			if (object == chartitem.this)
				chartitem_windowActivated(event);
		}
	}

	void chartitem_windowActivated(java.awt.event.WindowEvent event)
	{
		// to do: code goes here.
		
		set_bounds();
		paint();
	}

	class SymMouse extends java.awt.event.MouseAdapter
	{
		public void mouseClicked(java.awt.event.MouseEvent event)
		{
			Object object = event.getSource();
			if (object == chartitem.this)
				chartitem_mouseClicked(event);
		}
	}

	void chartitem_mouseClicked(java.awt.event.MouseEvent event)
	{
		// to do: code goes here.
		
		if (points.size() == 0)
		    return;
		local_scroll = true;    
		if (event.getX() < size().width / 2)
		{
		    // scroll left
		    
		    scroll_data(size().width / -2);
		}
		else
		{
		    // scroll right
		    
		    scroll_data(size().width / 2);
		}
		local_scroll = false;
	    paintmark(event.getX() - insets.right);
	}
	
	void scroll_data(int delta)
	{
	    if (delta > 0)
	    {
	        if (curr_record + delta > last_record)
	        {
	            curr_record = last_record - delta;
	        }
	    }
		pf.single_click = true;
		pf.point_log_file(0);
        if (curr_record + delta > w - 2)
		    pf.point_log_file(curr_record + (long)delta);
		else
		    curr_record = w - 2;
		pf.read_log_record();
		pf.display_log_record();
		pf.single_click = false;
		if (curr_record + delta > w - 2)
		    curr_record += delta;
		paint();
	}
	
	void paintmark(long x1)
	{
	    paint();
	    Graphics g = this.getGraphics();
        g.drawLine((int)x1+insets.left,top,(int)x1+insets.left,bottom);
        g.dispose();
        mark_loc = (int)x1;
        update_status();
    }
    
    void scrollmark(long x1)
    {
        local_scroll = true;
        if (x1 < first_point + 2)
        {
            if (x1 > 2)
            {
                if (x1 < w - 2)
                {
                    curr_record = w - 2;
                    hover_x = x1;
                    paintmark(x1);
                }
                else
                {
		            curr_record = x1;
		            hover_x = w - 2;
                    paintmark(w - 2);
                }
            }
        }
        else
            if (x1 > last_point)
            {
		        curr_record = x1;
		        hover_x = x1;
                paintmark(w - 2);
            }
            else
            {
                hover_x = (x1 - first_point) -2;
                paintmark((x1 - first_point) - 2);
            }
        local_scroll = false;
    }


	void chartitem_windowClosed(java.awt.event.WindowEvent event)
	{
		// to do: code goes here.
		this.dispose();
	}
	
	void clear_chart()
	{
	    if (points.size() == 0)
	        return;
	    points.removeAllElements();
        last_record = -1;
        current_point = -1;
        chart_loaded = false;
        local_scroll = false;
        curr_record = -1;
        mark_loc = 0;
	    chart_item = -1;
	    chart_high = -1;
	    chart_low = -1;
	    data_high = 0;
	    data_low = 65000;
	    frame_count = 0;
	    hover_x = 0;
        lastDrawnPoint = 0;
        lastx = 0;
	    conversion_factor = -1F;
        inupdate = false;
        inpaint = false;
	}
}