import java.io.*;
import java.awt.*;
import javax.swing.*;
import java.lang.Math.*;
import javax.swing.JTextPane;
import javax.swing.JButton;
import javax.swing.JSlider;
import com.symantec.itools.javax.swing.borders.BevelBorder;
import javax.swing.JLabel;
import javax.swing.JTextField;
import javax.swing.JCheckBox;
import com.symantec.itools.javax.swing.icons.ImageIcon;
import symantec.itools.awt.Wizard;
import com.symantec.itools.javax.swing.JChart;
import java.util.StringTokenizer;
import symantec.itools.awt.InvisibleButton;

public class palmthread extends Thread
{
    
    PLAYframe pf = null;
    PNSTEINdialog pd = null;

    public void run()
    {
        String theFile;// log file name
        String theFileDir;                          // log file dir name
	    String logfiledir = null;
	    String logfilename = null;
	    String file_ext = null;
	    boolean f_ok = false;
        boolean csv_file = false;
	    
	    long bytes_read = 0;
	    long file_length = 0;
	    int byte_value = 0;
	    int field_id = 0;
        int max_parms = 0;
	    
	    byte byte2 = 0;
	    byte byte1 = 0;
	    int parm_count = 0;
	    int logfiletype = 0;
	    int rc = 0;
	    
        tunerlib tlib = null;
	    File f1 = null;                             // work file
	    RandomAccessFile rf1 = null;                       // work file

	    File f = null;                            // work file
	    RandomAccessFile rf = null;                      // work file

		try
		{
		    if (tlib == null)
		    {
		        tlib = new tunerlib();
		        tlib.pd = pd;
        		  
		        if (tlib.getver() != 6)
		        {
		            pf.error_rtn("Missing or incorrect version of sjn2tntclib.dll");
		            return;
		        }
		    }
		}
        catch (UnsatisfiedLinkError ioe)
        {
                pd.error_rtn("Wrong or missing DLL - SNJ2TNTCLIB.DLL!  See www.tunerstein.com/dll.htm for help.");
                return;
        }
		
		  
		// call routine to process PNSTEIN eeprom (read)
		
		rc = tlib.getPNSTEIN(pd.port_list.getSelectedIndex() - 1);
		pd.setModal(false);
		pd.setVisible(false);
		if (rc != 0)
		  {
		    // PNSTEIN comm error
		    pf.error_rtn("Palm access error: " + Integer.toString(rc));
		    return;
		  }

	    f1 = new File(System.getProperty("user.dir"), "\\tnt1.tmp");
	    if(!f1.exists() || !f1.isFile())
	    {   //file not there, abort
	        pf.error_rtn("No logged data to save!");
	        return;
	    }
	    f_ok = false;
	    try
	    {
    	    rf1 = new RandomAccessFile(f1, "r");
            if (rf1.readByte() == 2)
                logfiletype = 1;
            else
                logfiletype = 2;
        }
        catch (IOException ioe)
        {
        }
	    do
	    {
    	    if (logfiletype == 1)
    	    {
	            pf.saveobdfile.setFile("*.db1");
    	        pf.saveobdfile.setVisible(true);
    	        logfilename = pf.saveobdfile.getFile();
    	        if (logfilename == null)
    	            break;
    	        logfiledir = pf.saveobdfile.getDirectory();
	            file_ext = logfilename.toLowerCase();
    	        if (file_ext.endsWith(".db1"))
    	            f_ok = true;
    	        else
    	            {
    	                pf.error_rtn("File must end with .db1!  Renamed to temp.db1!");
    	                logfilename = "temp.db1";
    	                f_ok = true;
    	            }    
    	    }
    	    if (logfiletype == 2)
    	    {
	            pf.savedrbfile.setFile("*.db2");
    	        pf.savedrbfile.setVisible(true);
    	        logfilename = pf.savedrbfile.getFile();
    	        if (logfilename == null)
    	            break; 
    	        logfiledir = pf.savedrbfile.getDirectory();
	            file_ext = logfilename.toLowerCase();
    	        if (file_ext.endsWith(".db2"))
    	            f_ok = true;
    	        else
    	            {
    	                pf.error_rtn("File must end with .db2!  Renamed to temp.db2!");
    	                logfilename = "temp.db2";
    	                f_ok = true;
    	            }    
    	    }
    	}
    	while (!f_ok);
    	if (logfilename == null || logfiledir == null)
    	{   
    	    return;
    	}
    	try
    	{
    	    file_length = rf1.length();
    	    if (rf1.length() > 0)
    	    {
	            f = new File(logfiledir, logfilename);
				if (f.exists())
				    f.delete();
	            rf = new RandomAccessFile(f, "rw");
	            bytes_read = 0;
	            do
	            {
	                if (bytes_read == 0)
	                {
	                    // write header
	                    rf.seek(4);
	                    rf.writeByte(0); // title length
	                    byte_value = rf1.readByte();
	                    max_parms = byte_value;
	                    rf.writeByte(byte_value); // number of parms
	                    rf.writeShort(0); // two fill byte
	                    // write parm headers
	                    int a = 0;
	                    do
	                    {
	                        rf.writeShort(0);
	                        rf.writeShort(0);
	                        rf.writeShort(0);
	                        rf.writeShort(0);
	                        rf.writeByte(0);
	                        rf.writeByte(0);
	                        rf.writeShort(0);
	                        rf.writeShort(0);
	                        byte_value = rf1.readByte();
	                        rf.writeByte(byte_value);
	                        rf.writeShort(0);
	                        rf.writeShort(0);
	                        rf.writeShort(0);
	                        rf.writeShort(0);
	                        rf.writeShort(0);
	                        rf.writeByte(0);
	                        rf.writeShort(0);
	                        rf.writeShort(0);
	                        ++ a;
	                    }
	                    while (a < max_parms);
	                    rf.writeShort(0);
	                    rf.writeShort(0);
                        rf.writeByte(0);
	                    bytes_read = rf1.getFilePointer() + 1;
	                }
	                else
	                {
	                    rf.writeFloat(0F);
	                    parm_count = 0;
	                    do
	                    {
	                        // write body
	                        field_id = rf1.readByte();
	                        if (logfiletype == 1)
	                        {
    	                        byte1 = rf1.readByte();
  	                            byte2 = rf1.readByte();
  	                        }
  	                        else
  	                        {
  	                            byte1 = rf1.readByte();
  	                        }
	                        float tf = 0F;
	                        if (field_id == 90) // mph
	                        {
	                            tf = (float)pf.build_int((byte)0,byte1);
	                            tf = tf * .621F;
	                            //System.out.println(byte1 + " " + tf);
                                rf.writeFloat(tf);
                            }
	                        else
	                        if (field_id == 0x0f) // o2 trim
	                        {
	                            tf = (float)pf.build_int((byte)0,byte1);
	                            rf.writeFloat(tf);
	                        }
	                        else
	                        if (field_id == 91) // map
	                        {
	                            tf = (float)pf.build_int((byte)0,byte1);
	                            tf = tf * .2952F;
	                            rf.writeFloat(tf);
	                        }
	                        else
	                        if (field_id == 92) // s/t
	                        {
	                            tf = (float)pf.build_int((byte)0,byte1);
	                            tf = ((tf / 128F) * 100F) - 100F;
	                            rf.writeFloat(tf);
	                        }
	                        else
	                        if (field_id == 93)// l/t
	                        {
	                            tf = (float)pf.build_int((byte)0,byte1);
	                            tf = ((tf / 128F) * 100F) - 100F;
	                            rf.writeFloat(tf);
	                        }
	                        else
	                        if (field_id == 94)// load
	                        {
	                            tf = (float)pf.build_int((byte)0,byte1);
	                            tf = ((tf / 255F) * 100F);
	                            rf.writeFloat(tf);
	                        }
	                        else
	                        if (field_id == 95)// 02 2
	                        {
	                            byte_value = pf.build_int((byte)0,byte1);
	                            tf = (float)(byte_value * .005F);
	                            rf.writeFloat(tf);
	                        }
	                        else
	                        if (field_id == 96)// time
	                        {
	                            byte_value = pf.build_int((byte)0,byte1);
	                            tf = (float)(byte_value);
	                            rf.writeFloat(tf);
	                        }
	                        else
	                        if (field_id == 9) // rpm
	                        {
	                            if (logfiletype == 1)
	                            {
	                                byte_value = pf.build_int(byte1, byte2);
	                                tf = (float)(byte_value / 4F);
//	                                System.out.println("rpm: " + tf);
	                            }
	                            if (logfiletype == 2)
	                            { 
	                                tf = (float)pf.build_int((byte)0,byte1) * 31.37F;
	                                //System.out.println(tf);
	                            }
                                rf.writeFloat(tf);
                            }
                            else
	                        if (field_id == 3)// o2 1
	                        {   
	                            if (logfiletype == 1)
	                            {
	                                byte_value = pf.build_int((byte)0,byte1);
	                                tf = (float)(byte_value * .005F);
	                                //System.out.println("o2v: " + tf);
	                            }
	                            if (logfiletype == 2)
	                            {
	                                tf = (float)pf.build_int((byte)0,byte1) * .02F;
	                            }
                                rf.writeFloat(tf);
	                        }
	                        else
	                        if (field_id == 0)// timing
	                        {
	                            if (logfiletype == 1)
	                            {
	                                byte_value = pf.build_int((byte)0,byte1);
                                    tf = ((float)byte_value - 128F) * .5F;    	                            
                                    //System.out.println("timing " + tf);
	                            }
	                            if (logfiletype == 2)
	                            {
	                                tf = (float)pf.build_int((byte)0,byte1) / 3F;
	                            }
	                            rf.writeFloat(tf);
	                        }
	                        else
	                        if (field_id == 12 || field_id == 13 || field_id == 14)// trim 1
	                        { 
	                            if (logfiletype == 1)
	                            {
	                                tf = (float)pf.build_int((byte)0,byte1);
	                                tf = ((tf / 128F) * 100F) - 100F;
	                                //System.out.println("trim: " + tf);
	                            }
	                            if (logfiletype == 2)
	                            {
	                                tf = (float)pf.build_int((byte)0,byte1) * 1.27F;
	                            }
	                            rf.writeFloat(tf);
	                        }
	                        else
	                        if (field_id == 7)// tps
	                        { 
	                            if (logfiletype == 1)
	                            {
	                                tf = (float)pf.build_int((byte)0,byte1);
	                                tf = ((tf / 255F) * 100F);
	                                //System.out.println("tps: " + tf);
	                            }
	                            if (logfiletype == 2)
	                            {
	                                tf = (float)pf.build_int((byte)0,byte1) / 2.5F;
	                            }
                                rf.writeFloat(tf);
	                        }
	                        else
	                        if (field_id == 20)
	                        {
	                            if (logfiletype == 1)
	                            {
	                                tf = (float)pf.build_int((byte)0,byte1);
	                                tf = tf * .6214F;
	                            }
	                            if (logfiletype == 2)
	                            {
	                                tf = 0F;
	                            }
                                rf.writeFloat(tf);
	                        }
	                        else
	                        if (field_id == 17) // knock
	                        {
	                            tf = (float)pf.build_int((byte)0,byte1);
	                            rf.writeFloat(tf);
	                        }
	                        else
	                        if (field_id == 10)
	                        {
	                            tf = (float)pf.build_int((byte)0,byte1) * .256F;
	                            rf.writeFloat(tf);
	                        }
	                        else
	                        if  (field_id == 18)
	                        {
	                            if (logfiletype == 1)
	                            {
	                                tf = (float)pf.build_int(byte1, byte2) / 100;
	                                tf = (tf * 60.0F) * .002205F;
	                                System.out.println("mas: " + tf);
	                            }
	                            if (logfiletype == 2)
	                            {
	                                tf= (float)pf.build_int((byte)0,byte1);
	                            }
                                rf.writeFloat(tf);
	                        }
	                        else
	                        if (field_id == 1 || field_id == 11)
	                        {
	                            if (logfiletype == 1)
	                            {
	                                tf = (float)pf.build_int((byte)0,byte1);
	                                tf = ((tf - 40F) * 1.8F) + 32F;
	                                //System.out.println("temp: " + tf);
	                            }
	                            if (logfiletype == 2)
	                            {
	                                if (field_id == 1)
	                                    tf = (float)(198 - pf.build_int((byte)0,byte1));
	                                if (field_id == 11)
	                                    tf = (float)(211 - pf.build_int((byte)0,byte1));
	                            }
                                rf.writeFloat(tf);
	                        }
	                        else
	                        {
//	                          System.out.println("unknown: " + field_id);
	                          rf.writeFloat(0F);
	                        }
	                        ++ parm_count;
//                            System.out.println(parm_count + " " + max_parms);
	                    }
	                    while (parm_count < max_parms);
	                    bytes_read = rf1.getFilePointer() + 1;
	                    //break;
	                }
	            } while (bytes_read < rf1.length());
	            rf.close();
	            rf = null;
    	    }
    	    rf1.close();
    	    rf1 = null;
    	}
    	catch (IOException ioe)
    	{
    	    pf.error_rtn("Error saving log data: " + ioe);
    	}
    	try
    	{
    	    if (rf != null)
    	        rf.close();
    	    if (rf1 != null)
    	        rf1.close();
    	}
    	catch (IOException ioe)
    	{
    	    pf.error_rtn("Error saving log data: " + ioe);
    	}
    	theFile = logfilename;
    	theFileDir = logfiledir;
    	csv_file = true;
	    if ( (theFile == null) || (theFile.equals("")))
	        return;
    	pf.recall_cfg1();
    	pf.reset_charts();    
        pf.plot_data();
    }
}
