import java.awt.*;

public class LOGOBDThread1 extends Thread
{
	// The following function is a placeholder for control initialization.
	// You should call this function from a constructor or initialization function.
	public void vcInit() {
		//{{INIT_CONTROLS
		//}}
	}
	
    TunerLog tuner_handle = null;
    LOGOBDframe obd_frame = null;
    serialio sio = null;
    int logfiletype = 0;
    error_dialog error_diag = null;
    int chart_flag;
    
    java.awt.TextField status = null;

    public void run()
    {
        if (sio == null)
            sio = new serialio();
        sio.tuner_handle = tuner_handle;
        sio.obd_stop_flag = 1;
        sio.drb_stop_flag = 1;
        sio.pms_stop_flag = 1;
        sio.status = status;
        if (sio.getver() != 6)
        {
            error_rtn("Wrong or missing DLL - SNJ2TNTCLIB.DLL!  See www.tunerstein.com/dll.htm for help.");
            return;
        }
            
        status.setText("Active");
        tuner_handle.stop_button.setEnabled(true);
        tuner_handle.pause_button.setEnabled(true);
        tuner_handle.log_button.setEnabled(false);
        if (tuner_handle.logcharts.isEnabled() &&
            tuner_handle.logcharts.isSelected())
          chart_flag = 1;
        else
          chart_flag = 0;
        
        // get array of fields from obd frame
        
        // open com port
	    obd_frame.selected_port = obd_frame.choose_port.getSelectedIndex() - 1;
	    obd_frame.selected_cable = obd_frame.cable_type.getSelectedIndex() - 1;
	    int x = sio.logdata(obd_frame.selected_port, 2, obd_frame.selected_cable, obd_frame.log_items, tuner_handle.reg_flag, chart_flag);
	    if (x != 0)
	    {
	      error_rtn("Data logging error," + x + " logged data will be saved");
	    }
        
        status.setText("Idle");
        tuner_handle.stop_button.setEnabled(false);
        tuner_handle.log_button.setEnabled(true);
        tuner_handle.pause_button.setText("Pause");
        tuner_handle.save_log_file(logfiletype);
        sio.obd_stop_flag = 0;
        sio.drb_stop_flag = 0;
        sio.pms_stop_flag = 0;
    }
	//{{DECLARE_CONTROLS
	//}}

	void error_rtn(String em)
	{
		try {
			// record_dialog Create and show as non-modal
			if (error_diag == null)
			error_diag = new error_dialog();
			error_diag.error_field.setText(em);
			error_diag.setVisible(true);
		} catch (java.lang.Exception e) {
		}
	}

}