/*
	A basic extension of the java.awt.Frame class
 */

import java.awt.*;
import javax.swing.JTextPane;
import javax.swing.JTextField;
import javax.swing.JComboBox;
import javax.swing.JCheckBox;
import com.symantec.itools.javax.swing.borders.BevelBorder;

public class LOGOBDframe extends Frame
{
    serialio serial_handle = null;
    LOGOBDThread thread_handle = null;
    TunerLog tuner_handle = null;
    
    int port_open = 99;
    int selected_port = -1;
    int selected_cable = -1;
    
    int log_items[] = new int[20];
    
   	public LOGOBDframe()
	{
		// This code is automatically generated by Visual Cafe when you add
		// components to the visual environment. It instantiates and initializes
		// the components. To modify the code, only use code syntax that matches
		// what Visual Cafe can generate, or Visual Cafe may be unable to back
		// parse your Java file into its visual environment.
		//{{INIT_CONTROLS
		setLayout(null);
		setBackground(java.awt.Color.lightGray);
		setSize(400,300);
		setVisible(false);
		status_line.setDisabledTextColor(java.awt.Color.lightGray);
		status_line.setEditable(false);
		add(status_line);
		status_line.setBounds(8,264,384,24);
		JTextField2.setText("This panel is used to confiure the OBD-II data collection interface");
		JTextField2.setDisabledTextColor(java.awt.Color.lightGray);
		JTextField2.setEditable(false);
		add(JTextField2);
		JTextField2.setBounds(8,8,384,40);
		choose_port.addItem("Choose port");
		choose_port.addItem("COM1");
		choose_port.addItem("COM2");
		choose_port.addItem("COM3");
		choose_port.addItem("COM4");
		try {
			choose_port.select(0);
		}
		catch (IllegalArgumentException e) { }
		add(choose_port);
		choose_port.setBounds(136,56,100,25);
		obd_enabled.setText("Interface enabled");
		obd_enabled.setActionCommand("Interface enabled");
		obd_enabled.setToolTipText("If selected, data will be logged from this interface via the selected com port");
		add(obd_enabled);
		obd_enabled.setBounds(8,56,128,24);
		cable_type.addItem("Choose cable");
		cable_type.addItem("Alex Peper S/C");
		cable_type.addItem("Mutiplexer Engineering");
		cable_type.addItem("$99 Logger");
		cable_type.addItem("EaseSim");
		try {
			cable_type.select(0);
		}
		catch (IllegalArgumentException e) { }
		add(cable_type);
		cable_type.setBounds(280,56,100,25);
		log_rpm.setText("Rpm");
		log_rpm.setActionCommand("Rpm");
		log_rpm.setBorder(bevelBorder1);
		log_rpm.setToolTipText("Log rpms");
		add(log_rpm);
		log_rpm.setBounds(8,88,64,24);
		add(log_o2);
		log_timing.setBounds(8,112,64,24);
		//$$ bevelBorder1.move(0,301);
		log_timing.setText("Timing");
		log_timing.setActionCommand("Timing");
		log_timing.setBorder(bevelBorder1);
		log_timing.setToolTipText("Log timing");
		add(log_timing);
		log_tps.setText("Tps");
		log_tps.setActionCommand("Tps");
		log_tps.setBorder(bevelBorder1);
		log_tps.setToolTipText("Log TPS");
		add(log_tps);
		log_tps.setBounds(8,136,64,24);
		log_air_temp.setText("Air temp");
		log_air_temp.setActionCommand("Rpm");
		log_air_temp.setBorder(bevelBorder1);
		log_air_temp.setToolTipText("Log intake air temperature");
		add(log_air_temp);
		log_air_temp.setBounds(200,160,80,24);
		log_water_temp.setText("Coolant temp");
		log_water_temp.setActionCommand("Rpm");
		log_water_temp.setBorder(bevelBorder1);
		log_water_temp.setToolTipText("Log coolant temp");
		add(log_water_temp);
		log_water_temp.setBounds(200,136,96,24);
		add(log_timing);
		add(log_tps);
		add(log_air_temp);
		add(log_water_temp);
		log_o2.setText("O2v");
		log_o2.setActionCommand("O2v");
		log_o2.setBorder(bevelBorder1);
		log_o2.setToolTipText("Log o2 voltage");
		add(log_o2);
		log_o2.setBounds(8,160,64,24);
		log_st_trim.setText("S/T trim");
		log_st_trim.setActionCommand("Rpm");
		log_st_trim.setBorder(bevelBorder1);
		log_st_trim.setToolTipText("Log short term fuel trim");
		add(log_st_trim);
		log_st_trim.setBounds(88,88,96,24);
		log_lt_trim.setText("L/T trim");
		log_lt_trim.setActionCommand("Rpm");
		log_lt_trim.setBorder(bevelBorder1);
		log_lt_trim.setToolTipText("Log long term fuel trim");
		add(log_lt_trim);
		log_lt_trim.setBounds(88,112,96,24);
		log_pressure.setText("Pressure");
		log_pressure.setActionCommand("Rpm");
		log_pressure.setBorder(bevelBorder1);
		log_pressure.setToolTipText("Log manifold pressure");
		add(log_pressure);
		log_pressure.setBounds(88,136,96,24);
		log_air_flow.setText("Air flow");
		log_air_flow.setActionCommand("Rpm");
		log_air_flow.setBorder(bevelBorder1);
		log_air_flow.setToolTipText("Log air flow (lb. min)");
		add(log_air_flow);
		log_air_flow.setBounds(88,160,96,24);
		log_mph.setText("MPH");
		log_mph.setActionCommand("Rpm");
		log_mph.setBorder(bevelBorder1);
		log_mph.setToolTipText("Log vehicle speed (mph)");
		add(log_mph);
		log_mph.setBounds(88,184,96,24);
		log_knock.setText("Knock");
		log_knock.setActionCommand("Rpm");
		log_knock.setBorder(bevelBorder1);
		log_knock.setToolTipText("Log knock sum");
		log_knock.setEnabled(false);
		add(log_knock);
		log_knock.setBounds(200,88,96,24);
		log_pw.setText("Pulse width");
		log_pw.setActionCommand("Rpm");
		log_pw.setBorder(bevelBorder1);
		log_pw.setToolTipText("Log injector pulsewidth");
		log_pw.setEnabled(false);
		add(log_pw);
		log_pw.setBounds(200,112,96,24);
		setTitle("OBD Data Logging ");
		//}}

		//{{INIT_MENUS
		//}}

		//{{REGISTER_LISTENERS
		SymWindow aSymWindow = new SymWindow();
		this.addWindowListener(aSymWindow);
		SymMouse aSymMouse = new SymMouse();
		obd_enabled.addMouseListener(aSymMouse);
		choose_port.addMouseListener(aSymMouse);
		cable_type.addMouseListener(aSymMouse);
		SymItem lSymItem = new SymItem();
		choose_port.addItemListener(lSymItem);
		cable_type.addItemListener(lSymItem);
		log_timing.addMouseListener(aSymMouse);
		log_tps.addMouseListener(aSymMouse);
		log_air_temp.addMouseListener(aSymMouse);
		log_water_temp.addMouseListener(aSymMouse);
		log_o2.addMouseListener(aSymMouse);
		log_st_trim.addMouseListener(aSymMouse);
		log_lt_trim.addMouseListener(aSymMouse);
		log_pressure.addMouseListener(aSymMouse);
		log_air_flow.addMouseListener(aSymMouse);
		log_mph.addMouseListener(aSymMouse);
		log_knock.addMouseListener(aSymMouse);
		log_pw.addMouseListener(aSymMouse);
		log_rpm.addMouseListener(aSymMouse);
		//}}
	}

	public LOGOBDframe(String title)
	{
		this();
		setTitle(title);
	}

    /**
     * Shows or hides the component depending on the boolean flag b.
     * @param b  if true, show the component; otherwise, hide the component.
     * @see java.awt.Component#isVisible
     */
    public void setVisible(boolean b)
	{
	    if (!obd_enabled.isSelected())
	    {
		    status_line.setText("Link is disabled");
		}
		super.setVisible(b);
	}

	static public void main(String args[])
	{
		(new LOGOBDframe()).setVisible(true);
	}
	
	public void addNotify()
	{
	    // Record the size of the window prior to calling parents addNotify.
	    Dimension d = getSize();
	    
		super.addNotify();

		if (fComponentsAdjusted)
			return;

		// Adjust components according to the insets
		Insets insets = getInsets();
		setSize(insets.left + insets.right + d.width, insets.top + insets.bottom + d.height);
		Component components[] = getComponents();
		for (int i = 0; i < components.length; i++)
		{
			Point p = components[i].getLocation();
			p.translate(insets.left, insets.top);
			components[i].setLocation(p);
		}
		fComponentsAdjusted = true;
	}

    // Used for addNotify check.
	boolean fComponentsAdjusted = false;

	//{{DECLARE_CONTROLS
	javax.swing.JTextField status_line = new javax.swing.JTextField();
	javax.swing.JTextField JTextField2 = new javax.swing.JTextField();
	java.awt.Choice choose_port = new java.awt.Choice();
	javax.swing.JCheckBox obd_enabled = new javax.swing.JCheckBox();
	java.awt.Choice cable_type = new java.awt.Choice();
	javax.swing.JCheckBox log_rpm = new javax.swing.JCheckBox();
	com.symantec.itools.javax.swing.borders.BevelBorder bevelBorder1 = new com.symantec.itools.javax.swing.borders.BevelBorder();
	javax.swing.JCheckBox log_timing = new javax.swing.JCheckBox();
	javax.swing.JCheckBox log_tps = new javax.swing.JCheckBox();
	javax.swing.JCheckBox log_air_temp = new javax.swing.JCheckBox();
	javax.swing.JCheckBox log_water_temp = new javax.swing.JCheckBox();
	javax.swing.JCheckBox log_o2 = new javax.swing.JCheckBox();
	javax.swing.JCheckBox log_st_trim = new javax.swing.JCheckBox();
	javax.swing.JCheckBox log_lt_trim = new javax.swing.JCheckBox();
	javax.swing.JCheckBox log_pressure = new javax.swing.JCheckBox();
	javax.swing.JCheckBox log_air_flow = new javax.swing.JCheckBox();
	javax.swing.JCheckBox log_mph = new javax.swing.JCheckBox();
	javax.swing.JCheckBox log_knock = new javax.swing.JCheckBox();
	javax.swing.JCheckBox log_pw = new javax.swing.JCheckBox();
	//}}

	//{{DECLARE_MENUS
	//}}

	class SymWindow extends java.awt.event.WindowAdapter
	{
		public void windowClosing(java.awt.event.WindowEvent event)
		{
			Object object = event.getSource();
			if (object == LOGOBDframe.this)
				LOGOBDframe_WindowClosing(event);
		}
	}
	
	void LOGOBDframe_WindowClosing(java.awt.event.WindowEvent event)
	{
		setVisible(false);		 // hide the Frame
	}

	class SymMouse extends java.awt.event.MouseAdapter
	{
		public void mouseClicked(java.awt.event.MouseEvent event)
		{
			Object object = event.getSource();
			if (object == obd_enabled)
				obdEnabled_mouseClicked(event);
			else if (object == choose_port)
				choosePort_MouseClicked(event);
			else if (object == cable_type)
				cableType_MouseClicked(event);
			else if (object == log_timing)
				logTiming_mouseClicked(event);
			else if (object == log_tps)
				logTps_mouseClicked(event);
			else if (object == log_air_temp)
				logAirTemp_mouseClicked(event);
			else if (object == log_water_temp)
				logWaterTemp_mouseClicked(event);
			else if (object == log_o2)
				logO2_mouseClicked(event);
			else if (object == log_st_trim)
				logStTrim_mouseClicked(event);
			else if (object == log_lt_trim)
				logLtTrim_mouseClicked(event);
			else if (object == log_pressure)
				logPressure_mouseClicked(event);
			else if (object == log_air_flow)
				logAirFlow_mouseClicked(event);
			else if (object == log_mph)
				logMph_mouseClicked(event);
			else if (object == log_knock)
				logKnock_mouseClicked(event);
			else if (object == log_pw)
				logPw_mouseClicked(event);
			else if (object == log_rpm)
				logRpm_mouseClicked(event);
		}
	}

	void obdEnabled_mouseClicked(java.awt.event.MouseEvent event)
	{
		// to do: code goes here.
	    if (obd_enabled.isSelected())
		    test_connection();
		else
		    status_line.setText("Link is disabled");
	}

	void test_connection()
	{
	    tuner_handle.obd_button.setBackground(java.awt.Color.lightGray);
	    if (!obd_enabled.isSelected())
	        return;
        int x = choose_port.getSelectedIndex();
	    if (x <= 0)
	    {
	        status_line.setText("No COM port selected");
	        obd_enabled.setSelected(false);
	        return;
	    }
	    selected_port = x - 1;  
	    x = cable_type.getSelectedIndex();
	    if (x <= 0)
	    {
	        status_line.setText("No cable type selected");
	        obd_enabled.setSelected(false);
	        return;
	    }
	    status_line.setText("Testing link...please wait");
	    selected_cable = x - 1;    
	    clear_log_items();
	    log_items[0] = 49;
	    // get c/e code (if any)
	    port_open = serial_handle.SioReset(selected_cable, selected_port,1024,1024);
	    if (port_open != 1)
	    {
	        status_line.setText("Port open error: " + Integer.toString(port_open));
	        obd_enabled.setSelected(false);
    	    tuner_handle.obd_button.setBackground(java.awt.Color.red);
	        return;
	    }
	    port_open = serial_handle.logData(selected_port, 1, selected_cable, log_items);
	    if (port_open == -1)
	    {
	        status_line.setText("No response from ECU");
	        serial_handle.SioDone(selected_port);
	        obd_enabled.setSelected(false);
    	    tuner_handle.obd_button.setBackground(java.awt.Color.red);
	        return;
	    }    
	    port_open = serial_handle.SioDone(selected_port);
	    if (port_open != 1)
	    {
	        status_line.setText("Port close error: " + Integer.toString(port_open));
	        obd_enabled.setSelected(false);
    	    tuner_handle.obd_button.setBackground(java.awt.Color.red);
	        return;
	    }
	    status_line.setText("Link is operational");
	    tuner_handle.obd_button.setBackground(java.awt.Color.green);
    }	   
    
    void clear_log_items()
    {
        int x = 0;
        do
        {
            log_items[x] = 0;
            ++ x;
        }
        while (x <= 19);
    }
    
    void set_log_items()
    {
        clear_log_items();
     
        if (log_rpm.isSelected())
            log_items[1] = 1;
        if (log_timing.isSelected())
            log_items[2] = 2;
        if (log_tps.isSelected())
            log_items[3] = 3;
        if (log_o2.isSelected())
            log_items[4] = 4;
        if (log_st_trim.isSelected())
            log_items[5] = 5;
        if (log_lt_trim.isSelected())
            log_items[6] = 6;
        if (log_pressure.isSelected())
            log_items[7] = 7;
        if (log_air_flow.isSelected())
            log_items[8] = 8;
        if (log_mph.isSelected())
            log_items[9] = 9;
        if (log_knock.isSelected())
            log_items[10] = 10;
        if (log_pw.isSelected())
            log_items[11] = 11;
        if (log_water_temp.isSelected())
            log_items[12] = 12;
        if (log_air_temp.isSelected())
            log_items[13] = 13;
        // value 255 = get error code
        
        int x = 0;
        tuner_handle.log_button.setEnabled(false);
//        if (obd_enabled.isSelected())
            do
            {
                if (log_items[x] != 0)
                {
                    tuner_handle.log_button.setEnabled(true);
                    break;
                }
                ++ x;
            }
            while (x < 14);
    }

	void choosePort_MouseClicked(java.awt.event.MouseEvent event)
	{
		// to do: code goes here.
	}

	void cableType_MouseClicked(java.awt.event.MouseEvent event)
	{
		// to do: code goes here.
	}

	class SymItem implements java.awt.event.ItemListener
	{
		public void itemStateChanged(java.awt.event.ItemEvent event)
		{
			Object object = event.getSource();
			if (object == choose_port)
				choosePort_ItemStateChanged(event);
			else if (object == cable_type)
				cableType_ItemStateChanged(event);
		}
	}

	void choosePort_ItemStateChanged(java.awt.event.ItemEvent event)
	{
		// to do: code goes here.
		test_connection();
	}

	void cableType_ItemStateChanged(java.awt.event.ItemEvent event)
	{
		// to do: code goes here.
		test_connection();
	}

	void logTiming_mouseClicked(java.awt.event.MouseEvent event)
	{
		// to do: code goes here.
		set_log_items();
	}

	void logTps_mouseClicked(java.awt.event.MouseEvent event)
	{
		// to do: code goes here.
		set_log_items();
	}

	void logAirTemp_mouseClicked(java.awt.event.MouseEvent event)
	{
		// to do: code goes here.
		set_log_items();
	}

	void logWaterTemp_mouseClicked(java.awt.event.MouseEvent event)
	{
		// to do: code goes here.
		set_log_items();
	}

	void logO2_mouseClicked(java.awt.event.MouseEvent event)
	{
		// to do: code goes here.
		set_log_items();
	}

	void logStTrim_mouseClicked(java.awt.event.MouseEvent event)
	{
		// to do: code goes here.
		set_log_items();
	}

	void logLtTrim_mouseClicked(java.awt.event.MouseEvent event)
	{
		// to do: code goes here.
		set_log_items();
	}

	void logPressure_mouseClicked(java.awt.event.MouseEvent event)
	{
		// to do: code goes here.
		set_log_items();
	}

	void logAirFlow_mouseClicked(java.awt.event.MouseEvent event)
	{
		// to do: code goes here.
		set_log_items();
	}

	void logMph_mouseClicked(java.awt.event.MouseEvent event)
	{
		// to do: code goes here.
		set_log_items();
	}

	void logKnock_mouseClicked(java.awt.event.MouseEvent event)
	{
		// to do: code goes here.
		set_log_items();
	}

	void logPw_mouseClicked(java.awt.event.MouseEvent event)
	{
		// to do: code goes here.
		set_log_items();
	}

	void logRpm_mouseClicked(java.awt.event.MouseEvent event)
	{
		// to do: code goes here.
		set_log_items();
	}
}

