/*
		A basic implementation of the JFrame class.
*/

import java.awt.*;
import javax.swing.*;
import java.util.*;
import java.lang.System.*;
import symantec.itools.awt.StatusBar;

public class chartitem extends javax.swing.JFrame
{
    int last_record = -1;
    float hover_value = 0.0F;
    Point p = null;
    int test_point = 0;
    int test_delta = 0;
    int curr_record = -1;
	int chart_item = -1;
	int chart_high = -1;
	int chart_low = -1;
	int data_high = 0;
	int data_low = 65000;
	int frame_count = 0;
	int hover_x = 0;
	String ts;
	String lts = " ";
    Vector points = new Vector(); // x-axis is data value, y-axis is plottable point
    int lastDrawnPoint = 0;
    int lastx = 0;
    int w;
    int h;
	int top;
	int bottom;
	int left;
	int right;
	float conversion_factor;
    boolean inupdate = false;
    boolean inpaint = false;
    boolean scroll_locked = false;
    Insets insets = insets();
    
    chartcontrol chartcontrol_frame = null;
    TunerLog tuner_handle = null;
    datavalues datavalue_handle = null;

	public chartitem()
	{
		// This code is automatically generated by Visual Cafe when you add
		// components to the visual environment. It instantiates and initializes
		// the components. To modify the code, only use code syntax that matches
		// what Visual Cafe can generate, or Visual Cafe may be unable to back
		// parse your Java file into its visual environment.
		//{{INIT_CONTROLS
		getContentPane().setLayout(null);
		setCursor(java.awt.Cursor.getPredefinedCursor(java.awt.Cursor.CROSSHAIR_CURSOR));
		setSize(405,130);
		setVisible(false);
		//}}

		//{{INIT_MENUS
		//}}
	
		//{{REGISTER_LISTENERS
		SymMouseMotion aSymMouseMotion = new SymMouseMotion();
		this.addMouseMotionListener(aSymMouseMotion);
		SymWindow aSymWindow = new SymWindow();
		this.addWindowListener(aSymWindow);
		SymMouse aSymMouse = new SymMouse();
		this.addMouseListener(aSymMouse);
		//}}
	}

	public chartitem(String sTitle)
	{
		this();
		setTitle(sTitle);
	}

	public void setVisible(boolean b)
	{
		if (b)
		{
		    if (p != null)
        	  setLocation(p);
            else
			  setLocation(50, 50);
	    }
	    p = getLocation();
		super.setVisible(b);
	}

	static public void main(String args[])
	{
		(new chartitem()).setVisible(true);
	}

	public void addNotify()
	{
		// Record the size of the window prior to calling parents addNotify.
		Dimension size = getSize();

		super.addNotify();

		if (frameSizeAdjusted)
			return;
		frameSizeAdjusted = true;

		// Adjust size of frame according to the insets and menu bar
		Insets insets = getInsets();
		javax.swing.JMenuBar menuBar = getRootPane().getJMenuBar();
		int menuBarHeight = 0;
		if (menuBar != null)
			menuBarHeight = menuBar.getPreferredSize().height;
		setSize(insets.left + insets.right + size.width, insets.top + insets.bottom + size.height + menuBarHeight);
	}

	// Used by addNotify
	boolean frameSizeAdjusted = false;

	//{{DECLARE_CONTROLS
	//}}

	//{{DECLARE_MENUS
	//}}

    public void paint(Graphics g)
    {
        Point curPt = null;
        int start;
        int lastx1;
        int ly1;
        int ly2;

/*		if (inupdate)
		{
			inupdate = false;
			return;
		}*/
		if (points.size() == 0)
		    return;
		set_bounds();
		lastx1 = lastx;
		lastx = left;
		if (curr_record > last_record && last_record > 0 && last_record < w)
		    curr_record = last_record;
		start = Math.max(0, curr_record - (w - 2));
        inpaint = true;    
//		System.out.println("paint " + start + " " + curr_record);
        for (int i=start; i<curr_record; i++)
        {
			Point pt = (Point)points.elementAt(i);
			if (curPt != null)
			{
			    if (i - start == hover_x + 1)
			    {
			        hover_value = (float)(pt.y) / 100F;
//			        System.out.println(hover_value + " " + pt.y);
			    }
				if (lastx >= right)
				{
					// scroll

					g.copyArea(left,top,right,bottom, -1, 0);

					// clear

					g.clearRect(right,top,right,bottom);

					lastx = right;
				}

				// draw line from lastx to x + 1
				ly1 = (int)(((curPt.y / 100) + (0 - chart_low)) * conversion_factor);
				ly2 = (int)(((pt.y / 100) + (0 - chart_low)) * conversion_factor);
				g.drawLine(lastx - 2,h - ly1 + insets.top,lastx - 1,h - ly2 + insets.top);
			}
			curPt = pt;
			++ lastx;
		}

		lastDrawnPoint = points.size();
        -- lastx;//lastx = lastx1;
    }

    public void update(Graphics g) 
    {
        Point curPt = null;
        int ly1;
        int ly2;
        int start;
		inupdate = true;
		//System.out.println("update");
		lastDrawnPoint = Math.max(0, lastDrawnPoint-1);
		if (lastx >= right)
			start = (points.size() - w);
		else
			start = 0;
        for (int i=lastDrawnPoint; i<points.size(); i++)
        {
			Point pt = (Point)points.elementAt(i);
			if (curPt != null)
			{
			    if (i - start == hover_x + 1)
			    {
			        hover_value = (float)(pt.y) / 100F;
			    }
				if (lastx >= right - 2)
				{
					// scroll

					g.copyArea(left,top,right,bottom, -1, 0);

					// clear

					g.clearRect(right,top,right,bottom);

					lastx = right - 2;
				}

				// draw line from lastx to x + 1
				ly1 = (int)(((curPt.y / 100) + (0 - chart_low)) * conversion_factor);
				ly2 = (int)(((pt.y / 100) + (0 - chart_low)) * conversion_factor);
				g.drawLine(lastx - 2,h - ly1 + insets.top,lastx - 1,h - ly2 + insets.top);
			}
			curPt = pt;
		}

		lastDrawnPoint = points.size();
    }

    void set_bounds()
    {

		insets = insets();
		w = size().width-insets.left-insets.right;
		h = size().height-insets.top-insets.bottom;
		left = insets.left;
		right = size().width - (insets.right + 1);
		top = insets.top;
		bottom = size().height - (insets.bottom + 1);
		conversion_factor = (float)h / ((float)chart_high + (0 - chart_low));
	}
    
    public void plot_point(int data_point)
    {
        
        set_bounds();
		if (lastx == 0)
		{
			lastx = left;
			ts = getTitle();
		}
		++ frame_count;
		if (data_point / 100 > chart_high)
		  data_point = chart_high;
		else
		  if (data_point / 100 < chart_low)
		    data_point = chart_low;
        Point pt = new Point(lastx, data_point);
		if (data_point / 100 > data_high)
			data_high = data_point / 100;
		if (data_point / 100 < data_low)
			data_low = data_point / 100;
        points.addElement(pt);
        setscale(data_high);
        paint();
        ++ lastx;
        ++ last_record;
        hover_value = data_point / 100;
        update_status();
        ++ curr_record;
        return;
	}
	
	void update_status()
	{
	    int delta;
	    
	    if (chart_item == 3 ||
	        chart_item == 7)
	      delta = 100;
	    else
	      delta = 1;
	    String x;
	    
	    x = "";
	    //x = "Min: " + Integer.toString(chart_low) + " ";
	    //x = x + "Max: " + Integer.toString(chart_high) + " ";
        if (data_low != 65000)
        {
	        x = x + "High: " + Integer.toString(data_high / delta) + " ";
	        x = x + "Low: " + Integer.toString(data_low / delta) + " ";
	    }
	    x = x + hover_value / delta;
	    if (datavalue_handle != null)
		  datavalue_handle.set_value(chart_item, (float)hover_value / delta);
	    //x = x + "(" + hover_x + ")";
	    setTitle(ts + " " + x);
	}

	class SymMouseMotion extends java.awt.event.MouseMotionAdapter
	{
		public void mouseMoved(java.awt.event.MouseEvent event)
		{
			Object object = event.getSource();
			if (object == chartitem.this)
				chartitem_mouseMoved(event);
		}
	}

	void chartitem_mouseMoved(java.awt.event.MouseEvent event)
	{
		// to do: code goes here.
		
		hover_x = event.getX() - insets.left;
		if (hover_x > w - 2 || hover_x > last_record)
		    return;
		    
		if (tuner_handle.chartcontrol_frame != null)
		  tuner_handle.chartcontrol_frame.hover_sync(hover_x);
//		paintmark(hover_x);
//		update_status();
	}
	
    public void paint()
    {
        Graphics g;
        if (!isVisible())
            return;
        if (points.size() == 0)
            return;
        g=this.getGraphics();
        g.clearRect(0,0,size().width,size().height);
        paint(g);
        g.dispose();
    }    
    
	void paintmark(int x1)
	{
	    paint();
	    Graphics g = this.getGraphics();
        g.drawLine(x1+insets.left,top,x1+insets.left,bottom);
        g.dispose();
//        mark_loc = x1;
    }
    
	class SymWindow extends java.awt.event.WindowAdapter
	{
		public void windowActivated(java.awt.event.WindowEvent event)
		{
			Object object = event.getSource();
			if (object == chartitem.this)
				chartitem_windowActivated(event);
		}
	}

	void chartitem_windowActivated(java.awt.event.WindowEvent event)
	{
		// to do: code goes here.
		
		set_bounds();
		paint();
	}

	class SymMouse extends java.awt.event.MouseAdapter
	{
		public void mouseClicked(java.awt.event.MouseEvent event)
		{
			Object object = event.getSource();
			if (object == chartitem.this)
				chartitem_mouseClicked(event);
		}
	}

	void chartitem_mouseClicked(java.awt.event.MouseEvent event)
	{
		// to do: code goes here.

//		System.out.println(scroll_locked);
		if (scroll_locked)
		    return;
		if (tuner_handle.chartcontrol_frame != null)
		  tuner_handle.chartcontrol_frame.click_sync(event.getX(),size().width);
		
/*		if (event.getX() < size().width / 2)
		{
		    // scroll left
		    
		    scroll_data(size().width / -2);
		}
		else
		{
		    // scroll right
		    
		    scroll_data(size().width / 2);
		}
//		local_scroll = false;
	    paintmark(event.getX() - insets.right);*/
	}
	
	void scroll_data(int getx)
	{
	    int delta;
	    
		if (getx < size().width / 2)
		{
		    // scroll left
		    
		    delta = size().width / -2;
		}
		else
		{
		    // scroll right
		    
		    delta = size().width / 2;
		}
//	    System.out.println(delta + " " + curr_record + " " + last_record);
	    if (delta > 0)
	    {
	        if (curr_record + delta > last_record)
	        {
	            curr_record = last_record;
	            paint();
        	    paintmark(getx - insets.right);
//        		System.out.println(curr_record);
	            return;
	        }
	    }
		if (curr_record + delta > w - 2)
		    curr_record += delta;
		else
		    curr_record = w - 2;
//		System.out.println(curr_record);
		paint();
	    paintmark(getx - insets.right);
		update_status();
	}

	void clear_chart()
	{
	    Graphics g = this.getGraphics();
        g.clearRect(0,0,size().width,size().height);
	    g.dispose();
	    points.removeAllElements();
        last_record = -1;
        curr_record = -1;
	    chart_item = -1;
	    chart_high = -1;
	    chart_low = -1;
	    test_point = 0;
	    test_delta = 0;
	    data_high = 0;
	    data_low = 65000;
	    frame_count = 0;
	    hover_x = 0;
        lastDrawnPoint = 0;
        lastx = 0;
	    conversion_factor = -1F;
        inupdate = false;
        inpaint = false;
	    if (points.size() == 0)
	        return;
	}

	void resetscale()
	{
	    int loop;
	    
	    if (points.size() == 0)
	        return;
	    data_low = 65000;
	    data_high = -1;
	    conversion_factor = -1;
	    for (loop=0;loop<points.size();loop++)
	    {
			Point pt = (Point)points.elementAt(loop);
		    if (pt.y / 100 > data_high)
			    data_high = pt.y / 100;
		    if (pt.y / 100 < data_low)
			    data_low = pt.y / 100;
	    }
	    setscale(data_high);
//	    paint();
	}

	void setscale(int v)
	{
		if (conversion_factor == -1F)	
	        conversion_factor = (float)h / (float)chart_high;
		if (chartcontrol_frame != null)
		{
		    if (chartcontrol_frame.autorange.isSelected())
		    {
		        if (v > 0)
		            conversion_factor = (float)h / (float)v;
		    }
		    else
    	        conversion_factor = (float)h / (float)chart_high;
		}
	}
	
    void setrange(int pid)
    {
        //System.out.println("range: " + pid);
        if (pid == 1)
        {
            chart_item = 9;
            setTitle("RPMS");
            chart_low = 0;
            chart_high = 8000;
        }
        if (pid == 2)
        {
            chart_item = 0;
            setTitle("Timing");
            chart_low = -40;
            chart_high = 40;
        }
        if (pid == 7)
        {
            chart_item = 7;
            setTitle("TPS");
            chart_low = 0;
            chart_high = 10000;
        }
        if (pid == 5)
        {
            chart_item = 3;
            setTitle("O2 Voltage");
            chart_low = 0;
            chart_high = 200;
        }
        if (pid == 10)
        {
            chart_item = 12;
            setTitle("Low/Short Fuel Trim");
            chart_low = -20;
            chart_high = 20;
        }
        if (pid == 11)
        {
            chart_item = 13;
            setTitle("Medium Fuel Trim");
            chart_low = -20;
            chart_high = 20;
        }
        if (pid == 8)
        {
            chart_item = 18;
            setTitle("Air Flow");
            chart_low = 0;
            chart_high = 255;
        }
        if (pid == 12)
        {
            chart_item = 20;
            setTitle("Speed (MPH)");
            chart_low = 0;
            chart_high = 200;
        }
        if (pid == 9)
        {
            chart_item = 17;
            setTitle("Knock Sum");
            chart_low = 0;
            chart_high = 100;
        }
        if (pid == 3)
        {
            chart_item = 10;
            setTitle("Injector Pulse Width");
            chart_low = 0;
            chart_high = 50;
        }
        if (pid == 4)
        {
            chart_item = 1;
            setTitle("Coolant Temperature");
            chart_low = 0;
            chart_high = 255;
        }
        if (pid == 6)
        {
            chart_item = 11;
            setTitle("Intake Charge Temperature");
            chart_low = 0;
            chart_high = 255;
        }
        if (pid == 14)
        {
            chart_item = 48;
            setTitle("Long/High Fuel Trim");
            chart_low = -20;
            chart_high = 20;
        }
    }
    
    public void resume_chart()
    {
        curr_record = last_record;
        paint();
    }
}