/*
		A basic implementation of the JFrame class.
*/

import java.awt.*;
import javax.swing.*;
import java.util.*;
import symantec.itools.awt.StatusBar;

public class chartitem extends javax.swing.JFrame
{
    int last_record = -1;
    int test_point = 0;
    int test_delta = 100;
    int curr_record = -1;
	int chart_item = -1;
	int chart_high = -1;
	int chart_low = -1;
	int data_high = 0;
	int data_low = 65000;
	int frame_count = 0;
	int hover_x = 0;
	String ts;
	String lts = " ";
    Vector points = new Vector(); // x-axis is data value, y-axis is plottable point
    int lastDrawnPoint = 0;
    int lastx = 0;
    int w;
    int h;
	int top;
	int bottom;
	int left;
	int right;
	float conversion_factor;
    boolean inupdate = false;
    boolean inpaint = false;
    boolean scroll_locked = false;
    Insets insets = insets();

	public chartitem()
	{
		// This code is automatically generated by Visual Cafe when you add
		// components to the visual environment. It instantiates and initializes
		// the components. To modify the code, only use code syntax that matches
		// what Visual Cafe can generate, or Visual Cafe may be unable to back
		// parse your Java file into its visual environment.
		//{{INIT_CONTROLS
		getContentPane().setLayout(null);
		setSize(405,130);
		setVisible(false);
		//}}

		//{{INIT_MENUS
		//}}
	
		//{{REGISTER_LISTENERS
		SymMouseMotion aSymMouseMotion = new SymMouseMotion();
		this.addMouseMotionListener(aSymMouseMotion);
		SymWindow aSymWindow = new SymWindow();
		this.addWindowListener(aSymWindow);
		SymMouse aSymMouse = new SymMouse();
		this.addMouseListener(aSymMouse);
		//}}
	}

	public chartitem(String sTitle)
	{
		this();
		setTitle(sTitle);
	}

	public void setVisible(boolean b)
	{
		if (b)
			setLocation(50, 50);
		super.setVisible(b);
	}

	static public void main(String args[])
	{
		(new chartitem()).setVisible(true);
	}

	public void addNotify()
	{
		// Record the size of the window prior to calling parents addNotify.
		Dimension size = getSize();

		super.addNotify();

		if (frameSizeAdjusted)
			return;
		frameSizeAdjusted = true;

		// Adjust size of frame according to the insets and menu bar
		Insets insets = getInsets();
		javax.swing.JMenuBar menuBar = getRootPane().getJMenuBar();
		int menuBarHeight = 0;
		if (menuBar != null)
			menuBarHeight = menuBar.getPreferredSize().height;
		setSize(insets.left + insets.right + size.width, insets.top + insets.bottom + size.height + menuBarHeight);
	}

	// Used by addNotify
	boolean frameSizeAdjusted = false;

	//{{DECLARE_CONTROLS
	//}}

	//{{DECLARE_MENUS
	//}}

    public void paint(Graphics g)
    {
        Point curPt = null;
        int start;
        int lastx1;
        int ly1;
        int ly2;

		if (inupdate)
		{
			inupdate = false;
			return;
		}
		set_bounds();
		lastx1 = lastx;
		lastx = left;
		if (curr_record > last_record && last_record > 0 && last_record < w)
		    curr_record = last_record;
		start = Math.max(0, curr_record - (w - 2));
        inpaint = true;    
//		System.out.println("paint " + start + " " + curr_record);
        for (int i=start; i<curr_record; i++)
        {
			Point pt = (Point)points.elementAt(i);
			if (curPt != null)
			{
				if (lastx >= right)
				{
					// scroll

					g.copyArea(left,top,right,bottom, -1, 0);

					// clear

					g.clearRect(right,top,right,bottom);

					lastx = right;
				}

				// draw line from lastx to x + 1
				ly1 = (int)((curPt.y / 100) * conversion_factor);
				ly2 = (int)((pt.y / 100) * conversion_factor);
				g.drawLine(lastx - 2,h - ly1 + insets.top,lastx - 1,h - ly2 + insets.top);
			}
			curPt = pt;
			++ lastx;
		}

		lastDrawnPoint = points.size();
        -- lastx;//lastx = lastx1;
    }

    public void update(Graphics g) 
    {
        Point curPt = null;
        int ly1;
        int ly2;
        int start;
		inupdate = true;
		//System.out.println("update");
		lastDrawnPoint = Math.max(0, lastDrawnPoint-1);
		if (lastx >= right)
			start = (points.size() - w);
		else
			start = 0;
        for (int i=lastDrawnPoint; i<points.size(); i++)
        {
			Point pt = (Point)points.elementAt(i);
			if (curPt != null)
			{
				if (lastx >= right - 2)
				{
					// scroll

					g.copyArea(left,top,right,bottom, -1, 0);

					// clear

					g.clearRect(right,top,right,bottom);

					lastx = right - 2;
				}

				// draw line from lastx to x + 1
				ly1 = (int)((curPt.y / 100) * conversion_factor);
				ly2 = (int)((pt.y / 100) * conversion_factor);
				g.drawLine(lastx - 2,h - ly1 + insets.top,lastx - 1,h - ly2 + insets.top);
			}
			curPt = pt;
		}

		lastDrawnPoint = points.size();
    }

    void set_bounds()
    {

		insets = insets();
		w = size().width-insets.left-insets.right;
		h = size().height-insets.top-insets.bottom;
		left = insets.left;
		right = size().width - (insets.right + 1);
		top = insets.top;
		bottom = size().height - (insets.bottom + 1);
		conversion_factor = (float)h / (float)chart_high;
	}
    
    public void plot_point(int data_point)
    {
        set_bounds();
        inupdate = true;
		if (lastx == 0)
		{
			lastx = left;
			ts = getTitle();
		}
		++ frame_count;
        Point pt = new Point(lastx, data_point);
		if (data_point / 100 > data_high)
			data_high = data_point / 100;
		if (data_point / 100 < data_low)
			data_low = data_point / 100;
        points.addElement(pt);
        repaint();
        ++ lastx;
        ++ last_record;
        update_status();
        ++ curr_record;
        return;
	}
	
	void update_status()
	{
	    String x;
	    
	    x = "Min: " + Integer.toString(chart_low) + " ";
	    x = x + "Max: " + Integer.toString(chart_high) + " ";
        if (data_low != 65000)
        {
	        x = x + "High: " + Integer.toString(data_high) + " ";
	        x = x + "Low: " + Integer.toString(data_low) + " ";
	    }
	    x = x + "(" + hover_x + ")";
	    if (lts.compareTo(ts + " " + x) == 0)
	        return;
	    setTitle(ts + " " + x);
	    lts = ts + " " + x;
	}

	class SymMouseMotion extends java.awt.event.MouseMotionAdapter
	{
		public void mouseMoved(java.awt.event.MouseEvent event)
		{
			Object object = event.getSource();
			if (object == chartitem.this)
				chartitem_mouseMoved(event);
		}
	}

	void chartitem_mouseMoved(java.awt.event.MouseEvent event)
	{
		// to do: code goes here.
		
		hover_x = event.getX() - insets.left;
		if (hover_x > w - 2 || hover_x > last_record)
		    return;
		update_status();
			 
	}
	
    public void paint()
    {
        Graphics g;
        g=this.getGraphics();
        g.clearRect(0,0,size().width,size().height);
        paint(g);
        g.dispose();
    }    
        

	class SymWindow extends java.awt.event.WindowAdapter
	{
		public void windowActivated(java.awt.event.WindowEvent event)
		{
			Object object = event.getSource();
			if (object == chartitem.this)
				chartitem_windowActivated(event);
		}
	}

	void chartitem_windowActivated(java.awt.event.WindowEvent event)
	{
		// to do: code goes here.
		
		set_bounds();
		paint();
	}

	class SymMouse extends java.awt.event.MouseAdapter
	{
		public void mouseClicked(java.awt.event.MouseEvent event)
		{
			Object object = event.getSource();
			if (object == chartitem.this)
				chartitem_mouseClicked(event);
		}
	}

	void chartitem_mouseClicked(java.awt.event.MouseEvent event)
	{
		// to do: code goes here.
		
		if (scroll_locked)
		    return;
		
		if (event.getX() < size().width / 2)
		{
		    // scroll left
		    
		    scroll_data(size().width / -2);
		}
		else
		{
		    // scroll right
		    
		    scroll_data(size().width / 2);
		}
	}
	
	void scroll_data(int delta)
	{
	    if (delta > 0)
	    {
	        if (curr_record + delta > last_record)
	        {
	            curr_record = last_record;
	            paint();
	            return;
	        }
	    }
		if (curr_record + delta > w - 2)
		    curr_record += delta;
		else
		    curr_record = w - 2;
		//out.println("scroll " + inupdate);    
		paint();
	}
	void clear_chart()
	{
	    if (points.size() == 0)
	        return;
	    points.removeAllElements();
        last_record = -1;
        current_point = -1;
        chart_loaded = false;
        local_scroll = false;
        curr_record = -1;
        mark_loc = 0;
	    chart_item = -1;
	    chart_high = -1;
	    chart_low = -1;
	    data_high = 0;
	    data_low = 65000;
	    frame_count = 0;
	    hover_x = 0;
        lastDrawnPoint = 0;
        lastx = 0;
	    conversion_factor = -1F;
        inupdate = false;
        inpaint = false;
	}
}