 /*
	1)  add "discard log file"    				done
	2)  add "create log file" 		    		done
	3)  add write log data					      done				
			write file header         				done
				log type	              				done
					1 = drb					              done
					2 = t16	              				done
				# of parms				            	done
				frame rate					            done
				parm list		              			done
			write raw data	          				done
				drb			                				done
				t16						                	done
	4)  add date to directory entry			  done
	5)  add time to directory entry			  done
	6)  add lf_name to directory entry		done
	7)  add p/c transfer process
			registered feature			        	done
			link to Tunestein Player
	8)  add playback charting
			open file (passed from list)	    done
			build table of logged parms		    done
			chart parms						            done
			draw frames						            done
			chart list						            done
				hide/display				            done
				load contents				            done
			play controls
				start				        >       		done
				stop			          ||      		done
				rewind			      	<<		      done
				single step fwd		  ->		      done
				single step rev		  <-  
				play rate adjust			          disabled
					faster			      ++		      disabled
					slower			      --		      disabled
					display rate			            done
			data point "click"		            done
	9)  add OBD data calc	        				done
	10) N/A									              done
	11) add log logic for obd-ii			    done	
			send parms						            done
			process data					            done
	12) add error recovery                done
	13) add time out - reconnect          done
			t16 - 5 seconds                   done        
	15) add beta limits                   done
			no p/c link						            done
			expire date	5/1/2001			        done
			log duration part throttle		    done
				2 minutes					              done
			log duration wot throttle		      done
				10 seconds					            done
	16) save/recall settings            	done
			interface choice				          done
			t16 parms						              done
			drb parms						              done
			logger chart choices			        done
	17) add directory init button
			registered feature
	18) add utility to display directory 
			entries
	19) add make csv utility
			registered feature
	20) registration scheme               done
	21) N/A									              done
	22) end of program logic				      done
			stop logging					            done
			save data						              done
	23) stop PDA from going to sleep		  done
	24) force config on first "start"	
	25) make directory self-cleaning		  done	
	26) add support for ford/gm enhanced
  		protocols	
	27) read data from serial buffer	  	done	
	28) display/clear error codes	
	29) lock rpms on						          done
	30)	add T16 sign on (init process)    done
	31) no "DONE" while log is being      done
	      played	                        done
	32) set "list" index for each 
	    loggable item                     done
	33) chart frames - optional   				done
	34) sync log list to loggable items
	35) get list of supported PID's
	36) screen to display data "values"
	37) t16 error detection
	38) peak hold, using above screen and
	      "buttons"
	39) add error count to buffer/rate
	      display
	*/

#define PILOT_PRECOMPILED_HEADERS_OFF

/* 4.25.00 changed to use Palm OS 3.5 headers */

#include <PalmOS.h>
#include <PalmCompatibility.h>
#include <SerialMgrOld.h>
#include <FloatMgr.h>
#include "Starter_Res.h"
  static char msg[100];

#define MainOptionsMenu                           1000
#define MainOptionsAboutPalmnStein                9000
#define MainOptionsTroubleCodes                   1001
#define MainOptionsSelectInterface                1005
#define MainOptionsConfigureLogger                1006
#define MainOptionsPlayBack                       1008

#define P1 keyBitPower
#define F1 keyBitHard1
#define F2 keyBitHard2
#define F3 keyBitHard3
#define F4 keyBitHard4
#define PAGEUP keyBitPageUp
#define PAGEDOWN keyBitPageDown
#define NOKEY NULL
#define keysAllowedMask		(P1 | PAGEUP | PAGEDOWN | F1 | F2 | F3 | F4)
#define max_items 29						// max loggable items
#define chart_limit 120
#define ok_to_log      (loggable_items && logger_status == 2)	// test for ok to log
#define red 0
#define blue 1
#define green 2

static double dv1;
static double inj_duty_cycle;
static double inj_pw;
static int    inj_rpms;
static float ratio[] =
  {
    5.90F,  //  0.0  0
    6.20F,  //  0.1  1
    6.50F,  //  0.2  2
    6.80F,  //  0.3  3
    7.10F,  //  0.4  4
    7.40F,  //  0.5  5
    7.70F,  //  0.6  6
    8.00F,  //  0.7  7
    8.30F,  //  0.8  8
    8.60F,  //  0.9  9
    8.90F,  //  1.0 10
    9.20F,  //  1.1 11
    9.50F,  //  1.2 12
    9.80F,  //  1.3 13

   10.10F,  //  1.4 14
   10.40F,  //  1.5 15
   10.70F,  //  1.6 16
   11.03F,  //  1.7 17
   11.40F,  //  1.8 18
   11.75F,  //  1.9 19
   12.20F,  //  2.0 20
   12.60F,  //  2.1 21
   13.06F,  //  2.2 22
   13.59F,  //  2.3 23
   14.10F,  //  2.4 24
   14.70F,  //  2.5 25
   15.85F,  //  2.6 26
   17.20F,  //  2.7 27
   18.76F,  //  2.8 28
   20.65F,  //  2.9 29

   21.70F,  //  3.0 30
   23.15F,  //  3.1 31
   24.60F,  //  3.2 32
   26.05F,  //  3.1 31
   27.50F,  //  3.4 34
   28.95F,  //  3.5 35
   30.40F,  //  3.6 36
   31.85F,  //  3.7 37
   33.30F,  //  3.8 38
   34.75F,  //  3.9 39
   36.20F,  //  4.0 40
   37.65F,  //  4.1 41
   39.10F,  //  4.2 42
   40.55F,  //  4.3 43
   42.00F,  //  4.4 44
   43.45F,  //  4.5 45
   44.90F,  //  4.6 46
   46.35F,  //  4.7 47
   47.80F,  //  4.8 48
   49.25F,  //  4.9 49
   50.70F,  //  5.0 50
   52.15F,  //  5.1 51
  };

static long lv1;
static unsigned long t16_timer = 0;
static int perf_level = 0;
static int g_err = 0;
static int c_err = 0;
static int perf_level_default = 0;
static int send_delay = 10;
//static int lap_number = -1;
//static UInt32_start = 0;
//static int lap_minutes = 0;
//static int lap_seconds = 0;
//static char lap_string[100][20];
//static UInt32  lap_ticks;
//static int     lap_milli;
static UInt32 last_send_time = 0;
static UInt32 plot_start_ticks = 0;
static UInt32 plot_frame_ticks = 0;
static UInt32 plot_last_ticks[3];
static Boolean pre_fetch_default = false;
static FormPtr MainfrmP;
static Boolean save_mode = false;
static Boolean skip_request = false;
static Boolean just_woke_up = false;
static Boolean use_ifr = false;
static Boolean timeslip_loaded = false;
static Boolean carsetup_loaded = false;
static UInt32 hardkeystate = 0;
static unsigned char avail_pids[256];
static int obd_protocol = 1;  // 1 - iso/sync, 2 vpw, 4 pwm, 10 iso no-sync
static unsigned char obd_sync = 0x48;  // 48 - 9141/vpw, 61 - pwm
static unsigned char obd_response = 0x81; // 81 iso, 82 vpw, 84 pwm
static formfirstcontrol;
static formlastcontrol;
static formcurrentcontrol;
static Boolean obd_logon = false;
static ControlPtr ctlptr;
static Boolean registered = false;			// product reg flag
static Boolean test_mode = false;  			// force test mode
static char    reg_string[200];
static char    obd_frames[400];
static char    interface_rev[10];
static int     t16_rev = 0;
static Boolean first_time = true;
static Boolean no_chart_update = false;
											//		used to test chart scaling
static Int16 use_drb = 0;					// 1 = use drb
static Int16 use_t16 = 1;					// 1 = use t16 (obd-ii)
static int   play_entry;					// log directory entry to "play"
static int   dlc_address = 0;
static int lasty_points[3][chart_limit + 5];
static int time_points[chart_limit + 5];
static int max_logfiles = 100;						// max logfiles in directory
static char		lf_name[20];			// current log file name
static char memo_text[1000];
static FileHand dir_handle = 0;	
static FileHand dtc_handle = 0;
static FileHand reg_handle = 0;		// handle to directory file
static FileHand log_handle = 0;			// handle to log file
static Boolean  tps_logged = false;
const  char *form_title;
const  char *play_title;

static struct  log_dir_struct
{
	char       log_name[50];				// directory entry name
	char       log_fnme[20];				// actual file name
	char       fill[40];					// room to grow
} log_directory[100];				// directory table

static Int16   items_to_log[max_items];		// table of loggable items
static Int16   item_count;					// number of items selected to log

static Boolean   loggable_items = false;	// true if at least one item is loggable
static Boolean   data_logged    = false;	// true if we've logged at least one frame
static Int16     logger_status  = 2;  		// 0 - run, 1 - paused, 2 - stopped

static int lastx[3];							// last x axis point for each chart
static int lasty[3];							// last y axis point for each chart
static int chart_status[3];			
static int play_status[3];			// chart status set to 1 if chart list[x] != 0
static Boolean chart_visible[3];
static Boolean show_peak = false;

static unsigned char log_buffer[8192];					// buffer for logged data, contains only raw data from ecu
static int frame_byte  = 0;						// number of bytes in the buffer
static int frame_count = 0;						// number of frames in the buffer
static int error_count = 0;						// number of errors in the frame

static Boolean logger_controls = false;					

static int serial_baud     = -1;			// serial port baud rate
static int serial_rts      = -1;			// serial port rts
static int serial_dts      = -1;			// serial port dts
static int serial_parity   = -1;			// serial port parity
static int serial_stopbits = -1;			// serial port stop bits
static int serial_charsize = -1;			// serial port data bits
static int serial_rxsize   = -1;			// serial port rx buf size
static int serial_txsize   = -1;			// serial port tx buf size
static int serial_open     = -1;			// serial port open flag
static UInt serial_library  = 1;			// handle to serial library

static char field_string[35][15] =
{
	"Rpms",
	"O2v",
	"Timing",
	"Tps",
	"Air Flw",
	"Sht Trim",
	"Lng Trim",
	"Air Temp",
	"Wtr Temp",
	"Low Trim",
	"Med Trim",
	"Knock Ret",
	"Pulse Wdth",
	"Hgh Trim",
	"",
	"None",
	"MPH",
	"MAP",
	"Sht Trim(2)",
	"Lng Trim(2)",
	"Load",
	"O2v B2",
	"",
	"",
	"O2v Trim",
	"Time",
	"ISC",
	"Boost (GM)",
	"WB Afr",
	"WB Afr"
};			// table of element names

static char play_fname[100];					// log file name
static char play_list_size[1];				// # of elements in log file
static char play_list[50];					// list of elements in log file
static char play_rate[1];					// first data byte
static unsigned char play_byte[2];					// second data byte
static char play_count;						// field in frame counter
static char log_type[1];					// 1= drb, 2 = t16
static char * t_list[25];					// list of chartable items	
static char * l_list[25];			
static char * d_list[25];			
static char * status_desc;
static char * dtc_desc;        		// list of loggable items
static char * file_list[100];
static char dtc_list[20][40];
static char empty_list[20] = "  ";
static Int32 first_frame;					// byte offset of first frame in log file
static Int32 current_frame;					// current frame offset in log file
static Int32 new_frame;					// current frame offset in log file
static int  play_run = 2;  					// 2 = stop, 0 = run
static Boolean play_mode = false;
static char dtc_detail[500];
static char status_detail[100];
static UInt32 t16_sent_requests = 0;
static UInt32 t16_rejected_requests = 0;
static UInt32 t16_received_responses = 0;
static UInt32 t16_rejected_responses = 0;
static long peak_values[40];
static IndexedColorType color_index[3];
static RGBColorType red_color;
static RGBColorType blue_color;
static RGBColorType green_color;
static DrawStateType draw_state;
static char pid[22] = {0x0c,0x14,0x0e,0x11,0x10,0x06,0x07,0x0f,0x05,0,0,0,0,0,0,0,0x0d,0x0b,0x08,0x09,0x04,0x18};
static char drb[] = {0x21,0x13,0x06,0x17,0x1a,0x0c,0x0d,0,0,0x26,0x29,0x0e,0,0,0,0,0,0,0,0,0,0,0x0f,0,0x16,0x12,0x12,0x12};
static char command_on[11] = {0xf6,0xf4,0xf1,0xf3,0xf5,0xfc,0xfb,0xfa,0xf9,0xf8,0xf7};
static char command_off[11] = {0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff};
static struct
{
  mil_light : 1;
  count     : 7;
} dtc;
static int dtc_count = 0;
/***********************************************************************
 *
 *   Entry Points
 *
 ***********************************************************************/
static void AppEventLoop(void);
static Boolean AppHandleEvent( EventPtr);
static void init_log_list();
static void set_log_list(int);
static void show_logger_controls();
static double valid_double(Word, double, double);
static VoidPtr GetObjectPtr(Word);
static void PnsCopyLabel (FormType *, UInt16, const Char*);
static void PnsSetTextPtr (FieldType *, Char *);
static void PnsSetListChoices (UInt16, Char **, Int16, Int16);
static void PnsSetTitle(char *);
static void data_logger();


/***********************************************************************
 *
 *   Internal Structures
 *
 ***********************************************************************/
typedef struct
{
  char        date[9];
  char        time[9];
  double      temp;
  double      humidity;
  double      baro;
  double      dialin;
  double      rt;
  double      et_60;
  double      et_330;
  double      et_660;
  double      mph_660;
  double      et_1000;
  double      et_1320;
  double      mph_1320;
  double      lrpm;
  double      srpm;
  double      altitude;
} timeslipstruct;

static timeslipstruct timesliprecord;

typedef struct
{
  char    tire_data[81];
  double  tire_rf;
  double  tire_lf;
  double  tire_rr;
  double  tire_lr;
  char    shock_data[81];
  double  shock_rf;
  double  shock_lf;
  double  shock_rr;
  double  shock_lr;
  char    plug_data[81];
  double  plug_gap;
  double  boost;
  double  weight;
  char    ecu_pgm_number[5];
  char    ecu_pgm_name[81];
  char    fuel_data[81];
  double  fuel_volume;
  double  fuel_pressure;
  double  nos_shot_1;
  double  nos_time_1;
  double  nos_rate_1;
  double  nos_shot_2;
  double  nos_time_2;
  double  nos_rate_2;
  double  water_inj;
  double  water_jet_1;
  double  water_jet_2;
} carstruct;

static carstruct carrecord;

typedef struct 
	{
		// interface presets
		
		char 		  use_t16_chk;
		char 		  use_drb_chk;
		char      use_fast_mode;
		Boolean		test_mode_chk;
		char	    chart_frames;
		int			  log_item_count;
		char	    log_items[50];
		char      chart_by_time;
		UInt16    slider_value;
		int       single_chart;
		int       color_support;
		Boolean   peak_hold;
		int       monitor_mode;
		
		// drb presets
		
		char		  drb_items[21];
		char		  drb_charts[3];
		
		// t16 presets
		
		char 		  t16_items[40];
		char		  t16_charts[3];
		
		// play presets 
		
		char      digital_mode;
		int       autosave;
		int       chart_width;
		int       chart_height;
		int       chart_scale;
		int       chart_spacing;
		int       chart_top[3];
		int       chart_base[3];
		UInt32    expiration_date;
		Boolean   auto_start;
		double    wideband_cal;
		double    map_cal;
		
	} StarterPreferenceType;

static StarterPreferenceType prefs;			// structure of pre-sets.

typedef struct 
	{
	Byte replaceme;
	} StarterAppInfoType;

typedef StarterAppInfoType* StarterAppInfoPtr;


/***********************************************************************
 *
 *   Global variables
 *
 ***********************************************************************/
//static Boolean HideSecretRecords;


/***********************************************************************
 *
 *   Internal Constants
 *
 ***********************************************************************/
#define appFileCreator					  'SWNG'
#define appVersionNum              0x05
#define appPrefID                  0x0c
#define appPrefVersionNum          0x0c


// Define the minimum OS version we support

#define ourMinVersion	sysMakeROMVersion(3,5,0,sysROMStageRelease,0)

static Boolean obd_connect();
static void err_rtn(char []);
static void hide_logger_controls();
static void show_peak_values();

static void PnsSetTitle(Char *title)
{
  if (StrLen(title) > 0)
    FrmSetTitle(FrmGetActiveForm(),title);
}

static void PnsSetListChoices (UInt16 listP, Char **itemsText, Int16 numItems, Int16 sel)
{
  int x;

  for (x=0;x<numItems;x++)
  {
    if (StrLen(itemsText[x]) <= 0)
      itemsText[x] = &field_string[14][0];
  }
  LstSetListChoices(GetObjectPtr(listP), itemsText, numItems);
  if (sel >= 0)
  	LstSetSelection(GetObjectPtr(listP),sel);
  FrmShowObject(FrmGetActiveForm(), FrmGetObjectIndex(FrmGetActiveForm(), listP ));
}

static void PnsSetTextPtr (FieldType *fldP, Char *textP)
{
  if (StrLen(textP) <= 0)
    return;
  FldSetTextPtr(fldP,textP);
  FldRecalculateField (fldP,true);
  FldDrawField(fldP);
}

static void PnsCopyLabel (FormType *formP, UInt16 labelID, const Char *newLabel)
{
  if (StrLen(newLabel) > 0)
    FrmCopyLabel(formP, labelID, newLabel);
}

static void process_pids()
{
  int x;
  int x1 = 0;
  int x2 = 0;
  int x3 = 0;
  
  if (use_t16 != 1)
    return;
    
  // scan list of items, if a selected item is unavail:
  //   de-select it
  //   decrement item_count
  
  for (x=0;x<max_items;x++)
    if (items_to_log[x] != 0 && x != 23)
    {
      ++ x1;
      if (avail_pids[obd_frames[(x * 15) + 7]] == 0)
      {
        for (x3=0;x3<3;x3++)
          if (chart_status[x3] == x1)
            chart_status[x3] = 0;
        items_to_log[x] = 0;
        -- item_count;
        ++ x2;
      }
    }
    
  if (x2 > 0)
  {
    hide_logger_controls();
    set_log_list(0);
    show_logger_controls();
//    err_rtn("skipped items");
  }
}

static Boolean hardkey( EventPtr);

static void err_rtn(char b[])
{
  char eb1[200];

  StrPrintF(eb1,"%s",b);
  InsPtEnable(!InsPtEnabled());
 	FrmCustomAlert(FileopenAlert,eb1,NULL,NULL);
  InsPtEnable(!InsPtEnabled());
}

static void setup_charts(int chart_table[])
{
  int chart_count = 0;
  int chart_array[3];
  int x  = 0;
  int x1;
  Boolean color_mode = false;
  UInt32 *UI1 = 0;
  UInt32 *UI2 = 0;
  UInt32 *UI3 = 0;
  
  // count the number of charts, build continuous list
  
  if (prefs.peak_hold && play_mode)
    return;
    
  for (x=0;x<3;x++)
    for (x1=0;x1<chart_limit+5;x1++)
      lasty_points[x][x1] = 0;
      
  for (x=0;x<max_items;x++)
    peak_values[x] = 0;
    
  chart_array[0] = chart_array[1] = chart_array[2] = 0;
  chart_visible[0] = chart_visible[1] = chart_visible[2] = false;
  for (x=0;x<3;x++)
    if (chart_table[x] != 0)
    {
      chart_array[chart_count] = chart_table[x];
      ++ chart_count;
    }
    
  // test for PDA color support
  
  WinScreenMode(winScreenModeGet,UI1,UI2,UI3,&color_mode); 
  if (!color_mode)
    prefs.color_support = 0;
  
  chart_table[0] = chart_array[0];
  chart_table[1] = chart_array[1];
  chart_table[2] = chart_array[2];
  
  if (prefs.single_chart)
  {
    prefs.chart_width   = chart_limit; // 120
    prefs.chart_height  = 121; // 21
    prefs.chart_scale   = 120; // 20
    prefs.chart_spacing =  40; // 40
    prefs.chart_top[0]  =  15; // 20
    prefs.chart_top[1]  =  15; // 60
    prefs.chart_top[2]  =  15; // 100
    prefs.chart_base[0] = prefs.chart_top[0] + prefs.chart_scale;
    prefs.chart_base[1] = prefs.chart_top[1] + prefs.chart_scale;
    prefs.chart_base[2] = prefs.chart_top[2] + prefs.chart_scale;
    lasty[0] = prefs.chart_base[0];
    lasty[1] = prefs.chart_base[1];
    lasty[2] = prefs.chart_base[2];
    return;
  }
  
  lasty[0] = prefs.chart_base[0];
  lasty[1] = prefs.chart_base[1];
  lasty[2] = prefs.chart_base[2];
  
  x = chart_count;
  
  switch (x)
  {
    case 1:
        prefs.chart_width   = chart_limit; // 120
        prefs.chart_height  = 121; // 21
        prefs.chart_scale   = 120; // 20
        prefs.chart_spacing =  40; // 40
        prefs.chart_top[0]  =  15; // 20
        prefs.chart_top[1]  =  65; // 60
        prefs.chart_top[2]  = 115; // 100
        prefs.chart_base[0] = prefs.chart_top[0] + prefs.chart_scale;
        prefs.chart_base[1] = prefs.chart_top[1] + prefs.chart_scale;
        prefs.chart_base[2] = prefs.chart_top[2] + prefs.chart_scale;
      break;
    case 2:
        chart_table[0] = chart_array[0];
        chart_table[2] = chart_array[1];
        chart_table[1] = chart_array[2];
        prefs.chart_width   = chart_limit; // 120
        prefs.chart_height  =  61; // 21
        prefs.chart_scale   =  60; // 20
        prefs.chart_spacing =  95; // 40
        prefs.chart_top[0]  =  15; // 20
        prefs.chart_top[1]  =  65; // 60
        prefs.chart_top[2]  =  95; // 100
        prefs.chart_base[0] = prefs.chart_top[0] + prefs.chart_scale;
        prefs.chart_base[1] = prefs.chart_top[1] + prefs.chart_scale;
        prefs.chart_base[2] = prefs.chart_top[2] + prefs.chart_scale;
        lasty[0] = prefs.chart_base[0];
        lasty[2] = prefs.chart_base[2];
        lasty[1] = prefs.chart_base[1];
      break;
    case 3:
    default:
        prefs.chart_width   = chart_limit; // 120
        prefs.chart_height  =  41; // 21
        prefs.chart_scale   =  40; // 20
        prefs.chart_spacing =  40; // 40
        prefs.chart_top[0]  =  15; // 20
        prefs.chart_top[1]  =  65; // 60
        prefs.chart_top[2]  = 115; // 100
        prefs.chart_base[0] = prefs.chart_top[0] + prefs.chart_scale;
        prefs.chart_base[1] = prefs.chart_top[1] + prefs.chart_scale;
        prefs.chart_base[2] = prefs.chart_top[2] + prefs.chart_scale;
      break;
  }
}


/***********************************************************************
 *
 * FUNCTION:    GetObjectPtr
 *
 * DESCRIPTION: This routine returns a pointer to an object in the current
 *              form.
 *
 * PARAMETERS:  formId - id of the form to display
 *
 * RETURNED:    VoidPtr
 *
 * REVISION HISTORY:
 *
 *
 ***********************************************************************/
static VoidPtr GetObjectPtr(Word objectID)
{
	FormPtr frmP;



	frmP = FrmGetActiveForm();
	return (FrmGetObjectPtr(frmP, FrmGetObjectIndex(frmP, objectID)));
}

static UInt32 TntGets(UInt16 rf, unsigned char p[], UInt32 c, Int32 t, Err* e)
{
  UInt32 x;
  char cs = 0;
  int i1;
  
  if (skip_request)
  {
    for (i1=0;i1<13;i1++)
      p[i1] = 0x00;
    p[1] = obd_response;
    
    return c;
  }
  
  x = SerReceive(rf,p,c,t,e);
  
  if (use_t16 == 1 && t == 14)
  {
    ++ t16_received_responses;
    
    if (p[3] != obd_response)
    {
      ++ t16_rejected_requests;
      ++ send_delay;
    }
    else  
    {
      for (i1=1;i1<13;i1++)
        cs += p[i1];
        
      if (cs != p[13] && p[3] == obd_response)
      {
        ++ t16_rejected_responses;
        ++ send_delay;
        p[1] = 0x80;
        p[3] = 2;
      }
    }    
  }
  
  return x;
}

static int test_bit(unsigned int val, int bit_to_test)
{
  unsigned int v1;
  unsigned int v2;
  static char buf[20];
  int bit;

  if (val == 0)
    return 0;
    
  if (bit_to_test < 0 || bit_to_test > 15)
    return 0;
    
  v1 = val;
  v2 = 32768;
  
  for (bit=15;bit>=0;bit--)
  {
    if (bit == bit_to_test)
    {
      if (v1 >= v2)
        return 1;
      else
        return 0;
    }
    if (v1 >= v2)
      v1 = v1 - v2;
    if (v1 < 0)
      return 0;
    v2 = v2 / 2;
  }
  
  return 0;
}

static int wait_for_bytes(int port, int cnt, int timeout)
{
	unsigned long td;
	UInt32        bt;
	
	// if we are in test mode, fake a positive response

	if (test_mode)
		return 0;
		
	if (skip_request)
	  return cnt;
	
	// seed the timer (current time in seconds) + time to wait
	
	td = TimGetSeconds() + (timeout);
	
	// start looping
	
	do
	{
		// get the number of bytes in the buffer, if it meets or exceeds our count, return
	
		SerReceiveCheck(serial_library,&bt);
		if (bt >= cnt)
			return bt;
	}
	while (TimGetSeconds() < td);  // loop until time period has elapsed
	
	// if we got hear, we ran out of time waiting for the data to appear
	
	return -1;
}

static void TntRxClear()
{
	UInt32 bt;
	
	// if we are in test mode, fake a positive response

	if (test_mode)
		return;
	
	SerReceiveCheck(serial_library,&bt);
	if (bt > 0)
	  SerReceiveFlush(serial_library,0);

}

static ULong TntTimer()
{
	// return current time in seconds
	
	return TimGetSeconds();
}

static void send_bytes(char b[], int l)
{
  Err ep;
  int l1 = 0;
  int l2 = 0;
  
  if (use_t16 == 1 || use_drb == 1)
  {
   if (send_delay > 0)
   {
     last_send_time = TimGetTicks() + send_delay;
     do
     {
     }
     while (TimGetTicks() < last_send_time);
   }
  }

  if (perf_level == 0 || perf_level == 1)
  {
    SerSend(serial_library,b,l,&ep);
    if (perf_level == 1)
      SerSendWait(serial_library,-1);
    return;
  }
  
  if (g_err == 5 && perf_level < 4)
  {
    ++ perf_level;
    g_err = 0;
  }

  for (l1=0;l1<l;l1++)
  {
    SerSend(serial_library,&b[l1],1,&ep);
    l2 = TimGetTicks();
    do
    {
    }
    while (l2 == TimGetTicks());
    if (perf_level == 4)
      SerSendWait(serial_library,-1);
  }
  if (perf_level == 3)
    SerSendWait(serial_library,-1);

}

static int TntPuts(int port, char ch[], int ct)
{

//  char buff[20];
  char tc;
  int  i1;
	
	// send a number of bytes to the serial port
	
  if ((ct == 15 || ct == -150) && ch[0] == 0x25)
  {

    if (!obd_logon)
    {
      perf_level = 4;
      if (!obd_connect())
      {
        // error
        return -1;
      }
      else
        obd_logon = true;
      perf_level = perf_level_default;
    }
    
    if (avail_pids[ch[7]] == 0 && ch[6] == 0x01 && use_t16 == 1)
    {
      skip_request = true;
      return 0;
    }
    else
      skip_request = false;
       
    if (obd_protocol == 1) // iso
    {
      if (TntTimer() < t16_timer + 5)
      {
        if (t16_rev >= 55)
        {
          if (ct == -150)
            tc = 0x10;
          else
            tc = 0x81; // 0x10
        }
        else
          tc = 0x10;
      }
      else
        tc = 0x01;
 
      ch[3] = 0x68;  
      if (tc != ch[1] || ct == -150)
      {
        ch[1] = tc;      
        ch[14] = 0;
        for (i1=1;i1<14;i1++)
          ch[14] += ch[i1];
      }
            
    }

    if (obd_protocol == 2 && ct == -150) // pwm
    {
      if (use_ifr)
        ch[1] = 0x80;
      else
        ch[1] = 0x84;
      if (ct == -150)
        ch[1] = 0x04;
      ch[3] = 0x61;
        ch[14] = 0;
        for (i1=1;i1<14;i1++)
          ch[14] += ch[i1];
    }

    if (obd_protocol == 3 && ct == -150) // vpw
    {
      if (ct == -150)
        ch[1] = 0x02;
      else
        ch[1] = 0x82;
      ch[3] = 0x68;
        ch[14] = 0;
        for (i1=1;i1<14;i1++)
          ch[14] += ch[i1];
    }  

  }

  if (ct == -150)
    ct = 15;

  send_bytes(ch,ct);
  
//  StrPrintF(buff,"%x",ch[1]);
//  FrmSetTitle(FrmGetActiveForm(),buff);
  
  if (ct == 15 && ch[0] == 0x25)
  {
    ++ t16_sent_requests;
    if (obd_protocol == 1)
      t16_timer = TntTimer();
  }
	return 0;
}

static void std_conversion()
{

  PnsSetTitle("Not implemented!");

}

static void nhra_conversion()
{
  static char title_string[30];
  double et;
  long   lt;
  double mph;
  long   lph;
  FormPtr frmP;
  
  frmP = FrmGetActiveForm();

  et = .9874;
  et = et - ((timesliprecord.altitude - 1200) / 100) * .0013;
  et = et * timesliprecord.et_1320;
  lt = et * 1000;
  
  mph = 1.0129;
  mph = mph + ((timesliprecord.altitude - 1200) / 100) * .0014;
  mph = mph * timesliprecord.mph_1320;
  lph = mph * 1000;
  StrPrintF(title_string,"ET: %ld.%03ld  MPH: %ld.%03ld",lt/1000,lt%1000,lph/1000,lph%1000);
  PnsSetTitle(title_string);
  
}

static Boolean get_pids(unsigned char lb[])
{
  int i1;
  int i2;
  char request_string[20];
  static char pid_buf[40];
  int i3 = 0;
  int pid_start = 0x01;
  Err er;
  FormPtr frmP;
  
  frmP = FrmGetActiveForm();
  
  PnsSetTitle("Getting supported parms");
    
  for (i1=0;i1<255;i1++)
    avail_pids[i1] = 0;
    
  if (test_mode)
  {
    lb[7]  = 0xff;
    lb[8]  = 0xff;
    lb[9]  = 0xff;
    lb[10] = 0xff;
  }
  
  // process current pid fram (in lb[])
  
  // if bit 0 of Byte D is 1, get the next block of PID's
  do
  {
    for (i1=7;i1<11;i1++)
    {
      for(i2=7;i2>=0;i2--)
      {
        avail_pids[pid_start] = test_bit((unsigned int)lb[i1],i2);
        if (avail_pids[pid_start] == 1)
        {
          i3 += 5;
        }
        ++ pid_start;
      }
    }
    
    if (pid_start < 255)
    {
      // build pid frame for next block of pid's
    	request_string[0]  = 0x25;
    	request_string[1]  = 0x04;
    	request_string[2]  = 0x05;
    	request_string[3]  = 0x61;
    	request_string[4]  = 0x6a;
    	request_string[5]  = 0xf1;
    	request_string[6]  = 0x01;
    	request_string[7]  = pid_start - 1;
    	request_string[8]  = 0x00;
    	request_string[9]  = 0x00;
    	request_string[10] = 0x00;
    	request_string[11] = 0x00;
    	request_string[12] = 0x00;
    	request_string[13] = 0x00;
    	request_string[14] = 0x00;
 
      // request the block

    	send_bytes(request_string,15);
    	if (wait_for_bytes(0,14,5) >= 0 && !test_mode)
    	{
        TntGets(serial_library,lb,14,-1,&er);
        if (lb[1] != 0x80)
        {
          continue;
        }
        else
        {
          
          StrPrintF(pid_buf,"Error getting PID frame %x",lb[3]);
          break;
        }
    	}
    	else
    	  if (!test_mode)
    	  {
    	    err_rtn("No pid response");
    	    break;
    	  }
    	  else
          break;
      
      // read the data or gen an error
    }
    else
      break;
  }
  while(1 == 1);        
  return true;
}

static Boolean get_ifr()
{

  Err er;
  char request_string[20];

 	request_string[0]  = 0x25;
 	request_string[1]  = 0x80;
 	request_string[2]  = 0x05;
 	request_string[3]  = 0x61;
 	request_string[4]  = 0x6a;
 	request_string[5]  = 0xf1;
 	request_string[6]  = 0x01;
 	request_string[7]  = 0x01;
 	request_string[8]  = 0x00;
 	request_string[9]  = 0x00;
 	request_string[10] = 0x00;
 	request_string[11] = 0x00;
 	request_string[12] = 0x00;
 	request_string[13] = 0x00;
 	request_string[14] = 0x43;

  TntRxClear();
  TntPuts(0,request_string,15);
  
  if (test_mode)
    return true;
    
  if (wait_for_bytes(0,14,1) >= 0)
  {
    SerReceive(serial_library,request_string,14,-1,&er);
    if (request_string[1] == 0x84)
      return true;
    else
      return false;
  }
  else
    return false;
}

static Boolean obd_connect()
{

  int i1 = 0;
  int i2 = 0;
  Err er;
  unsigned char lb[20];
  char buf[100];
  FormPtr frmP;
  
  char request_string[20];
  
  frmP = FrmGetActiveForm();
  
  if (test_mode)
  {
    get_pids(lb);
    return true;
  }
  
  // send pwm
  
	request_string[0]  = 0x25;
	request_string[1]  = 0x04;
	request_string[2]  = 0x05;
	request_string[3]  = 0x61;
	request_string[4]  = 0x6a;
	request_string[5]  = 0xf1;
	request_string[6]  = 0x01;
	request_string[7]  = 0x00;
	request_string[8]  = 0x00;
	request_string[9]  = 0x00;
	request_string[10] = 0x00;
	request_string[11] = 0x00;
	request_string[12] = 0x00;
	request_string[13] = 0x00;
	request_string[14] = 0x00;
	
	// send bogus bytes to get software rev
	TntRxClear();
  SerSend(serial_library,request_string,15,&er);
	if (wait_for_bytes(0,14,5) >= 0)
	{
	  lb[2] = 0;
	  SerReceive(serial_library,lb,14,-1,&er);
	  t16_rev = lb[2];
	  StrPrintF(interface_rev," %d",lb[2]);
	}
	else
  	err_rtn("No rev");
	TntRxClear();
	
	request_string[14] = 0xc6;
	
	// xmit the string
	
	
	i2 = 0;
	do
	{
	  StrPrintF(buf,"%s Testing PWM J1850",interface_rev);
	  PnsSetTitle(buf);
  	TntRxClear();
    send_bytes(request_string,15);

  	if (wait_for_bytes(0,14,1) >= 0)
    {
      TntGets(serial_library,lb,14,-1,&er);
      if (lb[1] != 0x80)
      {
        obd_sync = 0x41;
        obd_response = 0x84;
        obd_protocol = 2;
        obd_logon = true;
  			dlc_address = lb[4];
        get_pids(lb);  
        
        // validate ford in frame response
        
        use_ifr = get_ifr();
        
        return true;
      }
      else
      {
        // if ! chk sum error break
        if (lb[3] != 2)
          break;
      }
    }
    else
      break;
    ++ i2;
  }
  while (i2 < 5);
  
  if (i2 == 5)
  {
    err_rtn("Unable to test 1");
    return false;
  }  
    
  // send vpw

  request_string[1] = 0x82;
  request_string[3] = 0x68;
  request_string[14] = 0x4b;
  
	i2 = 0;
	do
	{
	  StrPrintF(buf,"%s Testing VPW J1850",interface_rev);
	  PnsSetTitle(buf);
  	TntRxClear();
    send_bytes(request_string,15);

    if (wait_for_bytes(0,14,1) >= 0)
    {
      TntGets(serial_library,lb,14,-1,&er);
//      StrPrintF(buf,"%x %x %x",lb[1],lb[2],lb[3]);
//      err_rtn(buf);
      if (lb[1] != 0x80)
      {
        obd_protocol = 3;
        obd_response = 0x82;
        obd_logon = true;
  			dlc_address = lb[4];
        get_pids(lb);
        return true;
      }
      else
      {
        // if ! chk sum error break
        if (lb[3] != 2)
          break;
      }
    }
    else
      break;
    ++ i2;
   }
   while (i2 < 5);

  if (i2 == 5)
  {
    err_rtn("Unable to test 2");
    return false;
  }  
    
  // send iso
	
  request_string[1] = 0x01;
  request_string[3] = 0x68;
  request_string[14] = 0xca;
  
	i2 = 0;
	do
	{

	  StrPrintF(buf,"%s Testing ISO 9141",interface_rev);
	  PnsSetTitle(buf);
  	TntRxClear();
    send_bytes(request_string,15);

  	if (wait_for_bytes(0,14,5) >= 0)
    {
      TntGets(serial_library,lb,14,-1,&er);
      if (lb[1] != 0x80)
      {
        obd_protocol = 1;
        t16_timer = TntTimer();
        obd_logon = true;
  			dlc_address = lb[4];
        get_pids(lb);
        return true;
      }
      else
      {
        // if ! chk sum error break
        if (lb[3] != 2)
        {
          t16_timer = 0;
          break;
        }
      }
    }
    else
      break;
    ++ i2;
   }
   while (i2 < 5);

  if (i2 == 5)
  {
    err_rtn("Unable to test 3");
    return false;
  }  
  
//  StrPrintF(buf,"%x %x %x %x",lb[0],lb[1],lb[2],lb[3]);
//  err_rtn(buf);
//  StrPrintF(buf,"%x %x %x %x %x %x",lb[4],lb[5],lb[6],lb[7],lb[8],lb[9]);
//  err_rtn(buf); 
//  StrPrintF(buf,"%x %x %x %x",lb[10],lb[11],lb[12],lb[13]);
//  err_rtn(buf);
  return false;
}

static long time_scale(double lv)
{
  float f1;
  float l1;
  int x;
  
  int y;
  int z;
  
  if (lv / (60 * SysTicksPerSecond()) < 1)
    return lv;
  else
  {
    x = 1;
    y = 1;
    z = 0;
    f1 = lv / (SysTicksPerSecond()); // get seconds
//    f1 += 3600;
    do
    {
      for (z=1;z<x;z++)
        y = y * 60;
      l1 = f1 / (float)(y);
      x = x + 1;
    }
    while (l1 > 60.0F);
    return l1 * (SysTicksPerSecond());
  }
}

static int get_value(int parm_id, unsigned char byte1, unsigned char byte2, int chart_value, int ft)
{
	double chart_base;
	UInt16  iv;
	int index;
	float remain;
	
	// decode the data bytes
	
	if (parm_id == 23)
	{
	  if (play_mode)
	  {
	    if (ft == 2)
  	    plot_start_ticks += (byte1 * 256) + byte2;
  	  else
  	    plot_start_ticks += byte1;
	    dv1 = plot_start_ticks;
	    lv1 = time_scale(plot_start_ticks);
	    if (ft == 2)
  	    return (byte1 * 256) + byte2;
  	  else
  	    return byte1;
    }
	  dv1 = (TimGetTicks() - plot_frame_ticks);
	  plot_frame_ticks = TimGetTicks();
	  lv1 = time_scale(dv1);
	  return dv1;
	}
	
	if (test_mode)
	{
		chart_value = prefs.chart_scale;
		dv1 = byte1;
	  lv1 = (long)(dv1 * 100);    
    if (peak_values[parm_id] < lv1)
      peak_values[parm_id] = lv1;
		if (prefs.peak_hold)
		{
		  if (play_run != 2 || logger_status != 2)
		  {
		    if (peak_values[parm_id] > lv1)
		      lv1 = peak_values[parm_id];
		  }
		}
		
		return lv1;
	}
	
	chart_base = 1.0F;
	if (ft == 1)
	{
		switch(parm_id)
		{
		  case 0:
  			dv1 = byte1 * 31.37F;
  			chart_base = (float)prefs.chart_scale / 8000;
  			inj_rpms = dv1;
        break;	
      case 1:
    		dv1 = byte1 * .02F;
    		chart_base = (float)prefs.chart_scale;
        break;   
      case 2:
    		dv1 = byte1 - 10.0F;
    		chart_base = (float)prefs.chart_scale / 40;
        break;
    	case 9:
    		dv1 = byte1 / 255.0F * 90.0F;;
    		chart_base = (float)prefs.chart_scale / 100; //.2F;
    		break;
      case 3:
		    dv1 = byte1 / 2.55;
		    chart_base = (float)prefs.chart_scale / 100;
		    break;
		  case 4:
    		dv1 = byte1 * 6.27F;
    		chart_base = (float)prefs.chart_scale / 1600;
    		break;
      case 5:
    	case 6:
    		dv1 = byte1 * 1.27F;
    		chart_base = (float)prefs.chart_scale / 162;
    		break;
    	case 10:
    		dv1 = byte1 * .256F;
    		chart_base = (float)prefs.chart_scale / 65;
    		inj_pw = dv1;
    		break;
      case 11:
      case 22:
    		dv1 = byte1 * 1.27F;
    		chart_base = (float)prefs.chart_scale / 323;
    		break;
    	case 24:
    		dv1 = byte1;
    		chart_base = (float)prefs.chart_scale / 2;
    	  break;
    	case 25: // gm 3bar
    	  dv1 = byte1;
    	  if (inj_rpms == 0 && prefs.map_cal == 0.0F)
    	  {
    	    prefs.map_cal = 84.0F - dv1;
    	  }
    	  
    	  if (dv1 - prefs.map_cal != 0)
    	  
    	  {
          dv1 = ((dv1 + prefs.map_cal) / 5.58F) - 14.696F;
   
          if (dv1 < 0.0F)
              dv1 = dv1 * 29.921F / 14.696F;  // convert to inHG
        }
        else
          dv1 = 0.0F;
        chart_base = (float)prefs.chart_scale / 30;
        break;
      case 26: // wide band vout
        if (inj_rpms >= 1500 && prefs.wideband_cal == 0.0F)
        {
          prefs.wideband_cal = 128.0F - dv1;
        }
    	  dv1 = dv1 + prefs.wideband_cal;
    	  dv1 = dv1 / 51.2F;
        index = (int)(dv1 * 10.0F);
        remain = dv1 - (float)index / 10.0F;
        dv1 = ratio[index] + (ratio[index+1] - ratio[index]) * remain / 0.1F;
        
    	  chart_base = (float)prefs.chart_scale / 30;
    	  break; 
    	case 27: // wideband lout
        if (inj_rpms >= 1500 && prefs.wideband_cal == 0.0F)
        {
          prefs.wideband_cal = 128.0F - dv1;
        }
    	  dv1 = dv1 + prefs.wideband_cal;
    	  dv1 = dv1 / 51.2F;
    	  dv1 = 9.0F + (dv1 * 2.0F);
    	  break;
    }
    
		chart_value = dv1 * chart_base; 
	  lv1 = (long)(dv1 * 100);    
    if (peak_values[parm_id] < lv1)
      peak_values[parm_id] = lv1;
		if (prefs.peak_hold)
		{
		  if (play_run != 2 || logger_status != 2)
		  {
		    if (peak_values[parm_id] > lv1)
		      lv1 = peak_values[parm_id];
		  }
		}
		return chart_value;
	
	}
	
	if (ft == 2)
	{
	  switch(parm_id)
	  {
	    case 0:
  			iv = (byte1 * 256) + byte2;
  			dv1 = iv / 4;
  			chart_value = dv1 * ((float)prefs.chart_scale / 8000); //.0025F;
  			break;
			case 1:
			case 21:
     		dv1 = byte1 * .005F;
     		chart_value = dv1 * ((float)prefs.chart_scale / 1.275); //15.68F;
        break;
      case 2:
     		dv1 = (byte1 - 128) * .5F;
     		chart_value = (dv1 * ((float)prefs.chart_scale / 128)) + ((float)prefs.chart_scale / 2); //.1562F) + 10;
        break;
      case 3:
  	    dv1 = (byte1 / 255.0F) * 100;
	      chart_value = dv1 * ((float)prefs.chart_scale / 100); //.2F;
        break;
      case 4:
  			iv = (byte1 * 256) + byte2;
	  		dv1 = (float)iv / 100;
		  	dv1 = ((dv1 * 60) * .002205);
			  chart_value = dv1 * ((float)prefs.chart_scale / 87); //.0305F;
		    break;
		  case 5:
		  case 18:
      case 6:
      case 19:
     		dv1 = (byte1 - 128) * .7812F;
     		chart_value = (dv1 * ((float)prefs.chart_scale / 100)) + ((float)prefs.chart_scale / 2);
     		break;
      case 7:
     	case 8:
  	    dv1 = ((byte1 - 40) * 1.8) + 32;
     		chart_value =  dv1 * ((float)prefs.chart_scale / 255); //.0784F;
		    break;
      case 16:
      case 17:
    		if (parm_id == 16)
    		  dv1 = byte1 * .621;  // mph
    		else
      		dv1 = byte1 * .2952; // in.hg
     		chart_value = dv1 * ((float)prefs.chart_scale / 255); //.0784F;
        break;
      case 20:
  	    dv1 = (byte1 / 255.0F) * 100;
    		chart_value = dv1 * ((float)prefs.chart_scale / 100); //.2F;
    		break;
    }

 	  lv1 = (long)(dv1 * 100);
    if (peak_values[parm_id] < lv1)
      peak_values[parm_id] = lv1;
		if (prefs.peak_hold)
		{
		  if (play_run != 2 || logger_status != 2)
		  {
		    if (peak_values[parm_id] > lv1)
		      lv1 = peak_values[parm_id];
		  }
		}
		return chart_value; 
	}
	
	return 0;
}

static int show_data_point(int x, int y, int c)
{
  static Int32    t_frame;
  static Int32    s_frame;
  static Int32    fs;
  static Err      err;
  static int      lx;
  static int      lf;
  static int      lp;
  int c1;
  static unsigned char     pb[2];
  
	FormPtr frmP;

	frmP = FrmGetActiveForm();

	// if calc frame is out of range, return
	
	if (prefs.single_chart == 1)
	  c1 = 0;
	else
	  c1 = c;
	
	if (lastx[c1] < x)
	  return 0;
	  
	if (x < 1 || x > 118)
	  return 0;
	
	// store current file pointer
	
  t_frame = FileTell(log_handle,&fs,&err);
  
	// calculate the frame to be read (temp_frame - (frame size * ((118 or last x) - (x - 1)))
	
	if (lastx[c1] < 118)
	  lx = lastx[c1];
	else
	  lx = 118;
	  
	if (log_type[0] == 1)
	  lf = play_list_size[0];
	  
	if (log_type[0] == 2)
	{
	  lf = play_list_size[0] * 2;
	}
	  
	s_frame = (t_frame - (lf * (lx - (x - 1))));
	
	FileSeek(log_handle,s_frame,fileOriginBeginning);
	
	// read the frame - read the bytes based on the selected chart item
	
	for (lp=0;lp<play_list_size[0];lp++)
	{
	  if (log_type[0] == 1)
	  {
			FileRead(log_handle,&pb[0],1,1,&err);
	  }
	  
	  if (log_type[0] == 2)
	  {
			FileRead(log_handle,&pb[0],1,1,&err);
			FileRead(log_handle,&pb[1],1,1,&err);
	  }
	  
	  // is the item being graphed?
	  
//	  if ((play_status[0] == lp + 1 && c == 1) ||
//	      (play_status[1] == lp + 1 && c == 2) ||
//	      (play_status[2] == lp + 1 && c == 3))
    if (play_status[c] == lp + 1)
	  {
	  
      get_value(play_list[play_status[c] - 1], pb[0], pb[1], lp, log_type[0]);
	
	  	// display the value for each graphed item

      if (play_list[lp] == 1 || play_list[lp] == 21 || play_list[lp] >= 26)
 	    	StrPrintF(play_fname,"%ld.%02ld",lv1/100,lv1%100);
 	  	else
   	  	StrPrintF(play_fname,"%ld",lv1/100);
   	  if (StrLen(play_fname) < 5)
   			PnsCopyLabel(frmP,playformChart1valueLabel + (c),play_fname);

	  }
	  
  }
	
	// reset current file pointer
	
	FileSeek(log_handle,t_frame,fileOriginBeginning);
	
	return 0;
}

static char * get_list_entry(int pid, int ft)
{
	// return a pointer to the parm "name" table
	
	if (pid == 23)
	  return &field_string[25][0];
  else	  
	if (pid == 24)
	  return &field_string[26][0];
  else	  
	if (pid == 25)
	  return &field_string[27][0];
  else	  
	if (pid == 26)
	  return &field_string[28][0];
  else	  
	if (pid == 27)
	  return &field_string[28][0];
	  
	if (pid >= 0 && pid <= 4)
		return &field_string[pid][0];
		
	if (ft == 2 && pid >= 5 && pid <= 23)
		return &field_string[pid][0];
		
	if (ft == 1)
	{
		if (pid == 5)
			return &field_string[9][0];
		if (pid == 6)
			return &field_string[10][0];
		if (pid >= 9 && pid <= 23)
			return &field_string[pid + 2][0];
	}		
	
	return 0;
}

static int clear_dtc()
{

  int m;
  Err er;
  int tint;
  unsigned char lb[20];
	char request_string[20];
	
  // form the dtc count request
  
	request_string[0]  = 0x25;
	request_string[1]  = 0x01;
	request_string[2]  = 0x05;
	request_string[3]  = 0x68;
	request_string[4]  = 0x6a;
	request_string[5]  = 0xf1;
	request_string[6]  = 0x04;
	request_string[7]  = 0x00;
	request_string[8]  = 0x00;
	request_string[9]  = 0x00;
	request_string[10] = 0x00;
	request_string[11] = 0x00;
	request_string[12] = 0x00;
	request_string[13] = 0x00;
	request_string[14] = 0xcd;
	
  // send he request

  TntRxClear();
  TntPuts(0,request_string,15);	  
  		  
  // wait until the request comes back, or 5 seconds
  		
	if (wait_for_bytes(0,14,5) <= 0 && !test_mode)
	{
	
	  // logon error
	  
	  err_rtn("No response from vehicle (DTC clear)");
	  logger_status = 2;
	  return -1;
	  
	}
	
	if (test_mode)
	  return 0;

	tint = TntGets(serial_library,lb,14,-1,&er);
  
	for (m=0;m<tint;m++)
		if (lb[m] == 0x44)
		{
			return 0;
		}
	  		
	// error
	  		
	if (m == tint)
	{
	  // logon error
	  // malformed response or no response
	  
	  err_rtn("Missing response byte (DTC clear");
	  logger_status = 2;
	  return -1;
						  		
	}
	
  return -1;
}

static void get_reg()
{

  Err er;
  int i1 = -1;
  char b1;
  
 	reg_handle = FileOpen(0,"Reg", 0, 0, fileModeReadOnly, &er);
	if (reg_handle == 0 || er != 0)
	{
	    if (5632 - er == -4)
	      return;
	  	StrPrintF(reg_string,"Reg ferr: %d",5632 - er);
      err_rtn(reg_string);
	  	return;
	}
	
	FileRead(reg_handle,reg_string,1,200,&er);
	
	// scan for "temp"
	
	b1 = 0;;
	
	for (i1=0;i1<199;i1++)  
	{
//	  if (StrCompare(&reg_string[i1],"sales@tunerstein.com") == 0)
	  if (StrCompare(&reg_string[i1],"tunerstein") == 0)
	  {
//	    if (prefs.expiration_date < TimGetSeconds())
	      b1 = 0;
	  }
	  b1 += reg_string[i1];
	}

  FileClose(reg_handle);
  
  if (reg_string[199] == b1)
    registered = true;
}

static int display_dtc(int dl)
{
  static char buf[100];
  static char buf1[100];
  int i1 = -1;
  int list_line;
  int i2;
  Err er;
	FormPtr frmP;

	frmP = FrmGetActiveForm();
  
  // get the selected line
  
  StrPrintF(buf1,"Searching");
  
  list_line = LstGetSelection(GetObjectPtr(dtcformDtclistList));
  
  
  // can not select the "first" line
  
  if (list_line == 0 || list_line > dtc_count)
  {
    return (-1);
  }
  
  // get the DTC code
  
	dtc_handle = FileOpen(0,"Dtc", 0, 0, fileModeReadOnly, &er);
	if (dtc_handle == 0 || er != 0)
	{
	  if (5632 - er != -4)
    {
    	StrPrintF(buf,"DTC ferr: %d",5632 - er);
    	err_rtn(buf);
    	return (-1);
    }
    StrPrintF(dtc_detail,"Missing DTC code file, notify the author\n");
    dtc_desc = &dtc_detail[0];
    PnsSetTextPtr(GetObjectPtr(dtcformDtcdetailField),dtc_detail);
//    FldRecalculateField (GetObjectPtr(dtcformDtcdetailField),true);
//    FldDrawField(GetObjectPtr(dtcformDtcdetailField));
    return (0);
	}
		
  // scan the file for a matching dtc code, 0x00 terms each record
  
  i1 = 0;
  i2 = 0;

  do
  {
    i1 = 0;
    do
    {
      FileRead(dtc_handle,&buf[i1],1,1,&er);
      if (FileEOF(dtc_handle) != 0)
      {
        i2 = 1;
        StrPrintF(dtc_detail,"Missing DTC code entry, note the code and notify the author\n");
        break;
      }
      ++ i1;
    }
    while (buf[i1 - 1] != 0x00);
    if (i2 == 0 &&
        buf[0] == dtc_list[list_line][0] &&
        buf[1] == dtc_list[list_line][1] &&
        buf[2] == dtc_list[list_line][2] &&
        buf[3] == dtc_list[list_line][3] &&
        buf[4] == dtc_list[list_line][4])
    {
      i2 = 1;
      StrPrintF(dtc_detail,"%s\n",buf);
    }
  }
  while (i2 == 0);
  FileClose(dtc_handle);
  
  dtc_desc = &dtc_detail[0];
  PnsSetTextPtr(GetObjectPtr(dtcformDtcdetailField),dtc_detail);
//  FldRecalculateField (GetObjectPtr(dtcformDtcdetailField),true);
//  FldDrawField(GetObjectPtr(dtcformDtcdetailField));
  return (0);
}

static int get_drbdtcs()
{
	FormPtr frmP;
  int m;
  int m1;
           int  tint;
  static   int  bit_value;
  unsigned int  dtc_word;
  unsigned char lb[20];
  unsigned char byte2 = 0;
  static unsigned char dtc_bytes[2];

	char request_string[20];
	Err er;
	
  frmP = FrmGetActiveForm();
  
  StrPrintF(&dtc_list[0][0],"Connecting - please wait");
  d_list[0] = &dtc_list[0][0];
 	d_list[1] = &field_string[14][0]; // put "none" in the first slot
 	d_list[2] = &field_string[14][0]; // put "none" in the first slot
  PnsSetListChoices(dtcformDtclistList, &d_list[0], 3, -1);
//  FrmShowObject(frmP, FrmGetObjectIndex(frmP, dtcformDtclistList ));
  
  // request dtc's
  
	request_string[0]  = 0x3c;
	request_string[1]  = 0x3b;
	request_string[2]  = 0xfe;
	request_string[3]  = 0xfd;
	
  TntRxClear();
  TntPuts(0,&request_string[2],1);	  
  wait_for_bytes(0,2,5);
  		  
  // send the request

  TntRxClear();
  TntPuts(0,&request_string[0],1);	  
  		  
  // wait until the request comes back, or 5 seconds
  		
	if (wait_for_bytes(0,2,5) <= 0 && !test_mode)
	{
	
	  // logon error
	  err_rtn("No response from vehicle (DTC list)");
	  logger_status = 2;
	  dtc.count = -1;
	  
	}
	else
	{
    if (!test_mode)
    {
     	tint = TntGets(serial_library,lb,2,-1,&er);
     	dtc_bytes[0] = lb[1];
    }
    else
    {
      dtc_bytes[0]  = 0xff;
    }
     
    TntRxClear();
    TntPuts(0,&request_string[1],1);	  
    		  
    // wait until the request comes back, or 5 seconds
    		
  	if (wait_for_bytes(0,2,5) <= 0 && !test_mode)
  	{
  	
  	  // logon error
  	  err_rtn("No response from vehicle (DTC list)");
  	  logger_status = 2;
  	  dtc.count = -1;
  	  
  	}
  	else
  	{
      if (!test_mode)
      {
       	tint = TntGets(serial_library,lb,2,-1,&er);
       	dtc_bytes[1] = lb[1];
      }
      else
      {
        dtc_bytes[1]  = 0xff;
      }
    }
  }  
  
  TntRxClear();
  TntPuts(0,&request_string[3],1);	
  wait_for_bytes(0,2,5);  
  
  if (dtc.count == -1)
    return -1;
  		  
  dtc.count = 0;
   
  m1 = 1;
  d_list[1] = &field_string[14][0]; // put "none" in the first slot
  d_list[2] = &field_string[14][0]; // put "none" in the first slot

  dtc_word = dtc_bytes[1];
  dtc_word = dtc_word * 256;
  dtc_word = dtc_word + dtc_bytes[0];

  if (dtc_word == 0)    
  {
    StrPrintF(&dtc_list[0][0],"No DTC's present");
    d_list[0] = &dtc_list[0][0];
    dtc.count = 0;
  }
  else
  {
    StrPrintF(&dtc_list[0][0],"DTC's found");
    d_list[0] = &dtc_list[0][0];
  }
  
  bit_value = 1;
  m1 = 1;
  m = 0;
  do
  {
    tint = m;
    bit_value = test_bit(dtc_word, tint);
    if (bit_value == 1)
    {
      switch (m)
      {
        case 0:
          StrPrintF(&dtc_list[m1][0],"11 O2 Sensor");
          break;
        case 1:
          StrPrintF(&dtc_list[m1][0],"12 Volume air flow sensor");
          break;
        case 2:
          StrPrintF(&dtc_list[m1][0],"13 Intake air temp sensor");
          break;
        case 3:
          StrPrintF(&dtc_list[m1][0],"14 TPS");
          break;
        case 4:
          StrPrintF(&dtc_list[m1][0],"15 ISC");
          break;
        case 5:
          StrPrintF(&dtc_list[m1][0],"21 Engine coolant sensor");
          break;
        case 6:
          StrPrintF(&dtc_list[m1][0],"22 Crank sensor");
          break;
        case 7:
          StrPrintF(&dtc_list[m1][0],"23 Cam sensor");
          break;
        case 8:
          StrPrintF(&dtc_list[m1][0],"24 Speed sensor");
          break;
        case 9:
          StrPrintF(&dtc_list[m1][0],"25 Barometric sensor");
          break;
        case 10:
          StrPrintF(&dtc_list[m1][0],"31 Knock sensor");
          break;
        case 11:
          StrPrintF(&dtc_list[m1][0],"36 Ignition timing");
          break;
        case 12:
          StrPrintF(&dtc_list[m1][0],"41 Injector");
          break;
        case 13:
          StrPrintF(&dtc_list[m1][0],"42 Fuel pump");
          break;
        case 14:
          StrPrintF(&dtc_list[m1][0],"43 EGR");
          break;
        case 15:
          StrPrintF(&dtc_list[m1][0],"44 Ignition system");
          break;
        default:
          StrPrintF(&dtc_list[m1][0],"Unknown");
          break;
      }
  	  d_list[m1] = &dtc_list[m1][0];
  	  m1 ++;
    }
    m++;
  }
  while (m<=15);
    
  PnsSetListChoices(dtcformDtclistList, &d_list[0], m1, -1);
//  FrmShowObject(frmP, FrmGetObjectIndex(frmP, dtcformDtclistList ));
  
  if (dtc.count == 0)
    return 0;
    
  return dtc.count;
  
}

static int get_dtcs()
{
	FormPtr frmP;
  int m;
  int m1;
  int tint;
  int retries;
  int mx;
  unsigned char lb[20];
  unsigned char byte1;
  unsigned char byte2 = 0;

	char request_string[20];
	Err er;
	
  frmP = FrmGetActiveForm();
  
  StrPrintF(&dtc_list[0][0],"Connecting - please wait");
  d_list[0] = &dtc_list[0][0];
 	d_list[1] = &field_string[14][0]; // put "none" in the first slot
 	d_list[2] = &field_string[14][0]; // put "none" in the first slot
  PnsSetListChoices(dtcformDtclistList, &d_list[0], 3, -1);
//  FrmShowObject(frmP, FrmGetObjectIndex(frmP, dtcformDtclistList ));
  
  // form the dtc count request
  
	request_string[0]  = 0x25;
	request_string[1]  = 0x01;
	request_string[2]  = 0x05;
	request_string[3]  = 0x68;
	request_string[4]  = 0x6a;
	request_string[5]  = 0xf1;
	request_string[6]  = 0x01;
	request_string[7]  = 0x01;
	request_string[8]  = 0x00;
	request_string[9]  = 0x00;
	request_string[10] = 0x00;
	request_string[11] = 0x00;
	request_string[12] = 0x00;
	request_string[13] = 0x00;
	request_string[14] = 0xcb;
	
	// wait 5 seconds
	
//  get_modes();
  retries = 0; 
  do
  {
    ++ retries;
    
    // send he request

    TntRxClear();
    if (TntPuts(0,request_string,-150) < 0)
      return -1;
    		  
    // wait until the request comes back, or 5 seconds
    		
  	if (wait_for_bytes(0,14,5) <= 0 && !test_mode)
  	{
  	
  	  // logon error
  	  
  	  continue;
  	  
  	}
 	
  	if (!test_mode)
    	tint = TntGets(serial_library,lb,14,-1,&er);
    else
    {
      tint = 8;
      lb[0] = obd_sync;
      lb[7] = 0x83;
    }
    
  	for (m=0;m<tint;m++)
  		if (lb[m] == obd_sync)
  		{
  			byte1 = lb[7];
  			retries = 100;
  			break;
  		}
  	  		
  }
  while (retries <= 3);
	
  	// error
  	  		
  if (m == tint)
  {
    // logon error
    // malformed response or no response
    
    err_rtn("Missing response byte (DTC count)");
    logger_status = 2;
    return -1;
  					  		
  }

  StrPrintF(&dtc_list[0][0],"%d trouble codes ",dtc.count);
	if (byte1 >= 128)
	{
	  dtc.mil_light = 1;
	  dtc.count = byte1 - 128;
	  StrPrintF(&dtc_list[0][StrLen(&dtc_list[0][0])],"C/E on");
	}
	else
	{
	  dtc.mil_light = 0;
	  dtc.count = byte1;
	  StrPrintF(&dtc_list[0][StrLen(&dtc_list[0][0])],"C/E off");
	}
		
	dtc_count = dtc.count;
  
	if (dtc.count == 0)
	{
  	d_list[0] = &dtc_list[0][0]; // put "none" in the first slot
  	d_list[1] = &field_string[14][0]; // put "none" in the first slot
  	d_list[2] = &field_string[14][0]; // put "none" in the first slot
  	PnsSetListChoices(dtcformDtclistList, &d_list[0], 3, -1);
//  	FrmShowObject(frmP, FrmGetObjectIndex(frmP, dtcformDtclistList ));
  	return 0;
  }
	
 	d_list[0] = &dtc_list[0][0]; // put "none" in the first slot
  d_list[1] = &field_string[14][0]; // put "none" in the first slot
  d_list[2] = &field_string[14][0]; // put "none" in the first slot

  // request dtc's
  
	request_string[0]  = 0x25;
	request_string[1]  = 0x10;
	request_string[2]  = 0x05;
	request_string[3]  = 0x68;
	request_string[4]  = 0x6a;
	request_string[5]  = 0xf1;
	request_string[6]  = 0x03;
	request_string[7]  = 0x00;
	request_string[8]  = 0x00;
	request_string[9]  = 0x00;
	request_string[10] = 0x00;
	request_string[11] = 0x00;
	request_string[12] = 0x00;
	request_string[13] = 0x00;
	request_string[14] = 0xdb;
	
  // send the request

  TntRxClear();
  TntPuts(0,request_string,-150);	  
  		  
  // wait until the request comes back, or 5 seconds
  		
	if (wait_for_bytes(0,14,5) <= 0 && !test_mode)
	{
	
	  // logon error
	  err_rtn("No response from vehicle (DTC list)");
	  logger_status = 2;
	  return -1;
	  
	}
	
	do
	{
	  // wait for 14 bytes
	  
  	if (!test_mode)
  	{
  	  if (wait_for_bytes(0,14,5) <= 0)
  	  {
  	    err_rtn("no response from vehicle (DTC list 2)");
  	    break;
  	  }
    	tint = TntGets(serial_library,lb,14,-1,&er);
    }
    else
    {
      tint = 12;
      lb[2]  = obd_sync;
      lb[6]  = 0x04;
      lb[7]  = 0x00;
      lb[8]  = 0x01;
      lb[9]  = 0x96;
      lb[10]  = 0x03;
      lb[11] = 0xff;
    }
    
    m = 6;
    m1 = 1;
    d_list[1] = &field_string[14][0]; // put "none" in the first slot
    d_list[2] = &field_string[14][0]; // put "none" in the first slot
//   	StrPrintF(msg,"DTC array ");
//   	for (mx=0;mx<14;mx++)
//   	  StrPrintF(&msg[StrLen(msg)],"%x ",lb[mx]);
//   	err_rtn(msg);
    do
    {
      // if the dtc code is 0, break;
      
      if ((lb[m] * 256) + lb[m+1] == 0)
      {
        m +=2 ;
        continue;
      }
        
      // format the dtc code
      
      if (lb[m] >= 192)
      {
        dtc_list[m1][0] = 'U';
        lb[m] -= 192;
      }
      else
      if (lb[m] >= 128)
      {
        dtc_list[m1][0] = 'B'; 
        lb[m] -= 128;
      }
      else
      if (lb[m] >= 64)
      {
        dtc_list[m1][0] = 'C';
        lb[m] -= 64;
      }
      else
      {
        dtc_list[m1][0] = 'P';
      }
        
  	  StrPrintF(&dtc_list[m1][1],"%x",(lb[m] * 256) + lb[m + 1]);
  	  d_list[m1] = &dtc_list[m1][0];
      m += 2;
      m1++;
    }
    while (m < 12);
    
    PnsSetListChoices(dtcformDtclistList, &d_list[0], m1, -1);
//    FrmShowObject(frmP, FrmGetObjectIndex(frmP, dtcformDtclistList ));
    
    if (test_mode)
      tint = 0;
    if (wait_for_bytes(0,14,1) <= 0)
      break;
      
  }
  while (tint > 0);
  return dtc.count;
  
}

static void set_log_list(int set_st)
{
	int fb;
	int fb1;
	int fb2;
//	int x;
	
	fb1 = 0;
	fb2 = 0;
	
	if (use_drb == 1)
		log_type[0] = 1;
	if (use_t16 == 1)
		log_type[0] = 2;
		
	l_list[0] = &field_string[15][0]; // put "none" in the first slot
	l_list[1] = &field_string[14][0]; // put "none" in the first slot

	
	for (fb=0;fb<max_items;fb++)
	{
		if (items_to_log[fb] != 0 && fb != 23)
		{
 			++ fb1;
 			l_list[fb1] = get_list_entry(fb,log_type[0]);
			if (fb2 < 3)
			{
			  if (set_st != 1)
			  {
  			  chart_status[fb2] = fb1;
  			  ++ fb2;
        }
			}
			l_list[fb1+1] = &field_string[14][0];
		}
	}
	++fb1;
	
	if (fb < 2)
	  fb = 2;
	  
	  
}

static int draw_chart(int chart_id, int dv)
{
	int basec = 0;
	int cid;
	int cix;
	int x;
	int time_ticks = 0;
	int tick_delta = 0;
	int time_delta = 0;
	
	RectangleType rp;
	
//	if (dv > prefs.chart_base[chart_id - 1] ||
//	    dv < prefs.chart_top[chart_id - 1])
//	  return -1;
	
	// draw the graph, this is not "time sensitive"
	
	basec = prefs.chart_base[chart_id - 1]; 
	
	cid = chart_id - 1;
	if (prefs.single_chart == 1)
	  cix = 0;
	else
	  cix = cid;
	
  if (prefs.chart_base[chart_id - 1] - dv <= prefs.chart_top[chart_id - 1])
    dv = prefs.chart_scale;

	// draw a line from the last point to the point defined as the new point
	
  if (prefs.chart_by_time == 1 && logger_status != 2)
  {

    // calc the room needed (one x per elapsed tick)
    
    time_ticks = (TimGetTicks() - plot_last_ticks[cid]) / prefs.slider_value;
    
    if (time_ticks < 1)
      time_ticks = 1;
      
    // scroll the chart
    
    if (prefs.chart_by_time != 1)
      time_ticks = 0;
    
    if (lastx[cix] + time_ticks > prefs.chart_width - 3 && time_ticks > 0)
    {
    	if (prefs.chart_frames)
     	{
    		rp.topLeft.x = 0;
    		rp.topLeft.y = prefs.chart_top[chart_id - 1] + 1;
    		rp.extent.x = prefs.chart_width; 
    		rp.extent.y = prefs.chart_height - 2;
    	}
    	else
     	{
    		rp.topLeft.x = 0;
    		rp.topLeft.y = prefs.chart_top[chart_id - 1];;
    		rp.extent.x = prefs.chart_width; 
    		rp.extent.y = prefs.chart_height;
    	}
      if (cid == 0 || prefs.single_chart != 1)
      {
      	WinScrollRectangle(&rp,winLeft,time_ticks,&rp);
       	WinEraseRectangle(&rp,0);
     	  lastx[cix] -= time_ticks;
     	}
       	
    }
    
    // calc the new start points
    
  }
  WinPushDrawState();
  if (prefs.chart_by_time == 1 && logger_status != 2)
  {
    if (prefs.color_support == 1)
    {
      if (prefs.single_chart == 1)
      {
        WinSetForeColor(color_index[cid]);
      }
      else
        if (lasty[cid] < prefs.chart_base[chart_id - 1] - dv)
          WinSetForeColor(color_index[red]);
        else
          if (lasty[cid] > prefs.chart_base[chart_id - 1] - dv)
            WinSetForeColor(color_index[blue]);
      }
      WinDrawLine(lastx[cix] ,lasty[cid],lastx[cix] + time_ticks - 1,(prefs.chart_base[chart_id - 1] - dv) /*+ basec*/);
    if (lastx[cix] <= prefs.chart_width - 3)
    {
      if (cid == 0 || prefs.single_chart != 1)
    	  lastx[cix] += time_ticks;
   	}
    lasty[cid] = prefs.chart_base[chart_id - 1] - dv;
    plot_last_ticks[cid] = TimGetTicks();
		WinPopDrawState();
    return 0;
  }
  else
  {
    if (prefs.color_support == 1)
    {
      if (prefs.single_chart == 1)
      {
        WinSetForeColor(color_index[cid]);
      }
      else
        if (lasty[cid] < prefs.chart_base[chart_id - 1] - dv)
          WinSetForeColor(color_index[red]);
        else
          if (lasty[cid] > prefs.chart_base[chart_id - 1] - dv)
            WinSetForeColor(color_index[blue]);
      }     
      if (!no_chart_update)
        WinDrawLine(lastx[cix] ,lasty[cid],lastx[cix] + 1,(prefs.chart_base[chart_id - 1] - dv) /*+ basec*/);
      else
//        WinDrawLine(lastx[cix] ,lasty[cid],lastx[cix] + 1,(prefs.chart_base[chart_id - 1] - dv) /*+ basec*/);
        WinDrawLine(lastx[cix] ,prefs.chart_base[chart_id - 1] - dv,lastx[cix] + 1,lasty[cid] /*+ basec*/);
  }
  WinPopDrawState();

  // save the new point as the "old" point for use in the next draw_chart call

  if (play_mode)
  {
    // add time index
    lasty_points[chart_id - 1][lasty_points[chart_id - 1][chart_limit + 1]] = lasty[cid];
    ++lasty_points[chart_id - 1][chart_limit + 1];
  }
  if (no_chart_update)
  {
    // update the time index
    lasty_points[chart_id - 1][0] = prefs.chart_base[chart_id - 1] - dv; 
  }
 	if (!no_chart_update)
    lasty[cid] = prefs.chart_base[chart_id - 1] - dv;
    
  if (lastx[cix] > prefs.chart_width - 3 && !play_mode)
  {
  	if (prefs.chart_frames)
   	{
  		rp.topLeft.x = 0;
  		rp.topLeft.y = prefs.chart_top[chart_id - 1] + 1;
  		rp.extent.x = prefs.chart_width;
  		rp.extent.y = prefs.chart_height - 2;
  	}
  	else
   	{
  		rp.topLeft.x = 0;
  		rp.topLeft.y = prefs.chart_top[chart_id - 1];
  		rp.extent.x = prefs.chart_width;
  		rp.extent.y = prefs.chart_height;
  	}
  	if (cid == 0 || prefs.single_chart != 1)
  	{
    	WinScrollRectangle(&rp,winLeft,20,&rp);
     	WinEraseRectangle(&rp,0);
     	lastx[cix] -= 20;
    }
  }  
  if (lastx[cix] > prefs.chart_width - 3)
  {
  	if (prefs.chart_frames)
   	{
  		rp.topLeft.x = 0;
  		rp.topLeft.y = prefs.chart_top[chart_id - 1] + 1;
  		rp.extent.x = prefs.chart_width;
  		rp.extent.y = prefs.chart_height - 2;
  	}
  	else
   	{
  		rp.topLeft.x = 0;
  		rp.topLeft.y = prefs.chart_top[chart_id - 1];
  		rp.extent.x = prefs.chart_width;
  		rp.extent.y = prefs.chart_height;
  	}
  	if (cid == 0 || prefs.single_chart != 1)
  	{
    	WinScrollRectangle(&rp,winLeft,1,&rp);
     	WinEraseRectangle(&rp,0);
    }
       	
    if (play_mode)
    {
     	for (x=0;x<lasty_points[cid][chart_limit + 1] - 1;x++)
     	{
     	  // scroll the time index
     	    
     	  lasty_points[cid][x] = lasty_points[cid][x + 1];
     	  lasty_points[cid][x + 1] = 0;
     	}
     	--lasty_points[cid][chart_limit + 1];
    }

   	// we scrolled a point, so scroll the lasty_points table
   	
  }
  else
  {
    if (cid == 0 || prefs.single_chart != 1)
  	  ++ lastx[cix];
  }
  
  return 0;
 }

static void erase_chart(int chart_id)
{
	int basec = prefs.chart_scale;
	RectangleType rp;
	
	basec = prefs.chart_top[chart_id - 1];
	basec = basec + (prefs.chart_spacing * (chart_id - 1)); 	// calc base point for each chart
	
	rp.topLeft.x = 0; // was 1
	rp.topLeft.y = prefs.chart_top[chart_id - 1];
	rp.extent.x = prefs.chart_width;
	rp.extent.y = prefs.chart_height;
	WinEraseRectangle(&rp,0);
	lastx[chart_id - 1] = 0;
	lasty[chart_id - 1] = prefs.chart_base[chart_id - 1]; //prefs.chart_spacing;
	
}

static void show_digital_values(int p, char lb[], FormPtr fp, int p1, int fld)
{

  static char vb[10][20];
  static char fn[20];
  
  if (p == 23)
    return;
  
	switch (p)
		{
  		case 0:
  		  StrPrintF(fn,"Rpms");
  		  break;
  		case 1:
  		  StrPrintF(fn,"O2v");
  		  break;
  		case 2:
  		  StrPrintF(fn,"Timing");
  		  break;
  		case 3:
  		  StrPrintF(fn,"TPS");
  		  break;
  		case 4:
  		  StrPrintF(fn,"Air Flow");
  		  break;
  		case 5:
  		  if (use_t16 == 1)
  		    StrPrintF(fn,"Sht Trim");
  		  else
    		  StrPrintF(fn,"Low Trim");
    		break;
  		case 6:
  		  if (use_t16 == 1)
  		    StrPrintF(fn,"Lng Trim");
  		  else
    		  StrPrintF(fn,"Med Trim");
    		break;
    	case 7:
    	  StrPrintF(fn,"Air Temp");
    	  break;
    	case 8:
    	  StrPrintF(fn,"Wtr Temp");
    	  break;
    	case 9:
    	  StrPrintF(fn,"Knock Ret");
    	  break;
    	case 10:
    	  StrPrintF(fn,"Inj P/W");
    	  break;
    	case 11:
    	  StrPrintF(fn,"Hgh Trim");
    	  break;
    	case 16:
    	  StrPrintF(fn,"MPH");
    	  break;
    	case 17:
    	  StrPrintF(fn,"MAP");
    	  break;
    	case 18:
    	  StrPrintF(fn,"Sht Trim 2");
    	  break;
    	case 19:
    	  StrPrintF(fn,"Lng Trim 2");
    	  break;
    	case 20:
    	  StrPrintF(fn,"Load");
    	  break;
    	case 21:
    	  StrPrintF(fn,"O2v 2");
    	  break;
    	case 22:
    	  StrPrintF(fn,"O2v Trim");
    	  break;
      case 23 :
        StrPrintF(fn,"Time");
        break;
      case 24 :
        StrPrintF(fn,"ISC");
        break;
      case 25 :
        StrPrintF(fn,"Boost (GM)");
        break;
      case 26:
        StrPrintF(fn,"W/B Afr");
        break;
      default:
        StrPrintF(fn,"Unknown");
  	}
  
  
  StrPrintF(&vb[p1][0],"%s: %s",fn,lb);
 	PnsCopyLabel(fp,fld + p1,&vb[p1][0]);
}

static int process_frame(int ft)
{
	Err er;
	FormPtr frmP;
	static	char lb[10];
	static Int32 fs;
	static int   fx;
	static int chart_value = 0;
	int x;
  int pc;	
//	char buf[40];

	
	frmP = FrmGetActiveForm();
	
	FileClearerr(log_handle);
	current_frame = FileTell(log_handle,&fs,&er);
	
	if (current_frame < first_frame)
	{
		FileSeek(log_handle,first_frame,fileOriginBeginning);
		current_frame = first_frame;
	}
	
	// read data
	
	play_count = 0;
	do
	{
		// get a data byte
		
		if (ft == 1)
		{
			FileRead(log_handle,&play_byte[0],1,1,&er);
		}
		
		if (ft == 2)
		{
			FileRead(log_handle,&play_byte[0],1,1,&er);
			FileRead(log_handle,&play_byte[1],1,1,&er);
		}
		
		// check eof
		
		if (FileEOF(log_handle) == 1)
		{
			return (-1);
		}
			
    // pre-read frame into an array
    
    // if tps_logged & tps < 100%, skip display of data	
		
		// data point is (x / 255) * 20 for most elements
		
		chart_value = get_value(play_list[play_count], play_byte[0], play_byte[1], fx, ft);
		if (play_list[play_count] == 1 || play_list[play_count] == 21 || play_list[play_count] == 23 || play_list[play_count] == 4 || play_list[play_count] >= 26)
    	StrPrintF(lb,"%ld.%02ld",lv1/100,lv1%100);
    else
    	StrPrintF(lb,"%ld",lv1/100);
    	
    if (play_list[play_count] == 23)
    {
      // create a new form title
      
      StrPrintF(status_detail,"Frame:%ld Time: %s",current_frame,lb);
      if (prefs.peak_hold)
        StrCat(status_detail," P");
      else
      {
        if (inj_pw != 0 && inj_rpms != 0)
        {
          inj_duty_cycle = (inj_rpms * inj_pw) / 1200;
          StrPrintF(&status_detail[StrLen(status_detail)]," DC:%ld",(long)inj_duty_cycle);
        }
      }
      PnsSetTitle(status_detail);
    }
    else
   		EvtResetAutoOffTimer();
    
    if (prefs.digital_mode == 1)
    {
      if (play_list_size[0] > 5)
     	  show_digital_values(play_list[play_count],lb,frmP,play_count,playformRpmfieldLabel);
     	else
     	  show_digital_values(play_list[play_count],lb,frmP,play_count,playformShortlistLabel);
    }
    else
    {
      pc = 0;
      if (play_list[play_count] > 23)
        pc = 1;
      for (x=0;x<3;x++)
        if (play_count + 1 - pc == play_status[x]) // - pc)
        {
          if (StrLen(lb) < 5 && play_list[play_count] != 23)
      			PnsCopyLabel(frmP,playformChart1valueLabel + x,lb);
    			if (play_list[play_count] != 23)
      			draw_chart(x + 1, chart_value);
      	  break;
        }
    }		
		++ play_count;
		
		// end of frame 
		
		if (play_count == play_list_size[0])
		{
			play_count = 0;
			break;
		}
	}
	while (1 == 1);
	return(0);
}

static void show_player_controls()
{
	FormPtr frmP;
	char lb[20];
	int x;
	
	frmP = FrmGetActiveForm();
	setup_charts(&play_status[0]);  
	  
	if (prefs.digital_mode != 1)
	{
  	for (x=playformRpmfieldLabel;x<playformRpmfieldLabel+15;x++)
    {		
     	FrmHideObject(frmP, FrmGetObjectIndex(frmP, x));
    }
  	for (x=playformShortlistLabel;x<playformShortlistLabel+5;x++)
    {		
     	FrmHideObject(frmP, FrmGetObjectIndex(frmP, x));
    }
  }
  else
  {
  	FrmHideObject(frmP, FrmGetObjectIndex(frmP, playformChart1valueLabel ));
 		FrmHideObject(frmP, FrmGetObjectIndex(frmP, playformChart2valueLabel ));
 		FrmHideObject(frmP, FrmGetObjectIndex(frmP, playformChart3valueLabel ));
  	FrmHideObject(frmP, FrmGetObjectIndex(frmP, playformChart1nameLabel ));
  	FrmHideObject(frmP, FrmGetObjectIndex(frmP, playformChart1nameLabel + 1));
  	FrmHideObject(frmP, FrmGetObjectIndex(frmP, playformChart1nameLabel + 2));
  	FrmHideObject(frmP, FrmGetObjectIndex(frmP, playformChartonechoiceList ));
 		FrmHideObject(frmP, FrmGetObjectIndex(frmP, playformChartthreechoiceList ));
 		FrmHideObject(frmP, FrmGetObjectIndex(frmP, playformCharttwochoiceList ));
    StrPrintF(lb," ");
  	for (x=playformRpmfieldLabel;x<playformRpmfieldLabel+15;x++)
    {		
      PnsCopyLabel(frmP,x,lb);
     	FrmShowObject(frmP, FrmGetObjectIndex(frmP, x));
    }
  	for (x=playformShortlistLabel;x<playformShortlistLabel+5;x++)
    {		
      PnsCopyLabel(frmP,x,lb);
     	FrmShowObject(frmP, FrmGetObjectIndex(frmP, x));
    }
  }
	if (prefs.digital_mode != 1)
	{
  	FrmHideObject(frmP, FrmGetObjectIndex(frmP, playformChart1valueLabel ));
 		FrmHideObject(frmP, FrmGetObjectIndex(frmP, playformChart2valueLabel ));
 		FrmHideObject(frmP, FrmGetObjectIndex(frmP, playformChart3valueLabel ));
  	FrmHideObject(frmP, FrmGetObjectIndex(frmP, playformChart1nameLabel ));
    StrPrintF(lb,"0");
		for (x=0;x<3;x++)
		{
	    FrmHideObject(frmP,FrmGetObjectIndex(frmP,playformChart1valueLabel + x));
      FrmHideObject(frmP,FrmGetObjectIndex(frmP,playformChart1nameLabel + x));
   		PnsCopyLabel(frmP,playformChart1valueLabel + x,lb);
		  if (play_status[x] != 0)
		  {
     		PnsCopyLabel(frmP,playformChart1nameLabel + x,t_list[play_status[x]]);
      	FrmShowObject(frmP, FrmGetObjectIndex(frmP, playformChart1valueLabel + x));
        FrmShowObject(frmP,FrmGetObjectIndex(frmP,playformChart1nameLabel + x));
        if (prefs.color_support == 1 && prefs.single_chart == 1)
        {
          WinPushDrawState();
          WinSetForeColor(color_index[x]);
          WinDrawLine(120,34 + (x * 50),155,34 + (x * 50));
          WinPopDrawState();
        }
      }
    }
	}
	
}

static void show_peak_values()
{
  int dmode;
  int x;
  static char lb[40];
  FormPtr frmP;
  
  dmode = prefs.digital_mode;
  frmP = FrmGetActiveForm();
  
  if (FrmGetActiveFormID() == PlayformForm)
  {
    FrmEraseForm(frmP);
    FrmDrawForm(frmP);
    prefs.digital_mode = 1;
    show_player_controls();
    for(x=0;x<play_list_size[0];x++)
      if (play_list[x] != 23)
      {
        lv1 = peak_values[play_list[x]];
    		if (play_list[x] == 1 || play_list[x] == 21 || play_list[x] >= 26)
        	StrPrintF(lb,"%ld.%02ld",lv1/100,lv1%100);
        else
        	StrPrintF(lb,"%ld",lv1/100);
        if (play_list_size[0] > 5)
       	  show_digital_values(play_list[x],lb,frmP,x,playformRpmfieldLabel);
       	else
       	  show_digital_values(play_list[x],lb,frmP,x,playformShortlistLabel);
      }
  }
  
  if (FrmGetActiveFormID() == MainForm)
  {
    FrmEraseForm(frmP);
    FrmDrawForm(frmP);
    prefs.digital_mode = 1;
    hide_logger_controls();
    show_logger_controls();
  }
  
  prefs.digital_mode = dmode;
  PnsSetTitle("Peak Values");
}

static void run_file()
{
	EventType 	event;
	Word      	error;
	
	FormPtr frmP;
	
	frmP = FrmGetActiveForm();
	
  show_player_controls();
  
  // save title
  
  play_title = FrmGetTitle((FormPtr)frmP);
  
	do
	{
		if (process_frame(log_type[0]) != 0)
		{
			play_run = 2;
		}
		else
		{
		  if (EvtEventAvail())
		  {
  			EvtGetEvent(&event, 1);
        if (!hardkey(&event))
  			if (! SysHandleEvent(&event))
  				if (! MenuHandleEvent(0, &event, &error))
  					if (! AppHandleEvent(&event))
  						FrmDispatchEvent(&event);
  		}
		}
	}
	while (play_run != 2);
	
	// restore title
	
	PnsSetTitle((char *)play_title);
}

static int play_log_file()
{
	Err er;
	

	int  fb;
	int  fb1;
	int  fb2;
	int  x;
	char lb[20];
	
	FormPtr frmP;
	
	frmP = FrmGetActiveForm();

	// get log type
	
	FileRead(log_handle,&log_type[0],1,1,&er);

	// get # of parms
	
	FileRead(log_handle,&play_list_size[0],1,1,&er);
	
	// get list of parms

	tps_logged = false;
	for (fb=0;fb<play_list_size[0];fb++)
	{
		FileRead(log_handle,&play_list[fb],1,1,&er);
		if ((log_type[0] == 0 && play_list[fb] == 3) ||
		    (log_type[0] == 1 && play_list[fb] == 3))
		  tps_logged = true;
	}
	
	// build list contents
	
	fb1 = 0;
	fb2 = 0;
	t_list[0] = &field_string[15][0]; // put "none" in the first slot
	t_list[1] = &field_string[14][0]; // put "none" in the first slot
	t_list[2] = &field_string[14][0]; // put "none" in the first slot
	play_status[0] = play_status[1] = play_status[2] = 0;
	for (fb=0;fb<play_list_size[0];fb++)
	  if (play_list[fb] != 23)
  	{
    	++ fb1;
  	  t_list[fb1] = get_list_entry(play_list[fb],log_type[0]);
  	  if (fb2 < 3)
  	  {
  	    play_status[fb2] = fb1;
  	    ++ fb2;
  	  }
  	}

	
	// set the list in the controls
	
//	LstSetListChoices(GetObjectPtr(playformChartonechoiceList), &t_list[0], fb1);
//	LstSetListChoices(GetObjectPtr(playformCharttwochoiceList), &t_list[0], fb1);
//	LstSetListChoices(GetObjectPtr(playformChartthreechoiceList), &t_list[0], fb1);
	
	// get frame rate

	FileRead(log_handle,&play_rate[0],1,1,&er);
  
//	show_rate();
	
	// show chart lists
	
	if (prefs.digital_mode != 1)
	{
  	for (x=playformRpmfieldLabel;x<playformRpmfieldLabel+15;x++)
    {		
     	FrmHideObject(frmP, FrmGetObjectIndex(frmP, x));
    }
  	for (x=playformShortlistLabel;x<playformShortlistLabel+5;x++)
    {		
     	FrmHideObject(frmP, FrmGetObjectIndex(frmP, x));
    }
/*  	FrmShowObject(frmP, FrmGetObjectIndex(frmP, playformChartonechoiceList ));
  	if (play_list_size[0] > 2)
  		FrmShowObject(frmP, FrmGetObjectIndex(frmP, playformChartthreechoiceList ));
  	
  	if (play_list_size[0] > 1)
  		FrmShowObject(frmP,  FrmGetObjectIndex(frmP, playformCharttwochoiceList ));*/
  }
  else
  {
  	FrmHideObject(frmP, FrmGetObjectIndex(frmP, playformChartonechoiceList ));
 		FrmHideObject(frmP, FrmGetObjectIndex(frmP, playformChartthreechoiceList ));
 		FrmHideObject(frmP, FrmGetObjectIndex(frmP, playformCharttwochoiceList ));
    StrPrintF(lb," ");
  	for (x=playformRpmfieldLabel;x<playformRpmfieldLabel+15;x++)
    {		
      PnsCopyLabel(frmP,x,lb);
     	FrmShowObject(frmP, FrmGetObjectIndex(frmP, x));
    }
  	for (x=playformShortlistLabel;x<playformShortlistLabel+5;x++)
    {		
      PnsCopyLabel(frmP,x,lb);
     	FrmShowObject(frmP, FrmGetObjectIndex(frmP, x));
    }
  }
	
	// save address of first data frame
	
	first_frame = FileTell(log_handle,NULL,&er);
	current_frame = first_frame;

	return 0;
}

static int read_directory(int f)
{
	Err er;
	FileHand dir_handle = 0;
	Char fname[32] = "pnstein";
	int lp;
	int lp1;
	Int32 fs = 0;
	
	// open file, if it fails, create it as new and try again
	// f = 1 (read/init), f = 2 (write)
	
	if (f == 1)
	{
		// open for read, if it fails - open for write, init, close, and re-open for read
		
		dir_handle = FileOpen(0,fname, 0, 0, fileModeUpdate, &er);
		if (dir_handle == 0 || er != 0)
		{
		  	StrPrintF(fname,"ferr: %d",5632 - er);
		  	err_rtn(fname);
		}
		
		// get the length of the file
		
		FileTell(dir_handle,&fs,&er);
				
		// if the file is empty, initialize it
		
		if (fs == 0)
		{
			
			// init table (100 entries)
			
		    for (lp=0;lp<max_logfiles;lp++)
		    {
		    	log_directory[lp].log_name[0] = 0;
		    	FileWrite(dir_handle,&log_directory[lp].log_name[0],1,100,&er);
		    }
		    
		}
		
	    // put is back to the start of the file
	    
	    FileRewind(dir_handle);

		// read into table
		
	    for (lp=0;lp<max_logfiles;lp++)
	    {
	    	FileRead(dir_handle,&log_directory[lp].log_name[0],1,100,&er);
	    }
    

		// close
		
		FileClose(dir_handle);

	    // read the directory
	    
	    for (lp=0;lp<max_logfiles;lp++)
	    {
	   
		    // delete entries which have missing log files
		    
		    if (log_directory[lp].log_name[0] != 0)
		    {
				dir_handle = FileOpen(0,&log_directory[lp].log_fnme[0], 0, 0, fileModeReadOnly, &er);
				if (dir_handle == 0 || er != 0)
				{
					log_directory[lp].log_name[0] = 0;
				}
				else
					FileClose(dir_handle);
		    }
	    }
	}
	
	if (f == 2)
	{

		// open for write
		
		dir_handle = FileOpen(0,fname, 0, 0, fileModeReadWrite, &er);
		
		// write entries
		
		lp1 = 0;
	    for (lp=0;lp<max_logfiles;lp++)
	    {
	    	if (log_directory[lp].log_name[0] != 0)
	    	{
		    	FileWrite(dir_handle,&log_directory[lp].log_name[0],1,100,&er);
		    	++ lp1;
		    }
	    }

	    for (lp=lp1;lp<max_logfiles;lp++)
	    {
	    	log_directory[lp].log_name[0] = 0;
	    	FileWrite(dir_handle,&log_directory[lp].log_name[0],1,100,&er);
	    }
	    
		// close file
		
		FileClose(dir_handle);
	}

	return 0;
}

static void show_memo()
{

  char memo_name[30];
	Err er;
	Int32 fs;
	MemHandle textH;
  Char * textP;	
  FileHand memo_handle = 0;
  FormPtr frmP;
  FieldPtr fld;
  
  frmP = FrmGetActiveForm();

  StrPrintF(memo_name,"%sm",log_directory[play_entry].log_fnme);

//  err_rtn(memo_name);

	memo_handle = FileOpen(0,memo_name, 0, 0, fileModeReadOnly, &er);
	if (memo_handle == 0 || er != 0)
	{
	  StrPrintF(memo_text,"No memo data");
	  fs = StrLen(memo_text);
	}
	else
	{
    FileTell(memo_handle,&fs,&er);
    
    if (fs > 1000)
      fs = 1000;
      
    FileRead(memo_handle,memo_text,1,fs,&er);  
  	
  	FileClose(memo_handle);
  	memo_text[fs] = '\0';
  }	
	fs += 1;

   textH = MemHandleNew(fs);
   if (textH)
      {
      textP = MemHandleLock(textH);
      MemMove(textP, memo_text, fs);
      fld = FrmGetObjectPtr (frmP, FrmGetObjectIndex(frmP,memoMemofieldField));
      FldSetTextHandle (fld, textH);
      MemHandleUnlock(textH);
      }
}

static void show_carsetup()
{
  char memo_name[30];
  long lp;
	Err er;
	MemHandle textH;
  Char * textP;	
  FileHand memo_handle = 0;
  FormPtr frmP;
  FieldPtr fld;
  Int32 fs;
  static int x;
  static int x1;
  static int x2;
  Boolean skip_field;
  
  frmP = FrmGetActiveForm();

  StrPrintF(memo_name,"%sc",log_directory[play_entry].log_fnme);

//  err_rtn(memo_name);

	memo_handle = FileOpen(0,memo_name, 0, 0, fileModeReadOnly, &er);
	if (memo_handle == 0 || er != 0)
	{
	
    StrPrintF(carrecord.tire_data," ");
    StrPrintF(carrecord.shock_data," ");
    StrPrintF(carrecord.plug_data," ");
    StrPrintF(carrecord.ecu_pgm_number," ");
    StrPrintF(carrecord.ecu_pgm_name," ");
    StrPrintF(carrecord.fuel_data," ");
    carrecord.tire_rf = 0;
    carrecord.tire_lf = 0;
    carrecord.tire_rr = 0;
    carrecord.tire_lr = 0;
    carrecord.shock_rf = 0;
    carrecord.shock_lf = 0;
    carrecord.shock_rr = 0;
    carrecord.shock_lr = 0;
    carrecord.plug_gap = 0;
    carrecord.boost = 0;
    carrecord.weight = 0;
    carrecord.fuel_volume = 0;
    carrecord.fuel_pressure = 0;
    carrecord.nos_shot_1 = 0;
    carrecord.nos_time_1 = 0;
    carrecord.nos_rate_1 = 0;
    carrecord.nos_shot_2 = 0;
    carrecord.nos_time_2 = 0;
    carrecord.nos_rate_2 = 0;
    carrecord.water_inj = 0;
    carrecord.water_jet_1 = 0;
    carrecord.water_jet_2 = 0;
  	memo_handle = FileOpen(0,memo_name, 0, 0, fileModeReadWrite, &er);
    FileWrite(memo_handle,&carrecord.tire_data[0],1,sizeof(carrecord),&er); 
    FileClose(memo_handle);
	  show_carsetup();
	  return;
	}
	
  FileTell(memo_handle,&fs,&er);
  
  if (fs < sizeof(carrecord))
  {
    FileClose(memo_handle);
    return;
  }
    
  FileRead(memo_handle,&carrecord.tire_data[0],1,sizeof(carrecord),&er);  
	
	FileClose(memo_handle);
	
	for (x=3101;x<=3154;x++)
	{
	  x1 = x - 3101;
	  skip_field = false;
	  switch(x)
	  {
      case carsetupTiretypeField:                     
	      StrPrintF(memo_text,"%s",carrecord.tire_data);
	      break;
      case carsetupShocktypeField:                    
	      StrPrintF(memo_text,"%s",carrecord.shock_data);
	      break;
      case carsetupEcuprogramnumberField:             
	      StrPrintF(memo_text,"%s",carrecord.ecu_pgm_number);
	      break;
      case carsetupEcuprogramnameField:               
	      StrPrintF(memo_text,"%s",carrecord.ecu_pgm_name);
	      break;
      case carsetupFuelbrandField:                    
	      StrPrintF(memo_text,"%s",carrecord.fuel_data);
	      break;
      case carsetupPlugtypeField:                     
	      StrPrintF(memo_text,"%s",carrecord.plug_data);
	      break;
      case carsetupTirerfField:                       
	      lp = (long)(carrecord.tire_rf);
 	    	StrPrintF(memo_text,"%ld",lp);
	      break;
      case carsetupTirelfField:                       
	      lp = (long)(carrecord.tire_lf);
 	    	StrPrintF(memo_text,"%ld",lp);
	      break;
      case carsetupTirerrField:                       
	      lp = (long)(carrecord.tire_rr);
 	    	StrPrintF(memo_text,"%ld",lp);
	      break;
      case carsetupTirelrField:                       
	      lp = (long)(carrecord.tire_lr);
 	    	StrPrintF(memo_text,"%ld",lp);
	      break;
      case carsetupShockrfField:                      
	      lp = (long)(carrecord.shock_rf);
 	    	StrPrintF(memo_text,"%ld",lp);
	      break;
      case carsetupShocklfField:                      
	      lp = (long)(carrecord.shock_lf);
 	    	StrPrintF(memo_text,"%ld",lp);
	      break;
      case carsetupShockrrField:                      
	      lp = (long)(carrecord.shock_rr);
 	    	StrPrintF(memo_text,"%ld",lp);
	      break;
      case carsetupShocklrField:                      
	      lp = (long)(carrecord.shock_lr);
 	    	StrPrintF(memo_text,"%ld",lp);
	      break;
      case carsetupPluggapField:                      
	      lp = (long)(carrecord.plug_gap * 1000);
 	    	StrPrintF(memo_text,".%03ld",lp%1000);
	      break;
      case carsetupBoostField:                        
	      lp = (long)(carrecord.boost);
 	    	StrPrintF(memo_text,"%ld",lp);
	      break;
      case carsetupFuelvolumeField:                   
	      lp = (long)(carrecord.fuel_volume);
 	    	StrPrintF(memo_text,"%ld",lp);
	      break;
      case carsetupBasepressureField:                 
	      lp = (long)(carrecord.fuel_pressure);
 	    	StrPrintF(memo_text,"%ld",lp);
	      break;
      case carsetupWeightField:                       
	      lp = (long)(carrecord.weight);
 	    	StrPrintF(memo_text,"%ld",lp);
	      break;
      case carsetupNosshot1Field:                     
	      lp = (long)(carrecord.nos_shot_1);
 	    	StrPrintF(memo_text,"%ld",lp);
	      break;
      case carsetupNosshot2Field:                     
	      lp = (long)(carrecord.nos_shot_2);
 	    	StrPrintF(memo_text,"%ld",lp);
	      break;
      case carsetupNosrate1Field:                     
	      lp = (long)(carrecord.nos_time_1);
 	    	StrPrintF(memo_text,"%ld",lp);
	      break;
      case carsetupNosrate2Field:                     
	      lp = (long)(carrecord.nos_time_2);
 	    	StrPrintF(memo_text,"%ld",lp);
	      break;
      case carsetupNosontime1Field:                   
	      lp = (long)(carrecord.nos_rate_1);
 	    	StrPrintF(memo_text,"%ld",lp);
	      break;
      case carsetupNosontime2Field:                   
	      lp = (long)(carrecord.nos_rate_1);
 	    	StrPrintF(memo_text,"%ld",lp);
	      break;
      case carsetupWionpointField:           
	      lp = (long)(carrecord.water_inj);
 	    	StrPrintF(memo_text,"%ld",lp);
	      break;
      case carsetupWijet1Field:
	      lp = (long)(carrecord.water_jet_1);
 	    	StrPrintF(memo_text,"%ld",lp);
	      break;
      case carsetupWijet2Field:                       
	      lp = (long)(carrecord.water_jet_1);
 	    	StrPrintF(memo_text,"%ld",lp);
	      break;
	    default:
	      skip_field = true;
	      break;
	  }
	  if (!skip_field)
	  {
  	  x2 = StrLen(memo_text);
  	  ++ x2;
      textH = MemHandleNew(20);
      if (textH)
      {
        textP = MemHandleLock(textH);
        MemMove(textP, memo_text, x2);
        fld = FrmGetObjectPtr (frmP, FrmGetObjectIndex(frmP,x));
        FldSetTextHandle (fld, textH);
        MemHandleUnlock(textH);
        FldRecalculateField (GetObjectPtr(x),true);
        FldDrawField(GetObjectPtr(x));
      }
    }
	}
	
}

static Boolean create_carsetup()
{
  char memo_name[30];
	Err er;
	FileHand memo_handle = 0;
  
  StrCopy(&carrecord.tire_data[0],FldGetTextPtr(GetObjectPtr(carsetupTiretypeField)));
  StrCopy(&carrecord.shock_data[0],FldGetTextPtr(GetObjectPtr(carsetupShocktypeField)));
  StrCopy(&carrecord.plug_data[0],FldGetTextPtr(GetObjectPtr(carsetupPlugtypeField)));
  StrCopy(&carrecord.ecu_pgm_number[0],FldGetTextPtr(GetObjectPtr(carsetupEcuprogramnumberField)));
  StrCopy(&carrecord.ecu_pgm_name[0],FldGetTextPtr(GetObjectPtr(carsetupEcuprogramnameField)));
  StrCopy(&carrecord.fuel_data[0],FldGetTextPtr(GetObjectPtr(carsetupFuelbrandField)));
  if (valid_double(carsetupTirerfField,0,99) == -999999)
    return false;
  carrecord.tire_rf = valid_double(carsetupTirerfField,0,99);
  if (valid_double(carsetupTirelfField,0,99) == -999999)
    return false;
  carrecord.tire_lf = valid_double(carsetupTirelfField,0,99);
  if (valid_double(carsetupTirerrField,0,99) == -999999)
    return false;
  carrecord.tire_rr = valid_double(carsetupTirerrField,0,99);
  if (valid_double(carsetupTirelrField,0,99) == -999999)
    return false;
  carrecord.tire_lr = valid_double(carsetupTirelrField,0,99);
  if (valid_double(carsetupShockrfField,0,99) == -999999)
    return false;
  carrecord.shock_rf = valid_double(carsetupShockrfField,0,99);
  if (valid_double(carsetupShocklfField,0,99) == -999999)
    return false;
  carrecord.shock_lf = valid_double(carsetupShocklfField,0,99);
  if (valid_double(carsetupShockrrField,0,99) == -999999)
    return false;
  carrecord.shock_rr = valid_double(carsetupShockrrField,0,99);
  if (valid_double(carsetupShocklrField,0,99) == -999999)
    return false;
  carrecord.shock_lr = valid_double(carsetupShocklrField,0,99);
  if (valid_double(carsetupPluggapField,0,1) == -999999)
    return false;
  carrecord.plug_gap = valid_double(carsetupPluggapField,0,1);
  if (valid_double(carsetupBoostField,0,99) == -999999)
    return false;
  carrecord.boost = valid_double(carsetupBoostField,0,99);
  if (valid_double(carsetupWeightField,0,8000) == -999999)
    return false;
  carrecord.weight = valid_double(carsetupWeightField,0,8000);
  if (valid_double(carsetupFuelvolumeField,0,99) == -999999)
    return false;
  carrecord.fuel_volume = valid_double(carsetupFuelvolumeField,0,99);
  if (valid_double(carsetupBasepressureField,0,99) == -999999)
    return false;
  carrecord.fuel_pressure = valid_double(carsetupBasepressureField,0,99);
  if (valid_double(carsetupNosshot1Field,0,500) == -999999)
    return false;
  carrecord.nos_shot_1 = valid_double(carsetupNosshot1Field,0,500);
  if (valid_double(carsetupNosontime1Field,0,60) == -999999)
    return false;
  carrecord.nos_time_1 = valid_double(carsetupNosontime1Field,0,60);
  if (valid_double(carsetupNosrate1Field,0,100) == -999999)
    return false;
  carrecord.nos_rate_1 = valid_double(carsetupNosrate1Field,0,100);
  if (valid_double(carsetupNosshot2Field,0,500) == -999999)
    return false;
  carrecord.nos_shot_2 = valid_double(carsetupNosshot2Field,0,500);
  if (valid_double(carsetupNosontime2Field,0,60) == -999999)
    return false;
  carrecord.nos_time_2 = valid_double(carsetupNosontime2Field,0,60);
  if (valid_double(carsetupNosrate2Field,0,100) == -999999)
    return false;
  carrecord.nos_rate_2 = valid_double(carsetupNosrate2Field,0,100);
  if (valid_double(carsetupWionpointField,0,99) == -999999)
    return false;
  carrecord.water_inj = valid_double(carsetupWionpointField,0,99);
  if (valid_double(carsetupWijet1Field,0,100) == -999999)
    return false;
  carrecord.water_jet_1 = valid_double(carsetupWijet1Field,0,100);
  if (valid_double(carsetupWijet2Field,0,100) == -999999)
    return false;
  carrecord.water_jet_2 = valid_double(carsetupWijet2Field,0,100);

  StrPrintF(memo_name,"%sc",log_directory[play_entry].log_fnme);
  FileDelete(0,memo_name);
	memo_handle = FileOpen(0,memo_name, 0, 0, fileModeReadWrite, &er);
	if (memo_handle == 0 || er != 0)
	  return false;
  FileWrite(memo_handle,&carrecord.tire_data[0],1,sizeof(carrecord),&er); 
  FileClose(memo_handle);
  return true;
}

static double valid_double(Word fld_id, double low, double hi)
{
	static FlpCompDouble fp;
	static char msg[40];
	static double d1;
	FormPtr frmP;
	
	frmP = FrmGetActiveForm();

  fp.fd = FlpAToF(FldGetTextPtr(GetObjectPtr(fld_id)));
  d1 = fp.d;
  if (d1 <= hi && d1 >= low)
  {
    return d1;
  }
  StrPrintF(msg,"Value must be in the range of %ld to %ld",(long)low,(long)hi);
  err_rtn(msg);
  FrmSetFocus(frmP,FrmGetObjectIndex(frmP, fld_id));
  return -999999;
}

static Boolean create_timeslip()
{
  char memo_name[30];
	Err er;
	FileHand memo_handle = 0;
  
  StrPrintF(memo_name,"%st",log_directory[play_entry].log_fnme);
  
  // open file
  
  StrCopy(&timesliprecord.date[0],FldGetTextPtr(GetObjectPtr(timeslipDateField)));
  StrCopy(&timesliprecord.time[0],FldGetTextPtr(GetObjectPtr(timeslipTimeField)));
  if (valid_double(timeslipTempField,0,200) == -999999)
    return false;
  timesliprecord.temp = valid_double(timeslipTempField,0,200);
  if (valid_double(timeslipHumidityField,0,100) == -999999)
    return false;
  timesliprecord.humidity = valid_double(timeslipHumidityField,0,100);
  if (valid_double(timeslipBaroField,0,100) == -999999)
    return false;
  timesliprecord.baro = valid_double(timeslipBaroField,0,100);
  if (valid_double(timeslipDialinField,0,60) == -999999)
    return false;
  timesliprecord.dialin = valid_double(timeslipDialinField,0,60);
  if (valid_double(timeslipRtField,0,60) == -999999)
    return false;
  timesliprecord.rt = valid_double(timeslipRtField,0,60);
  if (valid_double(timeslipFoot60Field,0,60) == -999999)
    return false;
  timesliprecord.et_60 = valid_double(timeslipFoot60Field,0,60);
  if (valid_double(timeslipFoot330Field,0,60) == -999999)
    return false;
  timesliprecord.et_330 = valid_double(timeslipFoot330Field,0,60);
  if (valid_double(timeslipFoot1000Field,0,60) == -999999)
    return false;
  timesliprecord.et_1000 = valid_double(timeslipFoot1000Field,0,60);
  if (valid_double(timeslipFoot18Field,0,6) == -999999)
    return false;
  timesliprecord.et_660 = valid_double(timeslipFoot18Field,0,6);
  if (valid_double(timeslipMph18Field,0,200) == -999999)
    return false;
  timesliprecord.mph_660 = valid_double(timeslipMph18Field,0,200);
  if (valid_double(timeslipEt14Field,0,60) == -999999)
    return false;
  timesliprecord.et_1320 = valid_double(timeslipEt14Field,0,60);
  if (valid_double(timeslipMph14Field,0,400) == -999999)
    return false;
  timesliprecord.mph_1320 = valid_double(timeslipMph14Field,0,400);
  if (valid_double(timeslipLaunchrpmField,0,8000) == -999999)
    return false;
  timesliprecord.lrpm = valid_double(timeslipLaunchrpmField,0,8000);
  if (valid_double(timeslipShiftrpmField,0,8000) == -999999)
    return false;
  timesliprecord.srpm = valid_double(timeslipShiftrpmField,0,8000);
  if (valid_double(timeslipAltitudeField,0,8000) == -999999)
    return false;
  timesliprecord.altitude = valid_double(timeslipAltitudeField,0,8000);
  
  FileDelete(0,memo_name);
	memo_handle = FileOpen(0,memo_name, 0, 0, fileModeReadWrite, &er);
	if (memo_handle == 0 || er != 0)
	  return true;
  FileWrite(memo_handle,&timesliprecord.date[0],1,sizeof(timesliprecord),&er); 
  FileClose(memo_handle);
  return true;
}

static void show_timeslip()
{

  char memo_name[30];
  long lp;
	Err er;
	MemHandle textH;
  Char * textP;	
  FileHand memo_handle = 0;
  FormPtr frmP;
  FieldPtr fld;
  Int32 fs;
  static int x;
  static int x1;
  static int x2;
  Boolean skip_field;
  
  frmP = FrmGetActiveForm();

  StrPrintF(memo_name,"%st",log_directory[play_entry].log_fnme);

//  err_rtn(memo_name);

	memo_handle = FileOpen(0,memo_name, 0, 0, fileModeReadOnly, &er);
	if (memo_handle == 0 || er != 0)
	{
	  // create base record
	  
	  StrPrintF(timesliprecord.date," ");
	  StrPrintF(timesliprecord.time," ");
	  timesliprecord.temp = 0;
    timesliprecord.humidity = 0;
    timesliprecord.baro = 0;
    timesliprecord.dialin = 0;
    timesliprecord.rt = 0;
    timesliprecord.et_60 = 0;
    timesliprecord.et_330 = 0;
    timesliprecord.et_660 = 0;
    timesliprecord.mph_660 = 0;
    timesliprecord.et_1000 = 0;
    timesliprecord.et_1320 = 0;
    timesliprecord.mph_1320 = 0;
    timesliprecord.lrpm = 0;
    timesliprecord.srpm = 0;
    timesliprecord.altitude = 0;
  	memo_handle = FileOpen(0,memo_name, 0, 0, fileModeReadWrite, &er);
    FileWrite(memo_handle,&timesliprecord.date[0],1,sizeof(timesliprecord),&er); 
    FileClose(memo_handle);
	  show_timeslip();
	  return;
	}
	
  FileTell(memo_handle,&fs,&er);
  
  if (fs < sizeof(timesliprecord))
  {
    FileClose(memo_handle);
    return;
  }
    
  FileRead(memo_handle,&timesliprecord.date[0],1,sizeof(timesliprecord),&er);  
	
	FileClose(memo_handle);
	
	for (x=3001;x<=3034;x++)
	{
	  x1 = x - 3001;
	  skip_field = false;
	  switch(x)
	  {
	    case timeslipDateField:
	      StrPrintF(memo_text,"%s",timesliprecord.date);
	      break;
	    case timeslipTimeField:
	      StrPrintF(memo_text,"%s",timesliprecord.time);
	      break;
	    case timeslipTempField:
	      lp = (long)(timesliprecord.temp * 100);
 	    	StrPrintF(memo_text,"%ld",lp/100);
	      break;
	    case timeslipAltitudeField:
	      lp = (long)(timesliprecord.altitude * 100);
 	    	StrPrintF(memo_text,"%ld",lp/100);
	      break;
	    case timeslipHumidityField:
	      lp = (long)(timesliprecord.humidity * 1000);
 	    	StrPrintF(memo_text,"%ld.%03ld",lp/1000,lp%1000);
	      break;
	    case timeslipBaroField:
	      lp = (long)(timesliprecord.baro * 1000);
 	    	StrPrintF(memo_text,"%ld.%03ld",lp/1000,lp%1000);
	      break;
	    case timeslipDialinField:
	      lp = (long)(timesliprecord.dialin * 1000);
 	    	StrPrintF(memo_text,"%ld.%03ld",lp/1000,lp%1000);
	      break;
	    case timeslipLaunchrpmField:
	      lp = (long)(timesliprecord.lrpm * 100);
 	    	StrPrintF(memo_text,"%ld",lp/100);
	      break;
	    case timeslipShiftrpmField:
	      lp = (long)(timesliprecord.srpm * 100);
 	    	StrPrintF(memo_text,"%ld",lp/100);
	      break;
	    case timeslipRtField:
	      lp = (long)(timesliprecord.rt * 1000);
 	    	StrPrintF(memo_text,"%ld.%03ld",lp/1000,lp%1000);
	      break;
	    case timeslipFoot60Field:
	      lp = (long)(timesliprecord.et_60 * 1000);
 	    	StrPrintF(memo_text,"%ld.%03ld",lp/1000,lp%1000);
	      break;
	    case timeslipFoot330Field:
	      lp = (long)(timesliprecord.et_330 * 1000);
 	    	StrPrintF(memo_text,"%ld.%03ld",lp/1000,lp%1000);
	      break;
	    case timeslipFoot18Field:
	      lp = (long)(timesliprecord.et_660 * 1000);
 	    	StrPrintF(memo_text,"%ld.%03ld",lp/1000,lp%1000);
	      break;
	    case timeslipMph18Field:
	      lp = (long)(timesliprecord.mph_660 * 1000);
 	    	StrPrintF(memo_text,"%ld.%03ld",lp/1000,lp%1000);
	      break;
	    case timeslipFoot1000Field:
	      lp = (long)(timesliprecord.et_1000 * 1000);
 	    	StrPrintF(memo_text,"%ld.%03ld",lp/1000,lp%1000);
	      break;
	    case timeslipEt14Field:
	      lp = (long)(timesliprecord.et_1320 * 1000);
 	    	StrPrintF(memo_text,"%ld.%03ld",lp/1000,lp%1000);
	      break;
	    case timeslipMph14Field:
	      lp = (long)(timesliprecord.mph_1320 * 1000);
 	    	StrPrintF(memo_text,"%ld.%03ld",lp/1000,lp%1000);
	      break;
	    default:
	      skip_field = true;
	      break;
	  }
	  if (!skip_field)
	  {
  	  x2 = StrLen(memo_text);
  	  ++ x2;
      textH = MemHandleNew(20);
      if (textH)
      {
        textP = MemHandleLock(textH);
        MemMove(textP, memo_text, x2);
        fld = FrmGetObjectPtr (frmP, FrmGetObjectIndex(frmP,x));
        FldSetTextHandle (fld, textH);
        MemHandleUnlock(textH);
        FldRecalculateField (GetObjectPtr(x),true);
        FldDrawField(GetObjectPtr(x));
      }
    }
	}
	
}

static void create_memo(char fname[])
{
  char memo_name[30];
	Err er;
	FileHand memo_handle = 0;
	int x;
	Int32 fs;
	DateTimeType file_date;
  
  StrPrintF(memo_name,"%sm",fname);
  FileDelete(0,memo_name);
  
  // open file
  
	memo_handle = FileOpen(0,memo_name, 0, 0, fileModeReadWrite, &er);
	if (memo_handle == 0 || er != 0)
	  return;
  
  // write the data
  
  // date
  
  // time

  TimSecondsToDateTime(TimGetSeconds(),&file_date);
	
	StrPrintF(memo_name,"%02d/%02d/%02d %02d:%02d:%02d, ",file_date.month,file_date.day,file_date.year,file_date.hour,file_date.minute,file_date.second);
  FileWrite(memo_handle,memo_name,1,StrLen(memo_name),&er); 
  		  
  // file size - log_handle
  
  FileTell(log_handle,&fs,&er);  
  StrPrintF(memo_name,"%ld bytes, ",fs);
  FileWrite(memo_handle,memo_name,1,StrLen(memo_name),&er); 
  
  // protocol
  
  if (use_drb == 1)
    StrPrintF(memo_name,"1g DSM, ");
  else
  {
    StrPrintF(memo_name,"OBD-II, ");
    if (obd_protocol == 3)
      StrCat(memo_name,"PWM, ");
    else
      if (obd_protocol == 2)
        StrCat(memo_name,"VPW, ");
      else
        StrCat(memo_name,"ISO, ");
  }
  
  FileWrite(memo_handle,memo_name,1,StrLen(memo_name),&er); 
  
  // write logged items
  
  for (x=1;x<item_count;x++)
  {
    StrPrintF(memo_name,"%s",&l_list[x][0]);
    if (x<item_count - 1)
    {
      StrCat(memo_name,", ");
    }
    FileWrite(memo_handle,memo_name,1,StrLen(memo_name),&er); 
  }
  
/*  if (lap_number > 0)
  {
    FileWrite(memo_handle,", Laps: ",1,8,&er);
    for (x=1;x<lap_number + 1;x++)
    {
      if (x != 1)
        FileWrite(memo_handle,",",1,1,&er);
      FileWrite(memo_handle,&lap_string[x][0],1,StrLen(&lap_string[x][0]),&er);
    }
  } */
  
  FileWrite(memo_handle,"\n",1,1,&er);
  // close the file

  FileClose(memo_handle);
}

static void update_memo(char fname[])
{
  char memo_name[30];
	Err er;
	FileHand memo_handle = 0;
	char *textP;
  
  StrPrintF(memo_name,"%sm",fname);
  FileDelete(0,memo_name);
  
  // open file
  
	memo_handle = FileOpen(0,memo_name, 0, 0, fileModeReadWrite, &er);
	if (memo_handle == 0 || er != 0)
	  return;
  
  // write the data

  textP = FldGetTextPtr (GetObjectPtr(memoMemofieldField));
  
  FileWrite(memo_handle,textP,1,StrLen(textP),&er);
  
  // close the file

  FileClose(memo_handle);
}

static int update_directory(int f, char fname[])
{
	static	Err er;
	static	UInt32 fmode;
	static	int lp;
	static  int fb;
	static  Int32 fs = 0;

	DateTimeType file_date;
	
	// f = 1, add entry to next available slot, if full, return error
	// f = 2, delete entry in slot pointed two by first byte of fname
	
	if (f == 1)
	{
	
		// get current date & time
		
		TimSecondsToDateTime(TimGetSeconds(),&file_date);
	
		// put the entry in the next open slot
	  
		for (fb=0;fb<max_logfiles;fb++)
			if (log_directory[fb].log_name[0] == 0)
			{
			  StrPrintF(log_directory[fb].log_name,"%12s - %2d/%2d/%d %2d:%2d:%2d",fname,file_date.month,file_date.day,file_date.year,file_date.hour,file_date.minute,file_date.second);
				StrCopy(log_directory[fb].log_fnme,lf_name);
				break;
			}
			
	}
	
	if (f == 2 && log_directory[fname[0]].log_name[0] != 0)
	{
		// delete the actual file
		
		FileDelete(0,log_directory[fname[0]].log_fnme);
		StrPrintF(play_fname,"%sm",log_directory[fname[0]].log_fnme); // memo
		FileDelete(0,play_fname);
		StrPrintF(play_fname,"%st",log_directory[fname[0]].log_fnme); // time slip
		FileDelete(0,play_fname);
		StrPrintF(play_fname,"%sc",log_directory[fname[0]].log_fnme); // car setup
		FileDelete(0,play_fname);
		
		// make the directory slot available
		
 	   	log_directory[fname[0]].log_name[0] = 0;
	}
	
	// write the directory
	
	read_directory(2);
	
	// reload the directory
	
	read_directory(1);	
	return(0);
}

/***********************************************************************
 *
 *   Internal Functions
 *
 *******************************************************************/
static int get_request_string(char buf[], int parm_id)
{
  	
  if (use_t16 == 1)
  {
    if (parm_id < 0 || parm_id > 21)
      buf[7] = pid[0];
    else
      buf[7] = pid[parm_id];
  }
  else
  {
    if (parm_id < 0 || parm_id > 26)
      buf[0] = drb[0];
    else
      buf[0] = drb[parm_id];
  }
  
  return 0;
}
    		
static void init_request_string()
{
  int i1 = 0;
  int i2 = 0;
  int i3 = 0;

  for (i1=0;i1<=22;i1++)
  {
 	  obd_frames[i2 + 0]  = 0x25;
 	  obd_frames[i2 + 1]  = 0x04;
 	  obd_frames[i2 + 2]  = 0x05;
 	  obd_frames[i2 + 3]  = 0x61;
 	  obd_frames[i2 + 4]  = 0x6a;
 	  obd_frames[i2 + 5]  = 0xf1;
 	  obd_frames[i2 + 6]  = 0x01;
 	  obd_frames[i2 + 7]  = 0x00;
 	  obd_frames[i2 + 8]  = 0x00;
 	  obd_frames[i2 + 9]  = 0x00;
 	  obd_frames[i2 + 10] = 0x00;
 	  obd_frames[i2 + 11] = 0x00;
 	  obd_frames[i2 + 12] = 0x00;
 	  obd_frames[i2 + 13] = 0x00;
 	  obd_frames[i2 + 14] = 0x00;
    
    if (obd_protocol == 1) // iso
    {
      obd_frames[i2 + 1] = 0x01;
      obd_frames[i2 + 3] = 0x68;
            
    }

    if (obd_protocol == 2) // pwm
    {
      if (pre_fetch_default)
        obd_frames[i2 + 1] = 0x84;
      else
        obd_frames[i2 + 1] = 0x04;
      obd_frames[i2 + 3] = 0x61;
    }

    if (obd_protocol == 3) // vpw
    {
      if (pre_fetch_default)
        obd_frames[i2 + 1] = 0x82;
      else
        obd_frames[i2 + 1] = 0x02;
      obd_frames[i2 + 3] = 0x68;
    }

 	  get_request_string(&obd_frames[i2], i1);
 	  for (i3=i2+1;i3<(i2+14);i3++)
 	    obd_frames[i2+14] += obd_frames[i3];
 	  
 	  i2 += 15;
 	}
}

static int TntReset(int port, int txbuf, int rxbuf)
{
	int rc = 0;
	Err rp;
	SerSettingsType settingsP;
	char buf[80];
	
	if (serial_open == 1)
	  return 0;
	
	// open the serial port or set port defaults
	
	if (port == -1) // set defaults
	{
	
		// the rts/cts flags are not 0 or 1, return error
		
		if (txbuf < 0 || txbuf > 1 ||
		    rxbuf < 0 || rxbuf > 1)
		    return -1;
		    
		// set the default rts/cts flags
		    
		serial_rts = rxbuf;
		serial_dts = txbuf;
	    return 0;		
	}
	
	// make sure comport is zero
	
	if (port != 0)
		return -1;
		
	// get pointer to serial library structure
		
	if (SysLibFind("Serial Library",&serial_library) != 0)
		return -1;
	
	// actually open the port 
	
	if ((rp = SerOpen(serial_library,0,serial_baud)) != 0)
	{
		SerClose(serial_library);
		StrPrintF(buf,"serial open: %d, please do a soft reset!",rp);
		err_rtn(buf);
		return -1;
	}

	// set things like rtc/cts/parity/etc
	
	SerGetSettings (serial_library, &settingsP); // get original settings
	settingsP.ctsTimeout = 0;
	settingsP.flags = serSettingsFlagBitsPerChar8 | serSettingsFlagStopBits1;
//  settingsP.flags = serDefaultSettings;
	SerSetSettings(serial_library,&settingsP);		// apply settings
	
	// set the port open flag
	
	serial_open = 1;
	return rc;
}

static int TntDone(int port)
{
	int rc = 0;
	
	// close the serial port
	
	SerClose(serial_library);
	
	// set the port closed flags
	
	serial_open = -1;
	serial_library = -1;
	return rc;
}

static int TntBaud(int port, int baud)
{
	int rc = 0;
	
	// set the DEFAULT baud rate
	
	if (baud < 2 || baud > 115200) // must be between 2 & 115200 inclusive
		return -1;
		
	serial_baud = baud;
	return rc;
}

static int TntParms(int port, int parity, int stopbits, int charsize)
{
	int rc = 0;
	
	// set the other default fields
	
	if (parity < 0 || parity > 2 ||			//none, even, odd
	    stopbits < 0 || stopbits > 2 ||		//0, 1 or 2
	    charsize < 7 || charsize > 8)		//7 or 8
		return -1;
		
	serial_parity = parity;
	serial_stopbits = stopbits;
	serial_charsize = charsize;	    
	return rc;
}

static void draw_frames(int ic)
{
	int basec = prefs.chart_scale;
	FormPtr frmP;
	
	// draw chart frames if items are being logged and list selection is other than 'none'
	if (prefs.digital_mode == 1)
	  return;
	
	if (prefs.chart_frames == 0)
	{
		if (chart_status[0])
			chart_visible[0] = true;
		if (chart_status[1])
			chart_visible[1] = true;
		if (chart_status[2])
			chart_visible[2] = true;
		return;
	}
	
	frmP = FrmGetActiveForm();
	
	// draw frame 1
	
	if ((chart_status[0] != 0 && !play_mode) ||
	    (play_status[0] != 0 && play_mode))
	{
		chart_visible[0] = true;
		basec = prefs.chart_top[0];
		WinDrawLine(0,basec,prefs.chart_width,basec);
//		WinDrawLine(0,basec,0,basec+prefs.chart_scale);
		WinDrawLine(0,basec+prefs.chart_scale,prefs.chart_width,basec+prefs.chart_scale);
//		WinDrawLine(prefs.chart_width,basec,prefs.chart_width,basec+prefs.chart_scale);
	}
	
	// draw frame 2
	
	if (ic > 1)
	if ((chart_status[1] != 0 && !play_mode) ||
	    (play_status[1] != 0 && play_mode))
	{
		chart_visible[1] = true;
		basec = prefs.chart_top[1];
		WinDrawLine(0,basec,prefs.chart_width,basec);
//		WinDrawLine(0,basec,0,basec+prefs.chart_scale);
		WinDrawLine(0,basec+prefs.chart_scale,prefs.chart_width,basec+prefs.chart_scale);
//		WinDrawLine(prefs.chart_width,basec,prefs.chart_width,basec+prefs.chart_scale);
	}
	
	// draw frame 3
	
	if (ic > 2)
		if ((chart_status[2] != 0 && !play_mode) ||
	    (play_status[2] != 0 && play_mode))
	{
		chart_visible[2] = true;
		basec = prefs.chart_top[2];
		WinDrawLine(0,basec,prefs.chart_width,basec);
//		WinDrawLine(0,basec,0,basec+prefs.chart_scale);
		WinDrawLine(0,basec+prefs.chart_scale,prefs.chart_width,basec+prefs.chart_scale);
//		WinDrawLine(prefs.chart_width,basec,prefs.chart_width,basec+prefs.chart_scale);
	}
}

static Boolean pre_fetch_rtn(int parm_ct, int parm_id)
{

  char ch[20];
  int  parm_index = 0;
  int  p1;
  int  p2;
  
  if (!pre_fetch_default)
    return false;
    
  if (parm_ct >= item_count)
    p1 = 0;
  else  
    p1 = parm_id + 1;

  for (p2=p1;p2<=max_items;p2++)
  	if (items_to_log[p2] != 0)
  	{
  		TntRxClear();
  	  if (use_drb == 1)
  	  {
  	    if (p2 != 23)
  	    {
      	  get_request_string(ch, p2);
    		  TntPuts(0,ch,1);
    		}
  		}
  	  else
  	    if (p2 != 23)
    	    TntPuts(0,&obd_frames[p2 * 15],15);	 
  	  return true;
  	} 
  	
  return false;	

}

static void data_logger()
{
	ULong 		start_time = 0;
	ULong       unreg_timeout = 0;
	ULong       wot_timeout = 0;
	int 		sample = 0;
	int 		field_count = 0;
//	UInt32     event_delay = 0;
	int 		delta  = 1;
	int 		m = 0;
	int x;
	int   		parm_ct = 0;
	int pc;
	int 		parm_id = 0;
	int 		basec  = prefs.chart_scale;
static	int			response_length;
static  int     buflen;
	int 		frame_rate = 0;
static	int         tint;
static Boolean pre_fetch = false;
	EventType 	event;
	Word      	error;
static	FormPtr 	frmP;
static	Err			er;
	
	char ch[20];
static	char lb[100];
static  unsigned char rb[20];
	unsigned char byte1 = 0;
	unsigned char byte2 = 0;
	
	
//	char buf[40];
	
	Boolean rate_saved = false;
	
	// initialize chart base points and status fields
	
	lastx[0] = lastx[1] = lastx[2] = 0;
//	lasty[0] = prefs.chart_base[0]; //prefs.chart_spacing;
//	lasty[1] = prefs.chart_base[1]; //prefs.chart_spacing;
//	lasty[2] = prefs.chart_base[2]; //prefs.chart_spacing;
	//chart_status[0] = chart_status[1] = chart_status[2] = 0;
	
	// set logged data flag to false
	
	data_logged = false;
	g_err = 0;
	c_err = 0;
	
	plot_start_ticks = 0;
	plot_frame_ticks = 0;
	plot_last_ticks[0] = TimGetTicks();
	plot_last_ticks[1] = TimGetTicks();
	plot_last_ticks[2] = TimGetTicks();
	
	if (use_drb == 1)
		log_type[0] = 1;
	if (use_t16 == 1)
		log_type[0] = 2;
		
	// set frame counter to 0
	
	frame_count = 0;
	
	// set "parm within frame" counter to 0
	
	frame_byte = 0;
	
	// get the logging start time
	
	unreg_timeout = TimGetSeconds() + 30;
	
	// set the error counter to 0
	
	error_count = 0;
	 
	// display first status message
	
	frmP = FrmGetActiveForm();

	// set up for obd 
	
	if (use_t16 == 1)
	{
		// note about needed to have DTR pulled high
		
		TntBaud(0,19200);		// 19200
		TntParms(0,0,0,8);		// one start bit, no parity, 8 data bits
		TntReset(0,100,100);	// open the port
  
    PnsSetTitle("Connecting");
		
		// seed the obd request frame (element 7 changes based on item requested)
		
    ch[0]  = 0x25;
    ch[1]  = 0x10;
    ch[2]  = 0x05;
    ch[3]  = 0x68;
    ch[4]  = 0x6a;
    ch[5]  = 0xf1;
    ch[6]  = 0x01;
    ch[7]  = 0x01;
    ch[8]  = 0x00;
    ch[9]  = 0x00;
    ch[10] = 0x00;
    ch[11] = 0x00;
    ch[12] = 0x00;
    ch[13] = 0x00;
    ch[14] = 0x00;
    
    // set the length of the response
    
    response_length = 14;
    
    // set chart status to reflect the log element to graph (0 = no chart)
    
    prefs.t16_charts[0] = chart_status[0];
    prefs.t16_charts[1] = chart_status[1];
    prefs.t16_charts[2] = chart_status[2];
    
    TntRxClear();

    if (!obd_logon)
    {
      perf_level = 4;
      if (!obd_connect())
      {
        // error
        PnsSetTitle("Connection failed");
        logger_status = 2;
        return;
      }
      else
        obd_logon = true;
      perf_level = perf_level_default;
    }
    
    init_request_string();
    process_pids();
//    if (obd_protocol == 1)
//      wait_for_bytes(serial_library,1,5);
    
//    if (t16_logon() != 0)
//      return;
	}
	
	// set up 1st gen dsm
	
	if (use_drb == 1)
	{
		// set response length 
		
		response_length = 2;
		
		TntBaud(0,1920);		// 1920 baud
		TntParms(0,0,0,8);		// no parity, one stop bit, 8 data bits
		TntReset(0,100,100);	// open the port
		
    // set chart status to reflect the log element to graph (0 = no chart)
     
//    prefs.drb_charts[0] = chart_status[0] = LstGetSelection(GetObjectPtr(MainChartonechoiceList));
//    prefs.drb_charts[1] = chart_status[1] = LstGetSelection(GetObjectPtr(MainCharttwochoiceList));
//    prefs.drb_charts[2] = chart_status[2] = LstGetSelection(GetObjectPtr(MainChartthreechoiceList));
	}

	// draw the frames (if any) for the charts
	
	draw_frames(item_count);
	
	// build a file name
	
 	StrPrintF(lf_name,"log%ld",TimGetSeconds());
  	
 	// open the log file
  
  if (prefs.monitor_mode != 1)
  {	
  	log_handle = FileOpen(0,lf_name, 0, 0, fileModeUpdate, &er);
  	if (log_handle == 0 || er != 0)
  	{
  	  	StrPrintF(lf_name,"ferr: %d",5632 - er);
  	  	err_rtn(lf_name);
  	}
  }	
  
	// write file type (1 = drb, 2 = t16)
	
	if (use_drb == 1)
		log_buffer[0] = 1;
		
	if (use_t16 == 1)
		log_buffer[0] = 2;	
		
	if (prefs.monitor_mode != 1)	
  	FileWrite(log_handle,&log_buffer[0],1,1,&er);
	
	// write number of parms to file
	
	log_buffer[0] = item_count;

	if (prefs.monitor_mode != 1)	
	  FileWrite(log_handle,&log_buffer[0],1,1,&er);
	
	// write parm list to file
	
  if (prefs.monitor_mode != 1)
  	for (m=0;m<max_items;m++)
  		if (items_to_log[m] != 0)
  		{
  			log_buffer[0] = m;
  //	  	StrPrintF(lf_name,"fv: %d",m);
  //	  	FrmCustomAlert(FileopenAlert,lf_name,NULL,NULL);
  			FileWrite(log_handle,&log_buffer[0],1,1,&er);
  		}

	// data logging loop
	
	parm_ct = 0;
	frame_byte = 0;
	field_count = 0;
  plot_frame_ticks = TimGetTicks();
  
  if (prefs.monitor_mode == 1)
    PnsSetTitle("MONITOR MODE - NOT LOGGING");
  
	pre_fetch = false;
	inj_duty_cycle = 0;
	inj_rpms = 0;
	inj_pw = 0;
//	lap_number = 0;
//  StrPrintF(&lap_string[0][0]," ");
	
	do
	{

		// check for a "key" press every parm in test mode, or once a frame if really logging
		
		if (EvtEventAvail() /*event_delay + 3 <= TimGetSeconds() || test_mode */)
		{
//		  event_delay = TimGetSeconds();
  		EvtGetEvent(&event, 1);
      if (!hardkey(&event))
  		if (! SysHandleEvent(&event))
  			if (! MenuHandleEvent(0, &event, &error))
  				if (! AppHandleEvent(&event))
  					FrmDispatchEvent(&event);
		}
		
		// if the logger is not paused, go get some data
		
/*    if (lap_number > 0)
    {
      lap_ticks = TimGetTicks() - lap_start;
      lap_seconds = lap_ticks / 100;
      lap_milli = lap_ticks - (lap_seconds * 100);
      lap_minutes = lap_seconds / 60;
      lap_seconds = lap_seconds - (lap_minutes * 60);
      StrPrintF(&lap_string[lap_number][0],"%d %d:%02d.%02d",lap_number,lap_minutes,lap_seconds,lap_milli);
    }
*/    
		if (logger_status != 1)
		{
		
      // if the parm to log is non-zero, lets log it
			
		  if (items_to_log[parm_id] != 0)
		  {
	   		++ parm_ct;
			  		
        if (!pre_fetch)
        {
  		 		// get the "request string" for this parm
  			  		
  				  	
  				// send the request to the ecu
  				  	
          TntRxClear();
  			  if (use_drb == 1)
  			  {
    				get_request_string(ch, parm_id);
    				if (parm_id != 23)
    				  TntPuts(0,ch,1);
  				}
  			  else
  			    if (parm_id != 23)
    			    TntPuts(0,&obd_frames[parm_id * 15],15);	 
			  } 
			  else
			    if (use_drb == 1)
			     	get_request_string(ch, parm_id);

			  		  		  
			  // wait until the request comes back, or 5 seconds
			  
			  if (parm_id != 23)
  			  buflen = wait_for_bytes(0,response_length,5);
			  
			  if (start_time == 0)
			    start_time = TimGetSeconds();
			  		
				if (test_mode || buflen > 0 || parm_id == 23)
	      {
	        // we got a response, so count it as logged
	        
					data_logged = true;
					if (plot_start_ticks == 0)
					  plot_start_ticks = TimGetTicks();
					if (plot_frame_ticks == 0)
					  plot_frame_ticks = TimGetTicks();
						
			  	if (!test_mode)
			  	{
			  		// read the data bytes
				  		
				    if (parm_id != 23)		
  			  		tint = TntGets(serial_library,rb,buflen,-1,&er);
			  		
				  	// data read so process it
						  	
				  	if (use_drb == 1) // process drb
				  	{
				  		// scan buffer until we find a code
				  		
				  		if (parm_id != 23)
				  		{
  						  		
  				  		for (m=0;m<tint;m++)
  				  			if (rb[m] == ch[0])
  				  			{
  				  				byte1 = rb[m+1];
  				  				break;
  				  			}
  						  		
  				  		// error
  						  		
  				  		if (m == tint)
  				  		{
  				  		  // malformed response or no response
  				  		  
  				  		  StrPrintF(play_fname,"Missing response byte %x %x %x",ch[0],rb[0],rb[1]);
  				  		  err_rtn(play_fname);
  				  		  logger_status = 2;
  				  		  break;
  				  		  
  				  		}
  						  		
              }
      		     pre_fetch = pre_fetch_rtn(parm_ct,parm_id);
              if (!skip_request)
                ++ frame_count;	       		    	
							tint = get_value(parm_id, byte1, 0, sample, 1);
    					if (parm_id == 23)
    					{
//    					  byte1 = tint / 256;
 //   					  byte2 = tint - (byte1 * 256);
                  byte1 = tint;
    					}
							if (parm_id == 1 || parm_id == 21 || parm_id == 23 || parm_id >= 26)
   				 	  	StrPrintF(lb,"%ld.%02ld",lv1/100,lv1%100);
   				 	  else
   				 	  	StrPrintF(lb,"%ld",lv1/100);
    			 	  if (prefs.digital_mode == 1)	
    			 	  {
    			 	    if (item_count > 5)
           	  	  show_digital_values(parm_id,lb,frmP,parm_ct - 1,MainRpmfieldLabel);
           	  	else
           	  	  show_digital_values(parm_id,lb,frmP,parm_ct - 1,MainShortlistLabel);
         	  	}
         	  	else
         	  	{
                pc = 0;
                if (parm_id > 23)
                  pc = 1;
         	  	  for (x=0;x<3;x++)
         	  	    if (chart_status[x] == parm_ct - pc)
         	  	    {
         	  	      if (parm_id != 23)
      				  	  	draw_chart(x + 1,tint);
      				  	  if (StrLen(lb) < 5 && parm_id != 23)
      								PnsCopyLabel(frmP,MainChart1valueLabel + x,lb);
    								break;
         	  	    }
				  	  }
							log_buffer[frame_byte + field_count] = byte1; // set a dummy value
								
							if (!registered)
								if (wot_timeout != 0)
									if (parm_id == 0 && byte1 > 240)  // 90%
										wot_timeout = TimGetSeconds() + 5;
											
							// increment field count
							
							++ field_count;
						}
							
						// add code to process obd-ii
							
						if (use_t16 == 1) // process obd
						{
							// scan for obd_response, data bytes are +5 & +6
							if (parm_id != 23)
							{
  				  		for (m=0;m<tint;m++)
  				  			if (rb[m] == obd_response || rb[m] == 0x80)
  				  			{
  				  			  if (rb[m] == obd_response)
  				  			  {
  				  			    if (rb[m + 3] == dlc_address)
  				  			    {
      				  				byte1 = rb[m+6];
      				  				byte2 = rb[m+7];
      				  			}
      				  			else
      				  			{
//      				  			  err_rtn("dlc change");
      				  			  m = tint;
      				  			}
    				  			}
  				  				break;
  				  			}
  						  		
  				  		// error
  					  		
  				  		if (m == tint || rb[m] == 0x80)
  				  		{
  				  		  // malformed response or no response
  				  		  
  				  		  if (rb[m] == 0x80)
  				  		  {
  //  			  		    StrPrintF(buf,"OBD error %d %x %x %x %x",rb[m+2],ch[0],ch[1],ch[2],ch[3]);
  //  			  		    err_rtn(buf);
  				  		    if (rb[m+2] == 3)
  				  		    {
  				  		      t16_timer = 0;
  				  		    }
  				  		  }
                  -- parm_ct;
                  pre_fetch = false;
                  ++ g_err;
                  continue;
  				  		  
  				  		}
						  }		
       		    pre_fetch = pre_fetch_rtn(parm_ct,parm_id);
              if (!skip_request)
                ++ frame_count;	       		    	
    					tint = get_value(parm_id, byte1, byte2, sample, 2);
    					if (parm_id == 23)
    					{
     					  byte1 = tint / 256;
     					  byte2 = tint - (byte1 * 256);
    					}
							log_buffer[frame_byte + field_count] = byte1; // set a dummy value
							log_buffer[frame_byte + field_count + 1] = byte2; // set a dummy value
							if (prefs.digital_mode == 1 ||
							    chart_status[0] == parm_ct ||
							    chart_status[1] == parm_ct ||
							    chart_status[2] == parm_ct)
							{
                if (parm_id == 1 || parm_id == 21 || parm_id == 23 || parm_id >= 26)
    			 	 	  	StrPrintF(lb,"%ld.%02ld",lv1/100,lv1%100);
  				 	  	else
  	  			 	  	StrPrintF(lb,"%ld",lv1/100);
      			 	  if (prefs.digital_mode == 1)	
      			 	  {
      			 	    if (item_count > 5)
             	  	  show_digital_values(parm_id,lb,frmP,parm_ct - 1,MainRpmfieldLabel);
             	  	else
             	  	  show_digital_values(parm_id,lb,frmP,parm_ct - 1,MainShortlistLabel);
           	  	}
           	  	else
           	  	{
           	  	  if (parm_id > 23)
           	  	    pc = 1;
           	  	  else
           	  	    pc = 0;
           	  	  for (x=0;x<3;x++)
           	  	    if (chart_status[x] == parm_ct - pc)
           	  	    {
           	  	      if (parm_id != 23)
        				  	  	draw_chart(x + 1,tint);
        				  	  if (StrLen(lb) < 5 && parm_id != 23)
        								PnsCopyLabel(frmP,MainChart1valueLabel + x,lb);
      								break;
           	  	    }
  				  	  }
  				  	}  
  				  	
							if (!registered)
								if (wot_timeout != 0)
									if (parm_id == 0 && byte1 > 250)
										wot_timeout = TimGetSeconds() + 5;
											
							// increment field count
							
							field_count += 2;
						}								
							
			  		// clear the rx buffer
							
					}  	
					else
					{
							  
					  // plot the data point(s)
						
     		    pre_fetch = pre_fetch_rtn(parm_ct,parm_id);
		    
						byte1 = sample;
            if (!skip_request)
              ++ frame_count;	       		    	
    	  	  tint = get_value(parm_id, byte1, byte2, sample, log_type[0]);
			  	  if (parm_id == 1 || parm_id == 21 || parm_id == 23 || parm_id >= 26)
	  		 	  	StrPrintF(lb,"%ld.%02ld",lv1/100,lv1%100);
	  		 	  else
  			 	  	StrPrintF(lb,"%ld",lv1/100);
   					if (parm_id == 23)
   					{
   					  if (use_t16 == 1)
   					  {
     					  byte1 = tint / 256;
     					  byte2 = tint - (byte1 * 256);
     					}
     					else
     					  byte1 = tint;
   					}
  			 	  if (prefs.digital_mode == 1)	
   			 	  {
   			 	    if (item_count > 5)
         	  	  show_digital_values(parm_id,lb,frmP,parm_ct - 1,MainRpmfieldLabel);
         	  	else
         	  	  show_digital_values(parm_id,lb,frmP,parm_ct - 1,MainShortlistLabel);
       	  	}
       	  	else
       	  	{
           	  	  if (parm_id > 23)
           	  	    pc = 1;
           	  	  else
           	  	    pc = 0;
      	  	  for (x=0;x<3;x++)
      	  	    if (chart_status[x] == parm_ct - pc)
      	  	    {
      	  	      if (parm_id != 23)
    				  	  	draw_chart(x + 1,tint);
     				  	  if (StrLen(lb) < 5 && parm_id != 23)
     								PnsCopyLabel(frmP,MainChart1valueLabel + x,lb);
   								break;
      	  	    }
				    }
						// test mode, so just count the fields
							
						log_buffer[frame_byte + field_count] = byte1; // set a dummy value
						if (use_t16 == 1)
						{
							log_buffer[frame_byte + field_count + 1] = byte2; // set a dummy value
							++ field_count;
						}
	
						++ field_count;
					}
				}
				else
				{

          // display error
          
//          err_rtn("No response from vehicle");
          
				 	// no response
          -- parm_ct;
          pre_fetch = false;
          ++ c_err;
          if (c_err < 5)
            continue;
	  		  logger_status = 2;
	  		  break;
				  	
				}  	

				if (test_mode && parm_ct == 1)
				{	  
				    // calc a point
				      
				  sample += delta;
					if (sample < 1 || sample > prefs.chart_scale - 1 || sample > 98)
					  delta = delta * -1;
		 	  }	    
			
		  }
		  
		  // increment the parm counter
		  
		  ++ parm_id;

      if (TimGetSeconds() > start_time)
      {
        frame_rate = frame_count;
        start_time = TimGetSeconds();
        frame_count = 1;
      }

		  // have we logged all the parms in the frame?
		  
		  if (parm_id == max_items || parm_ct == item_count)
		  {
		    // calc inj d/c
		    
		    if (inj_rpms != 0 && inj_pw != 0)
		      inj_duty_cycle = (inj_pw * inj_rpms) / 1200;
		      
		    parm_id = 0;
		    parm_ct = 0;
		    
		  	
		  	// reset the parm counter
		  	
		  	parm_id = 0;
		  	
		  	// update the "logged" data buffer size
		  	
		  	frame_byte += field_count;
		  	
		  	// init field count
		  	
		  	field_count = 0;
		  	
		  	// bump the frame count
		  	
//		  	++ frame_count;
		  	
		  	// buffer is full, so write it
		  	
		  	if (frame_byte > 8000)
		  	{
  				// write frame rate
  				
  				if (!rate_saved)
  				{
  					rate_saved = true;
  					log_buffer[8190] = frame_rate;
  					if (prefs.monitor_mode != 1)
    					FileWrite(log_handle,&log_buffer[8190],1,1,&er);
  				}

		  		// write log _buffer
		  		
 					if (prefs.monitor_mode != 1)
  		    	FileWrite(log_handle,&log_buffer[0],1,frame_byte,&er);
		  		
		  		frame_count = 0;
		  		frame_byte  = 0;
		  		start_time = TimGetSeconds();
		  	}
		  	

		  	if (frame_count > 0)
		  	{
		  		// update the frame rate and buffer size counters
		  		
          x = (t16_rejected_requests + t16_rejected_responses);
          StrPrintF(status_detail," ");
//          if (lap_number > 0)
//  			  	StrPrintF(&status_detail[StrLen(status_detail)],"%s ",&lap_string[lap_number][0]);
          if (frame_byte > 0)
  			  	StrPrintF(&status_detail[StrLen(status_detail)],"B:%d ",frame_byte);
          if (frame_rate > 0)
  			  	StrPrintF(&status_detail[StrLen(status_detail)],"R:%d ",frame_rate);
          if (send_delay > 0)
  			  	StrPrintF(&status_detail[StrLen(status_detail)],"D:%d ",send_delay);
  			  if (x > 0)
  			    StrPrintF(&status_detail[StrLen(status_detail)],"E:%d ",x);
			  	if (prefs.peak_hold)
			  	  StrCat(status_detail,"P ");
          else
            if (inj_duty_cycle != 0)
              StrPrintF(&status_detail[StrLen(status_detail)],"DC:%ld ",(long)inj_duty_cycle);
          if (prefs.monitor_mode != 1)
            PnsSetTitle(status_detail);
      		EvtResetAutoOffTimer();
  				if (send_delay > 0 && x == 0)
   				  -- send_delay;
          if (logger_status == 2)
            break;
     		}
		  }
		}
		
		if (!registered)
		{
			if (wot_timeout != 0)
				if (wot_timeout < TimGetSeconds())
					logger_status = 2;
					
			if (unreg_timeout < TimGetSeconds())
				logger_status = 2;			
		}
	}
	while (1 == 1); // loop until request to stop

	// close serial port
	
//	TntDone(0);
	
	// is there data left in the log buffer, if so - write it
	
  	if (frame_byte > 0)
  	{
		// write frame rate
		
		if (!rate_saved)
		{
			rate_saved = true;
			log_buffer[8190] = frame_rate;
			if (prefs.monitor_mode != 1)
  			FileWrite(log_handle,&log_buffer[8190],1,1,&er);
		}

  		// write log _buffer
  		
		if (prefs.monitor_mode != 1)
		{
    	FileWrite(log_handle,&log_buffer[0],1,frame_byte,&er);
    	create_memo(lf_name);
    }
  }
    
	// close log file
	
	
  if (prefs.monitor_mode != 1)
    FileClose(log_handle);
	
  PnsSetTitle((char *)form_title);

	// add entry to log directory, use "default name"
	
	// if we logged data, clear all the charts
	
	if (data_logged && prefs.monitor_mode != 1)
	{
//	  FrmEraseForm(frmP);
    save_mode = true;
		FrmPopupForm(SavedataForm);
//		FrmDrawForm(frmP);
	}	
	
	if (prefs.monitor_mode == 1)
	{
	  save_mode = false;
	  data_logged = false;
	}
}

static void hide_logger_controls()
{

  int x;
	// hide the controls
	
	FormPtr frmP;
	
	frmP = FrmGetActiveForm();
	if (FrmGetActiveFormID() != MainForm)
	  return;
	
	for (x=MainRpmfieldLabel;x<MainRpmfieldLabel+15;x++)
   	FrmHideObject(frmP, FrmGetObjectIndex(frmP, x));

	for (x=MainShortlistLabel;x<MainShortlistLabel+5;x++)
   	FrmHideObject(frmP, FrmGetObjectIndex(frmP, x));

 	FrmHideObject(frmP, FrmGetObjectIndex(frmP, MainStartloggingButton));
	FrmHideObject(frmP, FrmGetObjectIndex(frmP, MainPauseloggingButton));
	FrmHideObject(frmP, FrmGetObjectIndex(frmP, MainStoploggingButton));
	FrmHideObject(frmP, FrmGetObjectIndex(frmP, MainCharttimescaleSliderControl));
	FrmHideObject(frmP, FrmGetObjectIndex(frmP, MainChartonechoiceList ));
	FrmHideObject(frmP, FrmGetObjectIndex(frmP, MainCharttwochoiceList ));
	FrmHideObject(frmP, FrmGetObjectIndex(frmP, MainT16choiceoneList ));
	FrmHideObject(frmP, FrmGetObjectIndex(frmP, MainT16choicetwoList ));
	FrmHideObject(frmP, FrmGetObjectIndex(frmP, MainT16choicethreeList ));
	FrmHideObject(frmP, FrmGetObjectIndex(frmP, MainChartthreechoiceList ));
	FrmHideObject(frmP, FrmGetObjectIndex(frmP, MainChart1valueLabel));
	FrmHideObject(frmP, FrmGetObjectIndex(frmP, MainChart2valueLabel));
	FrmHideObject(frmP, FrmGetObjectIndex(frmP, MainChart3valueLabel));
 	FrmHideObject(frmP, FrmGetObjectIndex(frmP, MainChart1nameLabel));
 	FrmHideObject(frmP, FrmGetObjectIndex(frmP, MainChart1nameLabel + 2));
 	FrmHideObject(frmP, FrmGetObjectIndex(frmP, MainChart1nameLabel + 1));
//	chart_visible[0] = chart_visible[1] = chart_visible[2] = false;
}
	
static void show_logger_controls()
{
  static char lb[10];
  int x;
  
	// show the controls

	FormPtr frmP;
	
	setup_charts(&chart_status[0]);
	
	frmP = FrmGetActiveForm();
	if (FrmGetActiveFormID() != MainForm)
	  return;
	
	StrPrintF(lb,"0");
	PnsCopyLabel(frmP,MainChart1valueLabel,lb);
	PnsCopyLabel(frmP,MainChart2valueLabel,lb);
	PnsCopyLabel(frmP,MainChart3valueLabel,lb);
	if (prefs.digital_mode != 1)
  	for (x=0;x<3;x++)
  	{
      FrmHideObject(frmP,FrmGetObjectIndex(frmP,MainChart1nameLabel + x));
    	FrmHideObject(frmP, FrmGetObjectIndex(frmP, MainChart1valueLabel + x));
      if (chart_status[x] != 0)
      {
        PnsCopyLabel(frmP,MainChart1nameLabel + x,l_list[chart_status[x]]);
        FrmShowObject(frmP,FrmGetObjectIndex(frmP,MainChart1nameLabel + x));
      	FrmShowObject(frmP, FrmGetObjectIndex(frmP, MainChart1valueLabel + x));
        if (prefs.color_support == 1 && prefs.single_chart == 1)
        {
          WinPushDrawState();
          WinSetForeColor(color_index[x]);
          WinDrawLine(120,34 + (x * 50),155,34 + (x * 50));
          WinPopDrawState();
        }
      }
    }
  
  if (prefs.digital_mode == 1)
  {
    StrPrintF(lb," ");
    if (item_count > 5)
      for (x=MainRpmfieldLabel;x<MainRpmfieldLabel+15;x++)
      {		
        PnsCopyLabel(frmP,x,lb);
        if (prefs.digital_mode == 1)
        	FrmShowObject(frmP, FrmGetObjectIndex(frmP, x));
      }
    else
      for (x=MainShortlistLabel;x<MainShortlistLabel+5;x++)
      {		
        PnsCopyLabel(frmP,x,lb);
        if (prefs.digital_mode == 1)
        	FrmShowObject(frmP, FrmGetObjectIndex(frmP, x));
      }
  }
  
  //play_mode = false;
} 
 
static void init_log_list()
{
  Int16 loop1;
  
  
  // initialize log list to zero
  
  for (loop1 = 0;loop1<max_items;loop1++)
    items_to_log[loop1] = 0;
    
  if (use_t16 == 1) // get obd parm list
  {
  	for (loop1 = 0;loop1<40;loop1++)
  		prefs.t16_items[loop1] = 0;

//	CtlSetValue(GetObjectPtr(configuret16Logt16rpmsCheckbox),1);    		
	prefs.t16_items[0] = items_to_log[0] = CtlGetValue(GetObjectPtr(configuret16Logt16rpmsCheckbox));  
	prefs.t16_items[1] = items_to_log[1] = CtlGetValue(GetObjectPtr(configuret16Logt16o2vCheckbox));  
	prefs.t16_items[2] = items_to_log[2] = CtlGetValue(GetObjectPtr(configuret16Logt16timingCheckbox));  
	prefs.t16_items[3] = items_to_log[3] = CtlGetValue(GetObjectPtr(configuret16Logt16tpsCheckbox));  
	prefs.t16_items[4] = items_to_log[4] = CtlGetValue(GetObjectPtr(configuret16Logt16airflowCheckbox));  
	prefs.t16_items[5] = items_to_log[5] = CtlGetValue(GetObjectPtr(configuret16Logt16shorttrimCheckbox));  
	prefs.t16_items[6] = items_to_log[6] = CtlGetValue(GetObjectPtr(configuret16Logt16longtrimCheckbox));  
	prefs.t16_items[7] = items_to_log[7] = CtlGetValue(GetObjectPtr(configuret16Logt16airtempCheckbox));  
	prefs.t16_items[8] = items_to_log[8] = CtlGetValue(GetObjectPtr(configuret16Logt16watertempCheckbox));  
	prefs.t16_items[9]  = items_to_log[18] = CtlGetValue(GetObjectPtr(configuret16T16shorttrim2Checkbox));  
	prefs.t16_items[10] = items_to_log[19] = CtlGetValue(GetObjectPtr(configuret16T16longtrim2Checkbox));  
	prefs.t16_items[11] = items_to_log[20] = CtlGetValue(GetObjectPtr(configuret16T16loadCheckbox));  
	prefs.t16_items[12] = items_to_log[17] = CtlGetValue(GetObjectPtr(configuret16T16mapCheckbox));  
	prefs.t16_items[13] = items_to_log[16] = CtlGetValue(GetObjectPtr(configuret16T16mphCheckbox));  
	prefs.t16_items[14] = items_to_log[21] = CtlGetValue(GetObjectPtr(configuret16T16o2v2Checkbox));  
	prefs.t16_items[15] = items_to_log[23] = 1;
  }

  if (use_drb == 1) // get drb parm list
  {
  	for (loop1 = 0;loop1<20;loop1++)
  		prefs.drb_items[loop1] = 0;
  		
//	CtlSetValue(GetObjectPtr(configuredrbLogdrbrpmsCheckbox),1);  
	prefs.drb_items[0] = items_to_log[0]  = CtlGetValue(GetObjectPtr(configuredrbLogdrbrpmsCheckbox));  
	prefs.drb_items[1] = items_to_log[1]  = CtlGetValue(GetObjectPtr(configuredrbLogdrbo2vCheckbox));  
	prefs.drb_items[2] = items_to_log[2]  = CtlGetValue(GetObjectPtr(configuredrbLogdrbtimingCheckbox));  
	prefs.drb_items[3] = items_to_log[3]  = CtlGetValue(GetObjectPtr(configuredrbLogdrbtpsCheckbox));  
	prefs.drb_items[4] = items_to_log[4]  = CtlGetValue(GetObjectPtr(configuredrbLogdrbairflowCheckbox));  
 	prefs.drb_items[5] = items_to_log[5]  = CtlGetValue(GetObjectPtr(configuredrbLogdrblowtrimCheckbox));  
	prefs.drb_items[6] = items_to_log[6]  = CtlGetValue(GetObjectPtr(configuredrbLogdrbmedtrimCheckbox));  
	prefs.drb_items[7] = items_to_log[9]  = CtlGetValue(GetObjectPtr(configuredrbLogdrbknockCheckbox));  
	prefs.drb_items[8] = items_to_log[10] = CtlGetValue(GetObjectPtr(configuredrbLogdrbpulsewidthCheckbox));  
	prefs.drb_items[9] = items_to_log[11] = CtlGetValue(GetObjectPtr(configuredrbLogdrbhightrimCheckbox));  
	prefs.drb_items[15] = items_to_log[22] = CtlGetValue(GetObjectPtr(configuredrbLogdrbo2trimCheckbox));  
	prefs.drb_items[16] = items_to_log[23] = 1;
	prefs.drb_items[17] = items_to_log[24] = CtlGetValue(GetObjectPtr(configuredrbUnnamed1213Checkbox));  
	prefs.drb_items[18] = items_to_log[25] = CtlGetValue(GetObjectPtr(configuredrbRawmdpCheckbox));  
	prefs.drb_items[19] = items_to_log[26] = CtlGetValue(GetObjectPtr(configuredrbWidebandCheckbox));  
	prefs.drb_items[20] = items_to_log[27] = CtlGetValue(GetObjectPtr(configuredrbWidebandloutCheckbox));  
  }
  
  // reset the logging available flags
  
  loggable_items = false;
  item_count = 0;
  
  // scan the list count the "checked" parms
  
  prefs.log_item_count = 0;
  for (loop1=0;loop1<3;loop1++)
    if (items_to_log[chart_status[loop1] - 1] == 0)
      chart_status[loop1] = 0;
  for (loop1=0;loop1<max_items;loop1++)
  {
 		prefs.log_items[loop1] = items_to_log[loop1];
    if (items_to_log[loop1] != 0)
    {
   		++ item_count;
   		if (item_count > 1)
    		loggable_items = true;
  		++prefs.log_item_count;
	  }
	}
	
		
}

static void transfer_file()
{
  int   loop1;
  char buffer1[50];
  char buffer2[10];
  Err er;
  Int32  file_ptr;
  Int32  file_size;
  Int32  fx;
  int x1;
  
  FormPtr frmP;
  
  frmP = FrmGetActiveForm();
  
  
  // get selected dir entry
  
	if (log_directory[LstGetSelection(GetObjectPtr(MainLogfilelistList))].log_name[0] == 0)
	{
		return;
	}
	
  // open serial port
  
	TntBaud(0,19200);		// 19200
	TntParms(0,0,0,8);		// one start bit, no parity, 8 data bits
	TntReset(0,1024,1024);	// open the port
  
  // open log file
  
	play_entry = LstGetSelection(GetObjectPtr(MainLogfilelistList));
	log_handle = FileOpen(0,log_directory[play_entry].log_fnme,0,0,fileModeReadOnly,&er);
	if (log_handle == 0 || er != 0)
	{
	  	StrPrintF(play_fname,"log file ferr: %d",5632 - er);
//	  	FrmCustomAlert(FileopenAlert,play_fname,NULL,NULL);
//	  	TntDone(0);
	  	return;
	}
	
  // send enq every second until ack is returned
  
 	StrPrintF(play_fname,"point 1");
// 	err_rtn(play_fname);
// 	FrmCustomAlert(FileopenAlert,play_fname,NULL,NULL);

  for (loop1=0;loop1<5;loop1++)
  {
    buffer1[0] = 0xff;
    TntRxClear();
    TntPuts(0,buffer1,1);
    if (wait_for_bytes(0,1,5) > 0 || test_mode)
    {
      if (test_mode)
        buffer1[0] = 0x00;
      else
        TntGets(serial_library,(unsigned char *)buffer1,1,-1,&er);
      if (buffer1[0] == 0x00)
        break;
    }    
    else
    {
     	StrPrintF(play_fname,"point 1a");
//     	err_rtn(play_fname);
//    	FrmCustomAlert(FileopenAlert,play_fname,NULL,NULL);
    }
  }
  
 	StrPrintF(play_fname,"point 2");
// 	err_rtn(play_fname);
// 	FrmCustomAlert(FileopenAlert,play_fname,NULL,NULL);

  if (buffer1[0] != 0x00)
  {
    
    // time out error
 	StrPrintF(play_fname,"point 3");
// 	err_rtn(play_fname);
//	FrmCustomAlert(FileopenAlert,play_fname,NULL,NULL);


  }
  else
  {

   	StrPrintF(play_fname,"point 4");
// 	err_rtn(play_fname);
// 	  FrmCustomAlert(FileopenAlert,play_fname,NULL,NULL);

    // wait one second and then begin sending
  
    wait_for_bytes(0,1,2);
    
    // send the file type (obd/drb)
         
		FileRead(log_handle,&buffer1[0],1,1,&er);
		
    // send the # of parms
    
    FileRead(log_handle,&buffer1[1],1,1,&er);
    for (loop1=0;loop1<buffer1[1];loop1++)
    {
      FileRead(log_handle,&buffer1[loop1 + 2],1,1,&er);
     	StrPrintF(play_fname,"point a %d",&buffer1[loop1 + 2]);
// 	err_rtn(play_fname);
// 	    FrmCustomAlert(FileopenAlert,play_fname,NULL,NULL);
    }
    
		// convert the parm list
		
	  TntPuts(0,&buffer1[0],2);
  	for (loop1=2;loop1<buffer1[1] + 2;loop1++)
		{
		  if (buffer1[0] == 1)  // drb
		  {
		    if (buffer1[loop1] == 0)
		      buffer1[loop1] = 9;
		    else
		    if (buffer1[loop1] == 1)
		      buffer1[loop1] = 3;
		    else
		    if (buffer1[loop1] == 2)
		      buffer1[loop1] = 0;
		    else
		    if (buffer1[loop1] == 3)
		      buffer1[loop1] = 7;
		    else
		    if (buffer1[loop1] == 4)
		      buffer1[loop1] = 18;
		    else
		    if (buffer1[loop1] == 5)
		      buffer1[loop1] = 12;
		    else
		    if (buffer1[loop1] == 6)
		      buffer1[loop1] = 13;
		    else
		    if (buffer1[loop1] == 7)
		      buffer1[loop1] = 11;
		    else
		    if (buffer1[loop1] == 8)
		      buffer1[loop1] = 1;
		    else
		    if (buffer1[loop1] == 9)
		      buffer1[loop1] = 17;
		    else
		    if (buffer1[loop1] == 10)
		      buffer1[loop1] = 10;
		    else
		    if (buffer1[loop1] == 22)
		      buffer1[loop1] = 0x0f;
		    else
		    if (buffer1[loop1] == 11)
		      buffer1[loop1] = 48;
        else
        if (buffer1[loop1] == 23)
          buffer1[loop1] = 96;
        else
        if (buffer1[loop1] == 24)
          buffer1[loop1] = 97;
		  }
		  if (buffer1[0] == 2)  // obd
		  {
		    if (buffer1[loop1] == 0)
		      buffer1[loop1] = 9;
		    else
		    if (buffer1[loop1] == 1)
		      buffer1[loop1] = 3;
		    else
		    if (buffer1[loop1] == 2)
		      buffer1[loop1] = 0;
		    else
		    if (buffer1[loop1] == 3)
		      buffer1[loop1] = 7;
		    else
		    if (buffer1[loop1] == 4)
		      buffer1[loop1] = 18;
		    else
		    if (buffer1[loop1] == 5)
		      buffer1[loop1] = 12;
		    else
		    if (buffer1[loop1] == 6)
		      buffer1[loop1] = 13;
		    else
		    if (buffer1[loop1] == 7)
		      buffer1[loop1] = 11;
		    else
		    if (buffer1[loop1] == 8)
		      buffer1[loop1] = 1;
		    // add 6 new parms
        else
        if (buffer1[loop1] == 16)
          buffer1[loop1] = 90;
        else
        if (buffer1[loop1] == 17)
          buffer1[loop1] = 91;
        else
        if (buffer1[loop1] == 18)
          buffer1[loop1] = 92;
        else
        if (buffer1[loop1] == 19)
          buffer1[loop1] = 93;
        else
        if (buffer1[loop1] == 20)
          buffer1[loop1] = 94;
        else
        if (buffer1[loop1] == 21)
          buffer1[loop1] = 95;
        else
        if (buffer1[loop1] == 23)
          buffer1[loop1] = 96;
		  }
		  TntRxClear();
		  TntPuts(0,&buffer1[loop1],1);
		  wait_for_bytes(0,1,5);
		}
		
    // send the parm list
    
    
    // swallow a byte
    
    FileRead(log_handle,&buffer2[0],1,1,&er);
    
    // send the data frames
    
    file_ptr = 1;
    x1 = 0;
    TntRxClear();
    do
    {
   		EvtResetAutoOffTimer();
    	file_ptr = FileTell(log_handle,&file_size,&er);
    	fx = file_size - file_ptr;
    	StrPrintF(play_fname,"%ld %ld %ld",file_size,file_ptr,fx);
    	PnsSetTitle(play_fname);
      for (loop1=0;loop1<buffer1[1];loop1++)
      {
        FileRead(log_handle,&buffer2[0],1,buffer1[0],&er);
//        if (buffer1[0] == 2)
//          FileRead(log_handle,&buffer2[1],1,1,&er);
        TntRxClear();
        TntPuts(0,&buffer1[loop1 + 2],1);
//        SerSendWait(serial_library,-1);
        TntPuts(0,buffer2,buffer1[0]);
//        SerSendWait(serial_library,-1);
        if (wait_for_bytes(0,1,5) < 0)
        {
          x1 = 1;
          err_rtn("Transfer aborted!");
          break;
        }
      }
      
      if (x1 != 0)
        break;
      
    }
    while (FileEOF(log_handle) != 1 && x1 == 0);
    
    buffer1[0] = 0xff;
    TntPuts(0,buffer1,1);
    TntPuts(0,buffer1,1);
    TntPuts(0,buffer1,1);

  }
  
  // close log file
  
	FileClose(log_handle);

  // close serial port
  
  TntDone(0);
  
}

/***********************************************************************
 *
 * FUNCTION:    RomVersionCompatible
 *
 * DESCRIPTION: This routine checks that a ROM version is meet your
 *              minimum requirement.
 *
 * PARAMETERS:  requiredVersion - minimum rom version required
 *                                (see sysFtrNumROMVersion in SystemMgr.h 
 *                                for format)
 *              launchFlags     - flags that indicate if the application 
 *                                UI is initialized.
 *
 * RETURNED:    error code or zero if rom is compatible
 *
 * REVISION HISTORY:
 *
 ***********************************************************************/
static Err RomVersionCompatible(DWord requiredVersion, Word launchFlags)
{
	DWord romVersion;

	// See if we're on in minimum required version of the ROM or later.
	FtrGet(sysFtrCreator, sysFtrNumROMVersion, &romVersion);
	if (romVersion < requiredVersion)
		{
		if ((launchFlags & (sysAppLaunchFlagNewGlobals | sysAppLaunchFlagUIApp)) ==
			(sysAppLaunchFlagNewGlobals | sysAppLaunchFlagUIApp))
			{
			FrmAlert (RomIncompatibleAlert);
		
			// Pilot 1.0 will continuously relaunch this app unless we switch to 
			// another safe one.
			if (romVersion < sysMakeROMVersion(2,0,0,sysROMStageRelease,0))
				AppLaunchWithCommand(sysFileCDefaultApp, sysAppLaunchCmdNormalLaunch, NULL);
			}
		
		return (sysErrRomIncompatible);
		}

	return (0);
}


/***********************************************************************
 *
 * FUNCTION:    MainFormInit
 *
 * DESCRIPTION: This routine initializes the MainForm form.
 *
 * PARAMETERS:  frm - pointer to the MainForm form.
 *
 * RETURNED:    nothing
 *
 * REVISION HISTORY:
 *
 *
 ***********************************************************************/
static void MainFormInit(FormPtr frmP)
{
}


/***********************************************************************
 *
 * FUNCTION:    MainFormDoCommand
 *
 * DESCRIPTION: This routine performs the menu command specified.
 *
 * PARAMETERS:  command  - menu item id
 *
 * RETURNED:    nothing
 *
 * REVISION HISTORY:
 *
 *
 ***********************************************************************/
static Boolean MainFormDoCommand(Word command)
{
	Boolean handled = false;
	FormPtr frmP;
	int basec = prefs.chart_scale;
//	ULong ut;
	static char buf[20];

	int  lp;
	int  lp1;
	char sd;
	
	frmP = FrmGetActiveForm();

	switch (command)
		{
		case MainTransferfileButton:
		  if (test_mode)
		  {
		    err_rtn("Transfers not allowed in Test Mode");
		    return true;
		  }
		  sd = send_delay;
		  send_delay = 0;
		  
			if (registered && !test_mode)
				transfer_file();
			else
			  err_rtn("Feature locked!");
			send_delay = sd;
      PnsSetTitle((char *)form_title);

			return true;	
		// add code to transfer data to p/c
		
		// save button
		
/*		case MainSavelogfileButton:
			handled = true;
			
			// is logger running?
			
			if (logger_status != 2)
			{
				FrmAlert(AlreadyloggingAlert);
				return true;
			}
			
			// did we actually log any data?
			
			if (!data_logged)
		    {
	    		FrmAlert (NodataAlert);
	    		return true;
		    }
		    
		    // turn off logged flag
		    
		    data_logged = false;
		    
		    // hide the logger controls
		    
		    hide_logger_controls();
		    
		    // show the save "form"
		    
			frmP = FrmGetActiveForm();
//	    FrmEraseForm(frmP);
			FrmPopupForm(SavedataForm);
//			FrmDrawForm(frmP);
			
			// we're back from the save form, so show the logger controls
			
		    show_logger_controls();
		    return true; */
		case MainPauseloggingButton:
			
			// Pause button on main panel
			
		    
			if (logger_status != 0)
	    {
	      logger_status = 0;
    		return true;
	    }
		    
		    // set the logger to "pause mode"
		    
		    logger_status = 1;
		    
		    // notify the user we're paused
		    
		    PnsSetTitle("Logger paused");
		    return true;
		case MainStoploggingButton:
		
			// stop button on the main panel
			
			handled = true;
			
			// are we logging?
			
			if (logger_status == 2)
		    {
		      err_rtn("Logger not running");
	    		return true;
		    }
		    
		    // set the stop flag
		    
		    logger_status = 2;
		    return true;
		case MainStartloggingButton:       // start up
      
  			// start button on the main panel
  			
        if (FrmGetActiveFormID() != MainForm)
          return true;

  			handled = true;
			
			// have chosen an interface?
			
		    if (use_drb + use_t16 == 0)
		    {
        err_rtn("No interface selected");
				return true;
		    }
		    
		    // have we selected items to log
		    
			if (!loggable_items)
			{
			    err_rtn("No items selected for logging");
	    		return true;
			}
			
			// are we already logging?
			
			if (logger_status != 2)
			{
			  prefs.peak_hold = !prefs.peak_hold;
			  return true;
			}
			
			// if we arre paused, set us back to "run"
			
			if (logger_status == 1)
			{
			  logger_status = 0;
			  return true;
			}
			
			// is there unsaved data from a previous logging session?
			
		    if (data_logged)
		      return true;
/*			    if (FrmAlert (DiscardAlert) == DiscardCancel)
			    {
			
					// display the save data panel
					
				    data_logged = false;
				    hide_logger_controls();
					frmP = FrmGetActiveForm();
//				  FrmEraseForm(frmP);
          save_mode = true;
					FrmPopupForm(SavedataForm);
//					FrmDrawForm(frmP);
					show_logger_controls();
				    return true;
			    } */
			 
			// set the run flag
			    
			logger_status = 0;
			
			// call the logger
			
			if (!registered)
			  err_rtn("Please register!");
			
			frmP = FrmGetActiveForm();
			show_logger_controls();
			data_logger();
			hide_logger_controls();
			
			// logging is done, clear the graphs
			
		  FrmEraseForm(frmP);
			FrmDrawForm(frmP);
			return true;
		case chooseinterfaceDrbinterfaceCheckbox:
//		err_rtn("2");
		
			// check the drb interface box
			
			// find the box that is checked, and turn off the others
			
			if (CtlGetValue(GetObjectPtr(chooseinterfaceDrbinterfaceCheckbox)) == 0)
				CtlSetValue(GetObjectPtr(chooseinterfaceT16interfaceCheckbox),1);
			else
			{
				CtlSetValue(GetObjectPtr(chooseinterfaceT16interfaceCheckbox),0);
				CtlSetValue(GetObjectPtr(chooseinterfaceFastlogmodeCheckbox),0);
			}
				
			// set the drb use flag
					
			use_drb = CtlGetValue(GetObjectPtr(chooseinterfaceDrbinterfaceCheckbox));
			
			// set the t16 use flag
			
			use_t16 = CtlGetValue(GetObjectPtr(chooseinterfaceT16interfaceCheckbox));
			handled = true;
			break;
			
		case chooseinterfaceT16interfaceCheckbox:
//		  err_rtn("1");
			// check the t16 interface box
			
			// find the box that is checked, and turn off the others
			
			if (CtlGetValue(GetObjectPtr(chooseinterfaceT16interfaceCheckbox)) == 0)
			{
				CtlSetValue(GetObjectPtr(chooseinterfaceDrbinterfaceCheckbox),1);
				CtlSetValue(GetObjectPtr(chooseinterfaceFastlogmodeCheckbox),0);
			}
			else
				CtlSetValue(GetObjectPtr(chooseinterfaceDrbinterfaceCheckbox),0);
			
			// set the use drb flag
			
			use_drb = CtlGetValue(GetObjectPtr(chooseinterfaceDrbinterfaceCheckbox));

			// set the t16 use flag

			use_t16 = CtlGetValue(GetObjectPtr(chooseinterfaceT16interfaceCheckbox));
			handled = true;
			break;
		case chooseinterfaceFastlogmodeCheckbox:
		  if (CtlGetValue(GetObjectPtr(chooseinterfaceFastlogmodeCheckbox)) == 1)
		  {
		    pre_fetch_default = true;
//		    err_rtn("Warning, this MAY cause lockups or other problems on SOME PDA's!");
		  }
		  else
		    pre_fetch_default = false;
		  handled = true;
		  break;
		case chooseinterfaceTestmodeCheckbox:
		
			// are we in "test mode"?
		
			if (CtlGetValue(GetObjectPtr(chooseinterfaceTestmodeCheckbox)) == 0)
				test_mode = false;
			else
				test_mode = true;
			
			if (!registered)
			  test_mode = true;
			handled = true;
			break;
		case chooseinterfaceAutosaveCheckbox:
		
			// are we in "time scale mode"?
			
			prefs.autosave = CtlGetValue(GetObjectPtr(chooseinterfaceAutosaveCheckbox));
			handled = true;
			break;
		case chooseinterfaceSinglechartCheckbox:
		
			// are we in "time scale mode"?
			
			prefs.single_chart = CtlGetValue(GetObjectPtr(chooseinterfaceSinglechartCheckbox));
			handled = true;
			break;
		case chooseinterfaceAutostartsupportCheckbox:
		
			// are we in "time scale mode"?
			
			prefs.auto_start = CtlGetValue(GetObjectPtr(chooseinterfaceAutostartsupportCheckbox));
			handled = true;
			break;
		case chooseinterfaceColorsupportCheckbox:
		
			// are we in "time scale mode"?
			
			prefs.color_support = CtlGetValue(GetObjectPtr(chooseinterfaceColorsupportCheckbox));
			handled = true;
			break;
		case chooseinterfaceMonitorCheckbox:
		
			// are we in "time scale mode"?
			
			prefs.monitor_mode = CtlGetValue(GetObjectPtr(chooseinterfaceMonitorCheckbox));
			handled = true;
			break;
		case chooseinterfaceCharttimescaleCheckbox:
		
			// are we in "time scale mode"?
			
			prefs.chart_by_time = CtlGetValue(GetObjectPtr(chooseinterfaceCharttimescaleCheckbox));
			handled = true;
			break;
		case chooseinterfaceDigitalmodeCheckbox:
		
			// are we in "digital mode"?
			
			prefs.digital_mode = CtlGetValue(GetObjectPtr(chooseinterfaceDigitalmodeCheckbox));
			if (prefs.digital_mode == 1)
			  CtlSetValue(GetObjectPtr(chooseinterfaceChartframesCheckbox),0);
			handled = true;
			break;
		case chooseinterfaceChartframesCheckbox:
		
			// are we in "chart frame mode"?
			
			prefs.chart_frames = CtlGetValue(GetObjectPtr(chooseinterfaceChartframesCheckbox));
//		  prefs.chart_height = 21;
//		  prefs.chart_width = 120;
			handled = true;
			break;
		case chooseinterfaceConfigureloggerdoneButton:
			
			// done button on choose interface form

			// save the settings for preferences up date
			
			prefs.use_t16_chk = use_t16;
			prefs.use_drb_chk = use_drb;
			prefs.test_mode_chk = test_mode;
			prefs.chart_frames = CtlGetValue(GetObjectPtr(chooseinterfaceChartframesCheckbox));
			prefs.use_fast_mode = 1; //CtlGetValue(GetObjectPtr(chooseinterfaceFastlogmodeCheckbox));
			FrmReturnToForm(0);
//    	if (use_t16 == 1)
//    	{
//    		LstSetSelection(GetObjectPtr(MainT16choiceoneList),0);
//    		LstSetSelection(GetObjectPtr(MainT16choicetwoList),0);
//    		LstSetSelection(GetObjectPtr(MainT16choicethreeList),0);
//      }			
//    	if (use_drb == 1)
//    	{
//    		LstSetSelection(GetObjectPtr(MainChartonechoiceList),0);
 //   		LstSetSelection(GetObjectPtr(MainCharttwochoiceList),0);
 //   		LstSetSelection(GetObjectPtr(MainChartthreechoiceList),0);
//			}			
//    	FrmHideObject(frmP, FrmGetObjectIndex(frmP, MainChart1valueLabel));
 //   	FrmHideObject(frmP, FrmGetObjectIndex(frmP, MainChart2valueLabel));
  //  	FrmHideObject(frmP, FrmGetObjectIndex(frmP, MainChart3valueLabel));
      loggable_items = false;
			if (use_drb == 1)
				FrmPopupForm(ConfiguredrbForm);
			else
				FrmPopupForm(Configuret16Form);
				
			handled = true;
			break;
		case MainOptionsTroubleCodes:
    	if (FrmGetActiveFormID() != MainForm)
    	  return true;
	
			if (logger_status != 2 || play_mode) // || use_drb == 1)
				return true;

      if (!registered)
      {
        err_rtn("Registered feature!");
        return true;
      }

      if (use_t16 == 1)
      {
    		TntBaud(0,19200);		// 19200
    		TntParms(0,0,0,8);		// one start bit, no parity, 8 data bits
    		TntReset(0,100,100);	// open the port
      }
      else
      {
    		TntBaud(0,1920);		// 19200
    		TntParms(0,0,0,8);		// one start bit, no parity, 8 data bits
    		TntReset(0,100,100);	// open the port
      }  
			MainfrmP = FrmGetActiveForm();
//	    FrmEraseForm(MainfrmP);
			FrmPopupForm(DtcformForm);
//    	FrmDrawForm(MainfrmP);
      show_logger_controls();
			handled = true;
			break;
		case MainOptionsHowtoworkthelogger:
		  if (FrmGetActiveFormID() == MemoForm ||
		      FrmGetActiveFormID() == TimeslipForm ||
		      FrmGetActiveFormID() == CarsetupForm)
		  {
		    FrmPopupForm(HowtomemoForm);
		    return true;
		  }
		  if (FrmGetActiveFormID() == DrbformForm)
		  {
		    FrmPopupForm(HowtodrbForm);
		    return true;
		  }
		  if (save_mode)
		  {
		    FrmPopupForm(HowtosaveForm);
		    return true;
		  }
		  if (FrmGetActiveFormID() == PlayformForm)
		  {
		    FrmPopupForm(HowtoplayForm);
		    return true;
		  }
		  if (FrmGetActiveFormID() == DtcformForm)
		  {
		    FrmPopupForm(HowtodtcForm);
		    return true;
		  }
		  if (FrmGetActiveFormID() == ConfiguredrbForm ||
		      FrmGetActiveFormID() == ChooseinterfaceForm ||
		      FrmGetActiveFormID() == Configuret16Form)
		  {
		    FrmPopupForm(HowtoconfigureForm);
		    return true;
		  }
		  if (FrmGetActiveFormID() == ChooseformForm)
		  {
		    FrmPopupForm(HowtochartForm);
		    return true;
		  }
		  if (play_mode)
		  {
		    FrmPopupForm(HowtochooseForm);
		    return true;
		  }
			if (logger_status != 2 || play_mode)
				return true;
 			FrmPopupForm(HowtoForm);
			handled = true;
			break;
			
		case MainOptionsAboutPalmnStein:
		
			// about menu item, suppress if logging is not stopped
			
			if (logger_status != 2 || play_mode)
				return true;
 			FrmPopupForm(AboutformForm);
			handled = true;
			break;
			
		case MainOptionsSelectInterface:
		
		  if (FrmGetActiveFormID() != MainForm)
		    return true;	
		    
			// select interface menu item, suppress if logging is not stopped
			
			if (logger_status != 2)
			  return true;
			  
			// hide the controls
			  
			hide_logger_controls();
			
			// show the form 
			
			FrmPopupForm(ChooseinterfaceForm);
			handled = true;
			
			// back from the form, so display the logger controls
			
//			show_logger_controls();
			break;
			
		case MainOptionsConfigureLogger:
		
			// configure logger menu item
			
		  if (FrmGetActiveFormID() != MainForm)
		    return true;	
		
			
			// suppress if logging is not stopped
				
			if (logger_status != 2)
				return true;
				
			// error if no interface was chosen
			
		    if (use_drb + use_t16 == 0)
		    {
		      err_rtn("No interface selected");
	    		return true;
		    }
		    
		    // hide the logger controls
		    
			hide_logger_controls();
			
			// depending on the interface, pop up the desired item selection form
			
			if (use_drb == 1)
				FrmPopupForm(ConfiguredrbForm);
			else
				FrmPopupForm(Configuret16Form);
				
			//back from the form, so show the controls
			
			show_logger_controls();
			handled = true;
			break;
		case MainOptionsPlayBack:	
		
		  if (FrmGetActiveFormID() != MainForm)
		    return true;
		
			// play back menu item
			
			// suppress if logging is not stopped
			
			if (logger_status != 2 || play_mode)
			  return true;
			  
			// hide the logger controls
			
			hide_logger_controls();  
			
			// build an empty file list
			
			for (lp=0;lp<max_logfiles;lp++)
				file_list[lp] = empty_list;
				
			// read the directory and build the list to display
					
			lp1 = 0;
			for (lp=0;lp<max_logfiles;lp++)
			
				// if the list entry is not blank, put it on the screen
				
				if (log_directory[lp].log_name[0] != 0)
				{
					file_list[lp1] = log_directory[lp].log_name;
					++ lp1;
				}
				
			// point the list control to the new list
			
			PnsSetListChoices(MainLogfilelistList, &file_list[0], max_logfiles, lp1 - 1);
			LstSetSelection(GetObjectPtr(MainLogfilelistList),lp1 - 1);

			// show the playback controls
			
//			frmP = FrmGetActiveForm();
//			FrmShowObject(frmP, FrmGetObjectIndex(frmP, MainLogfilelistList));
//			FrmShowObject(frmP, FrmGetObjectIndex(frmP, MainPlayfileButton));
//			FrmShowObject(frmP, FrmGetObjectIndex(frmP, MainDeletefileButton));
//			FrmShowObject(frmP, FrmGetObjectIndex(frmP, MainTransferfileButton));
//			FrmShowObject(frmP, FrmGetObjectIndex(frmP, MainDonefileButton));
			play_mode = true;
			handled = true;
			break;
		case MainPlayfileButton:
		
			// play button
			
			if (log_directory[LstGetSelection(GetObjectPtr(MainLogfilelistList))].log_name[0] == 0)
			{
				return true;
			}
			
			play_entry = LstGetSelection(GetObjectPtr(MainLogfilelistList));

							
			// show the play screen
			
			play_mode = true;
	 		FrmPopupForm(PlayformForm);
	    return true;
		case MainDonefileButton:
		
		  if (FrmGetActiveFormID() != MainForm)
		    return true;	
		
			// done button of ply form
			
			// hide the player controls
			
			frmP = FrmGetActiveForm();
			FrmHideObject(frmP, FrmGetObjectIndex(frmP, MainLogfilelistList));
//			FrmHideObject(frmP, FrmGetObjectIndex(frmP, MainPlayfileButton));
//			FrmHideObject(frmP, FrmGetObjectIndex(frmP, MainDeletefileButton));
//			FrmHideObject(frmP, FrmGetObjectIndex(frmP, MainTransferfileButton));
//			FrmHideObject(frmP, FrmGetObjectIndex(frmP, MainDonefileButton));
			
			// show logger controls
			
			show_logger_controls();
			logger_status = 2;
			play_mode = false;
			handled = true;
			break;
		case MainDeletefileButton:
	    if (FrmAlert (DiscardAlert) != DiscardOk)
  		  return true;
			frmP = FrmGetActiveForm();

		    // get list pointer
		    
	    empty_list[0] = LstGetSelection(GetObjectPtr(MainLogfilelistList));

		    // delete entry
		    
	    update_directory(2,empty_list);
		    
		    // hide the control

			FrmHideObject(frmP, FrmGetObjectIndex(frmP, MainLogfilelistList));

		    // chg the pointer

			StrCopy(empty_list," ");
			for (lp=0;lp<max_logfiles;lp++)
				file_list[lp] = empty_list;
			lp1 = 0;
			for (lp=0;lp<max_logfiles;lp++)
				if (log_directory[lp].log_name[0] != 0)
				{
					file_list[lp1] = log_directory[lp].log_name;
					++ lp1;
				}
			PnsSetListChoices(MainLogfilelistList, &file_list[0], max_logfiles, lp1 - 1);
//			LstSetSelection(GetObjectPtr(MainLogfilelistList),lp1 - 1);

		    // show the control

//			FrmShowObject(frmP, FrmGetObjectIndex(frmP, MainLogfilelistList));

			handled = true;
			break;
		case MainCharttimescaleSliderControl:
		  
		  // get the control value
      		  
//      prefs.slider_value = CtlGetValue(GetObjectPtr(MainCharttimescaleSliderControl));
//      StrPrintF(buf,"%d",slider_value);
//      err_rtn(buf);
//      if (prefs.slider_value > 30)
//        prefs.slider_value = prefs.slider_value / 256;
//      ++ prefs.slider_value;
		  handled = true;
		  break;
		}
	return handled;
}

static Boolean loggerFormDoCommand(Word command)
{
	Boolean handled = false;
	FormPtr frmP;
	static char lb[20];
//	int x;

	switch (command)
		{
		case configuredrbClearcalsButton:
		  prefs.wideband_cal = 0.0F;
		  prefs.map_cal = 0.0F;
		  err_rtn("Calibrations have been cleared");
		  return true;
    case configuredrbRawmdpCheckbox:  
      CtlSetValue(GetObjectPtr(configuredrbWidebandCheckbox), !CtlGetValue(GetObjectPtr(configuredrbRawmdpCheckbox)));    	
      CtlSetValue(GetObjectPtr(configuredrbWidebandloutCheckbox), !CtlGetValue(GetObjectPtr(configuredrbRawmdpCheckbox)));    	
      return true;
	  case configuredrbWidebandCheckbox:
      CtlSetValue(GetObjectPtr(configuredrbRawmdpCheckbox), !CtlGetValue(GetObjectPtr(configuredrbWidebandCheckbox)));
      CtlSetValue(GetObjectPtr(configuredrbWidebandloutCheckbox), !CtlGetValue(GetObjectPtr(configuredrbWidebandCheckbox)));    	
	    return true;
	  case configuredrbWidebandloutCheckbox:
      CtlSetValue(GetObjectPtr(configuredrbRawmdpCheckbox), !CtlGetValue(GetObjectPtr(configuredrbWidebandloutCheckbox)));
      CtlSetValue(GetObjectPtr(configuredrbWidebandCheckbox), !CtlGetValue(GetObjectPtr(configuredrbWidebandloutCheckbox)));    	
	    return true;
		case configuredrbDrbokButton:
		case configuret16T16okButton:
			// clear the list of loggable elements, and rebuild it
			
      chart_status[0] = chart_status[1] = chart_status[2] = 0;
	    init_log_list();
		    
		    // hide the chart control lists
		    
			FrmReturnToForm(0);
			frmP = FrmGetActiveForm();
			FrmHideObject(frmP, FrmGetObjectIndex(frmP, MainChartonechoiceList ));
			FrmHideObject(frmP, FrmGetObjectIndex(frmP, MainCharttwochoiceList ));
			FrmHideObject(frmP, FrmGetObjectIndex(frmP, MainT16choiceoneList ));
			FrmHideObject(frmP, FrmGetObjectIndex(frmP, MainT16choicetwoList ));
			FrmHideObject(frmP, FrmGetObjectIndex(frmP, MainT16choicethreeList ));
			FrmHideObject(frmP, FrmGetObjectIndex(frmP, MainChartthreechoiceList ));

     	FrmHideObject(frmP, FrmGetObjectIndex(frmP, MainChart1nameLabel));
     	FrmHideObject(frmP, FrmGetObjectIndex(frmP, MainChart1nameLabel + 1));
     	FrmHideObject(frmP, FrmGetObjectIndex(frmP, MainChart1nameLabel + 2));
    	FrmHideObject(frmP, FrmGetObjectIndex(frmP, MainChart1valueLabel));
    	FrmHideObject(frmP, FrmGetObjectIndex(frmP, MainChart2valueLabel));
    	FrmHideObject(frmP, FrmGetObjectIndex(frmP, MainChart3valueLabel));

			// show the list set based on the number of parms being logged, and the interface type
			
			set_log_list(0);
			show_logger_controls();
			handled = true;
			break;
		}
	return handled;
}

static Boolean saveFormDoCommand(Word command)
{
	Boolean handled = false;

	switch (command)
		{
		
		case savedataSavedataButton:
		
			// save data, so get the name and put it in the directory
			
			if (prefs.autosave == 1)
			{
			  data_logged = false;
				update_directory(1, "Auto Save");
				FrmReturnToForm(0);
      }
			else
  		if (FldGetTextPtr (GetObjectPtr(savedataFilenameField)) != NULL)
  		{
  		  data_logged = false;
  			update_directory(1, FldGetTextPtr (GetObjectPtr(savedataFilenameField)));
  			FrmReturnToForm(0);
  		}
  		else
  		{
  		  err_rtn("Invalid or missing log file name");
  		  break;
  		}
			save_mode = false;
			handled = true;
			if (prefs.autosave == 1 && prefs.auto_start == 0)
			{
    	  MainFormDoCommand(MainOptionsPlayBack);
    	  MainFormDoCommand(MainPlayfileButton);
			}
			break;
			
		case savedataDiscarddataButton:
		
			// discard the data, pop up  confirmation
			
//		    if (FrmAlert (DiscardAlert) != DiscardCancel)
		    {
			    data_logged = false;
  				FrmReturnToForm(0);
	  			FileDelete(0,lf_name);
	  			StrCat(lf_name,"m");
	  			FileDelete(0,lf_name);
		    }
			handled = true;
			save_mode = false;
			break;
		}
	return handled;
}

static Boolean ChooseformFormDoCommand(Word command)
{
	Boolean handled = false;
//	int x;
	static int list_size;
	static int list_entry;
	FormPtr frmP;

  frmP = FrmGetActiveForm();
	switch (command)
		{
	
	  case chooseformChart1itemField:
	  case chooseformChart2itemField:
	  case chooseformChart3itemField:
   		FrmHideObject(frmP, FrmGetObjectIndex(frmP, chooseformChart1markLabel + g_err ));
      g_err = command - chooseformChart1itemField;
   		FrmShowObject(frmP, FrmGetObjectIndex(frmP, chooseformChart1markLabel + g_err ));
		case 6: // take the selection
		  
		  list_entry = LstGetSelection(GetObjectPtr(chooseformItemlistList));
		  if (!play_mode)
        PnsSetTextPtr(GetObjectPtr(chooseformChart1itemField + g_err),l_list[list_entry]);//(char *)dtc_desc);
      else
        PnsSetTextPtr(GetObjectPtr(chooseformChart1itemField + g_err),t_list[list_entry]);//(char *)dtc_desc);
//      FldRecalculateField (GetObjectPtr(chooseformChart1itemField + g_err),true);
//      FldDrawField(GetObjectPtr(chooseformChart1itemField + g_err));
      if (!play_mode)
        prefs.t16_charts[g_err] = chart_status[g_err] = list_entry;
      else
        play_status[g_err] = list_entry;
      if (list_entry == 0)
      {
        for (list_entry=g_err;list_entry<3;list_entry++)
        {
    		  if (!play_mode)
            PnsSetTextPtr(GetObjectPtr(chooseformChart1itemField + list_entry),l_list[0]);//(char *)dtc_desc);
          else
            PnsSetTextPtr(GetObjectPtr(chooseformChart1itemField + list_entry),t_list[0]);//(char *)dtc_desc);
//          FldRecalculateField (GetObjectPtr(chooseformChart1itemField + list_entry),true);
//          FldDrawField(GetObjectPtr(chooseformChart1itemField + list_entry));
          if (!play_mode)
            prefs.t16_charts[list_entry] = chart_status[list_entry] = 0;
          else
            play_status[list_entry] = 0;
        }
        list_entry = 0;
      }
		  handled = true;
		  break;
		
		case 4: // scroll the target field
		case 5: 
		
   		FrmHideObject(frmP, FrmGetObjectIndex(frmP, chooseformChart1markLabel + g_err ));
      ++ g_err;
      if (g_err > 2)
        g_err = 0;
   		FrmShowObject(frmP, FrmGetObjectIndex(frmP, chooseformChart1markLabel + g_err ));
		  
		  handled = true;
		  break;
		
		case 2: // scroll the list
		case 3:
		  // get list size
		  
		  list_size = LstGetNumberOfItems(GetObjectPtr(chooseformItemlistList));
		  
		  // get the current entry
		  
		  list_entry = LstGetSelection(GetObjectPtr(chooseformItemlistList));
		  
		  if (list_entry > 0 && command == 2)
		    -- list_entry;
		  else
		  if (list_entry < list_size - 1 && command == 3)
		    ++ list_entry;

   		FrmHideObject(frmP, FrmGetObjectIndex(frmP, chooseformItemlistList ));
      LstSetSelection(GetObjectPtr(chooseformItemlistList),list_entry);		  
      LstMakeItemVisible(GetObjectPtr(chooseformItemlistList),list_entry);		  
   		FrmShowObject(frmP, FrmGetObjectIndex(frmP, chooseformItemlistList ));
		  handled = true;
		  break;
		  
		case 1:
		
			handled = true;
      FrmReturnToForm(0);
   		if (!play_mode)
   		{
   		  hide_logger_controls();
   		  
   		  // set the chart size/location
   		  
   		  show_logger_controls();
   		}
   		else
   		{
   	    show_player_controls();
   		}
			break;
		default:
		  break;
		}
	return handled;
}

static Boolean dtcFormDoCommand(Word command)
{
	Boolean handled = true;
	static char buf[20];
	FormPtr frmP;

  frmP = FrmGetActiveForm();
	switch (command)
		{
		case dtcformDtclistList:
		  if (dtc_count > 0 && use_t16 == 1)
		  {
		    StrPrintF(buf,"Searching");
        PnsSetTextPtr(GetObjectPtr(dtcformDtcdetailField),buf);
//        FldRecalculateField (GetObjectPtr(dtcformDtcdetailField),true);
//        FldDrawField(GetObjectPtr(dtcformDtcdetailField));
		    display_dtc(0);
		  }
		
		  return true;
		case dtcformShowdtcButton:
		  if (use_t16 == 1)
  		  dtc_count = get_dtcs();
  		else  
  		  dtc_count = get_drbdtcs();
		  if (dtc_count > 0 && use_t16 == 1)
		  {
        StrPrintF(buf,"Select a DTC to display it's definition");
        PnsSetTextPtr(GetObjectPtr(dtcformDtcdetailField),buf);
//        FldRecalculateField (GetObjectPtr(dtcformDtcdetailField),true);
//        FldDrawField(GetObjectPtr(dtcformDtcdetailField));
      }
		  return true;
		case dtcformDtcclearButton:
		  if (dtc_count > 0 && use_t16 == 1)
      {
  		  clear_dtc();
  		  dtc_count = get_dtcs();
  		}
		  return true;
		  
		case dtcformDtcdoneButton :
		
		  // close serial port
		
			// discard the data, pop up  confirmation
			
//			TntDone(0);
    case aboutformAboutdoneButton:
//			FrmReturnToForm(0);

      FrmReturnToForm(0);
      if (item_count == 0 && FrmGetActiveFormID() == MainForm)
      {
        MainFormDoCommand(MainOptionsSelectInterface);
      }

			handled = true;
			break;
		}
	return handled;
}

static Boolean drbFormDoCommand(Word command)
{
	Boolean handled = true;
	FormPtr frmP;
	Boolean stop_all = false;
//	int  x;

  frmP = FrmGetActiveForm();
	switch (command)
		{
	  case drbformDrbstartButton:
      TntRxClear();
      TntPuts(0,&command_on[LstGetSelection(GetObjectPtr(drbformItemlistList))],1);
      wait_for_bytes(0,1,5);
      return true;
    case drbformDrballButton:
      stop_all = true;
    case drbformDrbstopButton:
      if (!stop_all)
      {
        TntRxClear();
        TntPuts(0,&command_off[LstGetSelection(GetObjectPtr(drbformItemlistList))],1);
        wait_for_bytes(0,1,5);
      }
      else
      {
/*        for (x=0;x<11;x++)
          if (command_on[x] != 0x00)
          {
            TntRxClear();
            TntPuts(0,&command_off[x],1);
            wait_for_bytes(0,1,5);
          }*/
        TntRxClear();
        TntPuts(0,&command_off[0],1);
        wait_for_bytes(0,1,5);
        FrmReturnToForm(0);
      }
      return true;
		case drbformItemlistList:
		  return true;
		}
	return handled;
}

static Boolean playFormDoCommand(Word command)
{
	Boolean handled = false;
	int basec = prefs.chart_scale;
	int x;
	int x1;
	int lx[3];
	int ly[3];
  Int32    fs;
  Int32    tf;
  Err      er;
	RectangleType rp;
	
	switch (command)
		{
			             
		case playformRewindButton:  
		  if (prefs.digital_mode != 1)
		  {
  			erase_chart(1);         
  			erase_chart(2);         
  			erase_chart(3);         
  			draw_frames(play_list_size[0]);
      }
      plot_start_ticks = 0;
      
			current_frame = first_frame;
			time_points[chart_limit + 1] = 1;
			FileSeek(log_handle,current_frame,fileOriginBeginning);
			if (prefs.digital_mode == 1)
			  process_frame(log_type[0]);
			return true;                     
		case playformBackwardsButton:  
		  
		  if (play_run != 2)
		    return true;
		    
			time_points[chart_limit + 1] = -1;
 			x = log_type[0];
			x = x * play_list_size[0];
			x = x * (prefs.chart_width - 1);
			
    	current_frame = FileTell(log_handle,&fs,&er);
			if (current_frame - x > first_frame || prefs.digital_mode)
			{
			  // scroll the chart
			  
			  if (prefs.digital_mode)
			  {
			    // scroll back one record
			    
  		  	if (log_type[0] == 2)
  			  {
            current_frame -= 2 * (play_list_size[0] * 2);
          }
          else    
          {
            current_frame -= 2 * (play_list_size[0]);
          }

          // position the file to the "left most frame"
          
  			  FileSeek(log_handle,current_frame,fileOriginBeginning);
  			  process_frame(log_type[0]);
  			  return true;
			  }
			  
  			for (x=0;x<3;x++)
  			{
        	if (prefs.chart_frames)
         	{
        		rp.topLeft.x = 0;
        		rp.topLeft.y = prefs.chart_top[x] + 1;
        		rp.extent.x = prefs.chart_width; 
        		rp.extent.y = prefs.chart_height - 2;
        	}
        	else
         	{
        		rp.topLeft.x = 0;
        		rp.topLeft.y = prefs.chart_top[x];;
        		rp.extent.x = prefs.chart_width; 
        		rp.extent.y = prefs.chart_height;
        	}
        	if (x == 0 || prefs.single_chart != 1)
        	{
          	WinScrollRectangle(&rp,winRight,1,&rp);
           	WinEraseRectangle(&rp,0);
          }
        } 
        
        // scroll points array
      
        // calculate starting frame
      
		  	if (log_type[0] == 2)
			  {
          new_frame = current_frame - ((prefs.chart_width) * play_list_size[0] * 2);
          current_frame -= (play_list_size[0] * 2);
        }
        else    
        {
          new_frame = current_frame - ((prefs.chart_width) * play_list_size[0]);
          current_frame -= (play_list_size[0]);
        }

        // position the file to the "left most frame"
        
			  FileSeek(log_handle,new_frame,fileOriginBeginning);
			  
        // update time index
          
        // update last x & y points
          
			  for (x=0;x<3;x++)
			  {
  			  lasty[x] = lasty_points[x][lasty_points[x][prefs.chart_width + 1] - 1];
			  }

        for(x1=0;x1<3;x1++)
        {  
         	for (x=lasty_points[x1][chart_limit + 1] - 1;x>0;x--)
        	{
      	    lasty_points[x1][x] = lasty_points[x1][x - 1];
        	}
        	lasty_points[x1][0] = 0;
        }
        
        // Draw lines
        
        play_mode = false;
        for (x=0;x<3;x++)
        {
          lx[x] = lastx[x];
          lastx[x] = 0;
          ly[x] = lasty[x];
          lasty[x] = lasty_points[x][1];
        }
        
        tf = current_frame;
        no_chart_update = true;
        
        process_frame(log_type[0]);
        
        current_frame = tf;
        no_chart_update = false;
        
        play_mode = true;
        for (x=0;x<3;x++)
        {
          lastx[x] = lx[x];
          lasty[x] = ly[x];
        }
        
        // set current frame pointer
        
			  FileSeek(log_handle,current_frame,fileOriginBeginning);
			
      }
			return true;                     
		case playformStopButton: 
			play_run = 2;                 
			time_points[chart_limit + 1] = 1;
			return true;
		case playformPlayButton:  

		  if (play_run != 2)
		    return true;
		  
			time_points[chart_limit + 1] = 1;
			play_run = 0; 
			run_file();
//      KeySetMask(keysAllowedMask);
			return true;                     
		case playformForwardButton:   

		  if (play_run != 2)
		    return true;
		    
			time_points[chart_limit + 1] = 1;
			process_frame(log_type[0]);
			return true;
			                  
		case playformChartonechoiceList:

		  if (play_run != 2)
		    return true;
		    
			erase_chart(1);
			if (LstGetSelection(GetObjectPtr(playformChartonechoiceList)) != 0)
			{
				basec = prefs.chart_top[0];
				chart_visible[0] = true;
				if (prefs.chart_frames && prefs.digital_mode == 0)
				{
					WinDrawLine(0,basec,prefs.chart_width,basec);
//					WinDrawLine(0,basec,0,basec+prefs.chart_scale);
					WinDrawLine(0,basec+prefs.chart_scale,prefs.chart_width,basec+prefs.chart_scale);
//					WinDrawLine(prefs.chart_width,basec,prefs.chart_width,basec+prefs.chart_scale); 
				}
				chart_status[0] = 1;
			}
			return true;
		case playformCharttwochoiceList:
		  if (play_run != 2)
		    return true;
		    
			erase_chart(2);
			// draw frame 2
			
			if (LstGetSelection(GetObjectPtr(playformCharttwochoiceList)) != 0)
			{
				chart_visible[1] = true;
				basec = prefs.chart_top[1];
				if (prefs.chart_frames && prefs.digital_mode == 0)
				{
					WinDrawLine(0,basec,prefs.chart_width,basec);
//					WinDrawLine(0,basec,0,basec+prefs.chart_scale);
					WinDrawLine(0,basec+prefs.chart_scale,prefs.chart_width,basec+prefs.chart_scale);
//					WinDrawLine(prefs.chart_width,basec,prefs.chart_width,basec+prefs.chart_scale);
				}
				chart_status[1] = 1;
			}
			return true;
		case playformChartthreechoiceList:
		  if (play_run != 2)
		    return true;
		    
			erase_chart(3);
			// draw frame 3
			
			if (LstGetSelection(GetObjectPtr(playformChartthreechoiceList)) != 0)
			{
				chart_visible[2] = true;
				basec = prefs.chart_top[2];
				if (prefs.chart_frames && prefs.digital_mode == 0)
				{
					WinDrawLine(0,basec,prefs.chart_width,basec);
//					WinDrawLine(0,basec,0,basec+prefs.chart_scale);
					WinDrawLine(0,basec+prefs.chart_scale,prefs.chart_width,basec+prefs.chart_scale);
//					WinDrawLine(prefs.chart_width,basec,prefs.chart_width,basec+prefs.chart_scale);
				}
				chart_status[2] = 1;
			}
			return true;
			
		case playformPlayokButton:
		  if (play_run != 2)
		    return true;
		    
			if (play_run != 2)
				return true;
		
			// done playing, close the form 
			
			if (log_handle != 0)
				FileClose(log_handle);
//			chart_status[0] = chart_status[1] = chart_status[2] = 0;
			FrmReturnToForm(0);
			return true;
			
		default:
			handled = true;
			break;
		}
	return handled;
}

/***********************************************************************
 *
 * FUNCTION:    MainFormHandleEvent
 *
 * DESCRIPTION: This routine is the event handler for the 
 *           
   "MainForm" of this application.
 *
 * PARAMETERS:  eventP  - a pointer to an EventType structure
 *
 * RETURNED:    true if the event has handle and should not be passed
 *              to a higher level handler.
 *
 * REVISION HISTORY:
 *
 *
 ***********************************************************************/
static Boolean MainFormHandleEvent(EventPtr eventP)
{
    Boolean handled = false;
    FormPtr frmP;

	switch (eventP->eType) 
		{
		case penDownEvent:
		  if (logger_status != 2)
		  {
/*        ++lap_number;
        if (lap_number == 100)
          lap_number = 0;
        lap_start = TimGetTicks(); */
        return true;
		  }
      return false;
		case lstSelectEvent:
			return MainFormDoCommand(eventP->data.lstSelect.listID);
		case ctlSelectEvent:
			return MainFormDoCommand(eventP->data.ctlSelect.controlID);
		case menuEvent:
			return MainFormDoCommand(eventP->data.menu.itemID);
//    case frmCloseEvent:
//      return true;
		case frmOpenEvent:
		  if (FrmGetActiveFormID() == MemoForm)
		  {
  			frmP = FrmGetActiveForm();
  			show_memo();
  			FrmDrawForm ( frmP);
		    return true;
		  }
		  
			frmP = FrmGetActiveForm();
			MainFormInit( frmP);
			FrmDrawForm ( frmP);
			if (logger_controls)
			{
//  			init_log_list();
				show_logger_controls();
				logger_controls = false;
			}
			if (FrmGetActiveFormID() == MainForm)
			{
        form_title = FrmGetTitle(frmP);
      }
			handled = true;
			break;
		default:
			break;
		
		}
	
	return handled;
}

static Boolean ChooseformFormHandleEvent(EventPtr eventP)
{
    Boolean handled = false;
    FormPtr frmP;
    int     xp;


	switch (eventP->eType) 
		{
		case ctlSelectEvent:
		case lstSelectEvent:
		case fldEnterEvent:
			return ChooseformFormDoCommand(eventP->data.ctlSelect.controlID);
		case menuEvent:
			return MainFormDoCommand(eventP->data.menu.itemID);

		case frmOpenEvent:
//		  chart_status[0] = chart_status[1] = chart_status[2] = 0;
			frmP = FrmGetActiveForm();
			FrmDrawForm ( frmP);
  		FrmHideObject(frmP, FrmGetObjectIndex(frmP, chooseformItemlistList ));
			LstSetSelection(GetObjectPtr(chooseformItemlistList),0);
			if (play_mode)
			  xp = play_list_size[0];
			else
  		  xp = item_count;
			if (xp < 3)
			  LstSetHeight(GetObjectPtr(chooseformItemlistList),xp);
			else
			  LstSetHeight(GetObjectPtr(chooseformItemlistList),3);
			if (!play_mode)
      	PnsSetListChoices(chooseformItemlistList, &l_list[0], xp, -1);
      else
      	PnsSetListChoices(chooseformItemlistList, &t_list[0], xp, -1);
//   		FrmShowObject(frmP, FrmGetObjectIndex(frmP, chooseformItemlistList ));
   		if (xp > 1)
   		{
   		  for (g_err=0;g_err<3;g_err++)
   		  {
    		  if (!play_mode)
    		  {
            PnsSetTextPtr(GetObjectPtr(chooseformChart1itemField + g_err),l_list[chart_status[g_err]]);//(char *)dtc_desc);
          }
          else
          {
            PnsSetTextPtr(GetObjectPtr(chooseformChart1itemField + g_err),t_list[play_status[g_err]]);//(char *)dtc_desc);
          }
   		  
//          FldRecalculateField (GetObjectPtr(chooseformChart1itemField + g_err),true);
//          FldDrawField(GetObjectPtr(chooseformChart1itemField + g_err));
   		  }
   		}
   		else
   		if ((play_mode && play_list_size[0] == 0) ||
   		    (!play_mode && item_count == 0))
   		{
   		
   		  // No fields selected, seed with none
   		  
   		  for (g_err=0;g_err<3;g_err++)
   		  {
    		  if (!play_mode)
    		  {
            PnsSetTextPtr(GetObjectPtr(chooseformChart1itemField + g_err),field_string[15]);//(char *)dtc_desc);
          }
          else
          {
            PnsSetTextPtr(GetObjectPtr(chooseformChart1itemField + g_err),field_string[15]);//(char *)dtc_desc);
          }
   		  
//          FldRecalculateField (GetObjectPtr(chooseformChart1itemField + g_err),true);
//          FldDrawField(GetObjectPtr(chooseformChart1itemField + g_err));
        }
   		}
   		
   		g_err = 0;
			handled = true;
			break;

		default:
			break;
		
		}
	
	return handled;
}

static Boolean chooseloggerFormHandleEvent(EventPtr eventP)
{
    Boolean handled = false;
    FormPtr frmP;


	switch (eventP->eType) 
		{
		case ctlSelectEvent:
			return loggerFormDoCommand(eventP->data.ctlSelect.controlID);
		case menuEvent:
			return MainFormDoCommand(eventP->data.menu.itemID);

		case frmOpenEvent:
			frmP = FrmGetActiveForm();
			FrmDrawForm ( frmP);
			if (use_t16 == 1)
			{
				CtlSetValue(GetObjectPtr(configuret16Logt16rpmsCheckbox),prefs.t16_items[0]);
				CtlSetValue(GetObjectPtr(configuret16Logt16o2vCheckbox),prefs.t16_items[1]);  
				CtlSetValue(GetObjectPtr(configuret16Logt16timingCheckbox),prefs.t16_items[2]);  
				CtlSetValue(GetObjectPtr(configuret16Logt16tpsCheckbox),prefs.t16_items[3]);  
				CtlSetValue(GetObjectPtr(configuret16Logt16airflowCheckbox),prefs.t16_items[4]);  
				CtlSetValue(GetObjectPtr(configuret16Logt16shorttrimCheckbox),prefs.t16_items[5]);  
				CtlSetValue(GetObjectPtr(configuret16Logt16longtrimCheckbox),prefs.t16_items[6]);  
				CtlSetValue(GetObjectPtr(configuret16Logt16airtempCheckbox),prefs.t16_items[7]);  
				CtlSetValue(GetObjectPtr(configuret16Logt16watertempCheckbox),prefs.t16_items[8]);  
        CtlSetValue(GetObjectPtr(configuret16T16shorttrim2Checkbox),prefs.t16_items[9]);  
        CtlSetValue(GetObjectPtr(configuret16T16longtrim2Checkbox),prefs.t16_items[10]);  
      	CtlSetValue(GetObjectPtr(configuret16T16loadCheckbox),prefs.t16_items[11]);  
      	CtlSetValue(GetObjectPtr(configuret16T16mapCheckbox),prefs.t16_items[12]);  
      	CtlSetValue(GetObjectPtr(configuret16T16mphCheckbox),prefs.t16_items[13]);  
      	CtlSetValue(GetObjectPtr(configuret16T16o2v2Checkbox),prefs.t16_items[14]);  
			}
			if (use_drb == 1)
			{
				CtlSetValue(GetObjectPtr(configuredrbLogdrbrpmsCheckbox),prefs.drb_items[0]);
				CtlSetValue(GetObjectPtr(configuredrbLogdrbo2vCheckbox),prefs.drb_items[1]);  
				CtlSetValue(GetObjectPtr(configuredrbLogdrbtimingCheckbox),prefs.drb_items[2]);  
				CtlSetValue(GetObjectPtr(configuredrbLogdrbtpsCheckbox),prefs.drb_items[3]);  
				CtlSetValue(GetObjectPtr(configuredrbLogdrbairflowCheckbox),prefs.drb_items[4]);  
				CtlSetValue(GetObjectPtr(configuredrbLogdrblowtrimCheckbox),prefs.drb_items[5]);  
				CtlSetValue(GetObjectPtr(configuredrbLogdrbmedtrimCheckbox),prefs.drb_items[6]);  
				CtlSetValue(GetObjectPtr(configuredrbLogdrbknockCheckbox),prefs.drb_items[7]);  
				CtlSetValue(GetObjectPtr(configuredrbLogdrbpulsewidthCheckbox),prefs.drb_items[8]);  
				CtlSetValue(GetObjectPtr(configuredrbLogdrbhightrimCheckbox),prefs.drb_items[9]);  
				CtlSetValue(GetObjectPtr(configuredrbLogdrbo2trimCheckbox),prefs.drb_items[15]);  
	      CtlSetValue(GetObjectPtr(configuredrbUnnamed1213Checkbox),prefs.drb_items[17]);  
	      CtlSetValue(GetObjectPtr(configuredrbRawmdpCheckbox),prefs.drb_items[18]);  
	      CtlSetValue(GetObjectPtr(configuredrbWidebandCheckbox),prefs.drb_items[19]);  
			}
			handled = true;
			break;

		default:
			break;
		
		}
	
	return handled;
}

static Boolean dtcFormHandleEvent(EventPtr eventP)
{
    Boolean handled = false;
    FormPtr frmP;


	switch (eventP->eType) 
		{
		case lstSelectEvent:
			return dtcFormDoCommand(eventP->data.lstSelect.listID);
		case ctlSelectEvent:
			return dtcFormDoCommand(eventP->data.ctlSelect.controlID);
		case menuEvent:
			return MainFormDoCommand(eventP->data.menu.itemID);

		case frmOpenEvent:
			frmP = FrmGetActiveForm();
			FrmDrawForm ( frmP);
			handled = true;
			break;

		default:
			break;
		
		}
	
	return handled;
}

static Boolean savedataFormHandleEvent(EventPtr eventP)
{
    Boolean handled = false;
    FormPtr frmP;
    static char sf_name[100];

	switch (eventP->eType) 
		{
		case ctlSelectEvent:
			return saveFormDoCommand(eventP->data.ctlSelect.controlID);
		case menuEvent:
			return MainFormDoCommand(eventP->data.menu.itemID);

		case frmOpenEvent:
			frmP = FrmGetActiveForm();
			FrmDrawForm ( frmP);
      FrmSetFocus(frmP,FrmGetObjectIndex(frmP, savedataFilenameField));
      if (prefs.autosave == 1)
      {
        StrPrintF(dtc_detail,"Auto Save");
     	  saveFormDoCommand(savedataSavedataButton);
      }
			handled = true;
			break;

		default:
			break;
		
		}
	
	return handled;
}

static Boolean timeslipFormHandleEvent(EventPtr eventP)
{
    Boolean handled = false;
    FormPtr frmP;

	switch (eventP->eType) 
		{
		case ctlSelectEvent:
			return saveFormDoCommand(eventP->data.ctlSelect.controlID);
		case menuEvent:
			return MainFormDoCommand(eventP->data.menu.itemID);

		case frmOpenEvent:
			frmP = FrmGetActiveForm();
			FrmDrawForm ( frmP);
			show_timeslip();
      FrmSetFocus(frmP,FrmGetObjectIndex(frmP, timeslipDateField));
      timeslip_loaded = true;
			handled = true;
			break;

		default:
			break;
		
		}
	
	return handled;
}

static Boolean carsetupFormHandleEvent(EventPtr eventP)
{
    Boolean handled = false;
    FormPtr frmP;

	switch (eventP->eType) 
		{
		case ctlSelectEvent:
			return saveFormDoCommand(eventP->data.ctlSelect.controlID);
		case menuEvent:
			return MainFormDoCommand(eventP->data.menu.itemID);

		case frmOpenEvent:
			frmP = FrmGetActiveForm();
			carsetup_loaded = true;
			FrmDrawForm ( frmP);
			show_carsetup();
      FrmSetFocus(frmP,FrmGetObjectIndex(frmP, carsetupTiretypeField));
			handled = true;
			break;

		default:
			break;
		
		}
	
	return handled;
}

static Boolean drbformFormHandleEvent(EventPtr eventP)
{
    Boolean handled = false;
    FormPtr frmP;
    static char sf_name[100];

	switch (eventP->eType) 
		{
		case lstSelectEvent:
			return drbFormDoCommand(eventP->data.lstSelect.listID);
		case ctlSelectEvent:
			return drbFormDoCommand(eventP->data.ctlSelect.controlID);
		case menuEvent:
			return MainFormDoCommand(eventP->data.menu.itemID);
		case frmOpenEvent:
			frmP = FrmGetActiveForm();
			FrmDrawForm ( frmP);
  		TntBaud(0,1920);		// 1920 baud
  		TntParms(0,0,0,8);		// no parity, one stop bit, 8 data bits
  		TntReset(0,100,100);	// open the port
			return true;
		default:
			break;
		
		}
	
	return handled;
}

static Boolean chooseinterfaceFormHandleEvent(EventPtr eventP)
{
    Boolean handled = false;
    FormPtr frmP;


	switch (eventP->eType) 
		{
		case ctlSelectEvent:
		case menuEvent:
			return MainFormDoCommand(eventP->data.ctlSelect.controlID);

		case frmOpenEvent:
			frmP = FrmGetActiveForm();
			FrmDrawForm ( frmP);
			CtlSetValue(GetObjectPtr(chooseinterfaceT16interfaceCheckbox),use_t16);
			CtlSetValue(GetObjectPtr(chooseinterfaceDrbinterfaceCheckbox),use_drb);
			CtlSetValue(GetObjectPtr(chooseinterfaceChartframesCheckbox),prefs.chart_frames);
			CtlSetValue(GetObjectPtr(chooseinterfaceFastlogmodeCheckbox),prefs.use_fast_mode);
			CtlSetValue(GetObjectPtr(chooseinterfaceCharttimescaleCheckbox),prefs.chart_by_time);
			CtlSetValue(GetObjectPtr(chooseinterfaceAutosaveCheckbox),prefs.autosave);
			CtlSetValue(GetObjectPtr(chooseinterfaceDigitalmodeCheckbox),prefs.digital_mode);
			CtlSetValue(GetObjectPtr(chooseinterfaceSinglechartCheckbox),prefs.single_chart);
			CtlSetValue(GetObjectPtr(chooseinterfaceColorsupportCheckbox),prefs.color_support);
			CtlSetValue(GetObjectPtr(chooseinterfaceMonitorCheckbox),prefs.monitor_mode);
			CtlSetValue(GetObjectPtr(chooseinterfaceAutostartsupportCheckbox),prefs.auto_start);
			handled = true;
			if (test_mode)
				CtlSetValue(GetObjectPtr(chooseinterfaceTestmodeCheckbox),1);
			else
				CtlSetValue(GetObjectPtr(chooseinterfaceTestmodeCheckbox),0);
			
			break;

		default:
			break;
		
		}
	
	return handled;
}

static Boolean playFormHandleEvent(EventPtr eventP)
{
    Boolean handled = false;
    static int dragx;
    FormPtr frmP;
    Err er;
//  	EventType 	event;
    int x;
    
	switch (eventP->eType) 
		{
		
		case ctlSelectEvent:
			return playFormDoCommand(eventP->data.ctlSelect.controlID);
		case lstSelectEvent:
			return playFormDoCommand(eventP->data.lstSelect.listID);
		case menuEvent:
		
		  if (play_run != 2)
		    return true;
		  else
  			return MainFormDoCommand(eventP->data.menu.itemID);
    case frmCloseEvent:
      FileClose(log_handle);
      return false;
		case frmOpenEvent:
		
			frmP = FrmGetActiveForm();
			FrmDrawForm ( frmP);
			
			// get selected file name
			
			log_handle = FileOpen(0,log_directory[play_entry].log_fnme,0,0,fileModeReadOnly,&er);
			if (log_handle == 0 || er != 0)
			{
			  	StrPrintF(play_fname,"log file ferr: %d",5632 - er);
			  	err_rtn(play_fname);
			}
			StrCopy(lf_name,log_directory[play_entry].log_fnme);
			
			erase_chart(1);
			erase_chart(2);
			erase_chart(3);
			play_log_file();
			plot_start_ticks = 0;
			show_player_controls();
 			draw_frames(play_list_size[0]);
      play_run = 1; 			
			play_run = 2;
			
			handled = true;
			break;
		case penMoveEvent:

		  if (play_run != 2)
		    return true;
		    
		  if (prefs.digital_mode == 1)
		    return true;
		    
		  if (dragx < eventP->screenX)  
		  {
    		time_points[chart_limit + 1] = -1;
  		  for (x=dragx;x<eventP->screenX;x++)
  		    playFormDoCommand(playformBackwardsButton);
  		}
  		else
  		{
    		time_points[chart_limit + 1] = 1;
  		  for (x=dragx;x>eventP->screenX;x--)
  		    if (process_frame(log_type[0]) < 0)
  		      break;
  		}
		  return true;
		case penDownEvent:

		  if (play_run != 2)
		    return true;
		    
		  if (prefs.digital_mode == 1)
		    return true;
		    
		  dragx = eventP->screenX;
		  
//		  for (x=0;x<3;x++)  
  			if (eventP->screenX >= 1  && eventP->screenX <= chart_limit)
//	  		    eventP->screenY >= prefs.chart_top[x] && eventP->screenY <= prefs.chart_top[x] + prefs.chart_scale  &&
//		  	    chart_visible[x])
  			{
  			  	show_data_point(eventP->screenX,eventP->screenY,0);
  			  	show_data_point(eventP->screenX,eventP->screenY,1);
  			  	show_data_point(eventP->screenX,eventP->screenY,2);
  			  	return true;
  			}
		default:
			break;
		
		}
	
	return handled;
}



/***********************************************************************
 *
 * FUNCTION:    AppHandleEvent
 *
 * DESCRIPTION: This routine loads form resources and set the event
 *              handler for the form loaded.
 *
 * PARAMETERS:  event  - a pointer to an EventType structure
 *
 * RETURNED:    true if the event has handle and should not be passed
 *              to a higher level handler.
 *
 * REVISION HISTORY:
 *
 *
 ***********************************************************************/
static Boolean AppHandleEvent( EventPtr eventP)
{
	Word formId;
	FormPtr frmP;

	if (eventP->eType == frmLoadEvent)
		{
		// Load the form resource.
		formId = eventP->data.frmLoad.formID;
		frmP = FrmInitForm(formId);
		FrmSetActiveForm(frmP);
		
		logger_controls = false;

		// Set the event handler for the form.  The handler of the currently
		// active form is called by FrmHandleEvent each time is receives an
		// event.
	
		switch (formId)
			{
			case MainForm:
				logger_controls = true;
				FrmSetEventHandler(frmP, MainFormHandleEvent);
				break;
			case ChooseinterfaceForm:
			  formfirstcontrol = 1101;
			  formlastcontrol = 1112;
			  formcurrentcontrol = 1101;
				FrmSetEventHandler(frmP, chooseinterfaceFormHandleEvent);
				break;
			case AboutformForm:
			case HowtoForm:
			case HowtomemoForm:
			case HowtoplayForm:
			case HowtodtcForm:
			case HowtoconfigureForm:
			case HowtosaveForm:
			case HowtochartForm:
			case HowtochooseForm:
			case DtcformForm:
			  if (formId == AboutformForm && registered)
			  {
			    // display reg data fields
     			PnsCopyLabel(frmP,aboutformRegnameLabel,&reg_string[0]);
     			PnsCopyLabel(frmP,aboutformRegaddressLabel,&reg_string[40]);
     			PnsCopyLabel(frmP,aboutformRegcityLabel,&reg_string[80]);
     			PnsCopyLabel(frmP,aboutformRegstateLabel,&reg_string[120]);
     			PnsCopyLabel(frmP,aboutformRegzipLabel,&reg_string[130]);
     			PnsCopyLabel(frmP,aboutformRegphoneLabel,&reg_string[150]);
			  }
				FrmSetEventHandler(frmP, dtcFormHandleEvent);
				break;
			case ConfiguredrbForm:
			case Configuret16Form:
        if (FrmGetActiveFormID() == ConfiguredrbForm)
        {
  			  formfirstcontrol = 1202;
  			  formlastcontrol = 1215;
  			  formcurrentcontrol = 1202;
        }
        else
        {
  			  formfirstcontrol = 1302;
  			  formlastcontrol = 1316;
  			  formcurrentcontrol = 1302;
        }
				FrmSetEventHandler(frmP, chooseloggerFormHandleEvent);
				break;
			case SavedataForm:
				FrmSetEventHandler(frmP, savedataFormHandleEvent);
				break;
		  case TimeslipForm:
				FrmSetEventHandler(frmP, timeslipFormHandleEvent);
				break;
		  case CarsetupForm:
				FrmSetEventHandler(frmP, carsetupFormHandleEvent);
				break;
			case DrbformForm:
				FrmSetEventHandler(frmP, drbformFormHandleEvent);
				break;
			case PlayformForm:
				FrmSetEventHandler(frmP, playFormHandleEvent);
				break;
		  case ChooseformForm:
				FrmSetEventHandler(frmP, ChooseformFormHandleEvent);
				break;
		  case MemoForm:
				FrmSetEventHandler(frmP, MainFormHandleEvent);
				break;
			default:
//				ErrFatalDisplay("Invalid Form Load Event");
				break;

			}
		return true;
		}
	
	return false;
}


/***********************************************************************
 *
 * FUNCTION:    AppEventLoop
 *
 * DESCRIPTION: This routine is the event loop for the application.  
 *
 * PARAMETERS:  nothing
 *
 * RETURNED:    nothing
 *
 * REVISION HISTORY:
 *
 *
 ***********************************************************************/
static void AppEventLoop(void)
{
	Word error;
	EventType event;
	Boolean exit_event = false;
	ULong auto_restart = 0;
	Boolean send_mode = true;
	char data_buf[20];
	char request_string[50];
	Err er;
	int len;
	FormPtr frmP;
	

  if (prefs.auto_start)
  {
 		EvtResetAutoOffTimer();
    EvtSetNullEventTick(SysTicksPerSecond() * 5);
  }
      
  auto_restart = TntTimer() + 15;

	do {
		EvtGetEvent(&event, evtWaitForever);
		
		if (hardkey(&event))
  	  continue;
    
		if (! SysHandleEvent(&event))
			if (! MenuHandleEvent(0, &event, &error))
				if (! AppHandleEvent(&event))
					FrmDispatchEvent(&event);
					
    if (first_time)
    {
  		FrmPopupForm(AboutformForm);
  		first_time = false;
  		continue;
    }
    
    if (FrmGetActiveFormID() != MainForm && TntTimer() > auto_restart)
      auto_restart = TntTimer() + 15;
    
    if (TntTimer() > auto_restart && prefs.auto_start && logger_status == 2 && FrmGetActiveFormID() == MainForm && !play_mode)
    {
    
      frmP = FrmGetActiveForm();
    
      // check protocol
      
      if (use_t16 == 1 || use_drb == 1)
      {
      
        // check loggable item count
        
        if (item_count > 1)
        {
          //err_rtn("a/s");
          
          // send request
          
          if (send_mode)
          {
            // set serial parms
            
    //        FrmSetTitle(frmP,"Sending request");

            if (use_t16)
            {
          		TntBaud(0,19200);	
          		TntParms(0,0,0,8);		// one start bit, no parity, 8 data bits
          		TntReset(0,100,100);	// open the port
             	request_string[0]  = 0x25;
             	request_string[1]  = 0x01;
             	request_string[2]  = 0x05;
             	request_string[3]  = 0x61;
             	request_string[4]  = 0x6a;
             	request_string[5]  = 0xf1;
             	request_string[6]  = 0x01;
             	request_string[7]  = 0x0c;
             	request_string[8]  = 0x00;
             	request_string[9]  = 0x00;
             	request_string[10] = 0x00;
             	request_string[11] = 0x00;
             	request_string[12] = 0x00;
             	request_string[13] = 0x00;
             	request_string[14] = 0x43;

              TntRxClear();
              TntPuts(0,request_string,-150);
              len = 14;
          	}
            else
            {
              TntBaud(0,1920);
          		TntParms(0,0,0,8);		// one start bit, no parity, 8 data bits
          		TntReset(0,100,100);	// open the port
              data_buf[0] = 0x21;
              TntRxClear();
              len = 2;
              TntPuts(0,data_buf,1);
            }

            // send inq
            
            send_mode = false;
            auto_restart = TntTimer() - 1;
          }
          else
          {
            // wait for response
            
  //          FrmSetTitle(frmP,"Waiting for response");
            
            if (wait_for_bytes(0,len,1) > 0 || test_mode)
            {
              if (use_t16 == 1)
              {
                if (test_mode)
                {
                  data_buf[8] = 0xaa;
                  data_buf[8] = 0xff;
                }
                else
                {
                  TntGets(serial_library,(unsigned char *) &data_buf[0],14,-1,&er);
//                  StrPrintF(request_string,"rcv %x %x %x %x %x",data_buf[1],data_buf[2],data_buf[3],data_buf[7],data_buf[8]);
//                  FrmSetTitle(frmP,request_string);
                  if ((unsigned char)data_buf[1] == 0x80)
                  {
                    data_buf[7] = 0x00;
                    data_buf[8] = 0x00;
                    obd_logon = false;
                    t16_timer = 0;
                    wait_for_bytes(0,100,5);
                    TntRxClear();
                  }
                }
                dv1 = (unsigned char)data_buf[7];
                dv1 *= 255;
                dv1 += (unsigned char)data_buf[8];
                if (dv1 / 4 > 1000) // exceed 1k rpms
                {
              	   MainFormDoCommand(MainStartloggingButton);
              	   TntRxClear();
              	}
              	else
              	  send_mode = true;
              }
              else
              {
                if (test_mode)
                  data_buf[1] = 0xff;
                else
                  TntGets(serial_library,(unsigned char *) &data_buf[0],2,-1,&er);
                dv1 = (unsigned char)data_buf[1];
                if (dv1 * 31.37 > 1000) // exceed 1k rpms
              	  MainFormDoCommand(MainStartloggingButton);
                else
                  send_mode = true;
              }
            }
            else
              send_mode = true;
            auto_restart = TntTimer() + 15;
          }
      
        }
      }
      
    }      
    
    if (prefs.auto_start)
    {
      EvtSetNullEventTick(SysTicksPerSecond());
   		EvtResetAutoOffTimer();
    }
		
		if (event.eType == appStopEvent && logger_status != 2)
		{
			logger_status = 2;
		}			
		else
			if (event.eType == appStopEvent)
				exit_event = true;

	} while (!exit_event);
}


static Boolean hardkey( EventPtr eventP)
{
  FormPtr frmP;
  
		if (eventP->eType == keyDownEvent)
    {
      frmP = FrmGetActiveForm();
    	hardkeystate = KeyCurrentState() & keysAllowedMask;
    	if (FrmGetActiveFormID() == HowtoForm || 
    	    FrmGetActiveFormID() == HowtoplayForm ||
    	    FrmGetActiveFormID() == HowtochooseForm ||
    	    FrmGetActiveFormID() == HowtochartForm ||
    	    FrmGetActiveFormID() == HowtosaveForm ||
    	    FrmGetActiveFormID() == HowtodtcForm ||
    	    FrmGetActiveFormID() == HowtomemoForm ||
    	    FrmGetActiveFormID() == HowtoconfigureForm)
    	{
      	if (hardkeystate & F1)
      	{
      	  FrmReturnToForm(0);
      	  return true;
      	}
    	}
    	if (FrmGetActiveFormID() == TimeslipForm)
    	{
    	  if (hardkeystate & F1)
    	  {
    	    if (create_timeslip())
    	    {
      	    timeslip_loaded = false;
      	    FrmReturnToForm(0);
      	    return true;
      	  }
    	  }
    	  if (hardkeystate & F2 && 
    	      timesliprecord.altitude != 0 &&
    	      timesliprecord.et_1320 != 0 &&
    	      timesliprecord.mph_1320 != 0)
    	  {
    	    if (create_timeslip())
    	      nhra_conversion();
    	    return true;
    	  }
    	  if (hardkeystate & PAGEUP && 
    	      timesliprecord.altitude != 0 &&
    	      timesliprecord.et_1320 != 0 &&
    	      timesliprecord.temp != 0 &&
    	      timesliprecord.baro != 0 &&
    	      timesliprecord.humidity != 0 &&
    	      timesliprecord.mph_1320 != 0)
    	  {
    	    if (create_timeslip())
      	    std_conversion();
      	  return true;
    	  }
    	  if (hardkeystate & F3 && !carsetup_loaded)
    	  {
          FrmPopupForm(CarsetupForm);
    	    return true;
    	  }
    	  if (hardkeystate & F4)
    	  {
    	    timeslip_loaded = false;
    	    FrmReturnToForm(0);
    	    return true;
    	  }
    	}
    	if (FrmGetActiveFormID() == CarsetupForm)
    	{
    	  if (hardkeystate & F1)
    	  {
    	    if (create_carsetup())
    	    {
      	    carsetup_loaded = false;
      	    FrmReturnToForm(0);
      	  }
    	    return true;
    	  }
    	  if (hardkeystate & F2 && !timeslip_loaded)
    	  {
          FrmPopupForm(TimeslipForm);
    	    return true;
    	  }
    	  if (hardkeystate & F4)
    	  {
    	    if (create_carsetup())
    	    {
      	    carsetup_loaded = false;
      	    FrmReturnToForm(0);
      	  }
    	    return true;
    	  }
    	}
    	if (FrmGetActiveFormID() == MemoForm)
    	{
    	  if (hardkeystate & F1)
    	  {
    	    update_memo(lf_name);
    	    FrmReturnToForm(0);
    	    return true;
    	  }
    	  if (hardkeystate & F2)
    	  {
          FrmPopupForm(TimeslipForm);
          return true;
    	  }
    	  if (hardkeystate & F3)
    	  {
          FrmPopupForm(CarsetupForm);
          return true;
    	  }
    	  if (hardkeystate & F4)
    	  {
    	    FrmReturnToForm(0);
    	    return true;
    	  }
    	}
    	if (FrmGetActiveFormID() == DtcformForm)
    	{
    	  if (hardkeystate & F1)
    	  {
    	    dtcFormDoCommand(dtcformDtcdoneButton);
    	    return true;
    	  }
    	  if (hardkeystate & F2)
    	  {
    	    dtcFormDoCommand(dtcformShowdtcButton);
    	    return true;
    	  }
    	  if (hardkeystate & F4)
    	  {
    	    dtcFormDoCommand(dtcformDtcclearButton);
    	    return true;
    	  }
    	    if (hardkeystate & PAGEUP)
    	    {
    	      if (LstGetSelection(GetObjectPtr(dtcformDtclistList)) > 0)
    	      {
    	        LstSetSelection(GetObjectPtr(dtcformDtclistList),LstGetSelection(GetObjectPtr(dtcformDtclistList)) - 1);
    	        dtcFormDoCommand(dtcformDtclistList);
    	        return true;
    	      }
    	    }
    	    if (hardkeystate & PAGEDOWN)
    	    {
    	        LstSetSelection(GetObjectPtr(dtcformDtclistList),LstGetSelection(GetObjectPtr(dtcformDtclistList)) + 1);
    	        dtcFormDoCommand(dtcformDtclistList);
    	        return true;
    	    }
    	}
    	if (FrmGetActiveFormID() == PlayformForm)
    	{
     	  if (hardkeystate & P1 && play_run == 2)
     	  {
     	    if (!just_woke_up)
       	    FrmPopupForm(ChooseformForm);
       	  just_woke_up = false;
     	    return true;
     	  }
  	    if (hardkeystate & P1 && play_run != 2)
  	    {
  	      erase_chart(3);
  	      erase_chart(1);
  	      erase_chart(2);
  	      if (prefs.digital_mode == 1)
  	      {
  	        prefs.digital_mode = 0;
  	      }
  	      else
  	        prefs.digital_mode = 1;
  	      show_player_controls();
  	      return true;
  	    }
    	  if (hardkeystate & F1)
    	  {
    	    if (play_run == 2)
    	    {
    	      if (!prefs.peak_hold)
    	      {
      	      prefs.peak_hold = true;
      	      show_peak_values();
      	    }
      	    else
      	    {
      	      prefs.peak_hold = false;
        	    playFormDoCommand(playformPlayokButton);
        	  }
      	  }
      	  else
      	    prefs.peak_hold = !prefs.peak_hold;
    	    return true;
    	  }
    	  if (hardkeystate & F2)
    	  {
    	    if (play_run == 2)
    	    {
    	      FrmPopupForm(MemoForm);
    	    }
    	    else
      	    playFormDoCommand(playformStopButton);
    	    return true;
    	  }
    	  if (hardkeystate & F4)
    	  {
    	    playFormDoCommand(playformBackwardsButton);
    	    return true;
    	  }
    	  if (hardkeystate & F3)
    	  {
    	    playFormDoCommand(playformForwardButton);
    	    return true;
    	  }
    	  if (hardkeystate & PAGEUP)
    	  {
    	    playFormDoCommand(playformPlayButton);
    	    return true;
    	  }
    	  if (hardkeystate & PAGEDOWN)
    	  {
    	    playFormDoCommand(playformRewindButton);
    	    return true;
    	  }
    	}
    	if (FrmGetActiveFormID() == AboutformForm)
    	{
    	  dtcFormDoCommand(aboutformAboutdoneButton);
    	  return true;
    	}
    	if (FrmGetActiveFormID() == ChooseinterfaceForm)
    	{
        	if (hardkeystate & F1)
        	{
        	  MainFormDoCommand(chooseinterfaceConfigureloggerdoneButton);
        	  return true;
        	}
        	if (hardkeystate & F2)
        	{
      			if (CtlGetValue(GetObjectPtr(formcurrentcontrol)) == 0)
      				CtlSetValue(GetObjectPtr(formcurrentcontrol),1);
      			else
      				CtlSetValue(GetObjectPtr(formcurrentcontrol),0);
        	  MainFormDoCommand(formcurrentcontrol);
        	}
        	if (hardkeystate & PAGEDOWN)
        	{
            ctlptr = FrmGetObjectPtr(frmP,FrmGetObjectIndex(frmP, formcurrentcontrol));        	
            if (ctlptr->font != stdFont)
            {
              ctlptr->font = stdFont;
              CtlDrawControl(ctlptr);
            }
        	  
        	  ++ formcurrentcontrol;
        	  if (formcurrentcontrol > formlastcontrol)
        	    formcurrentcontrol = formfirstcontrol;
        	}
        	if (hardkeystate & PAGEUP)
        	{
            ctlptr = FrmGetObjectPtr(frmP,FrmGetObjectIndex(frmP, formcurrentcontrol));        	
            if (ctlptr->font != stdFont)
            {
              ctlptr->font = stdFont;
              CtlDrawControl(ctlptr);
            }
        	  -- formcurrentcontrol;
        	  if (formcurrentcontrol < formfirstcontrol)
        	    formcurrentcontrol = formlastcontrol;
        	}
        	if (hardkeystate & F2 || hardkeystate & PAGEUP || hardkeystate & PAGEDOWN)
        	{
            ctlptr = FrmGetObjectPtr(frmP,FrmGetObjectIndex(frmP, formcurrentcontrol));        	
            ctlptr->font = boldFont;
            CtlDrawControl(ctlptr);
          	return true;
          }
    	}
    	if (FrmGetActiveFormID() == DrbformForm)
    	{
   	    if (hardkeystate & PAGEUP)
   	    {
   	      if (LstGetSelection(GetObjectPtr(drbformItemlistList)) > 0)
   	      {
   	        LstSetSelection(GetObjectPtr(drbformItemlistList),LstGetSelection(GetObjectPtr(drbformItemlistList)) - 1);
   	        return true;
   	      }
   	    }
   	    if (hardkeystate & PAGEDOWN)
   	    {
   	      if (LstGetSelection(GetObjectPtr(drbformItemlistList)) < 11)
   	      {
   	        LstSetSelection(GetObjectPtr(drbformItemlistList),LstGetSelection(GetObjectPtr(drbformItemlistList)) + 1);
   	        return true;
   	      }
   	    }
    	  if (hardkeystate & F4)
    	  {
    	    drbFormDoCommand(drbformDrbstopButton);
      	  return true;
      	}
    	  if (hardkeystate & F3)
    	  {
     	    drbFormDoCommand(drbformDrbstartButton);
      	  return true;
      	}
    	  if (hardkeystate & F1)
    	  {
     	    drbFormDoCommand(drbformDrballButton);
      	  return true;
      	}
    	}
    	if (FrmGetActiveFormID() == ConfiguredrbForm)
    	{
        	if (hardkeystate & F1)
        	{
        	  loggerFormDoCommand(configuredrbDrbokButton);
        	  return true;
        	}
        	if (hardkeystate & F2)
        	{
      			if (CtlGetValue(GetObjectPtr(formcurrentcontrol)) == 0)
      				CtlSetValue(GetObjectPtr(formcurrentcontrol),1);
      			else
      				CtlSetValue(GetObjectPtr(formcurrentcontrol),0);
      			hardkeystate = PAGEDOWN;
        	}
        	if (hardkeystate & PAGEDOWN)
        	{
            ctlptr = FrmGetObjectPtr(frmP,FrmGetObjectIndex(frmP, formcurrentcontrol));        	
            if (ctlptr->font != stdFont)
            {
              ctlptr->font = stdFont;
              CtlDrawControl(ctlptr);
            }
        	  
        	  ++ formcurrentcontrol;
        	  if (formcurrentcontrol > formlastcontrol)
        	    formcurrentcontrol = formfirstcontrol;
        	}
        	if (hardkeystate & PAGEUP)
        	{
            ctlptr = FrmGetObjectPtr(frmP,FrmGetObjectIndex(frmP, formcurrentcontrol));        	
            if (ctlptr->font != stdFont)
            {
              ctlptr->font = stdFont;
              CtlDrawControl(ctlptr);
            }
        	  -- formcurrentcontrol;
        	  if (formcurrentcontrol < formfirstcontrol)
        	    formcurrentcontrol = formlastcontrol;
        	}
        	if (hardkeystate & F2 || hardkeystate & PAGEUP || hardkeystate & PAGEDOWN)
        	{
            ctlptr = FrmGetObjectPtr(frmP,FrmGetObjectIndex(frmP, formcurrentcontrol));        	
            ctlptr->font = boldFont;
            CtlDrawControl(ctlptr);
          	return true;
          }
    	}
    	if (FrmGetActiveFormID() == Configuret16Form)
    	{
        	if (hardkeystate & F1)
        	{
        	  loggerFormDoCommand(configuret16T16okButton);
        	  return true;
        	}
        	if (hardkeystate & F2)
        	{
      			if (CtlGetValue(GetObjectPtr(formcurrentcontrol)) == 0)
      				CtlSetValue(GetObjectPtr(formcurrentcontrol),1);
      			else
      				CtlSetValue(GetObjectPtr(formcurrentcontrol),0);
      			hardkeystate = PAGEDOWN;
        	}
        	if (hardkeystate & PAGEDOWN)
        	{
            ctlptr = FrmGetObjectPtr(frmP,FrmGetObjectIndex(frmP, formcurrentcontrol));        	
            if (ctlptr->font != stdFont)
            {
              ctlptr->font = stdFont;
              CtlDrawControl(ctlptr);
            }
        	  
        	  ++ formcurrentcontrol;
        	  if (formcurrentcontrol > formlastcontrol)
        	    formcurrentcontrol = formfirstcontrol;
        	}
        	if (hardkeystate & PAGEUP)
        	{
            ctlptr = FrmGetObjectPtr(frmP,FrmGetObjectIndex(frmP, formcurrentcontrol));        	
            if (ctlptr->font != stdFont)
            {
              ctlptr->font = stdFont;
              CtlDrawControl(ctlptr);
            }
        	  -- formcurrentcontrol;
        	  if (formcurrentcontrol < formfirstcontrol)
        	    formcurrentcontrol = formlastcontrol;
        	}
        	if (hardkeystate & F2 || hardkeystate & PAGEUP || hardkeystate & PAGEDOWN)
        	{
            ctlptr = FrmGetObjectPtr(frmP,FrmGetObjectIndex(frmP, formcurrentcontrol));        	
            ctlptr->font = boldFont;
            CtlDrawControl(ctlptr);
          	return true;
          }
    	}
    	if (FrmGetActiveFormID() == SavedataForm && save_mode)
    	{
        	if (hardkeystate & F1)
        	{
        	  saveFormDoCommand(savedataSavedataButton);
        	  return true;
        	}
        	if (hardkeystate & F4)
        	{
        	  saveFormDoCommand(savedataDiscarddataButton);
        	  return true;
        	}
    	}
    	if (FrmGetActiveFormID() == ChooseformForm)
    	{
    	  if (hardkeystate & PAGEUP)
    	  {
    	    ChooseformFormDoCommand(2); 
    	    return true;
    	  }
    	  if (hardkeystate & PAGEDOWN)
    	  {
    	    ChooseformFormDoCommand(3); 
    	    return true;
    	  }
    	  if (hardkeystate & F1)
    	  {
    	    ChooseformFormDoCommand(1); 
    	    if (play_mode)
    	    {
    	      show_player_controls();
    	    }

    	    return true;
    	  }
    	  if (hardkeystate & F2)
    	  {
    	    ChooseformFormDoCommand(4);
    	    return true;
    	  }
    	  if (hardkeystate & F3)
    	  {
    	    ChooseformFormDoCommand(6);
    	    return true;
    	  }
    	}
    	if (FrmGetActiveFormID() == MainForm)
    	{
    	  if (!play_mode)
    	  {
      	  if (hardkeystate & P1 && logger_status == 2)
      	  {
      	    if (!just_woke_up)
        	    FrmPopupForm(ChooseformForm);
        	  just_woke_up = false;
      	    return true;
      	  }
     	    if (hardkeystate & PAGEUP && logger_status == 2)
          {
            MainFormDoCommand(MainOptionsSelectInterface);
            return true;
          }
     	    if (hardkeystate & PAGEDOWN && logger_status == 2)
          {
            MainFormDoCommand(MainOptionsTroubleCodes);
            return true;
          }
     	    if (hardkeystate & P1 && logger_status != 2)
     	    {
     	      hide_logger_controls();
     	      erase_chart(3);
     	      erase_chart(1);
     	      erase_chart(2);
     	      if (prefs.digital_mode == 1)
     	      {
     	        prefs.digital_mode = 0;
     	      }
     	      else
     	        prefs.digital_mode = 1;
     	      show_logger_controls();
     	      return true;
     	    }
     	    if (hardkeystate & PAGEUP && prefs.chart_by_time == 1 && logger_status == 0)
     	    {
            if (prefs.slider_value < 30)
            {
              ++ prefs.slider_value;
      	      MainFormDoCommand(MainCharttimescaleSliderControl);
      	      return true;
      	    }
     	    }
     	    if (hardkeystate & PAGEDOWN && prefs.chart_by_time == 1 && logger_status == 0)
     	    {
            if (prefs.slider_value > 1)
            {
              -- prefs.slider_value;
      	      MainFormDoCommand(MainCharttimescaleSliderControl);
      	      return true;
      	    }
     	    }
        	if (hardkeystate & F1)
        	{
        	  if (logger_status == 2)
           	  MainFormDoCommand(MainStartloggingButton);
           	else
           	  if (logger_status == 0)
           	    prefs.peak_hold = !prefs.peak_hold;
        	  return true;
        	}
        	if (hardkeystate & F2)
        	{
        	  if (prefs.monitor_mode != 1 && logger_status == 0)
          	  MainFormDoCommand(MainPauseloggingButton);
          	else
          	  if (logger_status == 1)
          	    logger_status = 0;
        	  return true;
        	}
        	if (hardkeystate & F3)
        	{
        	  if (logger_status == 2 && use_drb == 1 && registered)
        	  {
        	    FrmPopupForm(DrbformForm);
        	  }
        	  else
          	  MainFormDoCommand(MainStoploggingButton);
        	  return true;;
        	}
        	if (hardkeystate & F4)
        	{
        	  MainFormDoCommand(MainOptionsPlayBack);
        	  return true;;
        	}
        }
    	  if (play_mode)
    	  {
    	    if (hardkeystate & PAGEUP)
    	    {
    	      if (LstGetSelection(GetObjectPtr(MainLogfilelistList)) > 0)
    	      {
    	        LstSetSelection(GetObjectPtr(MainLogfilelistList),LstGetSelection(GetObjectPtr(MainLogfilelistList)) - 1);
    	        return true;
    	      }
    	    }
    	    if (hardkeystate & PAGEDOWN)
    	    {
    	        LstSetSelection(GetObjectPtr(MainLogfilelistList),LstGetSelection(GetObjectPtr(MainLogfilelistList)) + 1);
    	        return true;
    	    }
        	if (hardkeystate & F2)
        	{
        	  MainFormDoCommand(MainPlayfileButton);
        	  return true;
        	}
        	if (hardkeystate & F1)
        	{
        	  MainFormDoCommand(MainDonefileButton);
        	  return true;
        	}
        	if (hardkeystate & F4)
        	{
        	  MainFormDoCommand(MainDeletefileButton);
        	  return true;
        	}
        	if (hardkeystate & F3)
        	{
        	  MainFormDoCommand(MainTransferfileButton);
        	  return true;;
        	}
        }
    	}
    	if (hardkeystate & F1 ||
    	    hardkeystate & F2 ||
    	    hardkeystate & F3 ||
    	    hardkeystate & F4 ||
    	    hardkeystate & PAGEUP ||
    	    hardkeystate & PAGEDOWN ||
    	    hardkeystate & P1)
       return true; 
    }

    
  return false;
}

/***********************************************************************
 *
 * FUNCTION:     AppStart
 *
 * DESCRIPTION:  Get the current application's preferences.
 *
 * PARAMETERS:   nothing
 *
 * RETURNED:     Err value 0 if nothing went wrong
 *
 * REVISION HISTORY:
 *
 *
 ***********************************************************************/
static Err AppStart(void)
{
    Word prefsSize;
    int		fb;
/*
	StrCopy(&field_string[0][0],"Rpms");
	StrCopy(&field_string[1][0],"O2v");
	StrCopy(&field_string[2][0],"Timing");
	StrCopy(&field_string[3][0],"Tps");
	StrCopy(&field_string[4][0],"Air Flw");
	StrCopy(&field_string[5][0],"Sht Trim");
	StrCopy(&field_string[6][0],"Lng Trim");
	StrCopy(&field_string[7][0],"Air Temp");
	StrCopy(&field_string[8][0],"Wtr Temp");
	StrCopy(&field_string[9][0],"Low Trim");
	StrCopy(&field_string[10][0],"Med Trim");
	StrCopy(&field_string[11][0],"Knock");
	StrCopy(&field_string[12][0],"Pulse Wdth");
	StrCopy(&field_string[13][0],"Hgh Trim");
	StrCopy(&field_string[14][0],"");
	StrCopy(&field_string[15][0],"None");
	StrCopy(&field_string[16][0],"MPH"); // 0x0d
	StrCopy(&field_string[17][0],"MAP"); // 0x0b
	StrCopy(&field_string[18][0],"Sht Trim(2)"); //0x08
	StrCopy(&field_string[19][0],"Lng Trim(2)"); // 0x09
	StrCopy(&field_string[20][0],"Load"); // 0x04
	StrCopy(&field_string[21][0],"O2v B2");  // 0x18
	StrCopy(&field_string[24][0],"O2v Trim");  // 0x18
	StrCopy(&field_string[25][0],"Time");
	StrCopy(&field_string[26][0],"ISC");
	StrCopy(&field_string[27][0],"Boost (GM)");
	StrCopy(&field_string[28][0],"Wideband");
*/
	prefs.use_t16_chk = 1;
  prefs.use_drb_chk = 0;
  prefs.test_mode_chk = false;
  prefs.chart_frames = 0;
  prefs.auto_start = false;

  prefs.chart_width   = chart_limit; // 120
  prefs.chart_height  =  41; // 21
  prefs.chart_scale   =  40; // 20
  prefs.chart_spacing =  40; // 40
  prefs.chart_top[0]  =  15; // 20
  prefs.chart_top[1]  =  65; // 60
  prefs.chart_top[2]  = 115; // 100
  prefs.chart_base[0] = prefs.chart_top[0] + prefs.chart_scale;
  prefs.chart_base[1] = prefs.chart_top[1] + prefs.chart_scale;
  prefs.chart_base[2] = prefs.chart_top[2] + prefs.chart_scale;
  
  prefs.log_item_count = 0;
  prefs.chart_by_time = 0;
  prefs.slider_value = 1;
  prefs.single_chart = 0;
  prefs.color_support = 0;
  prefs.monitor_mode = 0;
  prefs.expiration_date = TimGetSeconds() + 2592000;
  prefs.peak_hold = false;
  prefs.map_cal = 0.0F;
  prefs.wideband_cal = 0.0F;
  chart_status[0] = chart_status[1] = chart_status[2] = 0;
  setup_charts(&chart_status[0]);
	SysLibFind("Serial Library",&serial_library);
	
  for (fb=0;fb<40;fb++)
  {
    prefs.t16_items[fb] = 0;
  }

  for (fb=0;fb<19;fb++)
  {
    if (fb < 3)
      prefs.drb_charts[fb] = prefs.t16_charts[fb] = 0;
    prefs.log_items[fb] = 0;
    prefs.drb_items[fb] = 0;
  }

	prefsSize = sizeof(StarterPreferenceType);
	if (PrefGetAppPreferences(appFileCreator, appPrefID, &prefs, &prefsSize, true) != 
		noPreferenceFound)
		{
		  play_status[0] = play_status[1] = play_status[2] = 0;
		  chart_status[0] = prefs.t16_charts[0];
		  chart_status[1] = prefs.t16_charts[1];
		  chart_status[2] = prefs.t16_charts[2];
			use_t16 = prefs.use_t16_chk;
			use_drb = prefs.use_drb_chk;
			test_mode = prefs.test_mode_chk;
			item_count = prefs.log_item_count;
//			prefs.slider_value = 1;
			
			if (item_count != 0)
				loggable_items = true;
				
			for (fb=0;fb<max_items;fb++)
				items_to_log[fb] = prefs.log_items[fb];
				
			if (prefs.use_fast_mode == 1)
			  pre_fetch_default = true;
		}

  prefs.peak_hold = false;
	set_log_list(1);
		
	read_directory(1);
 	return 0;
}


/***********************************************************************
 *
 * FUNCTION:    AppStop
 *
 * DESCRIPTION: Save the current state of the application.
 *
 * PARAMETERS:  nothing
 *
 * RETURNED:    nothing
 *
 * REVISION HISTORY:
 *
 *
 ***********************************************************************/
static void AppStop(void)
{
   
	// Write the saved preferences / saved-state information.  This data 
	// will be backed up during a HotSync.
	
//	prefs.slider_value = prefs.slider_value * 256;
	
	PrefSetAppPreferences (appFileCreator, appPrefID, appPrefVersionNum, 
		&prefs, sizeof (prefs), true);
	FrmCloseAllForms();
}



/***********************************************************************
 *
 * FUNCTION:    StarterPilotMain
 *
 * DESCRIPTION: This is the main entry point for the application.
 * PARAMETERS:  cmd - word value specifying the launch code. 
 *              cmdPB - pointer to a structure that is associated with the launch code. 
 *              launchFlags -  word value providing extra information about the launch.
 *
 * RETURNED:    Result of launch
 *
 * REVISION HISTORY:
 *
 *
 ***********************************************************************/
static DWord StarterPilotMain(Word cmd, Ptr cmdPBP, Word launchFlags)
{
	Err error;
	DateTimeType dt;
	UInt32 st;
    	MemHandle	paramH;
	    char*		paramP;
	    char		tmpStr[256];
      DmSearchStateType searchstate;
	    UInt cardno;
	    LocalID dbid; 

	
	switch (cmd)
		{
		case sysAppLaunchCmdNormalLaunch:     
   	  red_color.index = 0;
   	  red_color.r = 255;
   	  red_color.g = 0;
   	  red_color.b = 0;
   	  blue_color.index = 0;
   	  blue_color.r = 0;
   	  blue_color.g = 0;
   	  blue_color.b = 255;
   	  color_index[0] = WinRGBToIndex(&red_color);
   	  color_index[1] = WinRGBToIndex(&blue_color);
   	  green_color.index = 0;
   	  green_color.r = 0;
   	  green_color.g = 255;
   	  green_color.b = 0;
   	  color_index[2] = WinRGBToIndex(&green_color);
    	error = RomVersionCompatible (ourMinVersion, launchFlags);
    	if (error) return (error);
			error = AppStart();
			if (error) 
				return error;
      get_reg();
    	if (!registered)
    	{
    		st = TimGetSeconds();
    		TimSecondsToDateTime(st,&dt);
    	  max_logfiles = 4;
    	  test_mode = true;
    	}
			FrmGotoForm(MainForm);
      KeySetMask(keysAllowedMask);
			AppEventLoop();
		  if (serial_open == 1)
		    TntDone(0);
			AppStop();
			break;
  	case sysAppLaunchCmdSystemReset:

/*	    DmGetNextDatabaseByTypeCreator(true, &searchstate, 'appl',
				       'SWNG', true,
				       &cardno, &dbid);
	    SysUIAppSwitch(cardno, dbid, sysAppLaunchCmdNormalLaunch, (MemPtr)paramP);  */
      break;
    // handle the late wake up event  
		default:
			break;

		}
	KeySetMask(~keysAllowedMask);
	return 0;
}


/***********************************************************************
 *
 * FUNCTION:    PilotMain
 *
 * DESCRIPTION: This is the main entry point for the application.
 *
 * PARAMETERS:  cmd - word value specifying the launch code. 
 *              cmdPB - pointer to a structure that is associated with the launch code. 
 *              launchFlags -  word value providing extra information about the launch.
 * RETURNED:    Result of launch
 *
 * REVISION HISTORY:
 *
 *
 ***********************************************************************/
DWord PilotMain( Word cmd, Ptr cmdPBP, Word launchFlags)
{
    return StarterPilotMain(cmd, cmdPBP, launchFlags);
}
